/**
 * Creado por ivan fecha 10/05/18.
 */
angular
    .module('configuracion.module', [])
    .controller('loginConfiguracionController', loginConfiguracionController);





function loginConfiguracionController($interval, $ionicLoading,
                                      $scope,
                                      $rootScope,
                                      $timeout,
                                      $cordovaSQLite,
                                      $state,
                                      localStorageService,
                                      mobile,
                                      notificaciones,
                                      dispositivo,
                                      servidor,
                                      socket,
                                      estado) {

    var tiempoMuestraSpinner = 20000;

    $scope.btnEnviar = btnEnviar;


    document.addEventListener('deviceready', inicializar, false);


    $scope.$on("$ionicView.beforeEnter", function (event, data) {


    });





    function inicializar() {


        $scope.formulario = {
            puerto: 3001,
            password: '',
            ip: localStorageService.get("ip1")
        };

        // hardcodeado
        // if ($rootScope.desarrollo) {
        // $scope.formulario = {
        //     password: 'mdc1234',
        //     puerto: 3001,
        //     ip: "madredeciudades.no-ip.biz"
        // };
        // }

        escucharRespuesta();
    }





    // junta la ip con el puerto
    function armarUrlIngresada() {
        var ip = $scope.formulario.ip;
        return ip
    }





    function setearUrl(url) {
        servidor.setearUrl(url)
    }





    $scope.limpiar = function () {
        removerTodosLosListeners();
    };





    function removerTodosLosListeners() {
        servidor.removerTodosLosListeners();
    }





    function hayConexion() {
        return servidor.isconnected();
    }





    function btnEnviar() {


        var timeout;
        // comienza el spinner, si se cumple el tiempo muestra error
        $ionicLoading.show({
            animation: 'fade-in',
            maxWidth: 300
        }).then(function () {

            // una vez que se apreta el boton comienza a correr un tiempo en que se espera una respuesta,
            // sino remueve la escucha en caso de que se haya registrado
            // se desconecta del server si se llego a conectar
            // se cancela el intervalo que verifica si hay conexion
            // se cancela el spinner
            // se muestra el respectivo mensaje
            timeout = $timeout(function () {
                $interval.cancel(intervaloConexion); //cancela el intervalo que verifica la conexion

                removerTodosLosListeners(); //remueve la escucha en caso de que se haya registrado
                desconectarDelServer();  // se desconecta del server si se llego a conectar
                mobile.cancelarYocultarSpinner(); // se cancela el spinner

                alert("Intente nuevamente mas tarde")  // se muestra el respectivo mensaje
            }, tiempoMuestraSpinner);

        }, function (l) {

        });

        console.log("btn enviar");

        var url = armarUrlIngresada(); //une url y puerto
        console.error("url ingresada:" + url);


        $rootScope.puertoIngresado = $scope.formulario.puerto;
        $rootScope.ipIngresada = $scope.formulario.ip;
        servidor.guardarPuerto($rootScope.puertoIngresado);

        servidor.conectar(url, true);


        // intervalo que verifica si hay conexion
        var intervaloConexion = $interval(function () {

            // console.log("dentro de intervalo");

            //si esta conectado
            if (hayConexion()) {

                console.log("dentro de isconected");

                socket.registrarSocketon(); //escucha las respuesta


                $interval.cancel(intervaloConexion); //cancela este mismo interavlo para no seguir preguntando

                var datos = obtenerDatosParaEnviar();

                $timeout(function () {

                    //envia los datos del formulario al server
                    enviarAlServer(datos)
                        .then(function (respuesta) {
                            console.log("enviado correctamente:" + JSON.stringify(respuesta));
                            // cuando conecta no espera a los 5 segundos para desconectar y remover listeners
                            $timeout.cancel(timeout);

                        }, function () {
                            console.error("no se puedo enviar:");
                            $timeout.cancel(timeout);

                            alert("Intente nuevamente mas tarde");
                            mobile.cancelarYocultarSpinner();
                            removerTodosLosListeners();
                            desconectarDelServer();

                        });

                }, 200);
            }

        }, 30);

    }





    function irAlEstado(_estado) {
        estado.irAlEstado(_estado)
    }





    function obtenerDatosParaEnviar() {
        var datos = {
            empresa: ' ',
            password: $scope.formulario.password
        };

        if (datos.password == null) {
            datos.password = ''
        }

        return datos;

    }





    function enviarAlServer(datos) {
        // configuracion.enviar(datos)

        return servidor.enviarAlServer(datos);
    }





    function escucharRespuesta() {
        console.log("escuchando rta_validar_pass_config");
        notificaciones.escuchar("rta_validar_pass_config", $scope, rta_validar_pass_config);
    }





    function rta_validar_pass_config(a, msg) {
        console.log("entra en rta-validar-pass-config");

        removerTodosLosListeners();
        desconectarDelServer();
        detenerSpinner();

        msg = convertirMensaje(msg);
        if (respuestaOk(msg)) {
            $scope.formulario.password = '';
            irAlEstado('formularioConfiguracion');

            return;
        }
        mostrarMensaje(msg);
    }





    function desconectarDelServer() {
        servidor.desconectar();
    }





    function mostrarMensaje(msg) {
        alert(msg.Respuesta)
    }





    function respuestaOk(msg) {

        console.log(msg.Estado);
        return msg.Estado;
    }





    function convertirMensaje(msg) {
        msg = angular.fromJson(msg);
        return msg;
    }





    function detenerSpinner() {
        mobile.cancelarYocultarSpinner();
    }
}