//aca se cargan los módulos de angular conseguidos con bower y otros módulos creados por mi
angular
    .module('starter', [
        'angularMoment',
        'archivosModule',
        'audio',
        'baseDatos',
        'bluetooth',
        'botonAudioModule',
        // 'BluetoothModule',
        'ConversionesModule',
        'configuracion.module',
        'estado',
        'BluetoothModule',
        'fotosModule',
        'ionic',
        'imageCacheFactory',
        'LocalStorageModule',
        'mapa',
        'mobile',
        'ngAudio',
        'ngCordova',
        'notificaciones',
        'servicios',
        'LocalForageModule',
        "ngTouch",
        'socket',
        'websocket',
        'ui.utils.masks',
        'socketio.module',
        'tarifas',
        'localforage'
    ])


    .run(function ($ionicPlatform,
                   $state,
                   $timeout,
                   $interval,
                   $ionicHistory,
                   $ionicPopup,
                   $rootScope,
                   URLSERVER,
                   mobile,
                   servidor,
                   baseDatos,
                   dispositivo,
                   estado,
                   mapa,
                   sesion,
                   localStorageService) {




        // hardcodeado
        // hardcodeado
        // hardcodeado
        // hardcodeado
        // hardcodeado
        // hardcodeado para que ande el websocket puro y no socketio
        // servidor.setearTipo("websocket");


        $rootScope.vista_despacho = true;
        const VOLUMEN_MINIMO = 1.0;
        const VOLUMEN_MAXIMO = 1.0;






        function setearSistemaOperativo() {
            $rootScope.esUnAndroid = device.platform === 'Android';
            $rootScope.esUnIOS = device.platform === 'iOS';
        }






        function inicializarVariables() {


            <!-- build:apk -->
            $rootScope.apk = 'cpmobile';
            <!-- endbuild -->


            <!-- build:tipo -->
            $rootScope.tipo = 'CpMobile';
            <!-- endbuild -->


            <!-- build:desarrollo -->
            $rootScope.desarrollo = false;
            <!-- endbuild -->

            console.log("desarrollo:" + $rootScope.desarrollo);

            if (!$rootScope.desarrollo) {
                deshabilitarLogs()
            }

            $rootScope.banderaMostrarMensaje = false;


        }






        function deshabilitarLogs() {
            console.log = function () {
            };
            console.info = function () {
            };
            console.warn = function () {
            };
            console.error = function () {
            };
        }






        $ionicPlatform.ready(main);






        function main() {

            inicializarVariables();
            setearSistemaOperativo();
            escucharCambioDeEstado();  //con esto detecta cuando entra al mapa y lo refresca
            redefinirAlert();
            inicializarIdComando();
            inicializarZonasPedidas();

            if (esUnaComputadora()) {
                return
            }

            redefinirFuncionObjectEntries();
            redefinirFuncionObjectAssign();
            modificarVolumen();
            agregarListenersEstadoApp();
            iniciarConfiguracion();


            var deviceInformation = obtenerInformacionDispositivo();

            var imei = device.uuid;
            var dic = {
                imei: imei,
                version: deviceInformation.version,
                marca: deviceInformation.manufacturer,
                modelo: deviceInformation.model
            };

            mobile.setearVersionAndroid(dic.version);
            guardarInformacionDispositivo(dic);
            determinarSiHayQuePedirPermisos(dic.version);

        }






        function redefinirFuncionObjectEntries() {
            // si Object entries no esta disponible usa el polyfill. entries esta a partir del webview 54
            if (!Object.entries) {
                Object.entries = function (obj) {
                    var ownProps = Object.keys(obj),
                        i = ownProps.length,
                        resArray = new Array(i); // preallocate the Array
                    while (i--)
                        resArray[i] = [ownProps[i], obj[ownProps[i]]];

                    return resArray;
                };
            }
        }






        function redefinirFuncionObjectAssign() {
            if (typeof Object.assign != 'function') {
                Object.assign = function (target, varArgs) { // .length of function is 2
                    'use strict';
                    if (target == null) { // TypeError if undefined or null
                        throw new TypeError('Cannot convert undefined or null to object');
                    }

                    var to = Object(target);

                    for (var index = 1; index < arguments.length; index++) {
                        var nextSource = arguments[index];

                        if (nextSource != null) { // pasamos si es undefined o null
                            for (var nextKey in nextSource) {
                                // Evita un error cuando 'hasOwnProperty' ha sido sobrescrito
                                if (Object.prototype.hasOwnProperty.call(nextSource, nextKey)) {
                                    to[nextKey] = nextSource[nextKey];
                                }
                            }
                        }
                    }
                    return to;
                };
            }
        }






        function iniciarConfiguracion() {
            var prioridadBackButton = 100;
            mobile.activarModoBackground();
            mobile.mantenerPantallaEncendida();
            mobile.modificarComportamientoTeclado();
            cambiarColorStatusBar();


            // redefine comportamiento back button
            $ionicPlatform.registerBackButtonAction(function () {

                estado.determinarEstadoAir();

            }, prioridadBackButton);


            //si todavia no tengo el modelo del celular
            if (hayMarcaDelCelular()) {
                verificarSiEsHuawei();
                return;
            }

            // si no hay marca la trata de obtener
            mobile.obtenerDatosTelefono()
                .then(function (deviceInformation) {

                    //guarda la marca
                    localStorageService.set("marca", deviceInformation.manufacturer);

                    verificarSiEsHuawei();

                });

        }






        function inicializarIdComando() {
            if (localStorageService.get("idComando") == null) {
                localStorageService.set("idComando", 0);
            }
        }






        function determinarSiHayQuePedirPermisos(version) {
            var versionAndroid = parseFloat(version);
            if (versionAndroid >= 6) {
                requerirPermisosDeEjecucion();
            }
        }






        function agregarListenersEstadoApp() {

            //cuando esta offline ejecuta la funcion onOffline
            document.addEventListener("offline", onOffline, false);

            //cuando esta pausa ejecuta la funcion onPause
            document.addEventListener("pause", onPause, false);


            document.addEventListener("online", onOnline, false);
        }






        function onOnline() {
            // $rootScope.internetPrendido = true;
        }






        function redefinirAlert() {

            alert = function (msg) {
                $ionicPopup.alert({
                    title: $rootScope.tipo,
                    template: msg
                });
            };
        }






        function esUnaComputadora() {
            return !window.cordova;
        }






        function hayMarcaDelCelular() {
            return localStorageService.get("marca") != undefined;
        }






        $rootScope.salir = function () {
            mostrarMensajeConfirmacionSalida();
        };


        $rootScope.$on("cerrar_sesion", function (evento, msg) {
            console.log("llega cerrar sesion");

            if (msg['id_comando']) {
                servidor.confirmarComando(localStorageService.get('empresa'), msg['id_comando'], localStorageService.get('hash'));
            }


            $timeout(function () {
                cerrarSesion();
            }, 1000);


            if (msg.Estado) {
                return
            }

            // muestra el mensaje
            alert(msg.mensaje);

            // vuelve al login
            $timeout(function () {
                $state.go("login");
            }, 2000);

        });






        function salirDeLaApp() {
            ionic.Platform.exitApp()
        }






        function mostrarMensajeConfirmacionSalida() {

            $ionicPopup.confirm({
                title: $rootScope.tipo,
                template: '¿ Desea salir de la aplicación ?',
                okText: 'Aceptar',
                cancelText: 'Cancelar'

                //si apreta el OKtext se ejecuta la funcion
            }).then(function (acepta) {
                if (!acepta) {
                    return;
                }

                if (estaEnElLogin()) {
                    salirDeLaApp();
                    return;
                }

                ponerEstadoEnOcupado();

                //solo cierra sesion si se logueo alguna vez, ya que recien ahi se guarda el username en el localstorage
                if (!seLogueoAlgunaVez()) {
                    salirDeLaApp();
                    return;
                }

                enviarPingFinSesion();

                //lo pongo en un timeout porque me quiero garantizar que se envio el ping 3
                $timeout(function () {
                    cerrarSesion();
                    salirDeLaApp();
                }, 1300);
            });
        }






        function ponerEstadoEnOcupado() {
            //lo setea en ocupado para que cuando vuelva a iniciar sesion este ocupado
            localStorageService.set("estadoIcono", 0);
            if (localStorageService.get("estado") == 'libre') {
                localStorageService.set("estado", 'ocupado');
            }
        }






        function enviarPingFinSesion() {
            try {
                $rootScope.enviarPing(3);
            }
            catch (e) {
            }
        }






        function seLogueoAlgunaVez() {
            return sesion.obtenerDNI() != null
        }






        function estaEnElLogin() {
            return $state.current.name == 'login';
        }






        function cerrarSesion() {

            limpiarIntervalos();

            mobile.desactivarModoBackground();

            enviarCierreSesion();

        }






        function obtenerDatosSesion() {
            return sesion.obtenerSesion();
        }






        function limpiarIntervalos() {
            clearInterval($rootScope.HiloPosicion);
        }






        function esUnHuawei() {
            return localStorageService.get("marca") == "HUAWEI";
        }






        function verificarSiEsHuawei() {

            //si es un huawei muestra el mensaje indicando que tiene que poner la aplicacion como protegida
            // porque sino cuando esté en segundo plano la cerrará

            // si no es huawei sale
            if (!esUnHuawei()) {
                return
            }

            //si selecciono "no mostrar mas este mensaje", no aparece de nuevo
            if (localStorageService.get("NoMostrarMensajeAP")) {
                return
            }


            $ionicPopup.show({
                title: $rootScope.tipo,
                cssClass: 'popupHuawei',
                template: "Para que " + $rootScope.tipo + " funcione correctamente, deberá activarla como aplicación protegida.",
                buttons: [{
                    text: "Ir a activar",
                    type: 'button-positive',
                    onTap: function () {
                        cordova.plugins.ConfigAlert.alert();
                    }
                },
                    {
                        text: "No volver a mostrar",
                        type: 'button-stable',
                        onTap: function () {
                            localStorageService.set("NoMostrarMensajeAP", true);
                        }
                    }, {
                        text: "Cancelar",
                        type: 'button-stable'
                    }
                ]

                //cuando apreta el boton
            }).then(function (res) {
                console.log('respuesta de apretar el boton de activar la app como protegida: ' + res);
            });


        }






        function onPause() {
            //impide que la aplicacion entre en modo suspendido
            mobile.mantenerPantallaEncendida()
        }






        //si esta offline lo indica en el icono de internet, el ping lo pone en false, pero este se entera mas rapido, reduciendo errores
        function onOffline() {

            console.log("sin internet: ");
            // $rootScope.internetPrendido = false;
        }






        function requerirPermisosDeEjecucion() {
            // luego de las versiones 6.0 de android se debe solicitar permisos de ejecucion


            cordova.plugins.diagnostic.requestRuntimePermissions(function (statuses) {
                for (var permission in statuses) {
                    switch (statuses[permission]) {
                        case cordova.plugins.diagnostic.permissionStatus.GRANTED:
                            console.log("Permission granted to use " + permission);

                            //if (permission=='ACCESS_FINE_LOCATION')
                            //    localStorageService.set("ubicacionPermitida",true);

                            break;
                        case cordova.plugins.diagnostic.permissionStatus.NOT_REQUESTED:
                            console.log("Permission to use " + permission + " has not been requested yet");
                            break;
                        case cordova.plugins.diagnostic.permissionStatus.DENIED:
                            console.log("Permission denied to use " + permission + " - ask again?");
                            break;
                        case cordova.plugins.diagnostic.permissionStatus.DENIED_ALWAYS:
                            console.log("Permission permanently denied to use " + permission + " - guess we won't be using it then!");
                            break;
                    }
                }
            }, function (error) {
                console.error("The following error occurred: " + error);
            }, [
                cordova.plugins.diagnostic.runtimePermission.ACCESS_FINE_LOCATION,
                cordova.plugins.diagnostic.runtimePermission.ACCESS_COARSE_LOCATION,
                cordova.plugins.diagnostic.runtimePermission.RECORD_AUDIO,
                cordova.plugins.diagnostic.runtimePermission.READ_PHONE_STATE,
                cordova.plugins.diagnostic.runtimePermission.WRITE_EXTERNAL_STORAGE,
                cordova.plugins.diagnostic.runtimePermission.READ_EXTERNAL_STORAGE

            ]);
        }






        function cambiarColorStatusBar() {
            //cambiar color de la status bar. solo compatible con la version 5.1 en adelante

            if (window.StatusBar) {
                window.StatusBar.backgroundColorByHexString('#d32f2f');
            }
        }






        function obtenerInformacionDispositivo() {
            return ionic.Platform.device();
        }






        function estaEnDesarrollo() {
            return $rootScope.desarrollo;
        }






        function setearVolumenDispositivo(volumen) {
            $rootScope.volumen = volumen;
        }






        //lo tuve que poner porque cuando abría el teclado en la pantalla de cupones e iba al mapa
        //el mapa desaparecía
        function escucharCambioDeEstado() {

            $rootScope.$on('$stateChangeSuccess', function (event, toState, toParams, fromState, fromParams, options) {

                    if (toState.name == 'barra.general') {
                        $rootScope.vista_despacho = true;

                        $timeout(function () {
                            try {
                                if (angular.isDefined(mapa.obtenerMapa())) {
                                    mapa.refrescarMapa();
                                }
                            } catch (e) {

                            }
                        }, 20);
                    }
                }
            );
        }






        function inicializarZonasPedidas() {
            localStorageService.set("zonas_pedidas", null);
            localStorageService.set("movilesEnZonaActual", null);
            localStorageService.set("zona_actual", ["-", "-"]);
        }






        function modificarVolumen() {
            if ($rootScope.esUnAndroid) {
                if (estaEnDesarrollo()) {
                    setearVolumenDispositivo(VOLUMEN_MINIMO);
                } else {
                    setearVolumenDispositivo(VOLUMEN_MAXIMO);
                }
            }
        }






        function guardarInformacionDispositivo(dic) {
            localStorageService.set("dispositivo", dic);
        }






        function enviarCierreSesion() {
            var datosSesion = obtenerDatosSesion();
            servidor.getConexion().emit('cerrar_sesion', datosSesion, function () {
                console.log('emit cerrar sesion realizado: ');
            });

            console.log('dni' + datosSesion['dni'] + ' empresa:' + datosSesion['empresa']);
        }
    })

    //permite configurar los servicios tipo provider. aqui se configuran
    .config(function ($stateProvider, $urlRouterProvider, $ionicConfigProvider, $compileProvider) {
        ////posibles funciones que mejoran el rendimiento en produccion. no anda con el angular que uso :(
        //el angular no lo puedo actualizar porque sino deja de andar sliding tabs.
        //disponibles desde la version 1.5.9

        //$compileProvider.commentDirectivesEnabled(false);
        //$compileProvider.cssClassDirectivesEnabled(false);
        //es un texto que aparece en algunas lineas cuando debugueas la app en el browser
        $compileProvider.debugInfoEnabled(false);


        $ionicConfigProvider.tabs.position("top");
        $ionicConfigProvider.navBar.alignTitle("center");

        //establecimiento de estados, asociacion de url templates y posiblemente controladores


        $stateProvider

            .state('login', {
                url: '/login',
                templateUrl: 'templates/login.html',
                controller: 'LoginController'
            })

            .state('loginConfiguracion', {
                url: '/loginConfiguracion',
                templateUrl: 'configuracion/templates/loginConfiguracion.html',
                controller: 'loginConfiguracionController'
            })

            .state('formularioConfiguracion', {
                url: '/formularioConfiguracion',
                templateUrl: 'configuracion/templates/formularioConfiguracion.html',
                controller: 'formularioConfiguracionController'
            })

            .state('barra', {
                controller: 'BarraController',
                templateUrl: 'templates/barra.html'
            })

            .state('barra.general', {
                url: '/general',
                templateUrl: 'templates/general.html',
                reloadOnSearch: false
            })


            .state('barra.general.tarifador', {
                url: '/tarifador',
                views: {
                    '': {
                        templateUrl: 'tarifas/tarifador.html',
                        controller: 'tarifasController',
                    },
                    'botonAudio@barra.general.tarifador': {
                        controller: 'botonAudioController',
                        templateUrl: 'js/botonAudio/botonAudio.html'
                    }
                }
            })

            .state('barra.general.credito', {
                url: '/credito',
                templateUrl: 'templates/credito.html',
                controller: 'CreditoController'
            })

            .state('barra.general.creditos', {
                url: '/creditos',
                templateUrl: 'templates/creditos.html',
                controller: 'CreditosController'
            })

            .state('barra.general.listadoCupones', {
                url: '/listadoCupones',
                templateUrl: 'js/cupones/templates/listadoCupones.html',
                controller: 'CuponesController'
            })

            .state('barra.general.verCupon', {
                url: '/verCupon',
                templateUrl: 'js/cupones/templates/verCupon.html',
                controller: 'VerCuponController'
            })

            .state('barra.general.formularioCupon', {
                url: 'formularioCupon',
                templateUrl: 'js/cupones/templates/formularioCupon.html',
                controller: 'FormularioController'
            })

            .state('barra.general.formularioCupon.dniYpin', {
                url: '/dniYpin',
                templateUrl: 'js/cupones/templates/dniYpin.html',
                controller: 'DniYpinController'
            })

            // .state('barra.general.formularioCupon.pass', {
            //     url: '/pass',
            //     templateUrl: 'js/cupones/templates/pass.html',
            //     controller: 'PassController'
            // })

            .state('barra.general.servicios', {
                url: '/servicios',
                templateUrl: 'js/servicios/templates/servicios.html',
                controller: 'ServiciosController'
            })

            // .state('barra.general.detalleServicio', {
            //     url: '/servicios',
            //     templateUrl: 'js/servicios/templates/detalleServicio.html',
            //     controller: 'DetalleServicioController',
            //
            //     params: {
            //         id_servicio_seleccionado: null
            //     }
            // })

            .state('barra.general.importeServicio', {
                url: '/importeServicio',
                templateUrl: 'js/servicios/templates/importeServicio.html',
                controller: 'ImporteController'
            })

            .state('tarifas', {
                url: '/tarifas',
                controller: 'tarifasController'
            })

            .state('prueba', {
                url: '/prueba',
                templateUrl: 'templates/prueba.html'
            })
            //
            .state('inicial', {
                url: '/inicial',
                templateUrl: 'pruebas/serial.html'

            });


        // por defecto va al estado login
        $urlRouterProvider.otherwise('/login');






        function resolve(index, timeout) {
            return {
                data: function ($q, $timeout) {
                    var deferred = $q.defer();
                    $timeout(function () {
                        deferred.resolve(console.log('Data resolve called ' + index));
                    }, timeout);
                    return deferred.promise;
                }
            };
        }

    });


//si uso esto, tengo que inyectar exceptionoverwrite en el modulo principal
//puedo usar esto o puedo usar un decorador para expandir la funcionalidad de exception handler


//un decorador es para agregar funcionalidad a una funcion, sin sobreescribirla completamente
//app.decorator("$exceptionHandler", function ($delegate) {
//    return function (exception, cause) {
//        $delegate(exception, cause);
//        console.log(exception.message);
//    }
//});

//asi puedo DERIVAR la excepcion
//try { ... } catch(e) { $exceptionHandler(e); }

// { $exceptionHandler(e); }
//
// { $exceptionHandler(e); }


// .directive('smartFloat', function ($filter) {
//     var FLOAT_REGEXP_1 = /^\$?\d+.(\d{3})*(\,\d*)$/; //Numbers like: 1.123,56
//     var FLOAT_REGEXP_2 = /^\$?\d+,(\d{3})*(\.\d*)$/; //Numbers like: 1,123.56
//     var FLOAT_REGEXP_3 = /^\$?\d+(\.\d*)?$/; //Numbers like: 1123.56
//     var FLOAT_REGEXP_4 = /^\$?\d+(\,\d*)?$/; //Numbers like: 1123,56
//
//     return {
//         require: 'ngModel',
//         link: function (scope, elm, attrs, ctrl) {
//             ctrl.$parsers.unshift(function (viewValue) {
//                 if (FLOAT_REGEXP_1.test(viewValue)) {
//                     ctrl.$setValidity('float', true);
//                     return parseFloat(viewValue.replace('.', '').replace(',', '.'));
//                 } else if (FLOAT_REGEXP_2.test(viewValue)) {
//                     ctrl.$setValidity('float', true);
//                     return parseFloat(viewValue.replace(',', ''));
//                 } else if (FLOAT_REGEXP_3.test(viewValue)) {
//                     ctrl.$setValidity('float', true);
//                     return parseFloat(viewValue);
//                 } else if (FLOAT_REGEXP_4.test(viewValue)) {
//                     ctrl.$setValidity('float', true);
//                     return parseFloat(viewValue.replace(',', '.'));
//                 }else {
//                     ctrl.$setValidity('float', false);
//                     return undefined;
//                 }
//             });
//
//             ctrl.$formatters.unshift(
//                 function (modelValue) {
//                     return $filter('number')(parseFloat(modelValue) , 2);
//                 }
//             );
//         }
//     };
// })
//
//
//
//
// .directive('prueba', function() {
//     return {
//         require: 'ngModel',
//         link: function(scope, element, attrs, ngModelController) {
//             ngModelController.$parsers.push(function(data) {
//                 //convert data from view format to model format
//                 return data; //converted
//             });
//
//             ngModelController.$formatters.push(function(data) {
//                 //convert data from model format to view format
//                 data=data*.00;
//                 ngModelController.$setViewValue(data);
//                 ngModelController.$render();
//                 return data; //converted
//             });
//         }
//     }
// })