/**
 * Creado por ivan fecha 12/01/18.
 */
(function(angular){
    "use strict";
    angular
        .module('bluetooth')
        .factory('beacon', beacon);
    
    function beacon($cordovaBeacon,
                    $rootScope,
                    $q){



        var regiones = [];

        var factory = {


            estaRangingDisponible : estaRangingDisponible,
            crearRegion : crearRegion,
            detenerMonitorizarRegion : detenerMonitorizarRegion,
            detenerRangingBeacon : detenerRangingBeacon,
            empezarMonitorizarRegion : empezarMonitorizarRegion,
            empezarRangingBeacon : empezarRangingBeacon,
            estaPrendido : estaBluetoothPrendido,
            getMonitoredRegions : getMonitoredRegions,
            getRangedRegions : getRangedRegions,
            inicializar : inicializar,
            encender : prenderBluetooth,
            requestStateForRegion : requestStateForRegion,
            solicitarAutorizacion : solicitarAutorizacion,
            verificarTipoBeacon : verificarTipoBeacon


        };



        return factory;




        function inicializar (){

            var brIdentifier = 'AT05527';
            var brUuid = null;
            var brMajor = null;
            var brMinor = null;
            var brNotifyEntryStateOnDisplay = true;

            regiones[0] = crearRegion(brIdentifier, brUuid, brMajor, brMinor, brNotifyEntryStateOnDisplay); //crea una region que solo vera los beacons de los dispositivos con identificador 'at05527'
            empezarRangingBeacon(regiones[0]); //empieza a escuchar cuando hay beacons disponibles
            registrarEscucha(); //cada 1100 ms se ejecuta esta, es el 'socketon de beacons'

        }





        function estaRangingDisponible (){
            return $cordovaBeacon.isRangingAvailable().then(function(){
                console.log("esta ranging disponible");
            },function() {
                console.warn("no esta ranging disponible");
            })
        }








        //retorna true si en el mensaje indica que pertenece al grupo de los panicos
        function verificarTipoBeacon (beacon) {
           //console.log("beacon"+JSON.stringify(beacon));
           
            var major = beacon.major;
            var minor = beacon.minor;
            //console.warn("mayor: " + major);
            //console.log("menor: " + minor);

            if (major == 200) return 999; //ping
            if (major == 100 && minor == 10) return 1;
            if (major == 100 && minor == 20) return 2;
            if (major == 100 && minor == 30) return 3;


        }






        function solicitarAutorizacion() {
            $cordovaBeacon.requestAlwaysAuthorization();
        }







        function crearRegion(brIdentifier, brUuid, brMajor, brMinor, brNotifyEntryStateOnDisplay) {

            return $cordovaBeacon.createBeaconRegion(
                brIdentifier, brUuid, brMajor, brMinor, brNotifyEntryStateOnDisplay
            )
        }




        //monitorizar es estar atento a la llegada de un uuid especifico, cada vez que detecte uno "entra en la region" y 25 segundos despues de que no detecta uno
        //"sale de la region"

        function empezarMonitorizarRegion (region) {
            $cordovaBeacon.startMonitoringForRegion(region);
        }







        //detecta si h
        function empezarRangingBeacon (region) {
            $cordovaBeacon.startRangingBeaconsInRegion(region);
        }







        function detenerMonitorizarRegion(region) {
            $cordovaBeacon.stopMonitoringForRegion(region);
        }







        function detenerRangingBeacon(region) {
            $cordovaBeacon.stopRangingBeaconsInRegion(region);
        }







        function getMonitoredRegions() {
            return $cordovaBeacon.getMonitoredRegions();
        }







        function getRangedRegions() {
            return $cordovaBeacon.getRangedRegions();
        }






        function requestStateForRegion () {
            $cordovaBeacon.getRangedRegions();
        }





        function prenderBluetooth() {
            var defer = $q.defer();

            $cordovaBeacon.enableBluetooth(exito, falla);

            function exito() {
                defer.resolve();
            }

            function falla() {
                defer.reject();
            }

            return defer.promise;

        }















        function registrarEscucha() {


            //HAY BEACON EN LA REGION. es el mas importante. cada 1100 entra aca. haya o no beacons
            $rootScope.$on('$cordovaBeacon:didRangeBeaconsInRegion', function (event, pluginResult) {
                //console.log("RECIBIDO EN DID RANGE BEACONS IN REGION" + JSON.stringify(pluginResult));
                $rootScope.$emit("beaconEnRegion", pluginResult);
            });




            //asi seria lo que recibo
            //var a = {
            //    "eventType": "didRangeBeaconsInRegion",
            //    "region": {
            //        "identifier": "AT05527",
            //        "uuid": "e2c56db5-dffb-48d2-b060-d0f5a71096e0",
            //        "typeName": "BeaconRegion"
            //    },
            //    "beacons": [{
            //        "uuid": "e2c56db5-dffb-48d2-b060-d0f5a71096e0",
            //        "major": "1000",
            //        "minor": "999",
            //        "proximity": "ProximityImmediate",
            //        "rssi": -51,
            //        "tx": -61,
            //        "accuracy": 0.21
            //    }]
            //};

            ////llamda cuando sale de la region
            //$rootScope.$on('$cordovaBeacon:didExitRegion', function (event, pluginResult) {
            //    console.log("RECIBIDO EXIT" + JSON.stringify(pluginResult));
            //    $rootScope.$emit("salioDeRegion", pluginResult);
            //
            //});
            //
            ////llamada cuando se entra a la region
            //$rootScope.$on('$cordovaBeacon:didEnterRegion', function (event, pluginResult) {
            //    console.log("RECIBIDO ENTER REGION:" + JSON.stringify(pluginResult));
            //    $rootScope.$emit("entroARegion", pluginResult);
            //
            //});
            //
            ////llamada cuando comenzo a monitorizar la region
            //$rootScope.$on('$cordovaBeacon:didStartMonitoringForRegion', function (event, pluginResult) {
            //    console.log("RECIBIDO DID START MONITORING FOR REGION" + JSON.stringify(pluginResult));
            //    $rootScope.$emit("comenzoAmonitorizar", pluginResult);
            //
            //});
            //
            ////llamada cuando no hay beacons o si cambio el estado
            //$rootScope.$on('$cordovaBeacon:didDetermineStateForRegion', function (event, pluginResult) {
            //    console.log("RECIBIDO DETERMINA EL ESTADO PARA LA REGION:" + JSON.stringify(pluginResult));
            //    $rootScope.$emit("determinaEstadoDeRegion", pluginResult);
            //
            //});
            //
            //
            //$rootScope.$on('$cordovaBeacon:didChangeAuthorizationStatus', function (event, pluginResult) {
            //    console.log("RECIBIDO DID CHANGE AUTORIZATION ASTATUS" + JSON.stringify(pluginResult));
            //    $rootScope.$emit("cambioEstadoAutorizacion", pluginResult);
            //
            //});
            //
            //$rootScope.$on('$cordovaBeacon:peripheralManagerDidUpdateState', function (event, pluginResult) {
            //    console.log("RECIBIDO PERIPHERAL MANAGER" + JSON.stringify(pluginResult));
            //    $rootScope.$emit("actualizacionPerifericos", pluginResult);
            //
            //});
            //
            //$rootScope.$on('$cordovaBeacon:peripheralManagerDidStartAdvertising', function (event, pluginResult) {
            //    console.log("RECIBIDO peripheralManagerDidStartAdvertising" + JSON.stringify(pluginResult));
            //    $rootScope.$emit("escuchaPerifericos", pluginResult);
            //
            //});

        }









        function estaBluetoothPrendido() {
            var defer = $q.defer();
            $cordovaBeacon.isBluetoothEnabled().then(function (valor) {
                if (valor)
                    defer.resolve();
                else defer.reject();
            });
            return defer.promise;
        }

        

    }
    
})(angular);