angular  .module('bluetooth')
        .factory('lowEnergy', lowenergy);





    function lowenergy($q) {


        var factory = {

            apagar: apagar,
            autoconectar: autoconectar,
            conectar: conectar,
            desconectar: desconectar,
            detenerEscaneo: detenerEscaneo,
            escanear: escanear,
            escribir: escribir,
            estaConectado: estaConectado,
            leerDesdeServicio: leerDesdeServicio,
            encender: encender,
            readRSSI: readRSSI


        };

        return factory;


        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////
        //implementaciones
        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////

        function estaConectado(mac) {
            var defer = $q.defer();
            ble.isConnected(mac, function () {
                    console.log("dispositivo conectado");
                    defer.resolve();
                },
                function () {
                    console.log("dispositivo desconectado");
                    defer.reject();

                }
            );
            return defer.promise;

        }





        function apagar() {
            var defer = $q.defer();
            bluetoothle.disable(disableSuccess, disableError);





            function disableSuccess() {
                defer.resolve();


            }





            function disableError() {
                defer.reject();

            }





            return defer.promise;

        }





        function escanear(dispositivos, tiempoBusqueda) {

            console.log("entra en scanear");

            var defer = $q.defer();

            if (dispositivos == null) {
                dispositivos = [];
            }

            ble.scan(dispositivos, tiempoBusqueda, exito, falla);





            function exito(valor) {
                defer.resolve(valor);
                console.log("escaneados" + JSON.stringify(valor));
            }





            function falla() {
                defer.reject();
            }





            return defer.promise;

        }





        function escribir(mac, servicio, caracteristica, valor) {

            if (!valor) {
                valor = 0x07
            }

            console.log("entro en enviar write: ");


            var defer = $q.defer();

            var data = new Uint8Array(1);
            data[0] = valor; // mechanical switch

            console.log("datbufer es: " + data.buffer);

            //solo write no anda
            ble.writeWithoutResponse(mac, servicio, caracteristica, data.buffer, exito, falla);





            function exito() {
                console.error("cancelamiento de alarma enviado");
                defer.resolve();
            }





            function falla() {
                console.error("cancelamiento de alarma no enviado");
                defer.reject();
            }





            //
            //ble.writeWithoutResponse("00:0B:57:28:15:97", "1809", "2a21", stringToBytes('2'), suc29, fail29);
            //function suc29() {
            //    console.log("enviado29: ");
            //}
            //
            //function fail29() {
            //    console.log("no enviado29: ");
            //}
            //
            //
            //ble.write("00:0B:57:28:15:97", "1800", "2a00", stringToBytes('AT00000'), sucwrite, failwrite);
            //
            //function sucwrite() {
            //    console.log("enviado por write1: ");
            //}
            //
            //function failwrite() {
            //    console.log("no enviado por write1: ");
            //}
            //
            //
            //ble.write("00:0B:57:28:15:97", "1809", "2a21", stringToBytes('2'), sucwrite9, failwrite9);
            //
            //function sucwrite9() {
            //    console.log("enviado por write9: ");
            //}
            //
            //function failwrite9() {
            //    console.log("no enviado por write9: ");
            //}

            return defer.promise;


        }





        function detenerEscaneo() {
            var defer = $q.defer();

            ble.stopScan(function () {
                defer.resolve();
                console.log("detener escaneo");
            }, function () {
                defer.reject();
                console.log("no pudo detener escaneo");
            });

            return defer.promise;
        }





        function conectar(uuidOmac) {
            var defer = $q.defer();

            ble.connect(uuidOmac, exito, falla);





            function exito(valor) {
                defer.resolve(valor);
                console.log("si se pudo conectar");
            }





            function falla(valor) {
                defer.reject(valor);
                console.log("no se pudo conectar");
            }





            return defer.promise;

        }





        function autoconectar(uuidOmac) {
            var defer = $q.defer();

            ble.autoConnect(uuidOmac, exito, falla);





            function exito(valor) {
                defer.resolve(valor);
            }





            function falla(valor) {
                defer.reject(valor);
            }





            return defer.promise;

        }





        function desconectar(uuidOmac) {
            var defer = $q.defer();

            ble.disconnect(uuidOmac, exito, falla);





            function exito(valor) {
                defer.resolve(valor);
            }





            function falla() {
                defer.reject();
            }





            return defer.promise;

        }





        function readRSSI(device_id) {
            var defer = $q.defer();
            ble.readRSSI(device_id, function (rssi) {
                defer.resolve(rssi);
            }, function (err) {
                defer.reject(err);
            });

            return defer.promise;
        }





        function encender() {

            var defer = $q.defer();

            ble.enable(function () {
                defer.resolve();
            }, function () {
                defer.reject();
            });

            return defer.promise;
        }





        function leerDesdeServicio(mac, servicio, caracteristica) {
            var defer = $q.defer();

            ble.read(mac, servicio, caracteristica, exito, falla);





            function exito(valor) {
                defer.resolve(valor);
            }





            function falla() {
                defer.reject();
            }





            return defer.promise;

        }


    }

