angular
    .module('bluetooth', [])
    .service('bluetooth', bluetooth);





function bluetooth($rootScope,
                   $q,
                   lowEnergy,
                   serial,
                   beacon,
                   $timeout) {

    var tecnologiaUsada;  //define cual es la tecnologia bluetooth que usara el dispositivo. 'ble' o 'edr'.
    var claseBluetooth;
    var usaBluetooth;
    var beaconDisponible;
    var estaVivaConexion;
    var usaModuloCercania;

    var dentro = false;

    var factory = {

        autoconectar: autoconectar,
        apagar: apagar,
        conectar: conectar,
        //conectarInseguro : conectarInseguro,
        crearRegion: crearRegion,
        confirmarAlarmaAlModulo: confirmarAlarmaAlModulo,
        desconectar: desconectar,
        descubrirEmparejados: descubrirEmparejados,
        descubrirDesparejados: descubrirDesparejados,
        desuscribir : desuscribir,
        //desuscribirRawData : desuscribirRawData,
        detenerEscaneo: detenerEscaneo,
        disponible: disponible,
        //detenerMonitorizarRegion : detenerMonitorizarRegion,
        //detenerRangingBeacon : detenerRangingBeacon,
        determinarBluetoothAusar: determinarBluetoothAusar,
        //disponible : disponible,
        //empezarMonitorizarRegion : empezarMonitorizarRegion,
        //empezarRangingBeacon : empezarRangingBeacon,
        enviarPrenderLuz: enviarPrenderLuz,
        escanear: escanear,
        estaPrendido: estaPrendido,
        estaConectado: estaConectado,
        //estaPrendido : estaPrendido,
        //getMonitoredRegions : getMonitoredRegions,
        //getRangedRegions : getRangedRegions,
        //hacerDescubrible : hacerDescubrible,
        inicializar: inicializar,
        inicializarBeacon: inicializarBeacon,
        leer: leer,
        //leerDesdeServicio : leerDesdeServicio,
        //leerHasta : leerHasta,
        //leerRSSI : leerRSSI,
        limpiar: limpiar,
        //limpiarListener : limpiarListener,
        //listar : listar,
        //mostrarSettings : mostrarSettings,
        obtenerQueUsaBluetooth: obtenerQueUsaBluetooth,
        obtenerUsaModuloCercania: obtenerUsaModuloCercania,
        obtenerTecnologiaBluetooth: obtenerTecnologiaBluetooth,
        obtenerEstaVivaConexion: obtenerEstaVivaConexion,
        encender: encender,
        //readRSSI : readRSSI,
        setearQueUsaBluetooth: setearQueUsaBluetooth,
        setearTecnologiaBluetooth: setearTecnologiaBluetooth,
        setearEstaVivaConexion: setearEstaVivaConexion,
        obtenerBeaconDisponible: obtenerBeaconDisponible,
        setearBeaconDisponible: setearBeaconDisponible,
        setearUsaModuloCercania: setearUsaModuloCercania,
        subscribir: subscribir,
        vincular: vincular,
        estaRangingDisponible: isRangingAvailable,
        subscribirRaw: subscribirRaw,
        escribir: escribir,


    };


    return factory;



    function enviarPrenderLuz() {

        var datoConfirmacion = new Uint8Array(1); //envia un dato al modulo



        datoConfirmacion[0] = 34;

        return serial.escribir(datoConfirmacion)

    }


    function escribir(dato) {
        return serial.escribir(dato)
    }





    function limpiar() {
        return serial.limpiar();
    }





    function subscribirRaw() {
        return serial.subscribirRawData();
    }





    function subscribir() {
        return serial.subscribir();
    }


    function desuscribir (){
        return serial.desuscribir()
    }



    function disponible() {
        return serial.disponible();
    }





    function setearUsaModuloCercania(valor) {
        usaModuloCercania = valor;
    }





    function obtenerUsaModuloCercania() {
        return usaModuloCercania
    }





    function apagar() {
        return claseBluetooth.apagar()
    }





    function descubrirEmparejados() {
        return claseBluetooth.descubrirEmparejados();
    }





    function descubrirDesparejados() {
        return claseBluetooth.descubrirDesparejados();
    }





    function vincular(mac, pin) {
        return claseBluetooth.vincular(mac, pin)
    }





    function inicializar() {

        encender(); //prende el bluetooth automáticamente

    }





    function estaConectado(mac) {
        return claseBluetooth.estaConectado(mac);
    }





    function desconectar(mac) {
        return claseBluetooth.desconectar(mac)
    }





    function obtenerEstaVivaConexion() {
        return estaVivaConexion;
    }





    function setearEstaVivaConexion(valor) {
        estaVivaConexion = valor;
    }





    function detenerEscaneo() {
        return claseBluetooth.detenerEscaneo();
    }





    function inicializarBeacon() {
        beacon.inicializar();
    }





    function isRangingAvailable() {
        return beacon.estaRangingDisponible()
    }





    //devuelve si esta disponible en el dispositivo la tecnologia beacon
    function obtenerBeaconDisponible() {
        return beaconDisponible;
    }





    function setearBeaconDisponible(disponible) {
        beaconDisponible = disponible;
    }





    function estaPrendido() {

        return claseBluetooth.estaPrendido();
    }





    function crearRegion() {
        beacon.crearRegion();
    }





    // hay que hacer esto porque una vez que se desconecta del dispositivo,
    // recien pasa 20 segundos para que pueda conectarse nuevamente y cancelar la alarma/
    function iniciarTimeoutParaCancelamiento() {
        dentro = true;
        $timeout(function () {
            dentro = false
        }, 22000)
    }





    function estaDentroDelTimeout() {
        return dentro;
    }





    function confirmarAlarmaAlModulo(mac, servicio, caracteristica, valor) {

        console.error(dentro);
        if (estaDentroDelTimeout()) {
            console.error("dentro del timeout");
            return
        }


        //aca tengo que ver que tipo de bluetooth tiene para cancelar la alarma
        console.log("entro en confirmar alarma: ");


        if (tecnologiaUsada == 'serial') {

            return escribirSerial('0xAAAAAAAA').then(function () {
                console.log("pudo escribir");
            }, function () {
                console.log("falla escribir");
            });

        }


        else if (tecnologiaUsada == "lowenergy") {

            return detenerEscaneo().then(function () {
                console.log("pudo detener escaneo");
                escanear(null, 4).then(function () {
                    console.log("pudo escanear");
                    conectar(mac).then(function () {
                        console.log("pudo conectar");
                        escribirLowEnergy(mac, servicio, caracteristica).then(function () {
                            console.log("pudo escribir");

                            // hay que hacer esto porque una vez que se desconecta del dispositivo,
                            // recien pasa 20 segundos para que pueda conectarse nuevamente y cancelar la alarma/
                            iniciarTimeoutParaCancelamiento();
                        }, function () {
                            console.log("falla escribir");
                        });
                    }, function () {
                        console.log("falla conectar");
                    });
                }, function () {
                    console.log("falla escanear");
                });
            }, function () {
                console.log("falla detenerescaneo");
            });

        }

    }





    //setea el tipo de bluetooth que usa, por defecto asigna low energy
    function setearTecnologiaBluetooth(bluetoothParametro) {

        if (!bluetoothParametro) {
            bluetoothParametro = 'lowenergy'
        }

        tecnologiaUsada = bluetoothParametro;

    }





    //obtiene la tecnologiausada
    function obtenerTecnologiaBluetooth() {

        return tecnologiaUsada

    }





    function setearQueUsaBluetooth(valor) {
        usaBluetooth = valor;
    }





    function obtenerQueUsaBluetooth() {
        return usaBluetooth;
    }





    //verifica que bluetooth es el que puede usar el dispositivo
    function determinarBluetoothAusar() {
        var defer = $q.defer();


        //hacer logica para determinar que tecnologia usaria
        // devuelve serial a proposito y por defecto
        if ('a' != 'a') {
            claseBluetooth = lowEnergy; //obtiene al servicio entero y ya tiene disponibles los metodos
            setearTecnologiaBluetooth('lowenergy');
        } else {
            claseBluetooth = serial;
            setearTecnologiaBluetooth('serial');
        }

        defer.resolve(tecnologiaUsada);

        return defer.promise;
    }





    function autoconectar() {
        if (tecnologiaUsada != 'ble') {
            return false
        }
        return claseBluetooth.autoconectar();

    }





    function encender() {
        //llama el metodo del bluetooth correspondiente y lo devuelve

        //si esta beacon disponible usa el encender de beaocn que anda bien
        if (beaconDisponible) {
            return beacon.encender();

            //sino usa el que este disponible
        } else {
            return claseBluetooth.encender();
        }

    }





    function escanear(uuid, tiempo) {

        if (tecnologiaUsada != 'lowenergy') {
            return false
        }

        return claseBluetooth.escanear(uuid, tiempo);

    }





    //conecta con el dispositivo
    function conectar(uuid) {
        return claseBluetooth.conectar(uuid);
    }





    //envia un dato al dispositivo
    function escribirLowEnergy(mac, servicio, caracteristica, valor) {

        //determinar tipo de bluetooth para distintos métodos de escritura
        return claseBluetooth.escribir(mac, servicio, caracteristica, valor);
    }





    function escribirSerial(valor) {

        //determinar tipo de bluetooth para distintos métodos de escritura
        return claseBluetooth.escribir(valor);
    }





    function leer() {
        return serial.leer()
    }


}
