/**
 * Creado por ivan fecha 12/01/18.
 */

    angular
        .module('bluetooth')
        .factory('serial', serial);





    function serial($rootScope,$q, ConversionesService, notificaciones) {


        var factory = {


            conectar: conectar,
            //conectarInseguro : conectarInseguro,
            desconectar: desconectar,
            descubrirDesparejados: descubrirDesparejados,
            descubrirEmparejados: descubrirEmparejados,
            desuscribir: desuscribir,
            //desuscribirRawData : desuscribirRawData,
            disponible: disponible,
            escribir: escribir,
            estaConectado: estaConectado,
            estaPrendido: estaPrendido,
            //hacerDescubrible : hacerDescubrible ,
            leer: leer,
            leerHasta: leerHasta,
            //leerRSSI : leerRSSI,
            limpiar: limpiar,
            //limpiarListener : limpiarListener,

            //mostrarSettings : mostrarSettings,
            encender: encender,
            //setearListener :  setearListener,
            //setearNombre : setearNombre,
            subscribir: subscribir,
            subscribirRawData: subscribirRawData,
            vincular: vincular


        };


        return factory;





        function concatBytes(ui8a, byte) {
            var b = new Uint8Array(1);
            b[0] = byte;
            return concatTypedArrays(ui8a, b);
        }





        function subscribirRawData() {

            var defer = $q.defer();

            limpiar();

            bluetoothSerial.subscribeRawData(function (data) {

                console.log("data:"+data);
                var bytes = new Uint8Array(data);
                limpiar();
                console.error("bytes:"+bytes);
                defer.resolve(bytes);


                // notificaciones.anunciar("aba",bytes)

                $rootScope.$emit("aba", bytes)

            }, function () {
                defer.reject();
            });
            return defer.promise;
        }





        function descubrirEmparejados() {
            var defer = $q.defer();

            bluetoothSerial.list(success, fail);





            function success(datos) {
                defer.resolve(datos);
            }





            function fail() {
                defer.reject();
            }





            return defer.promise;
        }





        function subscribir() {

            var defer = $q.defer();

            bluetoothSerial.subscribe('\r\n', function (data) {

                // console.log("se suscribio");
                defer.resolve(data);

                $rootScope.$emit("rta_subscribe", data)
            }, function () {

                defer.reject("no se pudo suscribir");
            });

            return defer.promise;
        }





        function leer() {

            var defer = $q.defer();

            bluetoothSerial.read(function (data) {

                defer.resolve(data);
            }, function () {
                defer.reject()
            });


            return defer.promise;
        }





        function descubrirDesparejados() {

            var defer = $q.defer();

            console.log("descubriendo desparejados");
            bluetoothSerial.discoverUnpaired(success, failure);





            function success(data) {
                console.log(data);
                defer.resolve(data);
            }





            function failure() {

                defer.reject()
            }





            return defer.promise;
        }





        function descubrirEmparejados() {
            var defer = $q.defer();

            bluetoothSerial.list(success, failure);





            function success(data) {
                console.log(data);
                defer.resolve(data);
            }





            function failure() {

                defer.reject()
            }





            return defer.promise;
        }





        function limpiar() {

            var defer = $q.defer();

            bluetoothSerial.clear(success, failure);





            function success() {

                defer.resolve();
            }





            function failure() {

                defer.reject()
            }





            return defer.promise;
        }





        function desuscribir() {

            var defer = $q.defer();

            bluetoothSerial.unsubscribe(success, failure);





            function success() {

                defer.resolve();
            }





            function failure() {

                defer.reject()
            }





            return defer.promise;
        }





        function encender() {

            var defer = $q.defer();

            bluetoothSerial.enable(success, failure);





            function success() {

                defer.resolve();

            }





            function failure() {



                defer.reject()
            }





            return defer.promise;
        }





        function conectar(mac) {

            var defer = $q.defer();

            bluetoothSerial.connect(mac, success, failure);





            function success(data) {
                console.log(data);
                defer.resolve(data);
            }





            function failure() {
                console.log();
                defer.reject()
            }





            return defer.promise;
        }





        function leerHasta(valor) {
            if (!valor) {
                valor = '\n'
            }

            var defer = $q.defer();

            bluetoothSerial.readUntil(valor, success, failure);





            function success(data) {
                console.log(data);
                defer.resolve(data);
            }





            function failure() {
                console.log();
                defer.reject()
            }





            return defer.promise;
        }





        function disponible() {

            var defer = $q.defer();

            bluetoothSerial.available(success, failure);





            function success(data) {
                console.log(data);
                defer.resolve(data);
            }





            function failure() {
                console.log();
                defer.reject()
            }





            return defer.promise;
        }





        function escribir(data) {
            var defer = $q.defer();
            bluetoothSerial.write(data, success, failure);





            function success() {

                defer.resolve();
            }





            function failure() {

                defer.reject()
            }





            return defer.promise;
        }





        function vincular(mac, pin) {

            var defer = $q.defer();

            bluetoothSerial.pair(mac, pin, function (data) {

                console.error("entra a a pair");
                defer.resolve(data);

            }, function () {

                defer.reject("no se pudo vincular");

            });

            return defer.promise;

        }





        function estaConectado() {

            var defer = $q.defer();

            bluetoothSerial.isConnected(success, failure);





            function success() {
                console.log();
                defer.resolve();
            }





            function failure() {
                console.log();
                defer.reject()
            }





            return defer.promise;
        }





        function estaPrendido() {


            var defer = $q.defer();

            bluetoothSerial.isEnabled(success, failure);





            function success() {
                console.log();
                defer.resolve();
            }





            function failure() {
                console.log();
                defer.reject()
            }





            return defer.promise;
        }





        function desconectar() {

            var defer = $q.defer();

            bluetoothSerial.disconnect(success, failure);





            function success() {
                console.log();
                defer.resolve();
            }





            function failure() {
                console.log();
                defer.reject()
            }





            return defer.promise;
        }


    }
