angular
    .module('starter')
    .controller('AudioController', AudioController);





function AudioController($scope,
                         $rootScope,
                         $interval,
                         $ionicLoading,
                         ImageCacheFactory,
                         $state,
                         servidor,
                         $timeout,
                         $cordovaMedia,
                         archivos,
                         audio,
                         ImagePreloader,
                         localStorageService,
                         notificaciones) {


    $scope.$on("destroy", function (event, data) {
        if (angular.isDefined($scope.timeoutCuentaRegresiva)) {
            $interval.cancel($scope.timeoutCuentaRegresiva);

        }

        inicializarVariables();
    });


    $scope.borraArchivo = impostorBorrarArchivo;





    function inicializarVariables() {
        $scope.beepGrabacion = null;
        $scope.texto = null;
        $scope.tiempoReproducidoAudio = null;
        $scope.totalAudio = null;
        $scope.playVisible = null;
        $rootScope.girador = null;
        $rootScope.cambiaImagenBoton = null;
        $scope.audioGrabado = null;
        $scope.btnReproducirAudio = null;
        $scope.presionarBotonGrabacion = null;
        $scope.soltarBotonGrabacion = null;
        $scope.reproducir = null;
        $scope.reproducirSiguiente = null;
        $scope.playOrStop = null;
        $scope.detenerAudio = null;
        $scope.audios = [];
        $scope.permiteReproduccion = null;
        $scope.terminoDeConvertir = null;
    }





    ImagePreloader.preloadImages([
        "img/btn_audio_hablar_error_426px.png",
        "img/btn_audio_hablar_espera_1_426px.png",
        "img/btn_audio_hablar_centro.png",
        "img/btn_audio_hablar_normal_426px2.png",
        "img/btn_audio_hablar_presionado_426px.png",
        "img/btn_audio_press@4x.png",
        "img/btn_chat_press@4x.png",
        "img/btn_inicio_press@4x.png",
        "img/btn_zonas_press@4x.png",
        "img/btn_inicio_normal@4x.png",
        "img/casita.png",
        "img/flag.png",
        "img/ic_datos_nulo_48px.png",
        "img/ic_posicion_activa_48px.png",
        'img/ic_saldo_consumos_normal@4x.png',
        'img/ic_cupones_normal@4x.png',
        'img/ic_servicios_normal@4x.png',
        'img/ic_acerca_de_normal@4x.png',
        'img/ic_salir_normal@4x.png',
        'img/ic_saldo_consumos_press@4x.png',
        'img/ic_cupones_press@4x.png',
        'img/ic_servicios_press@4x.png',
        'img/ic_acerca_de_press@4x.png',
        'img/ic_salir_press@4x.png',
    ]).then(function () {
        console.log("Images done loading!");
    }, function (failed) {
        console.log("An image failed: " + failed);
    });


    localStorageService.set('audioRecibido', null); //para que no se pueda escuchar el ultimo audio recibido cuando inicio la aplicacion

    const TIMEOUT_HABLAR = 60000;
    var tiempoMinimoAudio = 1;//tiempo minimo que debe durar un audio grabado para que sea considerado valido
    var tiempoMaximoAudio = 10;    //tiempo maximo que debe durar un audio grabado para que sea considerado valido
    var src2 = "/android_asset/www/sounds/beep.amr";  //ruta y creacion de sonido que suena cunado comienza a grabar
    var src = "ion2.amr";//quitado y puesto aca. ruta y creacion de archivo usado para grabar audios


    $scope.beepGrabacion = $cordovaMedia.newMedia(src2);
    $scope.texto = "Presione para hablar"; //seteo variables iniciales
    $scope.tiempoReproducidoAudio = 0.0;  //tiempo de audio reproducido
    $scope.totalAudio = 0.0; //total de audio recibido inicial
    $scope.playVisible = true;  //si el boton de play esta visible inicialmento o el de pausa
    $rootScope.girador = "botonGrabarTrasero"; //estado inicial de la imagen que gira cuando apreto el boton de grabar audio
    $rootScope.cambiaImagenBoton = "botonNormal";  //estado inicial de la imagen delantera cuando apreto el boton de grabar audio
    $scope.audioGrabado = new Media(src);
    $scope.btnReproducirAudio = btnReproducirAudio; //comportamiento del boton que reproduce audio guardado
    $scope.presionarBotonGrabacion = presionarBotonGrabacion;
    $scope.soltarBotonGrabacion = soltarBotonGrabacion;
    $scope.reproducir = reproducir;
    $scope.reproducirSiguiente = reproducirSiguiente;
    $scope.playOrStop = playOrStop;
    $scope.detenerAudio = detenerAudio;
    $scope.audios = [];
    $scope.permiteReproduccion = true;
    $scope.terminoDeConvertir = true;


    $rootScope.$on('nuevo_mensaje_de_voz', function (a, msg) {
        nuevo_mensaje_de_voz(msg);
    });


    $rootScope.$on('rta_audio', function (a, msg) {
        rta_audio(msg);
    });


    notificaciones.escuchar("apreto_hablar",$scope,presionarBotonGrabacion);
    notificaciones.escuchar("solto_hablar",$scope,soltarBotonGrabacion);



    function btnReproducirAudio() {
        try {
            //var rutaAudioGuardado = "/android_asset/www/sounds/M.mp3";
            //var rutaAudioGuardado = localStorageService.get('audioRecibido');
            //$scope.au = rutaAudioGuardado;
            reproducirAudioPorBoton();
        }
        catch (e) {
            console.log("no hay audios todavia");
        }
    }








    //una vez que se toca, empieza a contar un tiempo; y cuando se cumple, recien comienza a grabar

    function presionarBotonGrabacion() {


        impostorBorrarArchivo(); //borra el archivo


        var requierePermisoParaEnviarAudio = audio.requierePermisoParaEnviarAudio();



        // NO PUEDE HABLAR CON LA CENTRAL
        if (requierePermisoParaEnviarAudio == 0){
            $rootScope.cambiaImagenBoton = "";
            $rootScope.cambiaImagenBoton = "noAnda";
            $scope.texto = "";
            $scope.texto = "No está habilitado para enviar mensajes de voz";
            $rootScope.girador = "";
            $rootScope.girador = "botonGrabarTrasero";

            return;
        }

        // requiere permiso para hablar
        if (requierePermisoParaEnviarAudio == 2) {

            // pregunta si no esta habilitado para hablar
            if (!estaHabilitadoEnviarAudio()) {


                solicitarPermisoHablar(); //solicita permiso para hablar

                $scope.cambiaImagenBoton = "";
                $scope.cambiaImagenBoton = "noAnda";
                $scope.texto = "";
                $scope.texto = "Solicitar permiso para hablar";
                $rootScope.girador = "";
                $rootScope.girador = "botonGrabarTrasero";

                return;
            }
        }


        // CUANDO PUEDE HABLAR SIN PEDIR PERMISO

        //clase devuelta para que rote la imagen
        $rootScope.girador = "";
        $rootScope.girador = "rota";

        //clase devuelta para que el centro del boton de grabar se ponga rojo y no rote
        $rootScope.cambiaImagenBoton = "";
        $rootScope.cambiaImagenBoton = "rojo";

        //texto mostrado cuando el boton esta presionado pero todavia no comenzó a grabar
        $scope.texto = "";
        $scope.texto = "Conectando...";

        //si hay internet en el momento que comenzara a grabar pone la bandera en verdadero, indicando que esta grabando
        //
        if ($rootScope.internetPrendido == true) {

            //si suelto antes del tiempo, impide ejecutar lo que esta dentro del timeout
            //clearTimeout(this.downTimer);

            //timeout que una vez cumplido permite iniciar la grabacion
            $scope.timeout = $timeout(function () {


                //invoca a la funcion que reproduce el beep pregrabacion
                $scope.beepGrabacion.play();
                navigator.vibrate(300);

                //timeout que quizas esta de mas
                //$timeout(function () {
                $scope.audioGrabado.startRecord();
                $scope.tiempoGrabando = tiempoMaximoAudio;
                $scope.timeoutCuentaRegresiva = $interval(function () {
                    $scope.tiempoGrabando--;
                    if ($scope.tiempoGrabando == -1) {

                        $interval.cancel($scope.timeoutCuentaRegresiva);
                        $scope.tiempoGrabando = "";
                        soltarBotonGrabacion();

                    }
                }, 1000);
                $rootScope.cambiaImagenBoton = "";
                $rootScope.cambiaImagenBoton = "grabando";
                $rootScope.girador = "";
                $rootScope.girador = "botonGrabarTrasero";
                $scope.texto = "";

                $scope.texto = "Grabando audio...";
                //bandera que indica que se comenzo a grabar, asi permite detener la grabacion mas tarde
                $scope.ban = true;

                //}, 1,false);

                //}, 1); //tiempo hasta que empieza a grabar

                //}, 1); //sino va 1000 en retardo

            }, 600); //recien empieza a reproducir sonido pre grabacion a los 600 ms y comienza a grabar

        }

        //si no hay internet, vuelve los botones y textos a como estaba inicialmente
        else {
            $rootScope.cambiaImagenBoton = "";
            $rootScope.cambiaImagenBoton = "noAnda";
            $scope.texto = "";

            $scope.texto = "No hay conexion";
            $rootScope.girador = "";
            $rootScope.girador = "botonGrabarTrasero";

            //alert("no hay internet");
        }

    }





    ///////////////////////////////////////////////////////////
    //funcion que detiene la grabacion

    function soltarBotonGrabacion() {


        $interval.cancel($scope.timeoutCuentaRegresiva);
        $scope.tiempoGrabando = "";
        $timeout.cancel($scope.timeout);


        if (!$scope.ban) {
            $scope.texto = "";
            $scope.texto = "Presione para hablar";
            $rootScope.cambiaImagenBoton = "";
            $rootScope.cambiaImagenBoton = "botonNormal";
            $rootScope.girador = "";
            $rootScope.girador = "botonGrabarTrasero";
            return;
        }


        //ojo con este. no conviene quitarlo. sino se tilda al grabar
        $timeout(function () {
            $scope.ban = false;
            $scope.texto = "";

            $scope.texto = "Presione para hablar";
            $rootScope.cambiaImagenBoton = "";
            $rootScope.cambiaImagenBoton = "botonNormal";
        }, 1, false);


        //setTimeout(function () {
        $scope.audioGrabado.stopRecord(); //detiene la grabacion de audio

        //si justo se corta internet entre que suelta y quiere llamar a enviar sale
        if (!$rootScope.internetPrendido) {
            alert("No se pudo enviar su mensaje. Compruebe su conexión a internet");
            return
        }

        setTimeout(function () {


            limitesDeGrabacion(tiempoMinimoAudio, tiempoMaximoAudio);

            $scope.intervalo = setInterval(function () {
                console.log("logu: ");

                if ($scope.duracionD == undefined) {
                    return;
                }

                clearInterval($scope.intervalo);
                console.log("el audio cumple con los minimos y los maximos:" + $scope.duracionD);
                //console.log("duracion dentro de intervalo:" + $scope.duraciona);

                //si justo se corta internet mientras consulta la duracion sale
                if ($rootScope.internetPrendido) {
                    if ($scope.duracionD == 'cumpleLimites') {

                        console.log("cumple limites");
                        enviarAudio($scope.duracionD);
                    }
                    else if ($scope.duracionD == 'noCumpleMax') {
                        console.log("no cumple limite superior, pero se envia igual");
                        enviarAudio($scope.duracionD);

                    }
                    else {
                        $rootScope.cambiaImagenBoton = "";
                        $rootScope.cambiaImagenBoton = "noAnda";
                        $rootScope.girador = "";
                        $rootScope.girador = "botonGrabarTrasero";
                        $scope.texto = "";

                        $scope.texto = "Grabe un audio superior a 1 segundo";
                        console.log("audio menor que el minimo");
                    }
                }
                else {
                    $rootScope.cambiaImagenBoton = "";
                    $rootScope.cambiaImagenBoton = "noAnda";
                    $rootScope.girador = "";
                    $rootScope.girador = "botonGrabarTrasero";
                    $scope.texto = "";

                    $scope.texto = "No se pudo grabar audio";
                    console.log("se perdio la conexion al intentar enviar");
                }
                $scope.duracionD = undefined;
                $scope.$applyAsync();


                //no quitar porque sino gira el boton de adentro
            }, 30); //intervalo que busca la duracion del audio para poder enviar

        }, 1); //espera que se detenga correctamente la grabacion

    }





    function impostorBorrarArchivo() {
        console.log("toco boton borrar");

        archivos.borrarArchivo('file:///storage/emulated/0/', "ion2.amr").then(function (respuesta) {
            console.log("respuesta en es:" + JSON.stringify(respuesta));
        }, function () {
            console.log("mal");
        });
    }





    function limitesDeGrabacion(min, max) {
        var src = "ion2.amr";
        var audioGrabado = new Media(src);


        //obligatorio usar el play para poder obtener la duracion
        audioGrabado.play();
        audioGrabado.stop();

        var timerDur = $interval(function () {

            var dur = audioGrabado.getDuration();
            if (dur > 0) {
                $interval.cancel(timerDur);
                audioGrabado.release();
                console.log("duracion dentro de la funcion:" + dur);
                //$scope.duraciona = dur;
                console.log("minimo es:" + min);
                //$scope.duracionD = (dur > min) && (dur < max);

                if ((dur >= min) && (dur <= max)) {
                    $scope.duracionD = 'cumpleLimites';
                } else if ((dur > max)) {
                    $scope.duracionD = 'noCumpleMax';
                } else {
                    $scope.duracionD = 'noCumpleLimites';
                }
            }
        }, 10);


    }





    function enviarAudio() {

        window.resolveLocalFileSystemURL("file:///storage/emulated/0/" + "ion2.amr", gotFile, fail);





        function fail(e) {

            window.resolveLocalFileSystemURL("file:///storage/sdcard1/" + "ion2.amr", gotFile, function () {
                window.resolveLocalFileSystemURL(cordova.file.cacheDirectory + "ion2.amr", gotFile, function () {
                    window.resolveLocalFileSystemURL(cordova.file.externalRootDirectory + "ion2.amr", gotFile, function () {
                        window.plugins.toast.showShortBottom('No se pudo enviar su mensaje', function (a) {
                        }, function (b) {
                            console.log("FileSystem Error" + JSON.stringify(e));
                            //clearInterval($scope.intervalo);
                            alert("No se pudo grabar su audio");
                        });
                    });
                });
            });
        }





        function gotFile(fileEntry) {

            fileEntry.file(function (file) {
                var reader = new FileReader();

                reader.onloadend = function () {
                    // alert("Text is: " + this.result);

                    if (!this.result){
                        alert("No se pudo grabar su audio");
                        return;
                    }

                    var data = this.result.replace(/^data:audio\/amr;base64,/, '');
                    var msg2 = {

                        'dni': localStorageService.get('username'),
                        'audio': data,
                        'empresa': localStorageService.get('empresa'),
                        'formato': "amr",
                        'hash': localStorageService.get('hash')
                    };

                    $scope.texto = "";
                    $scope.texto = "Presione para hablar";
                    $rootScope.cambiaImagenBoton = "";
                    $rootScope.cambiaImagenBoton = "botonNormal";
                    $scope.$applyAsync();

                    //si justo se corta internet mientras consulta la duracion y quiere enviar al server
                    if (!$rootScope.internetPrendido) {
                        alert("No se pudo enviar su mensaje. Compruebe su conexión a internet");
                        return
                    }

                    if (!msg2.audio) {
                        alert("No se pudo grabar su audio");
                        return;
                    }

                    //envia el audio solo si esta conectado, comunica si se pudo enviar o no
                    servidor.emitWhenConnected('audio', msg2, function () {

                    }, function () {
                        window.plugins.toast.showShortBottom('No se pudo enviar su mensaje. Compruebe su conexión a internet', function (a) {
                        }, function (b) {
                            // alert('toast error: ' + b)
                        });
                    });


                };

                // reader.readAsBinaryString(file);
                reader.readAsDataURL(file);
            });

        }
    }





    //////////////////////////////////////////////////////////////////////////////////////////////////////


    function reproducir(msg) {
        $scope.audios.push(msg['audio']);

        if ($scope.permiteReproduccion) {
            convertirAudioRecibido(msg['audio']);
        }
    }





    function reproducirSiguiente() {
        $scope.audios.splice(0, 1);

        if ($scope.audios.length == 0) {
            return;
        }

        convertirAudioRecibido($scope.audios[0]);

    }





    function nuevo_mensaje_de_voz(msg) {

        msg = angular.fromJson(msg);

        console.log("llega audio del servidor");


        if (audio.requierePermisoParaEnviarAudio()==2) {
            iniciarContadorHabilitadoEnviarAudio()
        }



        //$scope.$digest();
        //console.log("comando" + msg['id_comando']);
        // console.log("audio:" + msg['audio']);
        servidor.confirmarComando(localStorageService.get('empresa'), msg['id_comando'], localStorageService.get('hash'));

        //si el id comnado que llega es el mismoque el anterior o igual salgo de la funcion
        // if (localStorageService.get("idComando") >= msg['id_comando']) {
        //     return;
        // }

        localStorageService.set("idComando", msg['id_comando']);

        reproducir(msg);

        if ($state.current.name != "barra.general.credito") {
            cambioDePestania();
        }

    }










    function iniciarContadorHabilitadoEnviarAudio() {
        $rootScope.timeoutHablar = null;
        setearHabilitadoEnviarAudio(true);

        console.warn("inicia timer");
        $rootScope.timeoutHablar = $timeout(function () {
            setearHabilitadoEnviarAudio(false);
            console.warn("finaliza timer");
        }, TIMEOUT_HABLAR);
    }


      // $interval(function(){
      //         console.warn(estaHabilitadoEnviarAudio());
      //   },2000);


    function detenerContadorHabilitadoEnviarAudio() {
        $timeout.cancel($rootScope.timeoutHablar);
        $rootScope.timeoutHablar = null;
    }


    function estaHabilitadoEnviarAudio() {
        return audio.estaHabilitadoEnviarAudio()
    }


    function setearHabilitadoEnviarAudio(valor) {
        audio.setearHabilitadoEnviarAudio(valor)
    }



    function solicitarPermisoHablar() {

        audio.solicitarPermisoHablar().then(function(respuesta){
            console.log("respuesta en  es:"+JSON.stringify(respuesta));

        },function(error){
            console.error("error en  es:"+JSON.stringify(error));

        });

    }



    function rta_audio(msg) {

        msg = angular.fromJson(msg);

        console.log("mensaje estado audio:" + msg['Estado']);
        console.log("mensaje respuesta audio:" + msg['Respuesta']);

        if (msg.Estado == null) {
            console.log('rta audio llama a iniciar sesion: ');
            servidor.iniciarSesion();
            return;
        }

        if (msg.Estado) {
            window.plugins.toast.showShortBottom('AUDIO ENVIADO', function (a) {
                console.log("pudo mostrar: ");
            }, function (b) {
                console.log("no pudo mostrar: ");
            });
        } else if (!msg.Estado) {
            window.plugins.toast.showShortBottom('EL AUDIO NO SE PUDO ENVIAR', function (a) {
                console.log("pudo mostrar: ");
            }, function (b) {
                console.log("no pudo mostrar: ");
            });
        }
    }





    function cambioDePestania() {
        $scope.onTabTabbed(true, 2);
    }





    //funcion encargada de confirmar la recepcion de un mensaje
    function devolverMensajeDelServer(msgLocal) {
        servidor.confirmarComando(localStorageService.get('empresa'), msgLocal['id_comando'], localStorageService.get('hash'));
    }





    /////////////////////////////////////////////////////////////
    //funcion encargada de convertir audio recibido
    function convertirAudioRecibido(con2) {
        console.log('con2: ', con2);
        $scope.permiteReproduccion = false;

        var binary = window.atob(con2);
        var buffer = new ArrayBuffer(binary.length);

        //no entiendo estas 3 lineas,
        //convierte string a arraybuffer?
        var bytes = new Uint8Array(buffer);
        for (var i = 0; i < buffer.byteLength; i++) {
            //It takes only the least significant 8 bits of what's returned by data.charCodeAt.
            bytes[i] = binary.charCodeAt(i) & 0xFF;
        }

        //permite establecer un lugar de almacenamiento persistente en la ubicacion por defecto de la aplicacion
        window.requestFileSystem(window.PERSISTENT, 1024 * 1024, fileSystemOk, errorCallback);





        function fileSystemOk(fs) {

            fs.root.getFile('audio.mp3', {create: true}, function (fileEntry) {

                fileEntry.createWriter(function (fileWriter) {

                    fileWriter.onwriteend = function (e) {

                        //$scope.rutaRecibido = fileEntry.toURL();

                        //console.log(fileEntry.toURL());
                        localStorageService.set('audioRecibido', fileEntry.toURL());
                        reproducirAudio(fileEntry.toURL());
                        //return "" + fileEntry.toURL();
                    };

                    try {

                        fileWriter.write(new Blob([buffer], {type: 'audio/mp3'}));

                    } catch (e) {

                        var BlobBuilder = WebKitBlobBuilder;
                        var bb = new BlobBuilder();
                        bb.append(buffer);
                        fileWriter.write(bb.getBlob('audio/mp3'));

                    }

                }, errorCallback);
            }, errorCallback);

        }





        function errorCallback(error) {
            console.log(error + "error convirtiendo el audio recibido");
        }
    }





    //////////////////////////////////////////////////////
    //verificar esto, repeti las funciones porque no sabia si pisaba el media
    //    funcion encargada de reproducir los audios

    function playOrStop() {
        if ($scope.playVisible) {
            btnReproducirAudio();
        } else {
            detenerAudio();
        }

    }





    function reproducirAudio(ruta) {
        $scope.audioArribado = new Media(ruta);
        if ($rootScope.esUnAndroid) {
            sistema.setearVolumen($rootScope.volumen);
        }
        $scope.audioArribado.play();

        var timerDur = setInterval(function () {
            $scope.dur = $scope.audioArribado.getDuration();
            if ($scope.dur > 0) {
                clearInterval(timerDur);
                $scope.totalAudio = $scope.dur.toFixed(1);
                $scope.$applyAsync();
            }

        }, 1);
        //este intervallo se repite hasta que obtiene la duracion, ahi lo corta, el segundo intervalo se invoca un tiempo mas tarde por primera vez para tener la duracion
        //cada 500ms pregunta si se detuvo la reproduccion

        var a = setInterval(function () {
            $scope.audioArribado.getCurrentPosition(
                //success
                function (position) {
                    if (position < 0) {
                        console.log("fin y vuelvo a permitir reproduccion");
                        $scope.permiteReproduccion = true;
                        $scope.audioArribado.release();
                        reproducirSiguiente();

                        clearInterval(a);
                    }
                },
                // error
                function () {
                    console.log("An error occured!");
                }
            );
        }, 500);
    }





    //////////////////////////////////////////////////////


    function detenerAudio() {
        $scope.audioArribado.stop();
        $scope.playVisible = true;

    }





    function reproducirAudioPorBoton() {
        $scope.audioArribado.play();
        $scope.playVisible = false;

        //$scope.media2 = new Media(ruta);
        console.log("reproduciendo audio");
        //$scope.audioArribado.play();


        var mediaTimer = setInterval(function () {

            // get media position
            $scope.audioArribado.getCurrentPosition(
                // success callback
                function (position) {
                    if (position > 0) {
                        $scope.tiempoReproducidoAudio = position.toFixed(1);
                        $scope.$applyAsync();
                    }
                    else {
                        clearInterval(mediaTimer);
                        $scope.tiempoReproducidoAudio = 0.0;
                        $scope.playVisible = true;
                        $scope.$applyAsync();


                    }
                },

                // error callback
                function (e) {
                    console.log("Error getting pos=" + e);
                }
            );
        }, 100);

    }





    ///////////////////////////////////////////////////////////////////////////////////////////////
    //funcion que lee audio grabado por mi, lo transforma a base64 y lo envia al server


    //function updatePlayhead() {
    //    playhead.value = audioTrack.currentTime;
    //    var s = parseInt(audioTrack.currentTime % 60);
    //    var m = parseInt((audioTrack.currentTime / 60) % 60);
    //    s = (s >= 10) ? s : "0" + s;
    //    m = (m >= 10) ? m : "0" + m;
    //    playbacktime.innerHTML = m + ':' + s ;
    //
    //}


    //$scope.ntot = function (secs) {
    //    var hr = Math.floor(secs / 3600);
    //    var min = Math.floor((secs - (hr * 3600)) / 60);
    //    var sec = Math.floor(secs - (hr * 3600) - (min * 60));
    //    if (min < 10) {
    //        min = "0" + min;
    //    }
    //    if (sec < 10) {
    //        sec = "0" + sec;
    //    }
    //    return min + ':' + sec;
    //}


}
