angular
    .module('starter')
    .controller('ChatController', ChatController);




function ChatController($scope,
                        $log,
                        $rootScope,
                        $timeout,
                        $ionicPopup,
                        $ionicScrollDelegate,
                        $cordovaSQLite,
                        $ionicHistory,
                        $state,
                        $cordovaMedia,
                        localStorageService,
                        mobile,
                        dispositivo,
                        servidor,
                        moment,
                        estado) {

    var me = this;
    me.messages = [];
    var current_user = localStorageService.get('username');
    var empresa = localStorageService.get('empresa');
    var cantMsgmostrados = 10;
    var cantAntes;
    var cantMsgMostradosAntesSuma = cantMsgmostrados;

    $scope.audioNuevoMensaje = $cordovaMedia.newMedia("/android_asset/www/sounds/chat.mp3");

    $scope.agregarMensaje = agregarMensaje;
    $scope.btnMostrarMasMensajes = mostrarMasMensajes; //funcion que permite mostrar mas mensajes
    $scope.humanize = convertirFecha;
    $scope.reproducirMensaje = reproducirMensaje;




    function convertirFecha(timestamp) {

        if (!timestamp) {
            return false
        }
        try {
            return moment(timestamp).format("DD/MM/YYYY HH:mm:ss");
        }
        catch (e) {
        }

    }




    function reproducirMensaje(mensaje) {

        $log.warn("repro");
        dispositivo.leerConTTS(mensaje);

    }




    busquedaMensajes(cantMsgmostrados);


////////////////////////////////////////////////////////////////
//     lo que trae de la base de datos para poder mostrar

    function enviarEstadoAlServer(id) {
        for (var j = 0; j < me.messages.length; j++) {
            if (me.messages[j].id == id) {
                //me.messages.splice(me.messages.indexOf(me.messages[j]), 1);

                me.messages[j].estado = 'recibido';

                console.log('el id es : ' + JSON.stringify(me.messages[j]));
                //console.log('y la lista entera es: '+ me.messages[j].estado);
                return;

            }
        }
    }




    function busquedaMensajes(cantMsgmostrados) {


        function hayMensajes(result) {
            return result.rows.length > 0;
        }




        var query = "SELECT id,mensaje,remitente,fecha,estado FROM a5 WHERE dni=? order by id desc limit ?";


        // var query = "SELECT id,dni,mensaje,remitente,fecha FROM a5 WHERE dni=? order by id desc limit ?";
        $cordovaSQLite.execute($rootScope.db, query, [current_user, cantMsgmostrados]).then(function (result) {

            console.log('result.rows.length: ' + result.rows.length);

            //si hay mensajes
            if (hayMensajes(result)) {

                //si los recuperados son iguales a la cantidad que habia antes de recuperar
                if (result.rows.length == cantAntes) {

                    //esconde el boton de mostrar mensajes
                    $scope.hayMasMensajes = false;
                    alert("No hay mas mensajes guardados");

                    //si tiene menos de 10 no muestra el boton
                } else if (result.rows.length < 10) {
                    $scope.hayMasMensajes = false;
                }//si hay mas mensajes
                else {
                    $scope.hayMasMensajes = true;
                }

                //actualiza el valor
                cantAntes = result.rows.length;

                //variable local
                var msg;

                for (var i = result.rows.length - 1; i >= 0; i--) {

                    msg = {
                        'mensaje': result.rows.item(i).mensaje,
                        // 'dni': result.rows.item(i).dni,
                        'remitente': result.rows.item(i).remitente,
                        'fecha': result.rows.item(i).fecha,
                        'estado': result.rows.item(i).estado,
                        'id': result.rows.item(i).id

                    };

                    // console.log('mensaje recuperado es: ' + JSON.stringify(msg));

                    me.messages.push(msg);

                }

                  $timeout(function(){
                      try {
                          $ionicScrollDelegate.scrollBottom(false);
                      } catch (e) {
                      }
                    },0);

            }
        }, function (err) {
            console.error(err);
        });
    }




    function mostrarMasMensajes() {

        cantMsgMostradosAntesSuma = cantMsgmostrados;
        cantMsgmostrados = cantMsgmostrados + 5;

        //para limpiar la pantalla, sino van repitiéndose los mensajes
        me.messages = [];
        busquedaMensajes(cantMsgmostrados);

    }




///////////////////////////////////////////////////////////////
//     el segundo mensaje es si impide el scroll automatico o no. si esta en false hace scroll automatico hasta abajo
    function cargaMensajesEnPantalla(msg, scroll) {

        if (Keyboard) {
            Keyboard.close();
        }
        //agrega al arreglo de mensajes que se muestra en pantalla
        me.messages.push(msg);
        //if (scroll == false) {

        //$timeout(function () {

          $timeout(function(){
              try {
                  $ionicScrollDelegate.resize();
                  $ionicScrollDelegate.scrollBottom(false);
              } catch (e) {
              }
            },0);

        //}, 2200);


        //    $ionicScrollDelegate.$getByHandle('scrollmensajes').scrollBottom();
        //
        //}


    }




    //////////////////////////////////////////////////////
    // funcion que agrega mensaje disparada desde el html

    // lo que esta disponible a ser mostrado en el html, y lo que se envía al server

    function hayInternet() {
        return $rootScope.internetPrendido;
    }




    function agregarMensaje() {

        if (!hayInternet()) {
            me.message = '';
            alert("Revise su conexion a internet");
            return;
        }

        var idMio; //guardara el numero de mensaje
        var msg;
        var query = "SELECT last_insert_rowid() FROM a5";

        $cordovaSQLite.execute($rootScope.db, query).then(function (result) {
            if (result.rows.length >= 0) {

                console.log('result: ' + JSON.stringify(result.rows.length));
                var val = parseInt(JSON.stringify(result.rows.length));
                val = val + 1;
                idMio = val;
                msg = {

                    'dni': current_user,
                    'mensaje': me.message,
                    'fecha': moment(),
                    'remitente': 'yo',
                    'estado': 'enviando',
                    'id': idMio
                };

                console.log('id en agregar mensaje: ' + idMio);

                enviar(msg);
            }
        }, function (err) {
            console.log(err);
        });




        function enviar(msg) {

            me.message = '';

            //bien
            var msgServer = {

                'dni': msg.dni,
                'mensaje': mobile.validarStrSegunVersion(msg.mensaje),
                'empresa': empresa, //se guarda innecesariamente la empresa, solo sirve para enviar al server
                'hash': localStorageService.get('hash'),
                'id_mensaje_apk': msg.id

            };

            if (msgServer.dni == undefined ||
                msgServer.mensaje == undefined ||
                msgServer.empresa == undefined ||
                msgServer.hash == undefined ||
                msgServer.id_mensaje_apk == undefined) {
                console.log("hay valores undefined al querer enviar mensaje: ");
                alert("No se pudo enviar su mensaje");

                return;
            }
            cargaMensajesEnPantalla(msg, false);

            //deben ser los atributos de la tabla
            agregarMensajeAbaseDeDatos(msg);

            $timeout(function () {
                $scope.texto = "no enviado";
                enviarMensajeAlServer(msgServer);
            }, 50);
        }
    }




    function enviarMensajeAlServer(msg) {

        console.log("enviando mensajr: ");
        servidor.getConexion().emit('enviar_mensaje', msg);

    }




    //agrega mensaje a la base de datos.
    function agregarMensajeAbaseDeDatos(msg) {

        var query = "INSERT INTO a5 (dni,mensaje,remitente,fecha) VALUES (?,?,?,?)";

        $cordovaSQLite.execute($rootScope.db, query, [current_user, msg['mensaje'], msg['remitente'], msg['fecha']]).then(function (result) {
            // alert("insertado correctamente");
        }, function (err) {
            console.log(err);
        });
    }




    $rootScope.$on('rta_enviar_mensaje', function (a, msg) {
        rta_enviar_mensaje(msg);
    });




    //recibe la respuesta ante el envio del mensaje. valida el hash
    function rta_enviar_mensaje(msg) {

        msg = angular.fromJson(msg);

        if (msg.Estado == null) {
            console.log('rta enviar mensaje llama a iniciar sesion: ');
            servidor.iniciarSesion();
        }

        if (msg.Estado) {
            $scope.texto = "recibido";
            console.log("estado recibido" + msg['Estado']);

            console.log('en rta_enviar_mensaje: ');

            //todo aca tendría que actualizar el idServidor a la base de datos
            var idServidor = msg.id_mensaje_servidor;
            var idMio = msg.id_mensaje_apk;

            console.log('id: ' + idServidor);
            console.log('id: ' + idMio);

            var query = "update a5 set estado='recibido', idServidor = ? where id=?";

            console.log(query);
            $cordovaSQLite.execute($rootScope.db, query, [idServidor, idMio]).then(function (res) {
                console.log("update correcto" + res);
                //me.messages = [];
                //busquedaMensajes(++cantMsgMostradosAntesSuma);
                enviarEstadoAlServer(idMio);

            }, function (err) {
                console.log("update incorrecto" + err);
            });
        }

    }




    $rootScope.$on('nuevo_mensaje', function (a, msg) {
        nuevo_mensaje(msg);
    });




    function estaEnPantallaChat() {
        return localStorageService.get('indic') == 1;
    }




    function reproducirSonidoNuevoMensaje() {
        $scope.audioNuevoMensaje.play();
    }




    function leerMensaje(textoParaLeer) {

        dispositivo.leerConTTS(textoParaLeer);
    }




    function nuevo_mensaje(msg) {

        msg = angular.fromJson(msg);

        servidor.confirmarComando(localStorageService.get('empresa'), msg['id_comando'], localStorageService.get('hash'));

        // if (localStorageService.get("idComando") >= msg['id_comando']) {
        //     return;
        // }

        localStorageService.set("idComando", msg['id_comando']);


        msg['fecha'] = msg['fecha_hora'];

        //me.message = '';

        cargaMensajesEnPantalla(msg, false);
        //$ionicScrollDelegate.$getByHandle('scrollmensajes').scrollBottom();
        agregarMensajeAbaseDeDatos(msg);

        if ($rootScope.esUnAndroid) {
            sistema.setearVolumen($rootScope.volumen);
        }

        if (estaEnPantallaChat()) {
            reproducirSonidoNuevoMensaje();
            return;
        }


        if ($state.current.name != "barra.general.credito") {
            mostrarCartelLeerOescuchar(msg['mensaje']);
            return;
        }


        leerMensaje('tiene un nuevo mensaje');


        mostrarCartelConfirmacion().then(function (acepto) {
            if (!acepto) {
                return
            }

            estado.irAlEstado("^");

            $timeout(function () {
                $scope.onTabTabbed(true, 1);

                dispositivo.leerConTTS(msg.mensaje);
            }, 200);

        });
    }




    function mostrarCartelConfirmacion() {
        return $ionicPopup.confirm({
            title: 'NUEVO MENSAJE',
            template: 'Tiene un nuevo mensaje',
            okText: 'Leer',
            cancelText: 'Cancelar'
        })
    }




    function mostrarCartelLeerOescuchar(mensaje) {
        var textoParaLeer = 'tiene un nuevo mensaje';
        dispositivo.leerConTTS(textoParaLeer);

        var tituloPopup = 'NUEVO MENSAJE';
        var textoPopup = 'tiene un nuevo mensaje';
        dispositivo.popupLeerOescucharMensaje($scope, tituloPopup, textoPopup, mensaje);

    }

}



