angular
    .module('starter')
    .controller('DespachoController', DespachoController);






function DespachoController($scope,
                            $rootScope,
                            $exceptionHandler,
                            $timeout,
                            $interval,
                            $state,
                            $ionicHistory,
                            $ionicLoading,
                            $ionicPopup,
                            $ionicModal,
                            $cordovaMedia,
                            $cordovaSQLite,
                            archivos,
                            bluetooth,
                            catalogoCupones,
                            catalogoServicios,
                            cupon,
                            despacho,
                            dispositivo,
                            estado,
                            localStorageService,
                            mapa,
                            moment,
                            mobile,
                            notificaciones,
                            orm,
                            panico,
                            respuestas,
                            servidor,
                            servicios,
                            sesion,
                            socket,
                            tarifas,
                            tiempo) {


    // console.log(dsa);

    const LIMITE_PRECISION_EN_METROS = 50;
    const TIEMPO_ENVIO_PING = 15000;
    const TIEMPO_NO_PING = 22000; //tiempo que espera para indicar que no hay internet si no pudo enviar ping

    //variables del ambito
    $rootScope.internetPrendido = true;
    $rootScope.HiloPosicion = undefined;
    $scope.posicion = undefined;
    $scope.activarBoton = true;
    $scope.sonidoServicio = $cordovaMedia.newMedia("/android_asset/www/sounds/mensaje.amr");

    var banEmit = true; //bandera para que pueda enviar un 1 en estado de sesion inicialmente
    var horaUltimaPosicionObtenida; //se setea en hora actual cuando se empiece a tarifar
    var myPopup;
    var fechaServicioTmp = null;
    var telefonoTmp = null;
    var respuestaTO;
    var banderaAvisoGps = true;
    var intervaloUbicacionSimulada;
    var watcherPosicion;


    $scope.agregarDestino = agregarDestino;
    $scope.btnConPasajero = conPasajero;
    $scope.btnEnviarFoto = btnEnviarFoto;
    $scope.btnLibre = btnLibre;
    $scope.btnOcupado = btnOcupado;
    $scope.btnTarifador = btnTarifador;
    $scope.cambiarEstadoServicioAcancelado = cancelarServicio;
    $scope.enviarEstadoAlServer = function (valor) {
        enviarEstadoAlServer(valor) //funciones pequeñas se pueden escribir directamente
    };
    $scope.estaCuadroServicioAbierto = estaCuadroServicioAbierto;
    $scope.finalizarServicio = finalizarServicio;
    $scope.impostorNuevoServicio = impostorNuevoServicio;
    $scope.reproducirAudioServicio = reproducirAudioServicio;
    $scope.selectTotal = selectTotal;


    // todavia no implementado
    notificaciones.escuchar("fuera_servicio", $scope, fueraServicio);


    $scope.$on("destroy", function (event, data) {
        console.log("cancelando");
        clearInterval($rootScope.HiloPosicion);
        $interval.cancel($scope.hiloContadorPopup)
    });


    $rootScope.$on("rta_agregar_ticket", function (a, msg) {
        rta_agregar_ticket(msg)
    });


    $rootScope.$on("pasar_a_ocupado", function (a, msg) {
        pasar_a_ocupado(msg)
    });


    $rootScope.$on("cambiar_estado", function (a, msg) {
        cambiar_estado(msg)
    });


    document.addEventListener("deviceready", onDeviceReady, false);


    //////////////////////////////////////////////////////////////////////////////////////////////////////////
    // funciones
    //////////////////////////////////////////////////////////////////////////////////////////////////////////


    function fueraServicio() {
        console.error("fuera servicio tocado");
    }






    function obtenerDistanciaParaOcuparse(servicioActual) {

        var distanciaParaOcuparse = servicioActual.dist_para_ocuparse;

        // si no debe usar distancia
        if (distanciaParaOcuparse == 0) {
            return dispositivo.respuesta(true);
        }


        // si no hay latitud y longitud del servicio
        if (servicioActual.lat_servicio == 0 || servicioActual.lon_servicio == 0) {
            return dispositivo.respuesta(true);
        }


        // si debe usar distancia

        //determina diferencia metros entre posiciones
        var metrosDiferencia = mapa.distanciaEntre2PuntosEnMetros(
            localStorageService.get("latitud"),
            localStorageService.get("longitud"),
            servicioActual.lat_servicio,
            servicioActual.lon_servicio
        );

        console.log('metrosDiferencia: ' + metrosDiferencia);

        // valida la diferencia
        if (metrosDiferencia >= distanciaParaOcuparse) {
            return dispositivo.respuesta(false, "Debe estar cerca del pasajero para poder ocuparse");
        }

        // si esta cerca del pasajero

        return dispositivo.respuesta(true);
    }






    function conPasajero() {


        $rootScope.$emit("sacar_foto");

        var servicioActual = obtenerServicioActual();
        if (!servicioActual) {
            console.error("no hay servicio guardado");
            return
        }


        var distanciaParaOcuparse = obtenerDistanciaParaOcuparse(servicioActual);
        if (!distanciaParaOcuparse.Estado) {
            alert(distanciaParaOcuparse.Respuesta);
            return;
        }


        var tipoTarifa = servicioActual.id_tipo_tarifa;


        estaGpsPrendido().then(function (respuesta) {

            console.log("respuesta en  es:" + JSON.stringify(respuesta));

            iniciarTarifador(tipoTarifa)

        }, function (error) {

            console.error("error en  es:" + JSON.stringify(error));

        });


        guardarFechaInicioViajeEnCupon().then(function (respuesta) {
            console.log("respuesta en guardar fecha inicio es:" + JSON.stringify(respuesta));
        }, function (error) {
            console.error("error en  es:" + JSON.stringify(error));
        });


        enviarEstadoAlServer(2);
    }






    function guardarFechaInicioViajeEnCupon() {
        var id_cupon = obtenerIdCupon();
        console.error("idCupon:" + id_cupon);
        var horaActual = new Date(Date.now());
        var query = "update cupones set inicio_viaje='" + horaActual + "' where id_cupon=" + id_cupon;
        return orm.ejecutarQuery(query);
    }












    function btnEnviarFoto() {
    }






    function onDeviceReady() {


        // if (debeEnviarUbicacionFalsa()) {
        //     iniciarIntervaloEsFalsaUbicacion();
        // }

        iniciarWatcherPosicion();

        var servicio = obtenerServicioActual();

        actualizarEstadoMapa();


        if (tarifas.estaTarifando()) {
            continuarTarifando();
        }


        if (hayServiciosDeEsteUsuario(servicio)) {
            console.warn("hay servicios de este usuario");
            return;
        }


        // sino hay servicios
        limpiarLocalStorage();

        //si no esta libre
        if (despacho.obtenerEstado() != 1) {
            // se pone ocupado
            enviarEstadoAlServer(1);
            return;
        }

        // se pone libre
        despacho.setearEstado('libre')

    }






    function setearEstado() {
        return dispositivo.respuesta(true);
    }






    function debeEnviarUbicacionFalsa() {
        var a = sesion.obtenerEnviarUbicacionFalsa();
        console.error("debe enviar ubicacion falsa:" + a);
        return a
    }






    function iniciarIntervaloEsFalsaUbicacion() {
        console.error("iniciarno intervalo ubicacion falsa");

        intervaloUbicacionSimulada = $interval(function () {
            console.error("trantado intervalo");
            mobile.esFalsaLaUbicacion().then(function (ubicacionFalsaActiva) {
                console.log("respuesta en  es:" + JSON.stringify(ubicacionFalsaActiva));

                if (ubicacionFalsaActiva == "true") {
                    alert("Se ha detectado que una ubicación simulada está permitida. Desactivela e ingrese nuevamente");
                    $interval.cancel(intervaloUbicacionSimulada);

                    // tarea.cancelarIntervalosYtimeouts();

                }

            }, function (error) {
                console.error("error en  es:" + JSON.stringify(error));

            });
        }, 16000);
    }






    function btnTarifador() {
        abrirTarifador();
    }






    function abrirTarifador() {

        $rootScope.vista_despacho = false;

        estado.irAlEstado("barra.general.tarifador");

    }






    function btnLibre() {


        $rootScope.$emit("sacar_foto");


        $ionicPopup.confirm({
            template: 'Está usted seguro que desea ponerse ocupado?',
            title: $rootScope.tipo,
            buttons: [{
                text: 'Aceptar',
                type: 'button-positive',
                onTap: function () {
                    confirmacionLibre()
                }
            }, {
                text: 'Cancelar',
                type: 'button-default',
                onTap: function (e) {

                }
            }]
        });




        function confirmacionLibre() {
            //limpia datos de servicios viejos, no quitar de aca!
            despacho.limpiarLocalStorage();


            enviarEstadoAlServer(1); //envia que DEJO DE ESTAR LIBRE al server

            // ojo peligroso
            cambiarEstadoVisual(0);


            //si no hay internet (ojo que es si no tengo internet antes de tocar el boton,
            //pero que pasa si pierdo internet entre que envio la solicitud y que recibo la respuesta??????


            // este valor es fijo porque es de la calle. el tipo 2 es si me ocupo en la calle
            var tipoTarifa = 2;

            estaGpsPrendido().then(function (respuesta) {
                console.log("esta gps prendido:" + JSON.stringify(respuesta));

                iniciarTarifador(tipoTarifa);

            }, function (error) {
                console.error("error en  es:" + JSON.stringify(error));
                alert("No hay gps")
            });
        }

    }






    function btnOcupado() {

        $rootScope.$emit("sacar_foto");

        enviarEstadoAlServer(0); //envia que se quiere poner ocupado al server

        // agregado. ojo peligroso
        cambiarEstadoVisual(1);

        if (tarifas.estaTarifando()) {
            console.log("si esta tarifando");
            finalizarTarifador();
        }

    }






    function limpiarVisualTarifador() {
        $rootScope.fichasMetros = 0;
        $rootScope.fichasTiempo = 0;
        $rootScope.segundosAcumulados = 0;
        $rootScope.metrosAcumulados = 0;
        $rootScope.monto = {entero: 0, decimal: 0};
        $rootScope.velocidad = 0;
    }






    function finalizarTarifador() {


        guardarTiempoViaje(0);

        tarifas.setearTarifando(false); //bandera de tarifacion, es para que no tarife cuando entra en ocupado siempre


        $interval.cancel($rootScope.intervaloTarifador); //cancela intervalo del tarifador
        $rootScope.estaTarifando = false;   //obviamente deja de tarifar


        var fecha_hora_inicio = despacho.obtenerHoraInicioViaje();
        var fecha_hora_fin = despacho.guardarHoraFinViaje();


        tarifas.armarTicket(fecha_hora_inicio, fecha_hora_fin).then(function (ticket) {
            // console.log("respuesta en  es:" + JSON.stringify(ticket));

            if (!ticket) {
                console.error("no se pudo armar el ticket");
                return;
            }

            tarifas.guardarTicket(ticket); //guarda por si no lo puede enviar enseguida

            // limpiarAcumulados();

            enviarTicketAlServer(ticket);

        }, function (error) {
            console.error("error al querer enviar el ticket al servidor:" + JSON.stringify(error));
            return;
        });


    }






    function enviarTicketAlServer(ticket) {

        console.log("%c" + "ticket:" + JSON.stringify(ticket), "color:green");

        servidor.emitWhenConnected('agregar_ticket', ticket, function () {
            console.log('emit enviar ticket: ' + JSON.stringify(ticket));
        }, function () {
            console.log('hubo un error al realizar el emit común: posiblemente se perdio la conexion con el server ');
        })

    }






    function actualizarEstadoMapa() {
        // obtiene el estado actual y en base a eso muestra el cuadro de servicio , actualiza visual o limpiadatos
        //podria dividirlo en dos y cambiar el nombre incluso

        var estado = obtenerEstadoActual();

        // alert("entra a actualizar estado:" + estado);

        // // si actualizo la app y no tiene el estado
        // if (!estado) {
        //     $scope.estado = 'ocupado';
        //
        //
        //     limpiarLocalStorage();
        //
        //     enviarEstadoAlServer(1);
        //
        // }

        console.log("actualizando el mapa. estado:",estado);
        $scope.estado = estado;

        switch (estado) {
            case 'conPasajeroConCC': {
                $scope.mostrarCuadroServicio = false;
                break;
            }

            case 'conPasajeroSinCC': {
                $scope.mostrarCuadroServicio = false;
                break;
            }

            case 'buscandoAlPasajero': {
                $scope.mostrarCuadroServicio = true;
                mostrarCuadroDeServicio();
                actualizarElementosEnElMapa();
                break;
            }

            case 'libre': {
                $scope.mostrarCuadroServicio = false;
                //no poner limpiar aca porque todavia no envio el importe, y seguramente tampoco el cupon
                break;
            }

            case 'ocupado': {
                $scope.mostrarCuadroServicio = false;
                actualizarElementosEnElMapa();
                break;
            }
            default : {
                $scope.estado = 'ocupado';
                limpiarLocalStorage();
            }
        }
    }






    function hayServiciosDeEsteUsuario(servicio) {

        if (servicio == null) {
            return false;
        }

        return localStorageService.get("username") == servicio.usuario;
    }






    function guardarYactualizarEstadoMapa(estadoActual) {
        localStorageService.set("estado", estadoActual);
        actualizarEstadoMapa();

    }






    function obtenerEstadoActual() {
        return localStorageService.get("estado")
    }






    function obtenerServicioActual() {

        console.warn("obtener servicio actual");
        var servicio = localStorageService.get("servicio");
        if (servicio == null) {
            return false;
        }
        return servicio;

    }






    //todo esto se podria mejorar eliminando los callback hell
    function agregarDestino() {

        console.warn("entra en agregar destino");


        var destino = null;
        obtenerDestino().then(function (destinoP) {
            console.warn("destino:" + JSON.stringify(destinoP));
            destino = destinoP;
            guardarDestino(destinoP).then(function () {
                console.log("guardado");
                cupon.enviarDestino(destinoP).then(function () {
                    console.log("se envio correctamente");
                    informarAlUsuario("El destino se envió correctamente")
                })
            })
        })

    }






    function obtenerDestino() {
        return cupon.obtenerDestino();
    }






    function guardarDestino(destino) {
        return cupon.guardarDestino(destino)
    }






    function informarAlUsuario(mensaje) {
        console.log("entra en informar al usuario");
        alert(mensaje);
    }






    function finalizarServicio() {


        $rootScope.$emit("sacar_foto");

        if (tarifas.estaTarifando()) {
            finalizarTarifador();
        }


        setearServicioComoDespachado().then(function (respuesta) {
            console.log("respuesta en es:" + JSON.stringify(respuesta));

        }, function (error) {
            console.error("error en es:" + JSON.stringify(error));

        });

        // ojo peligroso
        cambiarEstadoVisual(1);

        enviarEstadoAlServer(0)

    }






    function limpiarLocalStorage() {
        despacho.limpiarLocalStorage();
    }






//cuando entra en segundo plano
    try {
        cordova.plugins.backgroundMode.on('activate', function () {

            //impide que deje de enviar datos
            cordova.plugins.backgroundMode.disableWebViewOptimizations();

        });
    } catch (e) {
    }


    try {
        //cuando vuelvo desde el segundo plano
        cordova.plugins.backgroundMode.on('deactivate',function () {

            try {
                if (angular.isDefined(StatusBar)) {
                    StatusBar.show();
                }
            } catch (e) {

            }

            //console.log("dentro de deactivate");
            //
            //clearInterval($rootScope.HiloPosicion);
            //
            //navigator.geolocation.clearWatch($scope.pos);
            //
            //obtenerPosicion();
            //
            //$rootScope.HiloPosicion = setInterval(function () {
            //    //console.log("dentro de hilo de deactivate");
            //
            //    $rootScope.enviarPing(2);
            //
            //}, 10000);
        });
    } catch (e) {
    }


//cada 10 segundos envio la posicion al server
    $rootScope.HiloPosicion = setInterval(function () {
        //console.log("suelto");

        $rootScope.enviarPing(2);

    }, TIEMPO_ENVIO_PING);


    var maximaVelocidadEnKmH = 140; //usada para determinar si va demasiado rapido, me lo tendria que pasar paco!!!!!!!!!!!!!!!!!!!!!!


    function limpiarAcumulados() {
        tarifas.limpiarAcumulados();
    }






    function mostrarPrecioInicial(precio_bajada_bandera) {


        // si hay bajada de bandera
        if (precio_bajada_bandera) {
            var monto = precio_bajada_bandera;
            var parts = parseFloat(monto).toFixed(2).split(/\./);
            $rootScope.monto = {entero: parts[0], decimal: parts[1]};

        } else {
            $rootScope.monto = {entero: p0, decimal: "00"};

        }

    }






//obtener la posicion
    function iniciarWatcherPosicion() {

        console.warn("iniciando watcher position");

        // no tocar
        var opciones = {
            maximumAge: 9000,
            enableHighAccuracy: true,
            timeout: 6000
        };

        watcherPosicion = navigator.geolocation.watchPosition(posicionObtenida, errorObtenerPosicion, opciones);

        // // ADVANCED GEO PLUGIN
        //  function getLocationSecondTry(){
        //     var config = {
        //         "minTime": 500,         // Min time interval between updates (ms)
        //         "minDistance": 1,       // Min distance between updates (meters)
        //         "noWarn": true,         // Native location provider warnings
        //         "providers": "all",     // Return GPS, NETWORK and CELL locations
        //         "useCache": true,       // Return GPS and NETWORK cached locations
        //         "satelliteData": false, // Return of GPS satellite info
        //         "buffer": false,        // Buffer location data
        //         "bufferSize": 0,        // Max elements in buffer
        //         "signalStrength": false // Return cell signal strength data
        //     };
        //
        //     AdvancedGeolocation.start(posicionObtenida, errorObtenerPosicion, config);
        //
        // }
    }






// simulacion recorrido


// var arl = [];
//
// // suma de metros de posiciones 77m
// // suma si no supongo recorrido 71m
// var posiciones = [
//
//     [-60.718836151063435, -32.93385993040158, 5.791497230529785, 1542308260589],
//     [-60.718826822535654, -32.93390739441883, 5.349087715148926, 1542308261617],
//     [-60.718825658945775, -32.93395674066453, 5.488134384155273, 1542308262628],
//     [-60.71881756003614, -32.93400564002036, 5.489650249481201, 1542308263659],
//     [-60.71881479787295, -32.934055108464676, 5.50668478012085, 1542308264692],
//     [-60.718811839258045, -32.93410369365588, 5.409485816955566, 1542308265717],
//     [-60.718801967686304, -32.9341528180178, 5.53953218460083, 1542308266741],
//     [-60.718800178644784, -32.93420189547818, 5.459725856781006, 1542308267786],
//     [-60.7184036, -32.9333992, null, 1542308268254],
//     [-60.7184036, -32.9333992, null, 1542308268354],
//     [-60.71879543062597, -32.934252972108226, 5.69672966003418, 1542308268784],
//     [-60.71879295302742, -32.9343037593766, 5.652026176452637, 1542308269808],
//     [-60.71878984739669, -32.93435326432227, 5.512331485748291, 1542308270832],
//     [-60.71877984997247, -32.93440308792005, 5.618154048919678, 1542308271867],
//     [-60.71877635129385, -32.9344521487693, 5.465087890625, 1542308272907],
//     [-60.7187732297336, -32.93450163034417, 5.509814739227295, 1542308273902],
//     [-60.718771595653685, -32.934553103859756, 5.725633144378662, 1542308274940]
// ];

// var arreglo = [[-60.71837524209745, -32.93349210593743, 0.8292083740234375, 1542304972912], [-60.71843289874708, -32.933507757231894, 5.655323028564453, 1542304973918], [-60.71848975098926, -32.933522306468525, 5.546969890594482, 1542304974948], [-60.71855053601057, -32.933528801195685, 5.718621730804443, 1542304975963], [-60.71860649970104, -32.93353926425876, 5.350894927978516, 1542304976985], [-60.718667505063365, -32.93355035667057, 5.825472831726074, 1542304978001], [-60.718722079614736, -32.93356356408004, 5.300739288330078, 1542304979023], [-60.718780506688226, -32.933569730300775, 5.495716094970703, 1542304980190], [-60.7188156992197, -32.93357965872085, 5.495716094970703, 1542304981069], [-60.71887465536291, -32.933581072962255, 5.504398822784424, 1542304982078], [-60.718932756095725, -32.93358620734922, 5.4522929191589355, 1542304983367], [-60.718994096964316, -32.93358487392493, 5.72662878036499, 1542304984112], [-60.71905543180405, -32.93359079097413, 5.761835098266602, 1542304985139], [-60.7191148722859, -32.93359314892105, 5.5535454750061035, 1542304986158], [-60.71917404415258, -32.933596219638545, 5.532829761505127, 1542304987180], [-60.71923126629577, -32.93360055301906, 5.362017631530762, 1542304988210], [-60.71929089182423, -32.93360257260957, 5.569151401519775, 1542304989236], [-60.71935105129448, -32.933609644858144, 5.669259071350098, 1542304990257], [-60.71941141933171, -32.93361112436016, 5.636318206787109, 1542304991282], [-60.71947198133314, -32.93361173266865, 5.65242338180542, 1542304992311], [-60.71953239903814, -32.93361412556173, 5.644826412200928, 1542304993319], [-60.71959078971667, -32.93361357332921, 5.449723243713379, 1542304994345], [-60.719651855013446, -32.933616080684416, 5.705804824829102, 1542304995363], [-60.719710884872995, -32.933617721721525, 5.512050628662109, 1542304996379], [-60.719767786438055, -32.93362243301136, 5.336181163787842, 1542304997404], [-60.71982618734976, -32.93363016758636, 5.517770767211914, 1542304998436], [-60.719884628759324, -32.93363427902032, 5.47323751449585, 1542304999446], [-60.719942832230124, -32.93363801764303, 5.447789192199707, 1542305000463], [-60.71997843682767, -32.93363509405346, 5.447789192199707, 1542305001473], [-60.7199744718026, -32.93358728442501, 5.329058647155762, 1542305002502], [-60.719965748279805, -32.933539619384085, 5.362281799316406, 1542305003521], [-60.71995848670447, -32.93349034494859, 5.520827293395996, 1542305004557], [-60.71995284091552, -32.933442151973225, 5.384663105010986, 1542305005576], [-60.71994616374757, -32.9333931923073, 5.479622840881348, 1542305006602], [-60.71993508462499, -32.9333431902348, 5.655310153961182, 1542305007636], [-60.719932392157, -32.93329151659039, 5.751347064971924, 1542305008660], [-60.71992300328777, -32.93324311833471, 5.4525146484375, 1542305009689], [-60.7199206469556, -32.93319078557437, 5.823299407958984, 1542305010698], [-60.71991459272506, -32.93314206700144, 5.446651935577393, 1542305011711], [-60.71990819788856, -32.93309471918723, 5.298562526702881, 1542305012740], [-60.71990022531658, -32.93304501861562, 5.576322078704834, 1542305013767], [-60.71989192931327, -32.93299450120508, 5.670393943786621, 1542305014786], [-60.71988737576041, -32.932945809998714, 5.430875301361084, 1542305015794], [-60.71988614011921, -32.93289379100628, 5.78540563583374, 1542305016823], [-60.719875509496674, -32.93284431241092, 5.590514659881592, 1542305017839], [-60.719865433156095, -32.93279375559088, 5.699781894683838, 1542305018867], [-60.719865332570684, -32.93274233580881, 5.717634677886963, 1542305019885], [-60.7198627665639, -32.932720828723355, 5.717634677886963, 1542305020917], [-60.71987394903661, -32.93267342391842, 5.373500823974609, 1542305021940], [-60.71988745862531, -32.93262313098574, 5.732692718505859, 1542305022972], [-60.71989435945935, -32.93257492507767, 5.3988118171691895, 1542305023990], [-60.71989929437817, -32.9325238812981, 5.694472789764404, 1542305025014], [-60.71990770882464, -32.93247585032461, 5.398233413696289, 1542305026023], [-60.71991352016865, -32.93242487301134, 5.694314002990723, 1542305027045], [-60.71991953632153, -32.93237528140852, 5.542853355407715, 1542305028068], [-60.71992962383232, -32.93232585429975, 5.5761003494262695, 1542305029103], [-60.71993799517992, -32.93227683979295, 5.505885124206543, 1542305030110], [-60.719950310428516, -32.932228916407404, 5.451385021209717, 1542305031123], [-60.719963735549726, -32.93217841429358, 5.753664970397949, 1542305032129], [-60.71996906746845, -32.932126241390485, 5.8226728439331055, 1542305033144], [-60.7199762446681, -32.93207585872233, 5.64220666885376, 1542305034169], [-60.71998963861587, -32.93202735962615, 5.535839557647705, 1542305035186], [-60.71999952429629, -32.93198010378921, 5.33499813079834, 1542305036200], [-60.72001052420311, -32.931928505275906, 5.828620910644531, 1542305037237], [-60.72005588561296, -32.93166754057606, 5.828620910644531, 1542305038273], [-60.72040318713469, -32.93159822967009, 33.316715240478516, 1542305039306], [-60.72074991496433, -32.931525037344265, 33.36729049682617, 1542305040329], [-60.72110573084732, -32.9314873851434, 33.470603942871094, 1542305041357], [-60.721451169133196, -32.931415427784195, 33.217281341552734, 1542305042385], [-60.721806774581225, -32.931370741009076, 33.55803680419922, 1542305043419], [-60.72216192785249, -32.93132690059787, 33.50249481201172, 1542305044447], [-60.722508289013106, -32.931263851062276, 33.07692337036133, 1542305045439], [-60.72285446238856, -32.93118886591185, 33.366485595703125, 1542305046476], [-60.723199477387425, -32.93112059740821, 33.082523345947266, 1542305047478], [-60.72321586310863, -32.931107826649864, 33.082523345947266, 1542305048490], [-60.72314729487498, -32.93081141517009, 33.57500457763672, 1542305049510], [-60.72310723364353, -32.930757476010015, 33.57500457763672, 1542305050525], [-60.72275185261154, -32.930798717382785, 33.482933044433594, 1542305051556], [-60.722395831147274, -32.93083657909619, 33.49281692504883, 1542305052582], [-60.72203942115529, -32.930841111983355, 33.267234802246094, 1542305053603], [-60.721682886430315, -32.9308735278758, 33.46970748901367, 1542305054634], [-60.721328521709985, -32.93089299179018, 33.14325714111328, 1542305055659], [-60.72097270771491, -32.93089424673835, 33.208065032958984, 1542305056678], [-60.72061824049629, -32.9308769664718, 33.13783645629883, 1542305057698], [-60.720264197662324, -32.930920518202, 33.39546203613281, 1542305058734], [-60.72008807212115, -32.93090887268167, 33.39546203613281, 1542305059788], [-60.72008893861751, -32.930608256706115, 33.42711639404297, 1542305060778], [-60.72011544795129, -32.93030790136708, 33.48955154418945, 1542305061789], [-60.720113860671724, -32.93025983428185, 5.34687614440918, 1542305062815], [-60.72011660754484, -32.93021069268941, 5.470314025878906, 1542305063849], [-60.72011722201569, -32.93015976447784, 5.663257122039795, 1542305064872], [-60.72011523632001, -32.93011038881564, 5.493457794189453, 1542305065903], [-60.72011364065159, -32.9300609306737, 5.501518249511719, 1542305066918], [-60.720115373177734, -32.93000996993206, 5.668890476226807, 1542305067944], [-60.72011718779885, -32.929961704264265, 5.369576454162598, 1542305068947], [-60.72011946568638, -32.929912012762045, 5.529539108276367, 1542305069977], [-60.720117723169885, -32.929862046412595, 5.55839204788208, 1542305070978], [-60.720114155474505, -32.92981266268153, 5.501314163208008, 1542305072010], [-60.72011425064971, -32.92976075879475, 5.771463871002197, 1542305073028], [-60.72010889956858, -32.92970941311537, 5.7311882972717285, 1542305074049]];


// aca genera el arreglo de posiciones y velocidades ya filtrado, para poder graficarlo después.
// generarArregloFiltrado(posiciones);


// function generarArregloFiltrado(posiciones) {
//
//     console.error("entra en generar arreglo");
//
//     localStorageService.set("posicionesCorrectas", null);
//     localStorageService.set("acumulados", null);
//
//     var latitudAnterior = posiciones[0][1];
//     var longitudAnterior = posiciones[0][0];
//     var posicionAnterior = [latitudAnterior, longitudAnterior];
//     var horaAnterior = posiciones[0][3];
//
//     // [1] es latitud
//     for (var i = 1, longitud = posiciones.length; i < longitud; i++) {
//
//
//         var posicionActual = [posiciones[i][1], posiciones[i][0]];
//         var velocidadActual = posiciones[i][2];
//         var horaActual = posiciones[i][3];
//
//         // si no tiene velocidad la salta
//         if (velocidadActual == null) {
//             console.error("velocidad es null, asi que salgo y no sumo");
//             continue
//         }
//
//         var valor = tarifas.tarifar(horaActual, horaAnterior, posicionAnterior, posicionActual, velocidadActual);
//
//
//         console.log("valor devuelto en tarifar:" + JSON.stringify(valor));
//         if (valor) {
//             guardarPosicionCorrectaEnHistorico(posiciones[i][0], posiciones[i][1], velocidadActual, horaActual); //tomo como valida y la guardo
//             posicionAnterior = posicionActual;
//             horaAnterior = horaActual;
//         }
//
//     }
//$local
// }


    $scope.dibujarRecorrido = function () {
        // mapa.dibujarRuta(loco);
        console.error("entra en dibujar rutas");
        var a = [[-60.65, -32.95328], [-60.64972, -32.95212], [-60.64947, -32.95106], [-60.64916, -32.9498], [-60.6488, -32.94847], [-60.6485, -32.94731], [-60.64715, -32.94757], [-60.64745, -32.94871], [-60.6488, -32.94847], [-60.65017, -32.94823], [-60.65153, -32.94795], [-60.65288, -32.94774], [-60.65412, -32.9475], [-60.65384, -32.94639], [-60.6535, -32.94495], [-60.65318, -32.94379], [-60.65288, -32.94244], [-60.65262, -32.94147], [-60.65234, -32.9403], [-60.65204, -32.93914], [-60.65176, -32.93791], [-60.65144, -32.93677], [-60.65114, -32.93561], [-60.65084, -32.93444], [-60.65058, -32.93326], [-60.65077, -32.93323], [-60.65204, -32.93302], [-60.65339, -32.93278], [-60.65369, -32.93396], [-60.65395, -32.93506], [-60.65427, -32.93628], [-60.6529, -32.93652]];
        // var a =[[-60.65083469999999, -32.953124], [-60.65269240000001, -32.9527497], [-60.6512269, -32.9468242], [-60.6471606, -32.9475386], [-60.6481147, -32.9512735], [-60.65215779999999, -32.9505438], [-60.64820400000001, -32.9349572], [-60.6479408, -32.9337861], [-60.6533713, -32.9327678], [-60.6536797, -32.9339364], [-60.6542367, -32.9362502]];
        mapa.dibujarRuta(a);

        var b = [[-60.65083469999999, -32.953124], [-60.65269240000001, -32.9527497], [-60.6512269, -32.9468242], [-60.6471606, -32.9475386], [-60.6481147, -32.9512735], [-60.65215779999999, -32.9505438], [-60.64820400000001, -32.9349572], [-60.6479408, -32.9337861], [-60.6533713, -32.9327678], [-60.6536797, -32.9339364], [-60.6542367, -32.9362502]];
        mapa.dibujarRuta(b, true);
        // mapa.dibujarRuta(tarifas.obtenerPosicionesCorrectas().then(false, false));
    };






// $scope.dibujarRecorrido();


    function limpiarUltimaPosicionCorrecta() {
        localStorageService.set("ultimaPosicionCorrecta", null);
    }






    function estaGpsPrendido() {
        return mobile.verificarPosicionDisponible();
    }






    function iniciarTarifador(tipoTarifa) {

        console.error("tipoTarifa:" + tipoTarifa);

        var tarifaAusar;

        var fechaActual = tiempo.obtenerHoraActual();

        var tarifasRecuperadas = tarifas.obtenerTarifas(); //obtiene las tarifas que me paso el server al inicio

        var feriados = tarifas.obtenerFeriados();


        // si devuelve algo
        if (feriados) {
            //si hay feriados guardados
            if (feriados.Estado) {

                console.log("hay feriados guardados");
                feriados = feriados.Respuesta; //los recupera

                var esHoyFeriado = tarifas.esHoyFeriado(fechaActual, feriados); //ve si hoy es feriado

                console.log("hoy es feriado:" + esHoyFeriado);
                // si es feriado
                if (esHoyFeriado) {

                    // busca tarifa de feriado, o sea el dia 8
                    tarifaAusar = tarifas.buscarTarifaActual(tipoTarifa, fechaActual, tarifasRecuperadas, 8);
                    console.error("tipoTarifa:" + tipoTarifa);
                    console.log('fechaActual: ' + JSON.stringify(fechaActual));
                    console.log('tarifasRecuperadas: ' + JSON.stringify(tarifasRecuperadas));
                    console.log("recupera tarifa de feriados:" + JSON.stringify(tarifaAusar));
                }
            }
        }

        // si no es un feriado
        if (!tarifaAusar) {
            console.error("entra en tarifa a usar false:");
            tarifaAusar = tarifas.buscarTarifaActual(tipoTarifa, fechaActual, tarifasRecuperadas);
            console.log("tarifa a usar:",JSON.stringify(tarifaAusar));
        }

        // si no devuelve alguna tarifa, tratará de usar la predeterminada.
        if (!tarifaAusar.Estado) {
            console.error("no hay tarifas. se usara la tarifa predeterminada");
            tarifaAusar = tarifas.buscarTarifaPredeterminada(fechaActual, tarifasRecuperadas);

            if (!tarifaAusar.Estado) {
                console.error("no se pudo obtener la tarifa en tipo 1");
                return;
            }
        }


        $rootScope.estaTarifando = true; //indica que esta tarifando

        despacho.borrarHoraInicioViaje();
        despacho.borrarHoraFinViaje();
        despacho.guardarHoraInicioViaje();

        tarifas.setearTarifando(true);
        tarifas.setearTarifaAusar(tarifaAusar.Respuesta);
        tarifas.inicializar(maximaVelocidadEnKmH);

        console.error("iniciando tarifador");

        tarifas.limpiarPosicionesCorrectas().then(false, false);

        limpiarUltimaPosicionCorrecta();

        limpiarAcumulados();

        limpiarVisualTarifador();

        var importeInicial = tarifas.obtenerTarifaAusar().tarifa_importes.precio_bajada_bandera;
        mostrarPrecioInicial(importeInicial);
        tarifas.guardarAcumulados({tiempo: 0, metros: 0, monto: importeInicial});

        //la primera sera la actual
        var posicionActual = obtenerUltimaPosicionDetectada();
        guardarUltimaPosicionCorrecta(posicionActual);

        guardarTiempoViaje(0); //arranca en 0 el contador de tiempo de viaje


        iniciarContadorSegundos(0);


        // si no debe mostrar el tarifador sale
        if (ocultarTarifadorEnEsteServicio()) {
            $rootScope.usaTarifadorVisual = false;
            return;
        }

        // si debe usar el tarifador en este servicio, se fija si lo debe usar en la app
        $rootScope.usaTarifadorVisual = tarifas.obtenerUsaTarifador();

        // si usa tarifador lleva a la pantalla
        if ($rootScope.usaTarifadorVisual) {
            $state.go("barra.general.tarifador", {reload: false, reloadOnSearch: false, notify: false})
        }
    }






    function ocultarTarifadorEnEsteServicio() {
        // devuelve true si NO tiene que usar el tarifador

        var servicio = obtenerServicioActual();
        console.log("servicio:" + JSON.stringify(servicio));

        if (!servicio) {
            return false;
        }

        console.log("tiene servicio");

        if (servicio.parametros_cupon == null) {
            return false
        }
        console.log("tiene parametros");

        if (servicio.parametros_cupon.Importe == null) {
            return false;
        }

        console.log("tiene importes");

        if (servicio.parametros_cupon.Importe[0] == 1) {
            return false;
        }

        console.log("el importe es 0");
        return true

    }






    function continuarTarifando() {

        var tarifaAusar = tarifas.obtenerTarifaAusar();
        if (!tarifaAusar) {
            return;
        }


        tarifas.obtenerPosicionesCorrectas().then(exitoObtenerPosicionesCorrectas, fallaObtenerPosicionesCorrectas);






        function exitoObtenerPosicionesCorrectas(posiciones) {

            //carga las posiciones en memoria, decidí ponerlo aca asi no ensucio las funciones base
            tarifas.setearPosicionesCorrectasMemoria(posiciones);

            tarifas.setearTarifaAusar(tarifaAusar);

            tarifas.inicializar(maximaVelocidadEnKmH);

            //la primera sera la actual
            var posicionActual = obtenerUltimaPosicionDetectada();
            guardarUltimaPosicionCorrecta(posicionActual);


            var acumulados = tarifas.obtenerAcumulados();
            // no hay acumulados
            if (!acumulados) {
                console.error("no puede continuar tarifando");
                return;
            }


            $rootScope.estaTarifando = true; //usada para determinar si esta tarifando o no

            tarifas.setearTiempoAcumulado(acumulados.tiempo);
            tarifas.setearMetrosAcumulados(acumulados.metros);


            dividirImporteVisualmente(acumulados.monto);

            if (acumulados.tiempo) {
                iniciarContadorSegundos(0);
            } else {
                iniciarContadorSegundos(0);
            }


            // si no debe mostrar el tarifador sale
            if (ocultarTarifadorEnEsteServicio()) {
                $rootScope.usaTarifadorVisual = false;
                return;
            }

            $rootScope.usaTarifadorVisual = tarifas.obtenerUsaTarifador();

            if ($rootScope.usaTarifadorVisual) {
                estado.irAlEstado("barra.general.tarifador");
            }
        }






        function fallaObtenerPosicionesCorrectas() {

        }
    }






    function dividirImporteVisualmente(monto) {
        // procedimiento: divide lel importe en la parte entera y decimal para mostrarlo de distinta manera en el html


        var parts = parseFloat(monto).toFixed(2).split(/\./);
        $rootScope.monto = {
            entero: parts[0],
            decimal: parts[1]
        };
    }






    function iniciarContadorSegundos(counter) {

        // inicializa con 0 o con el tiempo que llevaba el viaje
        // $rootScope.time = moment().hour(0).minute(0).second(counter).format('mm : ss');

        // va actualizando el tiempo en pantalla una vez por segundo
        $rootScope.intervaloTarifador = $interval(function () {
            // $rootScope.time = moment().hour(0).minute(0).second(counter++).format('mm : ss');
            determinarTarifa();
        }, 1000);
    }






    function guardarTiempoViaje(tiempo) {
        tarifas.guardarTiempoViaje(tiempo)
    }






    function determinarTarifa() {

        var posicionAnterior = obtenerUltimaPosicionCorrecta();
        // console.error("posicion anterior:" + JSON.stringify(posicionAnterior));

        var posicionActual = obtenerUltimaPosicionDetectada(); //no es lo mismo que sea la ultima correcta, pasa a ser correcta si pasa validaciones
        // console.error("posicion actual:" + JSON.stringify(posicionActual));


        if (!posicionAnterior || !posicionActual) {
            console.log("no hay posicion anterior o actual");
            return;
        }


        // console.log("velocidad de determinar tarifa:" + $rootScope.velocidad3);


        var respuesta = tarifas.tarifar(posicionAnterior, posicionActual);
        // console.error("respuesta" + JSON.stringify(respuesta));

        if (!respuesta.Estado) {
            return
        }


        if (respuesta.Respuesta) {
            if (respuesta.Respuesta.monto) {
                dividirImporteVisualmente(respuesta.Respuesta.monto)
            }
        }


        $rootScope.fichasMetros = respuesta.Respuesta.fichasMetros; //por si quiero mostrar las fichas
        $rootScope.fichasTiempo = respuesta.Respuesta.fichasSegundos; //por si quiero mostrar las fichas

        // lo muestra igual este bien o no la posición
        $rootScope.metrosAcumulados = respuesta.Respuesta.metros;

        // $rootScope.segundosAcumulados = respuesta.Respuesta.tiempo;

        //por si se quiere graficar despues
        //aunque también es para poder enviar al server cuando se finalice el viaje
        guardarPosicionCorrectaEnHistorico(posicionActual).then(false, false);

        guardarUltimaPosicionCorrecta(posicionActual);


    }






    function posicionObtenida(position) {

        // console.warn("%c" + 'entra en posicion obtenida:'+JSON.stringify(position), "color:green");


        $scope.ping = {
            'dni': localStorageService.get('username'),
            'latitud': position.coords.latitude,
            'longitud': position.coords.longitude,
            'estado1': localStorageService.get('estadoIcono'),
            'empresa': localStorageService.get('empresa'),
            'velocidad': position.coords.speed, //  Current ground speed of the device, specified in meters per second. _(Number)_
            'rumbo': position.coords.heading,
            'precision': position.coords.accuracy | 0,
            'hash': localStorageService.get('hash'),
            'estado_sesion': 2
            //'hora': position.timestamp
        };


        mostrarPrecisionGps($scope.ping.precision);


        //asi envia tipo de ping 1 solo la primera vez
        if (banEmit) {
            banEmit = false;
            $rootScope.enviarPing(1);
        }


        //actualiza mapa solo si esta en él
        if ($rootScope.indic == 0) {
            $rootScope.actualizarMapa(position.coords.latitude, position.coords.longitude, position.coords.heading);
        }


        var posicionActual = [
            position.coords.latitude,
            position.coords.longitude
        ];

        // console.error("posicion actual:" + JSON.stringify(posicionActual));

        guardarCoordenadaActual(posicionActual);


        /////////////////////////////////////////////////////////
        //se podría guardar opcionalmente. ahora la uso solo para tarifas

        var posicionCompleta = {
            latitud: position.coords.latitude,
            longitud: position.coords.longitude,
            velocidad: position.coords.speed,
            rumbo: position.coords.heading,
            precision: position.coords.accuracy | 0,
            hora: tiempo.obtenerHoraActual()
        };
        guardarUltimaPosicionCompleta(posicionCompleta);
        ///////////////////////////////////////////////////////

    }






//funcion invocada cuando no se puede obtener la posicion
    function errorObtenerPosicion(error) {
        console.warn("error");
        console.log('error en la obtencion de la posicion: ' + error.code + '\n' +
            'message: ' + error.message + '\n');

        //indica que el gps NO esta funcionando
        $rootScope.gpsPrendido = 'gpsDesactivado';

        console.log("el gps esta:" + $rootScope.gpsPrendido);
    }






    function guardarUltimaPosicionCompleta(posicionCompleta) {
        mapa.guardarUltimaPosicionCompleta(posicionCompleta);
    }






    function obtenerUltimaPosicionDetectada() {
        return mapa.obtenerUltimaPosicionCompleta()
    }






    function guardarUltimaPosicionCorrecta(posicionActual) {
        // var posicion = [longitud, latitud, speed, hora];
        localStorageService.set("ultimaPosicionCorrecta", posicionActual)
    }






    function obtenerUltimaPosicionCorrecta() {
        return localStorageService.get("ultimaPosicionCorrecta")
    }






    function guardarPosicionCorrectaEnHistorico(posicion) {
        return tarifas.guardarPosicionesCorrectas(posicion.longitud, posicion.latitud, posicion.velocidad, posicion.hora);
    }






    function guardarCoordenadaActual(coordenada) {
        return mapa.guardarCoordenadaActual(coordenada)
    }






    function consultarPosicionesViejas(devolucionPosiciones) {
        var dicPosiciones = {};
        //console.log('consultando posiciones no enviadas: ');

        var posiciones = [];

        var query = "select * from posicionesNoEnviadas";

        $cordovaSQLite.execute($rootScope.db, query).then(function (result) {
            if (result.rows.length > 0) {


                for (var i = 0; i < result.rows.length; i++) {

                    var msg = {
                        "latitud": result.rows.item(i).latitud,
                        "longitud": result.rows.item(i).longitud,
                        "estado1": result.rows.item(i).estado1,
                        "velocidad": result.rows.item(i).velocidad,
                        "rumbo": result.rows.item(i).rumbo,
                        "precision": result.rows.item(i).precision,
                        "hora": result.rows.item(i).hora
                    };

                    console.log('mensaje es: ' + JSON.stringify(msg));

                    posiciones.push(msg);

                }


                dicPosiciones.posiciones = posiciones;
                dicPosiciones.dni = localStorageService.get('username');
                dicPosiciones.empresa = localStorageService.get('empresa');
                dicPosiciones.hash = localStorageService.get('hash');


                //console.log('arreglo entero: ' + JSON.stringify(dicPosiciones));
                devolucionPosiciones(true, dicPosiciones)
            } else {
                devolucionPosiciones(false, dicPosiciones)

            }
        }, function (err) {
            console.log("no pudo recuperar posiciones, " + err);
        });

    }






    function mostrarGpsDesactivado() {
        $rootScope.gpsPrendido = 'gpsDesactivado';
    }






    function verificarEstadoGps() {

        mobile.verificarPosicionDisponible().then(function (gpsPrendido) {
            //console.log("enabled: " + enabled);


            if (gpsPrendido && estaDefinido($scope.ping)) {
                mostrarPrecisionGps($scope.ping.precision);
                return;
            }

            if (gpsPrendido && !estaDefinido($scope.ping)) {
                mostrarGpsDesactivado();
                return;
            }

            if (!gpsPrendido && banderaAvisoGps) {
                mostrarCartelQueNoTieneGps();
                banderaAvisoGps = false;
                return;
            }


            if (!gpsPrendido) {
                mostrarGpsDesactivado();
            }

        }, function () {
            console.log("error: ");
            mostrarGpsDesactivado();

        });

    }






    function estaDefinido(variable) {
        return angular.isDefined(variable)

    }






    function mostrarPrecisionGps(precisionActual) {
        //console.log("precision es: " + precision);

        if (precisionActual > LIMITE_PRECISION_EN_METROS) {
            mostrarGpsImpreciso();
            return;
        }

        mostrarGpsActivado();

    }






    function mostrarGpsImpreciso() {
        $rootScope.gpsPrendido = 'gpsImpreciso';
    }






    function mostrarGpsActivado() {
        $rootScope.gpsPrendido = 'gpsActivado';
    }






    function mostrarCartelQueNoTieneGps() {

        $ionicPopup.confirm({
            template: 'Para que ' + $rootScope.tipo + ' funcione correctamente. Deberá activar el acceso a su ubicacion',
            title: $rootScope.tipo,
            buttons: [{
                text: 'Activar',
                type: 'button-positive',
                onTap: function () {
                    cordova.plugins.diagnostic.switchToLocationSettings();
                }
            }, {
                text: 'Cancelar',
                type: 'button-default',
                onTap: function (e) {

                }
            }]
        });
    }






    function obtenerHoraActualConFormato() {
        return moment(horaUltimaPosicionObtenida).format("YYYY-MM-DD HH:mm:ss");
    }






    function setearHayInternet(estado) {
        $rootScope.internetPrendido = estado;
    }






    var pudoEnviarPing = true;


    var sucursal = sesion.obtenerSucursal();
    if (sucursal == null) {
        sucursal = 1;
    }

    $rootScope.enviarPing = function (estado) {

        if (!estaDefinido($scope.ping)) {
            console.warn("ojo que el ping es undefined: ");
            $rootScope.gpsPrendido = 'gpsDesactivado';
            return;
        }


        $scope.ping.estado_sesion = estado;

        $scope.ping.id_sucursal = sucursal;

        $scope.ping.estado_panico = devolverEstadoPanico();

        // console.log('$scope.ping.estado_panico: ' + $scope.ping.estado_panico);

        // consultarPosicionesViejas(rtaConsultaPosiciones);


        //si hay un cambio de red (3g a wifi) o si se desconecta(modo avion, o figura que tiene internet, pero es mentira) y se conecta
        //pasan cerca de 25 segundos hasta que se refleja que perdio conexion y reconecta y vuelve a andar todo_
        //en esos 25 segundos figuraria como que estoy conectado y dejaria enviar mensajes audios etc, pero no llegarian
        //con esta bandera si no puede enviar el ping se le comunica al usuario mostrandole que no hay internet y no le deja hacer nada
        //lo peor que puede pasar es que justo trate de enviar algo en esos 10 segundos que pasan entre ping y pudoEnviarPing
        //cuando envia ping cancela el timeout y no muestra que se perdio internet
        //si no puede enviar ping el timeout se corre y muestra que no tiene internet


        servidor.emitWhenConnected('ping_cpmobile', $scope.ping, function () {
            console.log('emit ping comun realizado: ' + JSON.stringify($scope.ping));

            pudoEnviarPing = true;

            setearHayInternet(true);

        }, function () {
            console.log('hubo un error al realizar el emit común: posiblemente se perdio la conexion con el server ');

            pudoEnviarPing = false;
            //guardarPosicionDesconectado();
        });

        //si trato de enviar el ping, pasan cinco segundos y no lo pudo enviar pone internet en false
        //no poner dentro de ping enviado porque no anda
        var t = $timeout(function () {
            if (pudoEnviarPing) {
                $timeout.cancel(t);

            } else {
                console.log("tiempo vencido al querer enviar ping poniendo internetPrendido en false: ");
                setearHayInternet(false);
                // guardarPosicionDesconectado();

            }
        }, TIEMPO_NO_PING);


        //por ultimo hago un control de si esta activo el gps
        verificarEstadoGps();


    };






    function rtaConsultaPosiciones(estado, respuesta) {

        //console.log('dicposiciones es: ' + JSON.stringify(respuesta));
        //console.log('estado es: ' + estado);
        if (estado) {
            enviarPosicionesRecuperadas(respuesta);
        }
    }






    function enviarPosicionesRecuperadas(respuesta) {
        servidor.emitWhenConnected("recuperar_posiciones", respuesta, function () {

            //$rootScope.internetPrendido = true;
            console.log('emit recuperar_posiciones realizado');
        }, function () {
            console.log('hubo un error al realizar el emit recuperar_posiciones:, posiblemente se perdio la conexion con el server ');
            //$rootScope.internetPrendido = false;

        });
    }






    function guardarPosicionDesconectado() {
        //si no hay internet por las dudas lo pongo en false


        console.log("dentro de guardar posicion desconectado ");

        var query2 = "insert into posicionesNoEnviadas (" +
            "dni," +
            "latitud," +
            "longitud," +
            "estado1," +
            "velocidad," +
            "rumbo," +
            "precision," +
            "hora) values (?,?,?,?,?,?,?,?)";

        //var query2 = "insert into posicionesNoEnviadas (dni) values (?)";

        //ojo constatar que sea igual al ping, lo pongo asi para evitar errores, especialmente por el orden para el insert
        $scope.pingDesconectado = {
            'dni': $scope.ping.dni,
            'latitud': $scope.ping.latitud,
            'longitud': $scope.ping.longitud,
            'estado1': $scope.ping.estado1,
            'velocidad': $scope.ping.velocidad,
            'rumbo': $scope.ping.rumbo,
            'precision': $scope.ping.precision
        };

        $scope.pingDesconectado.hora = obtenerHoraActualConFormato();

        //aca estaba hardcoreado el 3, ahora recupera el que tenia (modificado en version 1.6.1)
        //$scope.pingDesconectado.estado1 = 3;
        $scope.pingDesconectado.estado1 = localStorageService.get('estadoIcono');

        console.log('posicion no enviada: ' + JSON.stringify($scope.pingDesconectado));

        $cordovaSQLite.execute($rootScope.db, query2, [
            $scope.pingDesconectado.dni,
            $scope.pingDesconectado.latitud,
            $scope.pingDesconectado.longitud,
            $scope.pingDesconectado.estado1,
            $scope.pingDesconectado.velocidad,
            $scope.pingDesconectado.rumbo,
            $scope.pingDesconectado.precision,
            $scope.pingDesconectado.hora]).then(function (res) {
            console.log("posicion que no se pudo enviar insertada correctamente");
        }, function (err) {
            console.error(err);
        });

    }






    function estaEnPanico() {
        var estado = despacho.obtenerEstado();
        return estado == 2
    }






    function devolverEstadoPanico() {
        //hay 3 pánicos 1,2,3


        if (!estaEnPanico()) {
            return 0
        }

        // si esta en panico verifica el tipo de panico
        var estadoPanico = panico.obtenerPanicoActivo();
        if (!estadoPanico) {
            return 0
        }

        return estadoPanico

    }






    function limpiarPosiciones() {
        var query = "delete from posicionesNoEnviadas";

        $cordovaSQLite.execute($rootScope.db, query).then(function (res) {
            console.log("tabla posiciones limpiada correctamente");
        }, function (err) {
            console.error(err);
        });
    }






//despliega los elmentos que componen el grupo o sea el servicio
    $scope.abrirGrupo = function () {
        if ($scope.estaCuadroServicioAbierto()) {
            $scope.shownGroup = null;
        } else {
            $scope.shownGroup = $scope.servicio;
        }

    };






//retorna si el grupo (servicio en este caso) esta abierto
    function estaCuadroServicioAbierto() {
        return $scope.shownGroup === $scope.servicio;
    }






//invoca al lector de texto
    function reproducirAudioServicio() {
        dispositivo.leerConTTS(localStorageService.get("textoAleer"));
    }






//invocada cuando llega un servicio nuevo
    function guardarCoordenadasServicio(lat, lon) {
        despacho.guardarCoordenadasServicio(lat, lon);
    }






    function estaConElPasajeroObuscandolo(estado) {
        return estado != 'libre';
    }






    function modificarVolumen() {
        if ($rootScope.esUnAndroid) {
            sistema.setearVolumen($rootScope.volumen);
        }
    }






    function reproducirSonidoServicioNuevo() {
        $scope.sonidoServicio.play();
    }






    function detenerSonidoServicioNuevo() {
        $scope.sonidoServicio.stop();
    }






    function debePonerseOcupado(msg) {
        // devuelve true si debe ponerse ocupado, false si debe ponerse libre
        return msg.id_zona == 0;
    }






    function estaOcupado() {
        // devuelve true si esta ocupado false si esta libre u otro estado
        return obtenerEstadoActual() == 'ocupado';
    }






    function estaLibre() {
        return obtenerEstadoActual() == 'libre';
    }






    function cambiar_estado(msg) {
        msg = angular.fromJson(msg);
        servidor.confirmarComando(localStorageService.get('empresa'), msg['id_comando'], localStorageService.get('hash'));
        console.error("entrando a rta_libre: " + JSON.stringify(msg));

        var ponerOcupado = debePonerseOcupado(msg);
        var estadoOcupado = estaOcupado();
        var estadoLibre = estaLibre();
        var estaTarifando = tarifas.estaTarifando();



        if (estaTarifando) {
            console.log("esta tarifando, no puede cambiar de estado. sale");
            return
        }


        if (ponerOcupado && estadoOcupado) {
            console.log("esta ocupado y debe ponerse ocupado");
            return;
        }


        if (!ponerOcupado && estadoLibre) {
            console.log("esta libre y debe ponerse libre");
            return;
        }


        if (ponerOcupado && estadoLibre) {
            console.log("poniendose ocupado desde libre");
            cambiarEstadoVisual(0);
            return;
        }


        if (!ponerOcupado && estadoOcupado) {
            console.log("poniendose libre desde ocupado");
            cambiarEstadoVisual(1);
        }

    }






    function traerAppDesdeBackgroundAlFrente() {
        try {
            window.plugins.bringtofront()
        }
        catch (e) {

        }
    }






    var cancelamientoArribado = false;






    function iniciarContadorSegundosRestantes(segundos) {
        //tiempo en segundos que aparece el mensaje para poder confirmar un servicio. 30 es segun el timeout que me da el server
        $scope.contador = segundos;

        //si el contador viene con un valor menor a 5, mayor a 60 o indefinido, lo setea por defecto a 30 segundos
        if ($scope.contador < 5 || $scope.contador > 60 || $scope.contador == undefined) {
            $scope.contador = 30;
        }

        //inicia el contador regresivo
        $scope.hiloContadorPopup = $interval(function () {
            $scope.contador--;
        }, 1000);
    }






    function servicioNuevo(msg) {

        console.log('entrando a nuevo servicio: ' + msg);


        cancelamientoArribado = false;

        //convierte lo que llega
        msg = angular.fromJson(msg);


        var esValidaHoraTelefono = tarifas.validarHoraTelefono(moment(), msg.fecha_hora_actual, 5, "minutes");

        // si no es valida la hora del telefono
        if (!esValidaHoraTelefono) {


            navigator.geolocation.clearWatch(watcherPosicion);


            msg.respuesta = "NO";
            confirmarServicio(msg);

            var datosSesion = sesion.obtenerSesion();
            servidor.getConexion().emit('cerrar_sesion', datosSesion, function () {
                console.log('emit cerrar sesion realizado: ');
            });

            clearInterval($rootScope.HiloPosicion);
            $interval.cancel($scope.hiloContadorPopup);
            $interval.cancel($rootScope.intervaloTarifador);


            alert("Por favor configure correctamente su fecha y hora actual");

            $timeout(function () {
                servidor.desconectar();

                irAlEstado("login");
            }, 1000);


            return;
        }


        // si es valida la hora del servicio


        //verifica si es uno repetido y si es asi sale
        if (msg.telefono == telefonoTmp && msg.fecha_hora_servicio == fechaServicioTmp) {
            console.log("recibo el mismo servicio: ");
            return;
        }


        //guarda el id_comando_servicio
        localStorageService.set("id_comando_servicio", msg.id_comando);


        var estado = obtenerEstadoActual();

        //si no está libre sale.
        if (estaConElPasajeroObuscandolo(estado)) {
            console.log("mostrarCuadroServicio es : " + $scope.mostrarCuadroServicio);

            console.log("servicio entero es: " + localStorageService.get("servicio"));


            if (esElMismoServicioQueTiene()) {
                msg.respuesta = "SI";
            } else {
                msg.respuesta = "OC";
            }

            confirmarServicio(msg);

            return;
        }






        function esElMismoServicioQueTiene() {
            var servicio = localStorageService.get("servicio");
            if (servicio) {
                var id_servicio = servicio.id_servicio;
                return id_servicio == msg.id_servicio;
            }
            return false;
        }






        iniciarContadorSegundosRestantes(msg.seg_para_contestar);

        console.log('servicio arribado: ' + JSON.stringify(msg));






        function obtenerTipoTextoAmostrar() {
            return msg.mostrar_direccion;
        }






        var tipoTextoAmostrar = obtenerTipoTextoAmostrar();
        console.log("tipo" + tipoTextoAmostrar);
        switch (tipoTextoAmostrar) {
            case 0: {
                $scope.texto = "Hay un viaje disponible. ¿Desea aceptarlo?";
                $scope.muestraTextoViajeActual = false;
                break;
            }
            case 1: {
                $scope.texto = "Calle " + msg['direccion'];
                $scope.muestraTextoViajeActual = true;

                break;
            }
            case 2: {
                $scope.texto = "Hay un servicio a " + msg['distancia'] + " metros. ¿desea aceptarlo? ";
                $scope.muestraTextoViajeActual = false;

                break;
            }
            case 3: {
                if (msg['observacion']) {
                    $scope.texto = msg['direccion'] + ". Observación: " + msg['observacion'];
                } else {
                    $scope.texto = msg['direccion'];
                }

                $scope.muestraTextoViajeActual = true;

                break;
            }
        }


        // sie sta bajo el sonido lo sube nuevamente para que avise que tiene el viaje
        modificarVolumen();

        //reproduce la musica del servicio nuevo
        reproducirSonidoServicioNuevo();

        //traer App Desde Background Al Frente
        traerAppDesdeBackgroundAlFrente();


        mobile.vibrar(msg.seg_para_contestar * 1000);


        //cuando llega un servicio si no esta en la pantalla de mapa se va automaticamente hacia alli,
        //porque puede romperse el cartel de nuevo servicio
        if ($state.current.name != "barra.general") {
            irAlEstado("barra.general")
        }

        mostrarMensaje();






        function mostrarMensaje() {
            //aparece el popup de confirmacion de servicio


            myPopup = $ionicPopup.confirm({
                    templateUrl: "js/servicios/templates/servicio.html",
                    scope: $scope,
                    cssClass: 'mipopup',
                    okText: ' ACEPTAR',
                    okType: 'ion-android-done button-positive',
                    cancelText: ' IGNORAR',
                    cancelType: 'ion-android-close button-default'
                }
            );

            $rootScope.mensajeMostrado = true;

            fechaServicioTmp = msg.fecha_hora_servicio;
            telefonoTmp = msg.telefono;

            //si el popup de servicio nuevo se muestra correctamente
            myPopup.then(function (aceptaElServicio) {


                //$scope.estaMostrandoseMensaje = true;

                console.log('respuesta del popup: ' + aceptaElServicio);

                //si se termino el tiempo, apretó volver o se esconde el mensaje por algo, sale y lo comunica
                if (aceptaElServicio == undefined) {

                    if (!cancelamientoArribado) {
                        mostrarMensaje();
                        return;
                    }
                }


                //si contesto que acepta el servicio
                if (aceptaElServicio) {

                    if (tarifas.estaTarifando()) {
                        console.log("si esta tarifando");
                        finalizarTarifador();
                    }

                    //$scope.estaMostrandoseMensaje = false;
                    //setea la respuesta en si para pasarle al server
                    msg.respuesta = "SI";

                    msg.usuario = sesion.obtenerDNI();



                    //cupon.setearConCC(true); //si es con cc, para saber si debo pedir el importe
                    //cupon.setearConFirma(1);

                    console.error("antes:" + msg.fecha_hora_servicio);
                    var _fechaYhora = tiempo.str_to_datetime(msg.fecha_hora_servicio);
                    if (_fechaYhora.Estado) {
                        _fechaYhora = _fechaYhora.Respuesta;
                    }

                    var servicioAinsertar = {
                        "id_servicio": msg.id_servicio,
                        "fecha_hora_servicio": _fechaYhora,
                        "lat_servicio": msg.lat_servicio,
                        "lon_servicio": msg.lon_servicio,
                        "es_anticipado": msg.es_anticipado,
                        "estado": 'pendiente',
                        "direccion": msg.direccion,
                        "nombre": msg.nombre,
                        "entre_calles": msg.entre_calles,
                        "servicio_ptt": msg.servicio_ptt,
                        "observacion": msg.observacion,
                        "ciudad": msg.ciudad,
                        "telefono": msg.telefono
                    };

                    var usuarioActual = obtenerUsuarioActual();
                    servicioAinsertar.usuario = usuarioActual;

                    //guarda en la base de datos el servicio
                    orm.insertarEnBD("servicios", servicioAinsertar);

                    notificaciones.anunciar('nuevoServicio');

                    guardarYactualizarEstadoMapa('buscandoAlPasajero');

                    //si es con cta cte guarda los datos del cupón, si id_cupon viene con un uno lo guarda, sino no guarda nada
                    if (msg.id_cupon) {


                        console.error("comisiones:" + msg.comisiones);
                        //prepara los datos para guardar en la base de datos
                        var cupon = {

                            id_cupon: msg.id_cupon,
                            importe: msg.importe,
                            con_firma: msg.firma_cupones,
                            con_importe_fijo: msg.con_importe_fijo,
                            referencia: msg.referencia,
                            nombre_centro_de_costo: msg.nombre_centro_de_costo,
                            nombre_cliente: msg.nombre_cliente,
                            id_centro_de_costo: msg.id_centro_de_costo,
                            id_cliente: msg.id_cliente,
                            estado: 'recibido',
                            id_servicio: msg.id_servicio,
                            parametros_cupon: JSON.stringify(msg.parametros_cupon),
                            inicio_viaje: moment().seconds(0).milliseconds(0).toISOString(),
                            fin_viaje: moment().seconds(0).milliseconds(0).toISOString(),

                        };


                        cupon.usuario = usuarioActual;

                        guardarComisiones(msg.comisiones);

                        orm.insertarEnBD("cupones", cupon);


                        //si no es con cc
                    } else {
                        //verificar si debe ingresar el importe

                    }


                    //simula que no llega la latitud y longitud del servicio
                    //msg.lon_servicio = undefined;
                    //msg.lat_servicio = undefined;

                    //guarda direccion del servicio
                    console.log('msg.lon_servicio: ' + msg.lon_servicio);
                    console.log('msg.lat_servicio: ' + msg.lat_servicio);

                    guardarCoordenadasServicio(msg.lat_servicio, msg.lon_servicio);


                    //guarda el servicio
                    localStorageService.set("servicio", msg);


                    //estos son los elementos que se van a mostrar en el cuadro del viaje actual.
                    $scope.activarCentrar = true;

                    actualizarElementosEnElMapa();

                    mostrarCuadroDeServicio();

                    leerServicio(msg);


                    //si se selecciono "ignorar" en el popup
                } else {
                    //$scope.estaMostrandoseMensaje = false;

                    //setea la respuesta en no porque lo esta rechazando
                    msg.respuesta = "NO";


                    //no muestra el cuadro del viaje actual
                    $scope.mostrarCuadroServicio = false;

                }

                //confirma la recepcion del servicio con el server, acepte o no el servicio
                confirmarServicio(msg);

                detenerIntervalos();

                //detiene la reproduccion de la alarma de recepcion del mensaje
                detenerSonidoServicioNuevo();

                mobile.detenerVibrar()

            });
        }






        //al cumplirse el tiempo sin que se confirme, cancele o ignore, se llama a tiempoVencido
        respuestaTO = $timeout(function () {

            tiempoVencido(msg);
            mobile.detenerVibrar()
        }, $scope.contador * 1000);

    }






    function obtenerUsuarioActual() {
        return localStorageService.get("username")
    }






    function guardarComisiones(comisiones) {
        localStorageService.set("comisiones", comisiones)
    }






    function detenerIntervalos() {
        //cancela el intervalo de los segundos restantes
        $interval.cancel($scope.hiloContadorPopup);

        //cancela el timeout que enviaria el mensaje de timeout al server
        $timeout.cancel(respuestaTO);
    }






    function cerrarPopup() {
        myPopup.close(); //cierra el popup luego de los segundos indicados en el contador
    }






    function tiempoVencido(msg) {

        cancelamientoArribado = true;

        console.log("+entrando en tiempo vencido: ");

        detenerIntervalos();

        msg.respuesta = "TO";      // "TO" de timeout

        cerrarPopup();

        confirmarServicio(msg);

        detenerSonidoServicioNuevo()

    }






//cuando se cancela el servicio desde la web
    function leerMensaje(msg) {
        dispositivo.leerConTTS(msg.mensaje);
    }






    function enviarError(error) {
        var servicio = localStorageService.get("servicio");
        var idServicio;
        if (servicio) {
            idServicio = servicio.id_servicio;
        }


        var dic = {
            error: error + ".el idServicio es:" + idServicio,
            hash: localStorageService.get("hash")
        };

        if (servidor.getConexion()) {
            servidor.getConexion().emit("enviar_error", dic, function () {
                console.log('se pudo realizar el emit: ');
            });
        }
    }






    function servicioCancelado(msg) {
        cancelamientoArribado = true;
        // enviarError("entro a la funcion servicio cancelado");

        msg = angular.fromJson(msg);

        console.log(" + $rootScope.mensajeMostrado: dentro de servicio cancelado " + $rootScope.mensajeMostrado);
        if ($rootScope.mensajeMostrado) {
            msg.telefono = telefonoTmp;
            msg.fecha_hora_servicio = fechaServicioTmp;
            tiempoVencido(msg);
        }

        if (tarifas.estaTarifando()) {
            console.log("si esta tarifando");
            finalizarTarifador();
        }

        console.log('+entro en servicio cancelado: ');

        //confirma comando al server
        servidor.confirmarComando(localStorageService.get('empresa'), msg['id_comando'], localStorageService.get('hash'));

        // if (localStorageService.get("idComando") >= msg['id_comando']) {
        //     enviarError("el idcomando es mas grande");
        //     return;
        // }


        console.log("llega a setear comando");
        localStorageService.set("idComando", msg['id_comando']);


        //si no hay ningun servicio sale de la funcion
        if (localStorageService.get("servicio") == null) {
            // enviarError("no hay servicio");
            return;
        }

        // enviarError("antes del alert");

        //muestra en un alert el mensaje
        alert(msg.mensaje);

        //lee el mensaje
        leerMensaje(msg);

        cambiarEstadosCuponYservicioAcancelado();

        // enviarError("pudo cambiar estado de cupones")

        notificaciones.anunciar('servicioCancelado');

        limpiarPantalla();

        // enviarError("limpia la pantalla")

    }






    function rta_cancelar_servicio(msg) {
        msg = angular.fromJson(msg);

        mobile.cancelarYocultarSpinner();

        console.log('rta cancelar servicio: ' + JSON.stringify(msg));

        if (!msg.Estado) {
            alert(msg.Respuesta);
            return;
        }

        cambiarEstadosCuponYservicioAcancelado();
        notificaciones.anunciar('servicioCancelado');


        $timeout(function () {
            limpiarPantalla();
        }, 2000);

    }






    function cambiarEstadosCuponYservicioAcancelado() {
        console.warn("entra a cambiar estados cupon y servicio cancelado");


        var servicio = obtenerServicioActual();
        if (servicio == false) {
            alert("No hay servicio por cancelar");
            return;
        }

        var id_servicio = servicio.id_servicio;
        console.error("idServiccio:" + id_servicio);

        cambiarEstadoServicioAcancelado(id_servicio).then(function (respuesta) {
            console.log("respuesta en cambiar estado servicio cancelado es:" + JSON.stringify(respuesta));

        }, function (error) {
            console.error("error en  es:" + JSON.stringify(error));

        });


        // var id_cupon = obtenerIdCupon();
        //
        //
        // if (!id_cupon) {
        //     return
        // }
        //
        //
        // catalogoCupones.buscarCuponPorId(id_cupon)
        //     .then(function (respuesta) {
        //         console.log("resspuesta en buscarcuponporid es:" + JSON.stringify(respuesta));
        //
        //         if (!estaDefinido(respuesta[0])) {
        //             return;
        //         }
        //
        //         if (respuesta[0].estado == 'recibido') {
        //             return
        //         }
        //
        //
        //         cambiarEstadoCupon(id_cupon, 'cancelado')
        //     })
    }






    function obtenerIdCupon() {
        console.warn("obtener cupon por completar");

        var servicio = obtenerServicioActual();
        if (servicio == false) {
            return false;
        }

        if (servicio.id_cupon == null) {
            return false;
        }

        return servicio.id_cupon;
    }






    function cambiarEstadoCupon(id_cupon, estado) {
        console.warn("cambiar estado cupon cancelado");

        return catalogoCupones.cambiarEstadoCupon(id_cupon, estado);

    }






    function cambiarEstadoServicioAcancelado(id_servicio) {
        console.warn("cambiar estado servicio cancelado:" + id_servicio);
        return catalogoServicios.cambiarEstado(id_servicio, 'cancelado');
    }






//cuando el server responde ante una solicitud de cancelar un servicio
    function limpiarPantalla() {

        guardarYactualizarEstadoMapa('libre');

        setearZoomInicial();

        limpiarLineaYdestino();

        activarCentradoAutomatico();

        //indica que ya no esta con pasajero
        limpiarLocalStorage();

        //lo pone libre nuevamente
        enviarEstadoAlServer(0);

    }






//crea el estilo de linea continua verde
    $rootScope.estiloVerde =
        new ol.style.Style({
            stroke: new ol.style.Stroke({
                color: 'green',
                width: 3
            })
        });


// var a = [-60.7184027, -32.9333965];
// var b = [-60.714608, -32.934535];
//
// var c = [a, b];


//si hay lineas e icono de bandera la limpia
    function limpiarLineaYdestino() {


        if (localStorageService.get("hayLinea") == true) {
            //limpia la linea
            mapa.limpiarMapa([$scope.sourceLineas]);

            //$scope.bandera = undefined;

            //remueve el icono del destino
            mapa.removerFeature($scope.sourceIconos, $scope.bandera);

            localStorageService.set("hayLinea", false);
        }


    }



      $interval(function(){
              console.log("estado:",$scope.estado);
        },3000);



    function activarCentradoAutomatico() {

        $rootScope.activarCentrado();

    }






    function setearZoomInicial() {
        $timeout(function () {
            //$rootScope.$emit("hacerZoom", true);
            var mapaActual = mapa.obtenerMapa();
            mapa.grabarZoom(17, mapaActual);
        }, 10);
    }






//dibuja los elmentos del mapa, linea, iconos, una vez que se acepta el servicio
    function actualizarElementosEnElMapa() {
        //la linea es un feature

        var servicio = localStorageService.get("servicio");
        var lonServicio = localStorageService.get("lon_servicio");
        var latServicio = localStorageService.get("lat_servicio");
        var longitud = localStorageService.get("longitud");
        var latitud = localStorageService.get("latitud");

        if (servicio == undefined ||
            lonServicio == undefined || lonServicio == 0 ||
            latServicio == undefined || latServicio == 0 ||
            longitud == undefined || longitud == 0 ||
            latitud == undefined || latitud == 0) {
            return;
        }


        $rootScope.linea = mapa.crearLinea(
            lonServicio,
            latServicio,
            longitud,
            latitud
        );


        localStorageService.set("hayLinea", true);

        //argega la linea a la fuente de datos de la capa lineas
        mapa.agregarFeature($scope.sourceLineas, $rootScope.linea);

        //hace el zoom para qu entren todos lo elementos
        mapa.centrarEnUnPunto(
            longitud,
            lonServicio,
            latitud,
            latServicio,
            $scope.map
        );


        //crea el icono del destino
        $scope.bandera = mapa.crearIcono(
            lonServicio,
            latServicio,
            "/android_asset/www/img/flag.png",
            "bandera",
            0.6,
            [0.1, 0.95]
        );
        //agrega el icono ala funete de datos de la capa iconos
        mapa.agregarFeature($scope.sourceIconos, $scope.bandera);


    }






//muestra el servicio en pantalla
    function mostrarCuadroDeServicio() {
        console.warn("entra a mostrar cuadro servicio");
        var servicio = localStorageService.get("servicio");

        if (servicio == undefined) {
            return;
        }

        //setea los valores a mostrar en pantalla del servicio

        $scope.servicio = {
            "nombre": servicio.nombre,
            "direccion": servicio.direccion,
            "observaciones": servicio.observacion,
            "entre_calles": servicio.entre_calles,
            "hora_servicio": servicio.hora_servicio,
            "ciudad": servicio.ciudad,
            "fecha_hora_servicio": servicio.fecha_hora_servicio,
            "distancia": servicio.distancia,
            "id_cliente": servicio.id_cliente,
            "nombre_cliente": servicio.nombre_cliente,
            "id_centro_de_costo": servicio.id_centro_de_costo,
            "nombre_centro_de_costo": servicio.nombre_centro_de_costo,
            "referencia": servicio.referencia,
            "id_servicio": servicio.id_servicio
        };
    }






    function leerServicio(msg) {

        var textoAleer = obtenerTextoParaLeer(msg);

        guardarTextoAleer(textoAleer);

        reproducirAudioServicio();

    }






    function obtenerTextoParaLeer(msg) {
        console.log("msg: " + JSON.stringify(msg));

        var nombre = "";
        var observacion = "";
        var entreCalles = "";
        var textoAleer;

        if (esUnServicioConNombre(msg)) {
            nombre = ",para: " + msg.nombre;
        }
        if (esUnServicioConEntreCalles(msg)) {
            entreCalles = msg.entre_calles;
        }
        if (esUnServicioConObservacion(msg)) {
            observacion = ",observaciónes: " + msg.observacion;
        }

        if (esServicioAnticipado(msg)) {

            textoAleer =
                "servicio anticipado para las: " + msg.hora_servicio +
                ",en: " + msg.direccion + ',' + entreCalles +
                ",de: " + msg.ciudad +
                nombre +
                observacion;

            return textoAleer
        }

        textoAleer =
            msg.direccion + ',' + entreCalles +
            ",de: " + msg.ciudad +
            nombre +
            observacion;


        return textoAleer;
    }






    function esUnServicioConNombre(msg) {
        return msg.nombre != "" && msg.nombre != null;
    }






    function esUnServicioConEntreCalles(msg) {
        return msg.entre_calles != "";
    }






    function esUnServicioConObservacion(msg) {
        return msg.observacion != "";
    }






    function esServicioAnticipado(msg) {
        return msg.es_anticipado;
    }






//lee por tts el servicio
    function guardarTextoAleer(textoAleer) {
        localStorageService.set("textoAleer", textoAleer);
    }






//todo socketones. que tendrian que estar en respuestas service
//todo socketones. que tendrian que estar en respuestas service
//todo socketones. que tendrian que estar en respuestas service
//todo socketones. que tendrian que estar en respuestas service
//todo socketones. que tendrian que estar en respuestas service

    $rootScope.$on("rta_recuperar_posiciones", function (a, msg) {
        msg = angular.fromJson(msg);

        //entro en recuperar posiciones
        console.log('entro en rta_recuperar_posiciones: ');
        if (msg.Estado == null) {
            console.log('rta_recuperar posiciones llama a iniciar sesion: ');
            servidor.iniciarSesion();
        }

        if (msg.Estado) {
            limpiarPosiciones();
        }

    });

    $rootScope.$on('rta_ocupado', function (a, msg) {
        console.log('escucha ocupado: ');
        rta_enviar_estado_al_server(msg, 0)
    });


    $rootScope.$on('rta_libre', function (a, msg) {
        console.log('escucha libre: ');
        rta_enviar_estado_al_server(msg, 1)
    });


    $rootScope.$on('rta_con_pasajero', function (a, msg) {
        msg = angular.fromJson(msg);


        guardarCoordenadasServicio(null, null);

        var id_cupon = esConCuentaCorriente();
        if (id_cupon) {
            cambiarEstadoCupon(id_cupon, 'pendiente');
            guardarYactualizarEstadoMapa('conPasajeroConCC');
        } else {
            guardarYactualizarEstadoMapa('conPasajeroSinCC');
        }


        $rootScope.activarCentrado();

        setearZoomInicial();

        localStorageService.set("textoAleer", null);

        limpiarLineaYdestino();

        mobile.cancelarYocultarSpinner();

    });


    $rootScope.$on('nuevo_servicio', function (a, msg) {
        servicioNuevo(msg);
    });

    $rootScope.$on('servicio_cancelado', function (a, msg) {
        servicioCancelado(msg);
    });

    $rootScope.$on('rta_confirmar_servicio', function (a, msg) {
        rta_confirmar_servicio(msg);
    });

    $rootScope.$on("rta_cancelar_servicio", function (a, msg) {
        rta_cancelar_servicio(msg);
    });






    function cancelarServicio() {

        if (!hayInternet()) {
            alert("No se pudo cancelar el servicio. Compruebe su conexión a internet o comuniquesé con la central");
            return;
        }

        if (!$scope.mostrarCuadroServicio) {
            return;
        }

        $ionicPopup.confirm({
            title: "Esta seguro que desea cancelar el viaje?",
            okText: 'Aceptar',
            cancelText: 'Cancelar'
        }).then(function (apretoAceptar) {
            if (!apretoAceptar) {
                return;
            }

            $ionicLoading.show({
                animation: 'fade-in',
                maxWidth: 300,
                template: "<ion-spinner icon='bubbles'></ion-spinner><br/><span>Cargando..</span>"

            }).then(function () {

                mobile.iniciaTimeoutSpinner(6000);

                try {
                    if (apretoAceptar) {


                        var msg = {
                            "hash": localStorageService.get("hash"),
                            "empresa": localStorageService.get("empresa"),
                            "dni": localStorageService.get("username"),
                            "fecha_hora_servicio": localStorageService.get("servicio").fecha_hora_servicio,
                            "telefono": localStorageService.get("servicio").telefono,
                            "lat_movil": localStorageService.get('latitud'),
                            "lon_movil": localStorageService.get('longitud'),
                            "lat_servicio": localStorageService.get("servicio").lat_servicio,
                            "lon_servicio": localStorageService.get("servicio").lon_servicio,
                            "id_servicio": localStorageService.get("servicio").id_servicio
                        };

                        if (msg.lon_servicio == undefined) {
                            msg.lon_servicio = null;
                        }
                        if (msg.lat_servicio == undefined) {
                            msg.lat_servicio = null;
                        }
                        if (msg.lat_movil == undefined) {
                            msg.lat_movil = null;
                        }
                        if (msg.lon_movil == undefined) {
                            msg.lon_movil = null;
                        }

                        servidor.getConexion().emit('cancelar_servicio', msg, function () {
                            console.log('emit cancelar servicio: ');
                        });

                    }
                }
                catch (e) {
                    console.log("error al querer cancelar el servicio: ");
                }
            })

        });
    }






    function obtenerDatosAconfirmar(msg) {
        var id_cupon = null;
        if (msg.id_cupon) {
            id_cupon = msg.id_cupon;
        }
        return {

            "empresa": localStorageService.get('empresa'),
            "hash": localStorageService.get('hash'),
            "dni": localStorageService.get('username'),
            "respuesta": msg.respuesta,
            "telefono": msg.telefono,
            "fecha_hora_servicio": msg.fecha_hora_servicio,
            "id_cupon_auto": id_cupon

        };

    }






    function confirmarServicio(msg) {


        var datos = obtenerDatosAconfirmar(msg);

        console.log('+entrando en confirmarServicio: ' + JSON.stringify(datos));

        $rootScope.mensajeMostrado = false;

        telefonoTmp = null;
        fechaServicioTmp = null;

        //este emit no tiene respuesta
        servidor.getConexion().emit('confirmar_servicio', datos, function () {
            console.log('emit confirmar servicio: ');
        });
    }






    function enviarEstadoAlServer(estado) {

        // //si hay internet
        // if (!hayInternet()) {
        //     alert("Compruebe su conexion a internet");
        //     return
        // }

        //inicializa el spinner
        $ionicLoading.show({
            animation: 'fade-in',
            maxWidth: 300,
            template: "<ion-spinner icon='bubbles'></ion-spinner><br/><span>Cargando..</span>"

        }).then(function () {

            mobile.iniciaTimeoutSpinner(15000);

            //envia la solicitud al server
            servidor.enviarEstado(estado);
        }, function () {
            alert("No se pudo realizar la peticion")
        });


    }






//envia datos cuando hay un cambio de estado. de libre a ocupado, con pasajero,etc.
// se le comunica al server
    function hayInternet() {
        return $rootScope.internetPrendido;
    }






    function setearHoraFinViaje(id_cupon) {
        return catalogoCupones.setearHoraFinViaje(id_cupon);
    }






    function noLoPermiteElServidor(msg) {
        return !msg.Estado;
    }






    function esUnServicioNormal() {
        return estaConPasajero();
    }






    function rta_enviar_estado_al_server(msg, libreUocupado) {
        msg = angular.fromJson(msg);

        if (msg.Estado == null) {
            servidor.iniciarSesion();
            console.log('rta enviar estado server llama a iniciar sesion: ');
        }

        mobile.cancelarYocultarSpinner();

        //si me deja el server, intercambia visualmente el botón
        if (noLoPermiteElServidor(msg)) {
            alert(msg.Respuesta);
            return
        }

        if (debeLlenarFormulario()) {
            llenarFormulario(libreUocupado);
            console.log("debe llenar formulario");
            return;
        }

        if (debeLlenarImporte()) {
            llenarImporte(libreUocupado);
            console.log("debe llenar importe");
            return;
        }

        if (esUnServicioNormal()) {
            despacharViaje();
            console.log("es un servicio normal");

        }


        // el resto de los casos

        //si pasa de:
        // -libre a ocupado,
        // -de ocupado a libre,
        cambiarEstadoVisual(libreUocupado);

    }






    function debeLlenarFormulario() {
        return debeIngresarElImporte() && esConCuentaCorriente();
    }






    function debeLlenarImporte() {
        return debeIngresarElImporte() && !esConCuentaCorriente();
    }






    function llenarFormulario(libreUocupado) {
        console.warn("debe ingregar el iporte y es con cuentacorriente");
        $rootScope.cuponSeleccionado = obtenerIdCupon();

        cambiarEstadoVisual(libreUocupado);


        sePermiteModificarElCupon($rootScope.cuponSeleccionado).then(function (respuesta) {
            console.log("respuesta en se permite editar el cupon  es:" + JSON.stringify(respuesta));

            setearHoraFinViaje($rootScope.cuponSeleccionado).then(function (respuesta) {
                console.log("resspuesta en  es:" + JSON.stringify(respuesta));

                irAlEstado("barra.general.formularioCupon");

            }, function (error) {
                console.error("error en  es:" + JSON.stringify(error));

            });


        }, function (error) {
            console.error("error en  es:" + JSON.stringify(error));
            alert(error);


        });
    }






    function llenarImporte(libreUocupado) {
        console.warn("debe ingresar el importe");
        cambiarEstadoVisual(libreUocupado);
        irAlEstado("barra.general.importeServicio");
    }






    function despacharViaje() {
        console.warn("esta con pasajero");

        activarCentradoAutomatico();

        setearServicioComoDespachado().then(function (respuesta) {
            console.log("respuesta en setear servicio despachado es:" + JSON.stringify(respuesta));

        }, function (error) {
            console.error("error en  es:" + JSON.stringify(error));

        });
    }






    function sePermiteModificarElCupon(id_cupon) {
        return catalogoCupones.sePermiteModificarElCupon(id_cupon);
    }






    function esServicioConImporte() {
        return servicios.esImporteServicioObligatorio();
    }






    function debeIngresarElImporte(estado) {
        return (estaConPasajero(estado) && esServicioConImporte());
    }






//verifica si el estado es null y reconecta con el server
    function estaConPasajero() {
        var estado = obtenerEstadoActual();

        return estado === 'conPasajeroConCC' || estado == 'conPasajeroSinCC';
    }






    function esConCuentaCorriente() {
        return servicios.esConCuentaCorriente();
    }






    function setearServicioComoDespachado() {

        var servicio = obtenerServicioActual();
        var id_servicio;

        if (servicio) {
            id_servicio = servicio.id_servicio;
        }

        console.log("id_servicio:" + id_servicio);
        return catalogoServicios.cambiarEstado(id_servicio, 'despachado')
    }






    notificaciones.escuchar("ocupadoTarifador", $scope, finalizarTarifador);
    notificaciones.escuchar("finalizarTarifador", $scope, fin);






    function fin() {
        cambiarEstadoVisual(1);
        enviarEstadoAlServer(0)
    }






    function rta_agregar_ticket(msg) {

        if (msg.Estado) {
            console.error("entro en estado true");
            tarifas.borrarTickets();
            despacho.borrarHoraInicioViaje();
            despacho.borrarHoraFinViaje();
        } else {
            console.error("entro a estado false");
        }

    }






    function pasar_a_ocupado(msg) {

        //confirma comando al server
        servidor.confirmarComando(localStorageService.get('empresa'), msg['id_comando'], localStorageService.get('hash'));

        cambiarDistanciaParaOcuparse();
    }






    function cambiarDistanciaParaOcuparse() {

        var servicioActual = obtenerServicioActual();
        if (!servicioActual) {
            console.error("no hay servicio para cambiar distancia al ocuparse");
            return
        }

        servicioActual.dist_para_ocuparse = 0;

        actualizarServicio(servicioActual);

        conPasajero();
    }






    function actualizarServicio(servicio) {
        localStorageService.set("servicio", servicio);
    }






    function irAlEstado(_estado) {
        estado.irAlEstado(_estado)
    }






    //cambia el estado visual de los botones libre ocupado
    function cambiarEstadoVisual(libreUocupado) {

        console.log("actualiza el estado del mapa a ",libreUocupado);
        switch (libreUocupado) {

            //ocupado
            case 0: {
                guardarYactualizarEstadoMapa("ocupado");
                break;
            }
            // libre
            case 1: {
                guardarYactualizarEstadoMapa("libre");
                break;
            }

        }

        //guarda el estado actual del boton, libre o ocupado
        localStorageService.set('estadoIcono', libreUocupado);

    }






    //invocada cuando el server responde la confirmacion de servicio
    function rta_confirmar_servicio(msg) {
        console.log('+entrando en rta_confirmar-servicio: ');
        //msg = angular.fromJson(msg);
        servidor.confirmarComando(
            localStorageService.get('empresa'),
            localStorageService.get("id_comando_servicio"),
            localStorageService.get('hash')
        );

    }






////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//      impostores  impostores  impostores  impostores  impostores  impostores  impostores  impostores  impostores

//impostor de servicio cancelado por el radiotaxi
    $scope.impostorServicioCancelado = function () {

        var msg = {
            "id_comando": 123,
            "mensaje": "el servicio fue cancelado"
        };

        servicioCancelado(msg);

    };






//solo hecho para pruebas
    function selectTotal() {

        var query = "select * from cupones";
        orm.select(query).then(function (respuesta) {
            console.log("resspuesta en cupones es:" + JSON.stringify(respuesta))

        }, function (error) {
            console.error("error en  es:" + JSON.stringify(error))
        });


        query = "select * from servicios";
        orm.select(query).then(function (respuesta) {
            console.log("resspuesta en servicios es:" + JSON.stringify(respuesta))

        }, function (error) {
            console.error("error en  es:" + JSON.stringify(error))
        });


        query = "select * from destinos";
        orm.select(query).then(function (respuesta) {
            console.log("resspuesta en destinos es:" + JSON.stringify(respuesta))

        }, function (error) {
            console.error("error en  es:" + JSON.stringify(error))
        });
    }






    $scope.rutaSonido = "/android_asset/www/img/ic_sonido_activo@4x.png";
    $scope.rutaLoguitoServicio = "/android_asset/www/img/logoblanco.png";






//impostor de nuevo servicio
    function impostorNuevoServicio() {

        var msg = {
            "firma_cupones": 1,
            "ciudad": "Rosario",
            "id_cupon": 258,
            "importe": 0,
            "referencia": "",
            "parametros_cupon": {
                "IdCupon": [1, 1, 1, "Num. cupón"],
                "FechaHoraAutorizado": [0, 0, 0, "Fecha hora autorizado"],
                "FechaHoraFinViaje": [1, 0, 0, "Fin servicio"],
                "FechaFacturacion": [1, 0, 0, "Fecha de facturación"],
                "EsperaEnMinutos": [1, 0, 0, "Minutos de espera"],
                "Siniestro": [1, 0, 0, "Referencia"],
                "ImporteDisposicionFacturacion": [0, 0, 0, "Importe disposición facturación"],
                "GastosVarios": [1, 0, 0, "Gastos varios"],
                "Observaciones": [1, 0, 0, "Observaciones"],
                "ServicioRadioTaxi": [0, 0, 0, "Servicio de radiofrecuencia"],
                "FechaHoraInicioViaje": [1, 0, 0, "Inicio servicio"],
                "Espera": [1, 0, 0, "Espera"],
                "Pasajero": [1, 0, 0, "Nombre pasajero"],
                "SolicitadoPor": [0, 0, 0, "Solicitado por"],
                "DNIChofer": [0, 0, 0, "DNI del chofer"],
                "Km": [1, 0, 0, "Km"],
                "DisposicionEnMinutos": [1, 0, 0, "Minutos a disposición"],
                "ImporteDisposicionMovil": [0, 0, 0, "Importe disposición del móvil"],
                "ImporteFacturacion": [1, 0, 0, "Importe facturación"],
                "DNIPasajero": [0, 0, 0, "DNI Pasajero"],
                "Peajes": [1, 0, 0, "Peajes"],
                "Estacionamiento": [1, 0, 0, "Estacionamiento"],
                "NombreChofer": [0, 0, 0, "Nombre del chofer"],
                "Importe": [1, 1, 1, "Importe"]
            },
            "es_anticipado": 0,
            "id_servicio": 874,
            "direccion": "Uruguay 1234",
            "seg_para_contestar": 31,
            "nombre_centro_de_costo": "Centro 2",
            "nombre": "",
            "fecha_hora_servicio": "29/05/2018 17:24:27",
            "telefono": "ivan",
            "entre_calles": "Entre Entre Rios y Mitre",
            "con_importe_fijo": 0,
            "servicio_ptt": 0,
            "firmantes": [[120, 0, 0, "5366e5298a9050b175317a1e5772786f83edb0e8a3ca0e63635bdd1f2618ae89"], [120, 2, 3, "2fec291cb2abf84ab8991a58c3072a0cbe025cc977229c69164b76c22fa9c17e"]],
            "nombre_cliente": "Airtrack",
            "observacion": "Con cuenta corriente para el cliente 120",
            "lon_servicio": -60.6476731308,
            "id_centro_de_costo": 2,
            "comisiones": [[5, "Prueba 74", "15.00", 11], [10, "prueba 14", "0.00", 0]],
            "id_cliente": 120,
            "id_comando": 1707,
            "lat_servicio": -32.9765266558,
            "mostrar_direccion": 1,
            "hora_servicio": "17:24"
        }


        servicioNuevo(msg);

    }






    $scope.impostorSaldo = function () {
        var msg = {
            "Estado": true,
            "Respuesta": {
                "aviso_saldo": 'te queda 2 tarifa_dias',
                "hash": localStorageService.get("hash"),
                "nombre_empresa": "paco"

            }
        };

        respuestas.rta_iniciar_sesion(msg);
    };

    $scope.impostorSaldoInsuficiente = function () {
        var msg = {
            "Estado": false,
            "Respuesta": "no tiene mas credito. saliendo"
        };

        respuestas.rta_validar_saldo(msg);
    };

//$timeout(function () {
//    $scope.impostorNuevoServicio();
//}, 10000);


}






