angular
    .module('starter')
    .controller('LoginController', LoginController);




function LoginController($cordovaSQLite,
                         $cordovaFile,
                         $cordovaFileTransfer,
                         $ionicPopup,
                         $ionicLoading,
                         $interval,
                         $log,
                         $localForage,
                         $q,
                         $rootScope,
                         $scope,
                         $state,
                         $timeout,
                         archivos,
                         bluetooth,
                         dispositivo,
                         estado,
                         localStorageService,
                         mobile,
                         orm,
                         servidor,
                         sesion,
                         socket,
                         validaciones,
                         URLSERVER) {


    var tiempoMuestraSpinner = 15000;

    $rootScope.gpsPrendido = 'gpsActivado'; //muestra los iconos de gps e internet prendidos por defecto
    $rootScope.internetPrendido = true;
    $scope.formulario = {};
    $rootScope.versionAndroid = mobile.obtenerVersionAndroid(); // obtiene la version de android porque puede ser que se modifique con el tiempo, aunque es raro
    $scope.botonConfiguracion = {ruta: 'img/btnconfiguracion_normal@4x.png'};


    $scope.abrirLoginConfiguracion = abrirLoginConfiguracion;
    $scope.btnPoliticaPrivacidad = abrirPoliticaPrivacidad;
    $scope.btnLogin = btnLogin;
    $scope.conecta = conecta;
    $scope.desconectar = desconectar;
    $scope.seCambioCheckboxRecordar = seCambioCheckboxRecordar;


    //escucha ante un anuncio a insertar datos
    $rootScope.$on("insertar", function (a, b) {
        insertarDatosConfiguracion();
    });


    if (window.cordova) {
        document.addEventListener("deviceready", dispositivoListo, false);
    }




    function abrirLoginConfiguracion() {
        irAlEstado("loginConfiguracion")
    }




    function irAlEstado(_estado) {
        estado.irAlEstado(_estado)
    }




    //$scope.timeoutSpinner = 10;

    //forma de saber si un localStorageService esta vacio. si da 0 no tiene elementos
    //console.log(localStorageService.length());

    function verificarEstadoGps() {

        cordova.plugins.diagnostic.isLocationAvailable(function (enabled) {

            if (enabled) {
                $scope.hayPosicion = true;
                return
            }

            $scope.hayPosicion = false;

            $ionicPopup.confirm({
                template: 'Para que ' + $rootScope.tipo + ' funcione correctamente. Deberá activar el acceso a su ubicacion',
                title: $rootScope.tipo,
                buttons: [{
                    text: 'Activar',
                    type: 'button-positive',
                    onTap: function () {
                        cordova.plugins.diagnostic.switchToLocationSettings();
                    }
                }, {
                    text: 'Cancelar',
                    type: 'button-default',
                    onTap: function (e) {

                    }
                }]
            });

        }, function () {
            console.log("error");

        });

    }




    function insertarDatosConfiguracion() {
        var query = "INSERT INTO configuracion (empresa,nombreEmpresa) VALUES (?,?)";

        $cordovaSQLite.execute($rootScope.db, query, [localStorageService.get('empresa'), localStorageService.get('nombreEmpresa')]).then(function (result) {
            //alert("el id:" + localStorageService.get('empresa') + "fue insertado correctamente");
        }, function (err) {
            console.log(err);
        });
    }




    function recuperarEmpresa() {
        var query = "SELECT * FROM configuracion";

        $cordovaSQLite.execute($rootScope.db, query).then(function (results) {

            if (results.rows.length > 0) {
                console.log("id encontrado:" + results.rows.item(0)['empresa']);

                //recupera y muestra el nombre de la empresa
                $scope.formulario.empresa = results.rows.item(0)['nombreEmpresa'];


                //si empresa visible == false entonces permite escribir la empresa,
                //si es true queda deshabilitado y no permite ingresar la empresa

                $rootScope.empresaVisible = true;

                console.warn("1:" + $scope.formulario.empresa);
                console.warn("2:" + results.rows.item(0)['nombreEmpresa']);
                console.warn("3:" + $rootScope.empresaVisible);
            }
            else {

                //si empresa visible == false entonces permite escribir la empresa, si es true queda deshabilitado
                $rootScope.empresaVisible = false;
                $scope.formulario.empresa = "";

                console.warn("false");

                //este mensaje solo aparece antes de loguearse por primera vez
                console.log("no se encontro la empresa en la base de datos");

            }
        })
    }




    // $scope.username = 1;
    // $scope.contrasenia = '1';

    function continuarSiBluetoothEstaPrendido() {
        bluetooth.determinarBluetoothAusar().then(function (respuesta) {
            console.log("respuesta en  es:" + JSON.stringify(respuesta));

            if (respuesta != 'serial') {
                return;
            }

            bluetooth.estaPrendido().then(function (respuesta) {
                console.log("respuesta en  es:" + JSON.stringify(respuesta));
                hacerLogin();
            }, function (error) {
                console.error("error en  es:" + JSON.stringify(error));
                alert("Para poder ingresar debe encender el bluetooth. Ante inconvenientes " +
                    "comuniquesé con la central.");
            });


        }, function (error) {
            console.error("error en  es:" + JSON.stringify(error));

            alert("Para poder ingresar debe encender el bluetooth. Ante inconvenientes " +
                "comuniquesé con la central");
        });

    }




    function btnLogin() {

        // si no usa mac entra normalmente
        if (!sesion.obtenerUsaMac()) {
            hacerLogin();
            return;
        }

        // si usa mac primero verifica que el bluetooth este prendido para continuar en el login
        continuarSiBluetoothEstaPrendido();

    }








/////////////////////////////////////////////////////////////////////////////
    function hacerLogin() {


        var empresa = $scope.formulario.empresa;
        var username = $scope.formulario.username;
        var password = $scope.formulario.contrasenia;
        console.log("empresa:" + empresa);
        //$scope.controlDiagnostic();

        // if (!$rootScope.internetPrendido) {
        //     alert("No se pudo iniciar sesión. Compruebe su conexión a internet");
        //     return;
        // }


        var timeout = 0;

        $timeout(function () {

            //si tiene gps
            if (!$scope.hayPosicion) {
                verificarEstadoGps();
                return
            }


            //si el nombre de la empresa es undefined la guarda
            //por ejemplo la primera vez no habia nada. ingreso 1_66 se guardo 1_66. envio 1_66
            if (localStorageService.get("nombreEmpresa") == undefined) {
                var empresaConGuionBajo = dispositivo.reemplazarCaracter(empresa, "_");

                //empresa es 1_66 por ejemplo. aca parece que esta el problema,
                //por algun motivo guarda el nombre
                localStorageService.set("empresa", empresaConGuionBajo);
            }


            localStorageService.set('username', username);
            localStorageService.set('password', password);


            var usuario = {
                'empresa': localStorageService.get('empresa'),
                'dni': username,
                'password': password
            };

            //controla que los datos esten definidos para no enviar datos erroneos
            if (usuario.dni == undefined) {
                alert("Por favor ingrese un nombre de usuario valido");
                return;
            }
            if (usuario.empresa == undefined) {
                alert("Por favor ingrese una empresa valida");
                return;
            }
            if (usuario.password == undefined) {
                alert("Por favor ingrese una contraseña valida");
                return;
            }

            console.log('en login llama a iniciar sesion: ');


            // // si esta conectado inicia sesion
            // if (servidor.isconnected()) {
            //     console.log("ya esta conectado");
            //     servidor.iniciarSesion();
            //     return
            // }


            // obtiene la url con puerto a conectar.
            // -si es desarrollo conecta a paco o jony.
            // -si es produccion y trackphone a la url de trackphone
            // -si es produccion y cpmobile a la ingresada en configuracion

            // si no esta conectado, conecta
            // conectarConServer()


            conectar().then(function (respuesta) {
                console.log("respuesta en aba es:" + JSON.stringify(respuesta));
            }, function (error) {
                console.error("error en aba es:" + JSON.stringify(error));
                alert(error);
            });


        }, timeout);
    }




    function conecta() {
        servidor.conectar();

    }




    function hayIpsGuardadas() {
        var ip0 = localStorageService.get("ip0");
        var ip1 = localStorageService.get("ip1");
        var ip2 = localStorageService.get("ip2");
        var ip3 = localStorageService.get("ip3");

        console.log("0" + ip0);
        console.log("1" + ip1);
        console.log("2" + ip2);
        console.log("3" + ip3);
        if (!ip0 && !ip1 && !ip2 && !ip3) {
            return false;
        }

        return true;
    }




    function obtenerIp(numero) {

        switch (numero) {

            case 0: {
                return localStorageService.get("ip0");
                break;
            }

            case 1: {
                return localStorageService.get("ip1");

                break;
            }

            case 2: {
                return localStorageService.get("ip2");

                break;
            }

            case 3: {
                return localStorageService.get("ip3");

                break;
            }
        }

        return null


    }




    function esValidaLaIp(ip) {
        return validaciones.validar_vacio_null_y_undefined(ip).Estado
    }




    console.error("hora actual:" + Date());




    function conectar() {

        var defer = $q.defer();

        if ($rootScope.apk == 'trackphone') {

            var trackphone = true;

            conectarConServer(servidor.obtenerUrlServidor(), trackphone).then(function (respuesta) {
                console.log("respuesta en  es:" + JSON.stringify(respuesta));
                defer.resolve();
                return defer.promise;

            }, function () {
                defer.reject("intente nuevamente mas tarde.");
                return defer.promise;

            });

            return defer.promise;

        }

        ////////////////////////////////////
        // solo si es cpmobile


        console.log("es cpmobile");
        if (!hayIpsGuardadas()) {
            defer.reject("No se encontraron IP'S guardadas. Por favor agréguelas");
            $state.go("loginConfiguracion");
            return defer.promise;
        }


        var num = 0;
        probarConectar(num);




        function probarConectar(num) {
            //funcion que intenta conectar con las distintas ips. solo usable en cpmobile

            console.error("numero pasado:" + num);
            if (num > 3) {
                defer.reject("Revise su conexión a internet. Se intentó conectar con las IP'S guardadas sin éxito ");
                return defer.promise;
            }

            var ip = obtenerIp(num); //obtiene la ip guardada, segun el numero


            if (esValidaLaIp(ip)) {

                // no paso segundo parametro porque siempre es cpmobile esto
                conectarConServer(ip).then(function (respuesta) {
                    console.log("respuesta en  es:" + JSON.stringify(respuesta));
                    defer.resolve();
                    return defer.promise;
                }, function () {
                    console.error("entro en reject:" + num);
                    num++;
                    probarConectar(num)

                });
            } else {
                console.error("entro en else:" + num);
                num++;
                probarConectar(num)
            }
        }




        return defer.promise;

    }




    function conectarConServer(ip, trackphone) {

        mostrarSpinner(tiempoMuestraSpinner); //muestra spinner

        // crea el defered
        var defer = $q.defer();

        // guarda que es la ultima ip, asi si se conecta bien, la setea por defecto
        servidor.guardarUltimaIpProbada(ip);

        // trata de conectar
        servidor.conectar(ip, true, trackphone);

        //si se cumple el timeout descoencta todo_ para intentar nuevamente de manera "LIMPIA"
        var timeoutDeLimpieza = $timeout(function () {

            console.error("entro en timeout de cancelamiento");

            servidor.removerTodosLosListeners();//remueve listeners de conexion
            cancelarSpinner();//cancela spinner
            cancelarIntervalo(intervaloVerificacionConexion); //cancela el intervalo de verificacion de conexion
            desconectar(); //desconecta
            return defer.reject(); //retorna el rechazo asincronico

        }, tiempoMuestraSpinner);


        // inicia un intervalo en que verifica si esta conectado, cuando conecta se cancela el intervalo y trata
        // de iniciar sesion
        var intervaloVerificacionConexion = $interval(function () {


            // si esta conectado
            if (!servidor.isconnected()) {
                return
            }

            // cancela éste intervalo
            $interval.cancel(intervaloVerificacionConexion);

            // cancela el timeout que trata de conectar a otra ip
            $timeout.cancel(timeoutDeLimpieza);

            console.error("ya se conecto al servidor,ahora registra socketones");

            // empieza a escuchar la respuesta del inicio de sesion
            socket.registrarSocketon();


            // esta dentro de un timeout porque tarda un poco en registrar los socketones
            $timeout(function () {
                console.error("envia iniciar sesion");
                servidor.iniciarSesion();
                return defer.resolve();
            }, 500);

        }, 50);

        return defer.promise;
    }




    function mostrarSpinner(tiempoMuestraSpinner) {
        mobile.mostrarSpinner(tiempoMuestraSpinner);
    }




    function cancelarSpinner() {
        mobile.cancelarYocultarSpinner();
    }




    function desconectar() {
        servidor.desconectar();
    }




    function cancelarIntervalo(intervaloConexion) {
        $interval.cancel(intervaloConexion); //si o si dejar aca porque sino inicia sesion mil veces
    }




    function seCambioCheckboxRecordar() {
        $rootScope.recordar = $scope.recordar;
    }




    function habilitacionBotonIngresar() {
        $scope.botonIngresarDesactivado = true;
    }




    function recuperarDatosDelCpMobileViejo() {
        recuperarDatosCpMobile("parametros");
        recuperarDatosCpMobile("servicios");
        recuperarDatosCpMobile("cupones");
        recuperarDatosCpMobile("mensajes");
        recuperarDatosCpMobile("cupones_destinos");
    }




    function recuperarDatosCpMobile(tabla) {
        var tablaDestino = tabla;
        if (tabla == 'mensajes') {
            tablaDestino = 'a5'
        }
        if (tabla == 'cupones_destinos') {
            tablaDestino = 'destinos'
        }

        var base = window.sqlitePlugin.openDatabase({
            name: 'CpMobileBd',
            location: 'default'
        }, function () {

            var query = "select * from " + tabla;

            select(query, base).then(function (results) {
                if (results) {
                    guardarDatosDelCpMobileViejo(results, tabla, tablaDestino)
                }
            }, function (err) {
                $log.warn("no se puede hacer la select, posiblemente no exista la tabla del cpmobile viejo:" + tabla)
            });
        }, function () {
            $log.warn("no se pudo abrir la base datos vieja")
        });
    }




    function select(query, base) {
        return orm.select(query, base);
    }




    function obtenerRegistro(tabla, results, i) {

        switch (tabla) {
            case 'parametros': {
                var registro = armarParametroParaGuardar(results, i);
                console.error("guardando en obtener registro");
                localStorageService.set("ip1", registro.primera_ip);
                localStorageService.set("ip2", registro.segunda_ip);
                localStorageService.set("ip3", registro.tercera_ip);
                localStorageService.set("puerto", registro.puerto);


                return registro;
            }

            case 'cupones': {
                return armarCuponParaGuardar(results, i);
            }

            case 'cupones_destinos': {
                return armarDestinoParaGuardar(results, i);
            }

            case 'mensajes': {
                return armarMensajeParaGuardar(results, i);
            }

            case 'servicios': {
                return armarServicioParaGuardar(results, i);
            }
        }
    }




    function guardarDatosDelCpMobileViejo(results, tabla, tablaDestino) {

        for (var i = 0, longitud = results.length; i < longitud; i++) {

            var registro = obtenerRegistro(tabla, results, i);

            //o Tue Jun 26 2018 11:41:15 GMT-0300 (ART)

            if (registro != null) {
                guardarEnBd(tabla, registro).then(function (respuesta) {
                    $log.warn("respuesta en insertar en tabla " + tabla + " es:" + JSON.stringify(respuesta));
                }, function (error) {
                    $log.warn("error en insertar en tabla " + tabla + " es:" + JSON.stringify(error));
                });
            } else {
                $log.warn("registro nulo")
            }

        }

        // select solo para verificar
        // select("select * from " + tablaDestino, $rootScope.db).then(function (respuesta) {
        //     $log.warn("respuesta en busqueda:" + tablaDestino + " recuperados es:" + JSON.stringify(respuesta));
        // }, function (error) {
        //     $log.warn("error en busqueda es:" + JSON.stringify(error));
        // });
    }




    function armarParametroParaGuardar(results, i) {

        var parametro = {
            usuario: results[i].usuario,
            primera_ip: results[i].primera_ip,
            segunda_ip: results[i].segunda_ip,
            tercera_ip: results[i].tercera_ip,
            puerto: 3001,
            ultimo_password: results[i].ultimo_password
        };


        return parametro;
    }




    function armarDestinoParaGuardar(results, i) {
        var destino = {
            num_destino: results[i].num_destino,
            id_cupon: results[i].id_cupon_auto,
            lat_servicio: results[i].latitud,
            lon_servicio: results[i].longitud,
            espera: results[i].espera,
            enviado: results[i].enviado,
            fecha_hora: results[i].fecha_hora,
        };

        return destino;
    }




    function armarServicioParaGuardar(results, i) {
        var servicio = {
            id_servicio: results[i].id_servicio,
            fecha_hora_servicio: results[i].fecha_hora,
            lat_servicio: null,
            lon_servicio: null,
            es_anticipado: null,
            direccion: results[i].direccion,
            importe: results[i].importe,
            nombre: null,
            entre_calles: null,
            servicio_ptt: null,
            observacion: results[i].datos,
            ciudad: results[i].ciudad,
            telefono: null,
            usuario: results[i].usuario

        };


        switch (results[i].estado) {
            case 0: {
                servicio.estado = 'pendiente';
                break;
            }
            case 1: {
                servicio.estado = 'despachado';
                break;
            }
            case 2: {
                servicio.estado = 'cancelado';
                break;
            }
        }
        return servicio;
    }




    function armarCuponParaGuardar(results, i) {
        var cupon = {
            id_cupon: results[i].id_cupon_auto,
            id_servicio: results[i].id_servicio,
            id_centro_de_costo: results[i].id_centro_de_costo,
            id_cliente: results[i].id_cliente,
            id_firmante: null,
            num_cupon: results[i].cupon,
            con_firma: 0,
            con_importe_fijo: results[i].con_importe_fijo,
            disposicion_en_minutos: results[i].disposicion_en_minutos,
            espera: results[i].espera,
            espera_en_minutos: results[i].espera_en_minutos,
            estacionamiento: results[i].estacionamiento,
            fin_viaje: results[i].fin_viaje,
            gastos_varios: results[i].gastos_varios,
            importe: results[i].importe,
            inicio_viaje: results[i].inicio_viaje,
            km: results[i].km,
            nombre_cliente: results[i].nombre_cliente,
            nombre_centro_de_costo: results[i].nombre_centro_de_costo,
            peajes: results[i].peajes,
            referencia: null,
            parametros_cupon: JSON.stringify({
                "DisposicionEnMinutos": [1, 0, 0],
                "IdCupon": [1, 0, 0],
                "Importe": [1, 1, 0],
                "Km": [1, 0, 1],
                "EsperaEnMinutos": [1, 0, 0],
                "Espera": [1, 0, 0],
                "Peajes": [1, 0, 0],
                "Estacionamiento": [1, 0, 0],
                "GastosVarios": [1, 0, 0],
                "FechaHoraInicioViaje": [1, 0, 0],
                "FechaHoraFinViaje": [1, 0, 0],
            }),
            usuario: results[i].usuario
        };


        switch (results[i].estado) {
            case 0: {
                cupon.estado = 'pendiente';
                cupon.enviado = 0;
                break;
            }
            case 1: {
                cupon.estado = 'completado';
                cupon.enviado = 1;
                break;
            }
            case 2: {
                cupon.estado = 'cancelado';
                cupon.enviado = 1;
                break;
            }
        }
        return cupon;
    }




    function armarMensajeParaGuardar(results, i) {
        var mensaje = {
            id: results[i].id,
            idServidor: null,
            dni: results[i].usuario,
            mensaje: results[i].mensaje,
            estado: 'recibido',
            fecha: results[i].fecha_hora
        };

        if (results[i].remitente == 'Chofer') {
            mensaje.remitente = 'yo'
        } else {
            mensaje.remitente = 'otro'
        }

        return mensaje;
    }




    function guardarEnBd(tabla, datoAguardar) {

        if (tabla == 'mensajes') {
            return orm.insertarEnBD('a5', datoAguardar)
        }

        if (tabla == 'cupones_destinos') {
            return orm.insertarEnBD("destinos", datoAguardar)
        }

        return orm.insertarEnBD(tabla, datoAguardar)


    }




    function obtenerVersionBaseDatos() {
        return localStorageService.get("versionBaseDatos");
    }




    function actualizarBaseDatos() {
        var versionBaseDatos = obtenerVersionBaseDatos();

        $log.warn("version de base de datos:" + versionBaseDatos);

        // la primera vez que ejecuta esta version sea cpmobile o trackphone
        if (versionBaseDatos == null) {

            //al guardarla nunca mas entra aca. a menos que se borren todos los datos
            localStorageService.set("versionBaseDatos", '1.0');

            // agrega columna usuario
            agregarColumna("cupones", "usuario varchar(11)").then(function (respuesta) {
                $log.warn("respuesta en agregar columna cupon es:" + JSON.stringify(respuesta));
            }, function (error) {
                $log.warn("error en  es:" + JSON.stringify(error));
            });


            // agrega columna usuario
            agregarColumna("servicios", "usuario varchar(11)").then(function (respuesta) {
                $log.warn("respuesta en agregar columna a servicios es:" + JSON.stringify(respuesta));
            }, function (error) {
                $log.warn("error en  es:" + JSON.stringify(error));
            });


            // si es cp mobile recupera los datos
            if ($rootScope.apk == 'cpmobile') {
                $log.warn("es cpmobile trata de recuperar datos viejos");
                $timeout(function () {

                    //si es la primera vez que instala cpmobile no pasa nada
                    recuperarDatosDelCpMobileViejo();
                }, 1500);
            }
            // si es trackphone no recupera los datos del cpmobile
            else if ($rootScope.apk == 'trackphone') {

                $timeout(function () {

                    // agrega campo usuario
                    agregarCampoUsuarioAtablas();
                    $log.warn("actualiza campo usuario porque es trackphone")
                }, 1500);

            }

            // si ya ejecuto esta version alguna vez
        } else {
            $log.warn("ya esta actualizada la base de datos")
        }
    }




    function agregarCampoUsuarioAtablas() {

        // si es trackPhone y ya tenía cupones o servicios hay que poner el usuario por defecto
        var usuarioActual = obtenerUsuarioActual();

        // si no hay usuario guardado es porque entra por primera vez. entonces no actualiza los usuarios
        if (usuarioActual == null) {
            return
        }


        var cupon = {
            usuario: usuarioActual
        };

        actualizarTabla("cupones", cupon).then(function (respuesta) {
            $log.warn("actualizacion cupon ok")
        }, function (error) {
            $log.warn("actualizacion cupon mal")
        });


        var servicio = {
            usuario: usuarioActual
        };

        actualizarTabla("servicios", servicio).then(function (respuesta) {
            $log.warn("actualizacion servicio ok")
        }, function (error) {
            $log.warn("actualizacion servicio mal")
        });
    }




    function actualizarTabla(tabla, dato) {
        return orm.update(tabla, dato);
    }




    function obtenerUsuarioActual() {
        return localStorageService.get("username")
    }




    function agregarColumna(tabla, columna) {
        return orm.alterTable(tabla, columna);
    }




    function gurdarVersionApp(version) {
        localStorageService.set("versionApk", version);
    }




    //setea la version de la app
    function verificarVersionLocal() {
        cordova.getAppVersion.getVersionNumber(function (version) {

            console.log("la version de la app es " + version);
            $scope.versionDeLaApp = version;
            gurdarVersionApp(version);
        });
    }




    function crearTablas() {
        var query = "CREATE TABLE IF NOT EXISTS configuracion (" +
            "empresa varchar PRIMARY KEY," +
            "nombreEmpresa varchar)";

        orm.ejecutarQueryCreacionTablas(query, "configuracion");

        recuperarEmpresa();


        //a5 seria la tabla mensajes, lo que pasa es que lo puse por poner cuando estaba haciendo pruebas y quedo asi sin querer
        query = "CREATE TABLE IF NOT EXISTS a5 (" +
            "id INTEGER PRIMARY KEY," +
            " idServidor int null," +
            " dni text," +
            " mensaje text," +
            "estado text default 'enviando'," +
            " remitente text," +
            " fecha datetime)";

        orm.ejecutarQueryCreacionTablas(query, "a5");


        query = "CREATE TABLE IF NOT EXISTS parametros (" +
            "usuario VARCHAR(11) PRIMARY KEY, " +
            "primera_ip VARCHAR(50), " +
            "segunda_ip VARCHAR(50), " +
            "tercera_ip VARCHAR(50), " +
            "puerto INT(5), " +
            "ultimo_password VARCHAR(15))";

        orm.ejecutarQueryCreacionTablas(query, "parametros");


        query = "CREATE TABLE if not exists posicionesNoEnviadas (" +
            "id int primary key," +
            "dni int," +
            "latitud real," +
            "longitud real," +
            "estado1 tinyint," +
            "velocidad real," +
            "rumbo real," +
            "precision tinyint," +
            "hora varchar)";

        orm.ejecutarQueryCreacionTablas(query, "posiciones pendientes");


        query = "CREATE TABLE IF NOT EXISTS servicios (" +
            " id_servicio INTEGER PRIMARY KEY," +
            " fecha_hora_servicio varchar(19)," +
            " lat_servicio float," +
            " lon_servicio float," +
            " es_anticipado tinyint," +
            " direccion varchar(50)," +
            " estado varchar (20)," +
            " importe real," +
            " nombre varchar(50)," +
            " entre_calles varchar(100)," +
            " servicio_ptt tinyint," +
            " observacion varchar (60)," +
            " ciudad varchar(40)," +
            " telefono varchar (20))";

        //baseDatos.borrarTabla("servicios");
        orm.ejecutarQueryCreacionTablas(query, "servicios");


        query = "CREATE TABLE IF NOT EXISTS cupones (" +
            " id_cupon INTEGER PRIMARY KEY," +
            " id_servicio integer," +
            " id_centro_de_costo int," +
            " id_cliente smallint," +
            " id_firmante int," +
            " num_cupon varchar(20)," +
            " con_firma tinyint," +
            " con_importe_fijo tinyint," +
            " disposicion_en_minutos int," +
            " enviado tinyint default 0," +
            " estado varchar (20)," +
            " espera real," +
            " espera_en_minutos int," +
            " estacionamiento real," +
            " fin_viaje varchar(19)," +
            " gastos_varios real," +
            " importe real," +
            " inicio_viaje varchar(19)," +
            " km real," +
            " nombre_cliente varchar(50)," +
            " nombre_centro_de_costo varchar(50)," +
            " peajes real," +
            " referencia varchar (100)," +
            " parametros_cupon varchar (1000))"
        ;


        //baseDatos.borrarTabla("cupones");
        orm.ejecutarQueryCreacionTablas(query, "cupones");


        query = "CREATE TABLE IF NOT EXISTS destinos (" +
            " num_destino INTEGER not null," +
            " id_cupon integer," +
            " lat_servicio float," +
            " lon_servicio float," +
            " espera int," +
            " enviado tinyint default 0," +
            " fecha_hora varchar(19)," +
            " primary key(id_cupon, num_destino))";

        orm.ejecutarQueryCreacionTablas(query, "destinos");
    }




    function dispositivoListo() {
        // listarArchivosDeDirectorio("file:///storage/emulated/0/camara/").then(function(respuesta){

        console.log("1-", device.versionNameCamara);

        // _mostrarStatusBarSiEstaElTecladoAbierto();


        // _esconderStatusBar();

        // launchnavigator.navigate("London, UK");

        verificarEstadoGps();


        habilitacionBotonIngresar();


        // cordova.plugins.backgroundMode.ondeactivate = function () {
        //     // _esconderStatusBar()
        // };


        console.log('desarrolo: ' + $rootScope.desarrollo);


        $rootScope.db = window.sqlitePlugin.openDatabase({name: 'my2.db', location: 'default'},
            function () {
                // $cordovaSQLite.deleteDB(db);
                //tinyint 0 - 255
                //smallint -32000 - 32000

                //baseDatos.borrarTabla("destinos");

                crearTablas();

                actualizarBaseDatos();
            },

            function (err) {
                alert(err);
            }
        );


        // function verificacionDeVersion() {
        //
        //     verificarVersionLocal();
        //
        //     servidor.getConexion().emit('version', "true");
        //
        //     servidor.getConexion.on('rta_version', function (msg) {
        //         if (msg.version > $scope.versionDeLaApp) {
        //             popupActualizacion();
        //         }
        //     });
        //
        //     //hardcodeado
        //     popupActualizacion()
        // }


        // function popupActualizacion() {
        //     var myPopup = $ionicPopup.confirm({
        //             title: "Hay una actualizacion disponible",
        //             scope: $scope,
        //             template: "¿Desea actualizar?",
        //             okText: 'Actualizar',
        //             cancelText: 'Mas tarde'
        //         }
        //     );
        //
        //     myPopup.then(function (res) {
        //         if (res) {
        //             window.open = cordova.InAppBrowser.open('https://play.google.com/store/apps/details?id=com.trackphone', '_system', 'location=no, clearcache=yes, hardwareback=yes');
        //         }
        //
        //     });
        // }


        //verificacionDeVersion();
        verificarVersionLocal();


        $scope.recordar = localStorageService.get("recordar");
        $rootScope.recordar = $scope.recordar;

        if ($rootScope.recordar) {
            $scope.formulario.username = localStorageService.get("username");
            $scope.formulario.contrasenia = localStorageService.get("password");
        }







    }




    function _esconderStatusBar() {
        mobile.esconderStatusBar()
    }




    function abrirPoliticaPrivacidad() {
        window.open = cordova.InAppBrowser.open('http://admin.trackphone.com.ar/#/politicas', '_system', 'location=no, clearcache=yes, hardwareback=yes');
    }




    function _mostrarStatusBarSiEstaElTecladoAbierto() {
        mobile.mostrarStatusBarSiEstaElTecladoAbierto();
    }

}