angular
    .module('starter')
    .controller('MapaController', MapaController);





function MapaController(mapa,
                        $rootScope,
                        $scope,
                        $interval,
                        $timeout,
                        $ionicLoading,
                        servidor,
                        localStorageService) {


    $scope.activarCentrar = true;


    $scope.IndexMapa = function () {
        $rootScope.indic = localStorageService.get('indic');
        if ($rootScope.indic == 0) {
            return "mapa-1";
        }

        return "mapa-2";

    };

    //permite desactivar el centrado automatico
    $scope.desactivarCentrado = function () {
        $scope.activarCentrar = false;
        console.log("centrado desactivado");
    };


    //activa el centrado automatico
    $rootScope.activarCentrado = function () {
        console.log("entrando en activar centrado");
        $scope.activarCentrar = true;
        var lat = localStorageService.get('latitud');
        var long = localStorageService.get('longitud');

        console.log("lat:" + lat);
        console.log("lon:" + long);

        //invocada para actualizar el mapa con posiciones actuales
        if (lat == null || long == null) {
            $rootScope.gpsPrendido = 'gpsDesactivado';
            return;
        }


        //si tiene latitud y longitud
        //$rootScope.gpsPrendido = 'gpsActivado';
        $rootScope.actualizarMapa(lat, long);
        console.log("centrado activo");
    };


    //establece los tiles del mapa
    var capaMapa = mapa.crearCapaTile(mapa.crearSourceXYZ());

    //crea la funente de datos para pasarle a la capa
    $scope.sourceLineas = mapa.crearSourceVector();

    //crea la capa
    $scope.capaLineas = mapa.crearCapaVector($scope.sourceLineas);

    //crea el estilo de linea
    var estiloLinea = new ol.style.Style({
        stroke: new ol.style.Stroke({
            color: 'green',
            width: 3
        })
    });

    //setea el estilo de la linea a la capa de las lineas
    $scope.capaLineas.setStyle(estiloLinea);


    var lat = localStorageService.get('latitud');
    var long = localStorageService.get('longitud');

    //invocada para actualizar el mapa con posiciones actuales
    if (lat == null || long == null) {
        lat = -32.97;
        long = -60.68;
    }

    var iconoPrincipal = mapa.crearIcono(long, lat, "/android_asset/www/img/ic_movil_mapa70.png", "iconoCentral", 0.6);

    $scope.sourceIconos = mapa.crearSourceVector();

    $scope.capaIconos = mapa.crearCapaVector($scope.sourceIconos);

    mapa.agregarFeature($scope.sourceIconos, iconoPrincipal);

    //crea el mapa

    var vista = new ol.View({
        projection: 'EPSG:4326',
        center: [long, lat],
        zoom: 17
    });

    $scope.map = mapa.crearMapa(vista, document.getElementById('map'), [capaMapa, $scope.capaLineas, $scope.capaIconos]);


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    //hace zoom o quita zoom
    $scope.zoom = function (tipo) {
        //aumenta o reduce el zoom en el valor que le ingrese
        var zoomActual = $scope.map.getView().getZoom() + tipo;

        //setea el nuevo zoom
        $scope.map.getView().setZoom(zoomActual);
    };





    //modifica la rotacion y posicion del movil
    function modificar_movil(lat, long, rumbo) {

        if (iconoPrincipal != undefined) {
            //se pone en un timeout, porque puede tirar error de $apply
            $timeout(function () {
                mapa.centrarIcono(iconoPrincipal, long, lat);
                // try {
                //     iconoPrincipal.getStyle().getImage().setRotation(rumbo * 0.01745329251);
                // } catch (e) {
                // }
                //iconFeature.getGeometry().setCoordinates([long, lat]);
            }, 0);
        }
    }





    //modifica el centro del mapa
    function modificar_centro_mapa(lat, long) {

        if ($scope.map != undefined) {
            //se pone en un timeout, porque puede tirar error de $apply
            $timeout(function () {
                $scope.map.getView().setCenter([long, lat]);
            }, 0);
        }
    }



    function hayServicio() {
        return localStorageService.get("servicio");
    }

    //invoca la modificacion y centrado de mapa
    $rootScope.actualizarMapa = function (lat, long, rumbo) {

        //lat=lat+0.005;

        if ($scope.activarCentrar == true) {
            modificar_centro_mapa(lat, long);
        }

        //pase lo que pase mueve el movil
        modificar_movil(lat, long, rumbo);


        if (!hayServicio()) {
            return
        }


        //define las latitudes y longitudes para modificar la linea
        var arreglo = [
            [long, lat],
            [localStorageService.get("lon_servicio"), localStorageService.get("lat_servicio")
            ]
        ];


        //si las del servicio estan definidas, dibuja la linea
        if (!hayLatLon()) {
            return
        }

        mapa.actualizarLinea($rootScope.linea, arreglo);

        //si esta activo el centrado, hace el zoom automatico
        if ($scope.activarCentrar == true) {
            mapa.centrarEnUnPunto(
                long,
                localStorageService.get('lon_servicio'),
                lat,
                localStorageService.get('lat_servicio'),
                $scope.map
            );

        }
    };



    function hayLatLon() {
        return localStorageService.get('lon_servicio') != undefined &&
            localStorageService.get('lon_servicio') != 0 &&
            localStorageService.get('lat_servicio') != undefined &&
            localStorageService.get('lat_servicio') != 0;
    }

    //obtiene informacion de la version de android y en base a eso devuelve una clase si es mayor a la version 5.0
    // porque sino muestra el mapa en tamaño completo
    $scope.polyfillMapa = function () {

        //obtiene informacion del dispositivo
        var deviceInformation = ionic.Platform.device();

        //obtiene informacion de la version
        var a = deviceInformation.version;

        //convierte el texto a numero para poder comparar mas facil
        var b = parseInt(a);
        //alert(b);
        //hacer que sea posterior a la 5
        if (b >= 5) {
            return "divMapa";
        }
    };


    //actualiza el mapa,porque a veces lo muestra expandido, ya que define el tamaño del mapa y despues el div que
    //lo contiene
    //con estoasi le anda a adrian
    // handle event
    $timeout(function () {
        try {
            if ($scope.map) {
                $scope.map.updateSize();
            }
        } catch (e) {
        }
    }, 200);


    // $rootScope.linea = mapa.crearLinea(
    //     lonOrigen,
    //     latOrigen,
    //     lonDestino,
    //     latDestino,
    //     lonDestino3,latDestino3
    // );
    //
    //
    // localStorageService.set("hayLinea", true);
    //
    // //argega la linea a la fuente de datos de la capa lineas
    // mapa.agregarFeature($scope.sourceLineas, $rootScope.linea);


    //     var a = {
    //         latitud: -32.933374,
    //         longitud: -60.7183357,
    //         precision:20,
    //         fecha:Date.now()
    //
    //     };
    //
    //     function precisionMaxima (valor){
    //         return valor>50
    //     }
    //
    //     arregloFinal=[];
    // for (var i = 0, longitud = posicion.length; i < longitud; i++) {
    //     if (precisionMaxima(posicion[i].precision)){
    //         if ()
    //         arregloFinal.push(posicion[i])
    //     }
    // }
    //
    //
    //
    //
    //
    //
    //     console.log("distancia:" + mapa.distanciaEntre2PuntosEnMetros(latOrigen,lonOrigen,latDestino,lonDestino));


}

