/**
 * Creado por ivan fecha 16/02/18.
 */
angular
    .module('starter')
    .controller('FormularioController', cuponesController);





function cuponesController($rootScope,
                           $document,
                           $scope,
                           $window,
                           $ionicHistory,
                           $ionicPopup,
                           $interval,
                           $stateParams,
                           $timeout,
                           $q,
                           catalogoCupones,
                           catalogoServicios,
                           cupon,
                           despacho,
                           dispositivo,
                           estado,
                           localStorageService,
                           mobile,
                           moment,
                           servicios,
                           sesion,
                           tarifas,
                           tiempo,
                           utiles,
                           validaciones) {



    //esta puesto para ejecutarlo en el browser, ya que no tiene el deviceready obviamente
    //antes de consultar en base de datos me tengo que asegurar que el dispositivo este listo
    if (window.cordova) {
        document.addEventListener("deviceready", dispositivoListo, false);
    }
    else {
        dispositivoListo();
    }


    $scope.botonVolverAtras = volverAtras;
    $scope.botonFirmaConPapel = botonFirmaConPapel;
    $scope.botonFirmaDigital = botonFirmaDigital;
    $scope.botonEnviaSinFirma = botonEnviaSinFirma;
    $scope.foco = hacerFocoEnInvalido;
    $scope.cambioFechaViaje = cambiarFechaViaje;

    var fechaInicioViajeCargada = null;
    var fechaFinViajeCargada = null;
    var vinoPorBotonPapel;
    const HORAS_MAXIMAS_DIFERENCIA_HORARIA = 6;





    function dispositivoListo() {


        const TIEMPO_MUESTRA_SPINNER = 5000;

        mobile.mostrarSpinner(TIEMPO_MUESTRA_SPINNER);

        $rootScope.vista_despacho = false;

        inicializarVariables();

        // $(function () {
        //     $('.money').mask('0000.00', {
        //         reverse: true
        //     });
        //
        // });
    }





    function esObjetoValido(valor) {
        return validaciones.validar_objeto_vacio(valor).Estado
    }





    function hacerFocoEnInvalido() {

        // obtiene todos los invalidos del dom
        var articleFirst = document.querySelectorAll("input.ng-invalid");

        // si no es null vacio etc
        if (esObjetoValido(articleFirst)) {
            // dejar $timeout porque sino no actualiza
            $timeout(function () {

                // hace foco en el primero invalido
                articleFirst[0].focus();
            }, 0);
        }
    }





    function esImporteServicioObligatorio() {
        servicios.esImporteServicioObligatorio();
    }





    function cancelarSpinner() {
        mobile.cancelarYocultarSpinner();
    }





    function inicializarVariables() {


        console.log("carga controller formulario");
        console.log("$rootScope.cuponSeleccionado es" + $rootScope.cuponSeleccionado);

        // obliga en el formulario a ingresar el importe
        $scope.importeObligatorio = esImporteServicioObligatorio();
        console.log("importe es obligatorio" + $scope.importeObligatorio);
        //aca tendria que cargar los datos del cupon actual o el seleccionado


        catalogoCupones.buscarCuponPorId($rootScope.cuponSeleccionado).then(function (respuesta) {
            console.log("respuesta en formulario cupones es:" + JSON.stringify(respuesta));

            mostrarDatosCupon(respuesta);
            mostrarDatosServicio($scope.cupon.id_servicio);
            mostrarBotones();


            setearParametrosCupon(respuesta[0].parametros_cupon);
            cancelarSpinner();

        }, function (error) {
            console.error("error en buscar cupones por id es:" + JSON.stringify(error))
        });
    }





    function setearParametrosCupon(_datos) {

        var datos = angular.fromJson(_datos);

        console.error("datos:" + JSON.stringify(datos));
        $scope.parametrosCupon = {

            disposicion_en_minutos: datos.DisposicionEnMinutos,
            num_cupon: datos.IdCupon,
            importe: datos.Importe,
            km: datos.Km,
            espera_en_minutos: datos.EsperaEnMinutos,
            espera: datos.Espera,
            peajes: datos.Peajes,
            estacionamiento: datos.Estacionamiento,
            gastos_varios: datos.GastosVarios,
            inicio_viaje: datos.FechaHoraInicioViaje,
            fin_viaje: datos.FechaHoraFinViaje,

        };

    }





    //
    // function HsetearParametrosCupon() {
    //
    //     $scope.parametrosCupon = {
    //
    //         disposicion_en_minutos: [0, 1, 1],
    //         num_cupon: [1, 0, 1],
    //         importe: [1, 1, 1],
    //         km: [0, 1, 1],
    //         espera_en_minutos: [1, 0, 0],
    //         espera: [1, 1, 1],
    //         peajes: [0, 1, 1],
    //         estacionamiento: [0, 1, 1],
    //         gastos_varios: [0, 1, 1],
    //         inicio_viaje: [0, 1, 1],
    //         fin_viaje: [0, 1, 1],
    //
    //     };
    //
    //
    // }


    function estaCuponEnviado() {
        return $scope.cupon.enviado == 1;
    }





    function mostrarBotones() {


        if (!esCuponConFirma() || estaCuponEnviado()) {
            $scope.mostrarBotonEnviarComun = true;
            $scope.mostrarBotonConFirmaDigital = false;
            return;
        }

        $scope.mostrarBotonEnviarComun = false;
        $scope.mostrarBotonConFirmaDigital = true;


    }





    function mostrarCartelDeConfirmacionFecha() {

        return $ionicPopup.confirm({
                title: $rootScope.tipo,
                cssClass: 'popupModificacionFecha',
                subTitle: 'La fecha elegida tiene una diferencia mayor a ' + HORAS_MAXIMAS_DIFERENCIA_HORARIA + ' horas',
                template: "¿Confirma?",
                scope: $scope,
                okText: 'SI',
                cancelText: 'NO'
            }
        )
    }





    function cambiarFechaViaje(fechaElegida, tipoFechaElegida) {

        var fechaCargadaAlInicio;
        if (tipoFechaElegida == 'inicio') {
            fechaCargadaAlInicio = fechaInicioViajeCargada;
        } else {
            fechaCargadaAlInicio = fechaFinViajeCargada;
        }

        if (tiempo.esValidaLaDiferenciaHoraria(fechaCargadaAlInicio, fechaElegida, HORAS_MAXIMAS_DIFERENCIA_HORARIA)) {
            return
        }

        // sino es valida
        mostrarCartelDeConfirmacionFecha().then(function (acepta) {
            console.log("resspuesta en  es:" + JSON.stringify(acepta));

            if (acepta || tipoFechaElegida == null) {
                return
            }

            // si no acepta setea la fecha previa
            if (!acepta && tipoFechaElegida == 'inicio') {
                $scope.cupon.inicio_viaje = fechaCargadaAlInicio;
                return
            }

            if (!acepta && tipoFechaElegida == 'fin') {
                $scope.cupon.fin_viaje = fechaCargadaAlInicio;
            }


        }, function (error) {
            console.error("error en  es:" + JSON.stringify(error));

        });

    }





    function mostrarDatosCupon(respuesta) {

        // setea los datos recuperadso
        $scope.cupon = respuesta[0];

        // obtiene si es con importe fijo
        $scope.importeSoloLectura = cupon.esConImporteFijo($scope.cupon.con_importe_fijo);


        // trata de obtener el importe por defecto
        var importeTarifador = cupon.obtenerImportePorDefecto($scope.cupon);
        if (importeTarifador == 0 || importeTarifador == null) {
            $scope.cupon.importe = null;
        } else {
            $scope.cupon.importe = importeTarifador;
        }

        // trata de obtener los km recorridos por defecto
        var kmRecorridos = cupon.obtenerKmRecorridos($scope.cupon);
        if (kmRecorridos == 0 || kmRecorridos == null) {
            $scope.cupon.km = null;
        } else {
            $scope.cupon.km = kmRecorridos;
        }


        if (respuesta[0].espera == 0) {
            $scope.cupon.espera = null;
        }
        if (respuesta[0].peajes == 0) {
            $scope.cupon.peajes = null;
        }
        if (respuesta[0].estacionamiento == 0) {
            $scope.cupon.estacionamiento = null;
        }
        if (respuesta[0].gastos_varios == 0) {
            $scope.cupon.gastos_varios = null;
        }


        $scope.mostrarNumCupon = $scope.cupon.num_cupon;

        //lo trae de una manera que no le gusta al html, tengo que convertir previamente
        $scope.cupon.inicio_viaje = new Date($scope.cupon.inicio_viaje);
        $scope.cupon.fin_viaje = new Date($scope.cupon.fin_viaje);

        fechaInicioViajeCargada = $scope.cupon.inicio_viaje;
        fechaFinViajeCargada = $scope.cupon.fin_viaje;


        var comisiones = obtenerComisiones();
        // var comisiones=null;
        // var comisiones = [];
        // var comisiones=['hola'];
        // var comisiones=[[1,2],[3,4]];
        //

        console.log('comisiones: '+JSON.stringify(comisiones));

        // devuelve true si debe mostrar las comisiones
        $scope.mostrarComisiones = mostrarComisiones(comisiones);

    }





    function mostrarComisiones(comisiones) {


        // si no hay comisiones
        if (!hayComisiones()) {
            $scope.cupon.comisiones = null;
            return false;
        }


        // si hay una sola elige la que hay
        if (hayUnaSolaComision()) {
            $scope.cupon.comisionSeleccionada = comisiones[0];
            return false;
        }


        // si hay varias comisiones, las guarda para mostrarlas
        $scope.cupon.comisiones = comisiones;

        // y elije la primera por defecto
        $scope.cupon.comisionSeleccionada = comisiones[0];

        return true;





        // funciones internas que mejoran la legibilidad
        function hayComisiones() {
            if (!comisiones) {
                return false;
            }
            return comisiones.length != 0;

        }





        function hayUnaSolaComision() {
            return comisiones.length == 1;
        }
    }





    function obtenerComisiones() {
        return localStorageService.get("comisiones");
    }





    function mostrarDatosServicio(id_servicio) {
        catalogoServicios.buscarServicioPorId(id_servicio).then(function (respuesta) {
            console.log("resspuesta en vercupon  es:" + JSON.stringify(respuesta));
            $scope.servicio = respuesta[0];
        }, function (error) {
            console.error("error en  es:" + JSON.stringify(error))
        });
    }





    function debeMostrarNumCupon() {
        return $scope.parametrosCupon.num_cupon[0] == 1
    }





    function esObligatorioIngresarElNumCupon() {
        return $scope.parametrosCupon.num_cupon[1] == 1
    }





    function botonFirmaConPapel(valido) {

        console.error("el formulario es:" + valido);
        $scope.apreto = true;

        if (valido == false) {
            hacerFocoEnInvalido();
            return;
        }

        vinoPorBotonPapel = true;

        console.error(debeMostrarNumCupon());
        if (debeMostrarNumCupon()) {

            var numObligatorio = esObligatorioIngresarElNumCupon();

            pedirNumeroCupon(numObligatorio); //lo tengo que hacer asi sino no funciona bien, no devuelve nada o
            // se ejecuta una sola vez,


        } else {
            $scope.cupon.num_cupon = utiles.limpiarCaracteresYagregarPrefijo('P', $scope.cupon.id_servicio);
            botonGuardarCupon();
        }


    }





    function pedirNumeroCupon(numObligatorio) {
        pedirNumeroCuponPorAlert(numObligatorio).then(function (respuesta) {
            console.log("respuesta de llamada:" + respuesta);

            if (respuesta == null || respuesta == '') {
                console.warn("seteando cupon null");

                // si ya tenia un valor no lo modifica
                if (!$scope.cupon.num_cupon) {
                    $scope.cupon.num_cupon = null;
                }
            } else {
                $scope.cupon.num_cupon = respuesta;
            }

            botonGuardarCupon();
        }, function () {
            pedirNumeroCupon(numObligatorio);
        });
    }





    $scope.verificarTamanio = function () {
        return dispositivo.hayScroll();
    };


    $scope.$on('$destroy', function () {
        console.warn("saliendo");
    });





    function pedirNumeroCuponPorAlert(numObligatorio) {


        var defer = $q.defer();

        $ionicPopup.prompt({
            cssClass: 'popupContrasenia',
            okText: ' ACEPTAR',
            okType: 'button-positive',
            cancelText: ' CANCELAR',
            cancelType: 'button-default',
            title: 'Ingrese el numero de cupón',
            inputType: 'text',
            template: '<input ng-model="data.response" required type="text" autofocus>'

        }).then(function (respuesta) {


            if ((respuesta == "" || !respuesta) && numObligatorio) {
                defer.reject(respuesta);
                return; //dejar este return sino se resuelve
            }

            defer.resolve(respuesta);

        });

        return defer.promise;

    }





    function botonFirmaDigital(valido) {
        console.error("el formulario es:" + valido);
        $scope.apreto = true;


        if (valido == false) {
            hacerFocoEnInvalido();
            return;
        }
        vinoPorBotonPapel = false;


        $scope.cupon.num_cupon = utiles.limpiarCaracteresYagregarPrefijo('D', $scope.cupon.id_servicio);


        botonGuardarCupon();

    }





    function botonEnviaSinFirma(valido) {

        console.error("valido:" + valido);
        $scope.apreto = true;

        if (valido == false) {
            hacerFocoEnInvalido();
            return;
        }

        botonGuardarCupon()
    }





    //las funciones monadicas (1 solo argumento):
    //    consigue algo => devuelve ese algo
    //    setean algo => no devuelve nada
    //    son un evento => no devuelven nada


    function validarEnvioCupon() {



        // si se firma digitalmente pero no fue enviado
        if (seFirmaDigitalmente() && !estaCuponEnviado()) {
            irAlEstado('.dniYpin');
            return;
        }

        // cualquiera de los otros casos
        actualizarYenviarCupon();


    }





    function seFirmaDigitalmente() {
        return esCuponConFirma() && !vinoPorBotonPapel;
    }





    function botonGuardarCupon() {


        console.log("$scope.cupon" + JSON.stringify($scope.cupon));


        saberSicuponFueEnviado($scope.cupon.id_cupon).then(function (cuponFueEnviado) {
            console.log("res" + JSON.stringify(cuponFueEnviado));
            console.log("respuesta en o es:" + cuponFueEnviado);
            console.log("cupon fue enviado:" + cuponFueEnviado[0].enviado);

            validarEnvioCupon(cuponFueEnviado[0]);

        }, function (error) {

            // si no se sabe si fue enviado o no
            console.error("error en  es:" + JSON.stringify(error));
            alert("No se pudo modificar el cupón");

        });

    }





    function saberSicuponFueEnviado(id_cupon) {
        return catalogoCupones.saberSicuponFueEnviado(id_cupon)
    }





    function actualizarYenviarCupon() {

        $scope.cupon.estado = 'completado';

        actualizarCupon()
            .then(function (respuesta) {

                console.log("resspuesta en  es:" + JSON.stringify(respuesta));


                armarYenviarCupon();

                //si no viene de un servicio muestra el cupon
                irAlEstado("barra.general.verCupon");

            })
            .catch(function (error) {
                console.error("error en  es:" + JSON.stringify(error));
                alert("Ocurrió un error a la hora de modificar el cupón")
            });
    }





    function actualizarCupon() {
        var cupon = armarCuponParaModificar($scope.cupon);
        return catalogoCupones.actualizarCupon(cupon, $scope.cupon.id_cupon)
    }





    function armarCuponParaModificar(cupon) {

        return {
            "num_cupon": cupon.num_cupon,
            "importe": cupon.importe,
            "km": cupon.km,
            "espera_en_minutos": cupon.espera_en_minutos,
            "espera": cupon.espera,
            "peajes": cupon.peajes,
            "estacionamiento": cupon.estacionamiento,
            "gastos_varios": cupon.gastos_varios,
            "inicio_viaje": cupon.inicio_viaje,
            "fin_viaje": cupon.fin_viaje,
            "disposicion_en_minutos": cupon.disposicion_en_minutos,
            "estado": cupon.estado,
            "id_firmante": cupon.id_firmante
        }

    }





    function mostrarMensaje(mensaje, ubicacion, duracion) {
        // dispositivo.mostrarToast(mensaje, ubicacion, duracion);
        alert(mensaje)
    }





    // papel,digital o lo que sea
    function esCuponConFirma() {
        var esConFirma = $scope.cupon.con_firma == 1;
        console.log("esConFirma" + esConFirma);
        return esConFirma
    }





    function irAlEstado(nombreEstado) {
        estado.irAlEstado(nombreEstado)
    }





    function armarYenviarCupon() {

        var cuponParaElServer = obtenerCuponParaServer();

        console.log("cupon para el server:" + JSON.stringify(cuponParaElServer));
        enviarCuponAlServer(cuponParaElServer).then(function (respuesta) {
            console.log("resspuesta en  es:" + JSON.stringify(respuesta));
            // mostrarMensaje("El cupón fue enviado correctamente", "medio", "largo");

        }, function (error) {
            console.error("error en  es:" + JSON.stringify(error));
            mostrarMensaje("El cupón no se pudo enviar", "medio", "largo");

        });

    }





    function obtenerCuponParaServer() {

        var importe = '';
        if ($scope.cupon.importe){
            importe = parseFloat($scope.cupon.importe)
        }

        return {
            'id_cupon': $scope.cupon.id_cupon,
            'num_cupon': $scope.cupon.num_cupon,
            'importe': importe,
            'id_cliente':$scope.cupon.id_cliente,
            "km": $scope.cupon.km,
            "espera_en_minutos": $scope.cupon.espera_en_minutos,
            "espera": $scope.cupon.espera,
            "peajes": $scope.cupon.peajes,
            "estacionamiento": $scope.cupon.estacionamiento,
            "gastos_varios": $scope.cupon.gastos_varios,
            "inicio_viaje": moment($scope.cupon.inicio_viaje).format("YYYY-MM-DD HH:mm:ss"),
            "fin_viaje": moment($scope.cupon.fin_viaje).format("YYYY-MM-DD HH:mm:ss"),
            "disposicion_en_minutos": $scope.cupon.disposicion_en_minutos,
            "con_importe_fijo": $scope.cupon.con_importe_fijo,
            "id_centro_de_costo": null,
            "id_firmante": null,
            "id_comision": obtenerIdComisionSeleccionada()
        }

    }





    function obtenerIdComisionSeleccionada() {

        // por defecto null
        var comision = null;

        // si elegio alguna, o si hay una sola comision
        if ($scope.cupon.comisionSeleccionada != null) {
            comision = $scope.cupon.comisionSeleccionada[0] // el indice 0 es el id
        }

        return comision;

    }





    $rootScope.enviarConDniYpin = function () {

        if (sonValidosLosDatosDelCliente()) {

            var resultado = verificarHayFirmantes();

            //QUE PASA SI NO HAY FIRMANTES
            console.log("de verificar si hay firmantes:" + JSON.stringify(resultado));

            var cuponParaElServer = obtenerCuponParaServer();
            enviarAlserverSiHayFirmantes(resultado, cuponParaElServer);

        } else {
            alert("DNI y/o pin inválidos")
        }
    };





    function enviarAlserverSiHayFirmantes(resultado, cuponParaElServer) {


        if (!hayFirmantes(resultado)) {
            alert("el numero ingresado no corresponde a ningún firmante");
            return;
        }

        console.error("fimante:" + resultado.Respuesta[2]);

        cuponParaElServer = agregarDatosCtaCteAlCupon(cuponParaElServer, resultado);


        console.error("asi le envío el cupón al server antes llamar actualizar" + JSON.stringify(cuponParaElServer));

        $scope.cupon.estado = 'completado';
        $scope.cupon.id_firmante = resultado.Respuesta[2];

        actualizarCupon().then(function () {

            console.log("%c" + JSON.stringify(cuponParaElServer), "color:green");


            enviarCuponAlServer(cuponParaElServer).then(function (respuesta) {
                console.log("resspuesta en  es:" + JSON.stringify(respuesta));
                // mostrarMensaje("El cupón fue enviado correctamente", "medio", "largo");

                alert("El cupón fue firmado correctamente");

            }, function (error) {
                console.error("error en  es:" + JSON.stringify(error));
                mostrarMensaje("El cupón no se pudo enviar", "medio", "largo");

            });


            //si no viene de un servicio muestra el cupon
            irAlEstado("barra.general.verCupon");



        }, function (error) {
            console.error("error en  es:" + JSON.stringify(error));

        });


    }





    function agregarDatosCtaCteAlCupon(cuponParaElServer, resultado) {
        cuponParaElServer.id_centro_firmante = resultado.Respuesta[1];
        cuponParaElServer.id_firmante = resultado.Respuesta[2];
        cuponParaElServer.pasajero = $scope.servicio.nombrePasajero;

        return cuponParaElServer;

    }





    function hayFirmantes(resultado) {
        return resultado.Estado
    }





    function verificarHayFirmantes() {
        return servicios.verificarSiHayFirmantes($scope.cupon.dni + $scope.cupon.pinCupon);
    }





    function sonValidosLosDatosDelCliente() {
        return ($scope.cupon.dni != null && $scope.cupon.pinCupon != null)
    }





    function enviarCuponAlServer(cuponParaElServer) {

        $rootScope.banderaMostrarMensaje = true;

        //trata de enviar el importe al server si hay conexion
        return cupon.enviarCupon(cuponParaElServer)

    }





    function volverAtras() {
        estado.determinarEstadoAir()
    }
}