/**
 * Creado por ivan fecha 16/02/18.
 */
(function () {
    'use strict';

    angular
        .module('starter')
        .factory('catalogoCupones', factoryCupon);




    /* @ngInject */
    function factoryCupon($q,
                          $rootScope,
                          $log,
                          cupon,
                          dispositivo,
                          estado,
                          localStorageService,
                          notificaciones,
                          orm,
                          tiempo) {


        var factory = {

            actualizarCupon: actualizarCupon,
            buscarCupones: buscarCuponesPorFecha,
            buscarCuponPorId: buscarCuponesPorId,
            cambiarEstadoCupon: cambiarEstadoCupon,
            enviarCuponesPendientes: enviarCuponesPendientes,
            enviarDestinosPendientes: enviarDestinosPendientes,
            listarCuponesPendientes: listarCuponesPendientes,
            rta_enviar_cupon: rta_enviar_cupon,
            rta_enviar_destino: rta_enviar_destino,
            saberSicuponFueEnviado: saberSicuponFueEnviado,
            sePermiteModificarElCupon: sePermiteModificarElCupon,
            setearHoraFinViaje: setearHoraFinViaje

        };


        return factory;




        function obtenerUsuarioActual() {
            return localStorageService.get("username");
        }




        //esta funcion esta buena. es la base para las demas
        function sePermiteModificarElCupon(id_cupon) {


            console.log("idCupon" + id_cupon);
            var defer = $q.defer();

            buscarCuponesPorId(id_cupon).then(function (respuesta) {
                console.log("resspuesta en rta_enviar_cupon es:" + JSON.stringify(respuesta));

                if (respuesta == null) {
                    defer.reject("No se puede modificar el cupón");
                    return;
                }

                var estado = respuesta[0].estado;
                var id_firmante = respuesta[0].id_firmante;

                if (id_firmante != null) {
                    defer.reject("No se puede modificar el cupón porque fué firmado digitalmente");
                    return;
                }

                if (estado == null) {
                    defer.reject("No se puede modificar el cupón");
                    return;
                }


                if (estado == 'finalizado') {
                    defer.reject('Ya no se puede modificar el cupon porque la central ya lo facturó');
                    return;
                }

                if (estado == 'cancelado') {
                    defer.reject('No se puede modificar el cupón porque el servicio fué cancelado');
                    return;
                }


                if (estado == 'pendiente') {
                    defer.resolve('pendiente');
                    return;
                }

                if (estado == 'completado') {
                    defer.resolve('completado');
                    return;
                }

                // cualquier otro estado
                defer.reject("No se puede modificar el cupón");

            }, function (error) {
                console.error("error en  es:" + JSON.stringify(error));
                defer.reject('Ha ocurrido un error')
            });

            return defer.promise;

        }




        function cambiarEstadoCupon(id_cupon, estado) {

            var query = "update cupones set estado='" + estado + "' where id_cupon=" + id_cupon;
            return orm.ejecutarQuery(query);
        }




        function setearHoraFinViaje(id_cupon) {

            var horaActual = new Date(Date.now());
            var query = "update cupones set fin_viaje='" + horaActual + "' where id_cupon=" + id_cupon;
            return orm.ejecutarQuery(query);
        }




        function saberSicuponFueEnviado(id_cupon) {
            var defer = $q.defer();

            var query = "select enviado from cupones where id_cupon='" + id_cupon + "'";

            orm.select(query).then(function (respuesta) {

                defer.resolve(respuesta);
            }, function (error) {
                defer.reject(error);
            });

            return defer.promise;
        }




        function renombrarClavesDeObjeto(obj, old_name, new_name) {
            return dispositivo.renombrarClavesDeObjeto(obj, old_name, new_name);
        }




        function rta_enviar_cupon(msg) {

            // solo muestra el mensaje si salio algo mal
            if (!msg.Estado) {

                if ($rootScope.banderaMostrarMensaje) {
                    alert(msg.Respuesta);
                    $rootScope.banderaMostrarMensaje = false
                }

                return;
            }

            console.log("%c" + JSON.stringify(msg), "color:#dfa016");
            console.log("%c" + msg.Estado, "color:#dfa016");
            console.log("fueFinalizado" + estaElCuponFinalizado(msg));


            if (estaElCuponFinalizado(msg)) {
                notificaciones.anunciar('cuponFinalizado');
                actualizarCuponFinalizado(msg);
                return;
            }

            modificarCuponEnviado(msg.id_cupon, 1);

        }




        function estaElCuponFinalizado(msg) {
            return msg.Estado == false;
        }




        function actualizarCuponFinalizado(msg) {
            console.error("actualizando cupon finalizado");
            msg.datos_cupon.enviado = 1;
            msg.datos_cupon.estado = 'finalizado';

            renombrarClavesDeObjeto(msg.datos_cupon, "fecha_hora_fin_viaje", "fin_viaje");
            renombrarClavesDeObjeto(msg.datos_cupon, "fecha_hora_inicio_viaje", "inicio_viaje");


            actualizarCupon(msg.datos_cupon, msg.id_cupon).then(function (respuesta) {
                console.log("resspuesta en actualziar cupon fianlizado es:" + JSON.stringify(respuesta));

            }, function (error) {
                console.error("error en  es:" + JSON.stringify(error));

            });
        }




        function modificarCuponEnviado(id_cupon, estado) {

            var query = "update cupones set enviado='" + estado + "' where id_cupon=" + id_cupon;
            return orm.ejecutarQuery(query);
        }




        function rta_enviar_destino(msg) {

            var actualizacionDestino = {
                enviado: '1'
            };

            actualizarDestinos(actualizacionDestino, msg.num_destino, msg.id_cupon).then(function (respuesta) {
                $log.warn("resspuesta en actualizar destinos es:" + JSON.stringify(respuesta));

            }, function (error) {
                $log.warn("error en actualizar destinos es:" + JSON.stringify(error));

            });

        }




        function enviarDestinosPendientes() {
            buscarDestinosPendientes().then(function (respuesta) {
                // console.log("respuesta en busqueda de destinos pendientes es:" + JSON.stringify(respuesta));


                if (respuesta == null) {
                    // console.log("no hay destinos pendientes para enviar");
                    return
                }

                //si hay pendientes
                for (var i = 0, longitud = respuesta.length; i < longitud; i++) {

                    cupon.enviarDestino(respuesta[i]);
                }

                //por cada uno tengo que enviar
                //espero su respuesta
                //cada vez que llega la respuesta actualizo enviado


            }, function (error) {
                // console.error("error en busqueda de destinos pendientes es:" + JSON.stringify(error))
            });
        }




        function enviarCuponesPendientes() {
            //console.log("parametro:"+JSON.stringify(parametros));
            buscarCuponesPendientesDeEnvio(true).then(function (respuesta) {
                // console.log("respuesta en busqueda de cupones pendientes de enviar cupones pendienteses:" +
                //     JSON.stringify(respuesta));

                if (respuesta == null) {
                    // console.log("no hay cupones pendientes");
                    return
                }

                //si hay pendientes
                for (var i = 0, longitud = respuesta.length; i < longitud; i++) {

                    cupon.enviarCupon(respuesta[i]);

                }

            }, function (error) {
                // console.error("error en busqueda de cupones pendientes es:" + JSON.stringify(error))
            });

        }




        function armarQueryUpdate(tabla, obj) {


            console.log("obj:" + JSON.stringify(obj));
            var llaves = Object.entries(obj);
            var texto = "update " + tabla + " set ";


            if (llaves.length == 0) {
                return "vacio";
            }


            for (var i = 0, longitud = llaves.length; i < longitud; i++) {
                if (llaves[i][1] == null) {
                    continue;
                }

                texto += llaves[i][0] + "=" + "'" + llaves[i][1] + "',";
            }

            texto = texto.slice(0, -1);


            return texto;

        }




        function actualizarCupon(objeto, id_cupon) {
            var defer = $q.defer();

            var query = armarQueryUpdate("cupones", objeto);

            query = query + " where id_cupon=" + id_cupon;

            console.error("query lista para ejecutar de actualizar cupon:" + query);
            orm.ejecutarQuery(query).then(function (respuesta) {
                defer.resolve(respuesta);
            }, function (error) {
                defer.reject(error);
            });

            return defer.promise;
        }




        function actualizarDestinos(objeto, num_destino, id_cupon) {
            var defer = $q.defer();

            var query = armarQueryUpdate("destinos", objeto);

            console.error("quer:" + query);

            query = query + " where num_destino=" + num_destino + " AND id_cupon=" + id_cupon;

            console.error("query nueva:" + query);
            orm.ejecutarQuery(query).then(function (respuesta) {
                defer.resolve(respuesta);
            }, function (error) {
                defer.reject(error);
            });

            return defer.promise;
        }




        function buscarCuponesPorId(id) {
            var query = "select * from cupones where id_cupon ='" + id + "'";
            console.log("query a realizar" + query);
            return orm.select(query)

        }




        function buscarServicioPorId(id) {
            var query = "select * from servicios where id_servicio ='" + id + "'";
            console.log("query a realizar" + query);
            return orm.select(query)

        }




        function buscarDestinos(id_cupon, num_destino) {
            var query = "select * " +
                "from destinos " +
                "where id_cupon ='" + id_cupon + "' AND " +
                "num_destino ='" + num_destino + "'";
            console.log("query a realizar" + query);
            return orm.select(query)
        }




        //busca cupones de un rango de fechas
        //sino le pasa nada busca el de hoy
        function buscarCuponesPorFecha(inicio, fin) {


            var defer = $q.defer();
            var inicial;
            var final;


            //si no le pasa nada busca en el dia de hoy
            if (inicio == null) {
                var hoy = tiempo.obtenerFechaHoy('YYYY-MM-DD');
                inicial = hoy + ' 00:00:00';
                final = hoy + ' 23:59:59';

                //si le pasa solo el dia busca de ese dia
            } else if (fin == null) {
                inicial = inicio + ' 00:00:00';
                final = inicio + ' 23:59:59';

                //si le pasa ambos busca en un rango
            } else {
                inicial = inicio + ' 00:00:00';
                final = fin + ' 23:59:59';
            }

            var usuarioActual = obtenerUsuarioActual();

            var query = "SELECT c.id_cupon, c.estado, c.id_servicio, s.fecha_hora_servicio, c.num_cupon" +
                " FROM cupones c inner join servicios s" +
                " ON s.id_servicio=c.id_servicio " +
                " WHERE fecha_hora_servicio between '" + inicial + "' AND '" + final + "' and c.estado!='recibido' and c.estado!='pendiente' and c.usuario='" + usuarioActual + "'";

            $log.warn("query de busqueda de cupones:" + query);

            orm.select(query).then(function (respuesta) {

                defer.resolve(respuesta);

            }, function (error) {

                defer.reject(error);
            });


            return defer.promise;
        }




        function listarCuponesPendientes() {
            var usuarioActual = obtenerUsuarioActual();
            var defer = $q.defer();
            var query = "select c.id_cupon, c.id_servicio, c.estado, s.fecha_hora_servicio, c.num_cupon" +
                " FROM cupones c inner join servicios s" +
                " ON s.id_servicio = c.id_servicio " +
                " WHERE c.estado = 'pendiente' and c.usuario='" + usuarioActual + "'";

            // console.log("query de busqueda de cupones:" + query);


            orm.select(query).then(function (respuesta) {

                defer.resolve(respuesta);

            }, function (error) {

                defer.reject(error);
            });


            return defer.promise;
        }




        function buscarCuponesPendientesDeEnvio() {
            var usuarioActual = obtenerUsuarioActual();
            var defer = $q.defer();
            var query = "select c.id_cupon, c.id_servicio, s.fecha_hora_servicio, c.num_cupon," +
                " c.importe, c.km, c.espera, c.espera_en_minutos, c.peajes, c.estacionamiento, c.gastos_varios," +
                " c.inicio_viaje, c.fin_viaje, c.disposicion_en_minutos, c.id_cliente, c.id_centro_de_costo," +
                " c.con_importe_fijo, c.id_firmante" +
                " FROM cupones c inner join servicios s" +
                " ON s.id_servicio = c.id_servicio " +
                " WHERE c.estado = 'completado' AND c.enviado = '0' and c.usuario='" + usuarioActual + "'";

            // console.log("query de busqueda de cupones:" + query);


            orm.select(query).then(function (respuesta) {

                defer.resolve(respuesta);

            }, function (error) {

                defer.reject(error);
            });


            return defer.promise;
        }




        function buscarDestinosPendientes() {
            var defer = $q.defer();

            var usuarioActual = obtenerUsuarioActual();

            var query = "select " +
                "d.lat_servicio," +
                "d.num_destino," +
                "d.lon_servicio," +
                "d.id_cupon," +
                "d.enviado," +
                "d.fecha_hora," +
                "d.espera " +
                " from destinos as d " +
                " inner join cupones as c " +
                " on c.id_cupon = d.id_cupon " +
                " where d.enviado = '0' and usuario='" + usuarioActual + "'";

            // console.log("query de busqueda de destinos:" + query);

            orm.select(query).then(function (respuesta) {

                defer.resolve(respuesta);

            }, function (error) {

                defer.reject(error);
            });

            return defer.promise;
        }
    }
})();