/**
 * Creado por ivan fecha 16/02/18.
 */
(function () {
    'use strict';

    angular
        .module('starter')
        .factory('cupon', factoryCupon);


    var conFirma;
    var completarCupones;





    /* @ngInject */
    function factoryCupon($q,
                          $log,
                          dispositivo,
                          localStorageService,
                          moment,
                          orm,
                          servidor,
                          sesion,
                          tarifas,
                          validaciones) {

        var factory = {


            buscarUltimoNumeroDestino: buscarUltimoNumeroDestino,
            enviarDestino: enviarDestino,
            enviarCupon: enviarCupon,
            esConImporteFijo: esConImporteFijo,
            guardarDestino: guardarDestino,
            isConFirma: isConFirma,
            isCompletarCupones: isCompletarCupones,
            obtenerImportePorDefecto: obtenerImportePorDefecto,
            obtenerKmRecorridos: obtenerKmRecorridos,
            obtenerDestino: obtenerDestino,
            setearCompletarCupones: setearCompletarCupones,
            setearConFirma: setearConFirma
        };


        return factory;





        function yaTieneImporte(cupon) {
            if (cupon.importe) {
                return dispositivo.respuesta(true);
            }

            return dispositivo.respuesta(false,'no hay importe');

        }





        function obtenerImportePorDefecto(cupon) {

            // si no puede obtener el cupon, devuelve 0
            if (!cupon) {
                console.error("sale. no hay cupon");
                return 0
            }

            // si es con importe fijo devuelve el importe
            if (esConImporteFijo(cupon.con_importe_fijo)) {
                console.error("si es con importe fijo");
                return cupon.importe
            }


            // si tiene importe lo devuelve, evaluacion innecesaria, pero es a modo de
            if (yaTieneImporte(cupon).Estado) {
                return cupon.importe
            }


            // SI NO no no no ES CON IMPORTE FIJO

            // si no debe sugerir el importe, devuelve 0
            if (!sesion.obtenerSugerirImporte()) {
                console.error("no debe sugerir importe");
                return 0
            }


            var acumuladosTarifa = tarifas.obtenerAcumulados();
            // si no hay acumulados, devuelve 0
            if (!acumuladosTarifa) {
                console.error("no hay acumulados");
                return 0
            }

            // si no hay importe, devuelve 0
            var importeTarifa = acumuladosTarifa.monto;
            if (!importeTarifa) {
                console.error("no tiene importe tarifa");
                return 0
            }

            return importeTarifa
        }

        function obtenerKmRecorridos(cupon) {

            // si no puede obtener el cupon, devuelve 0
            if (!cupon) {
                console.error("sale. no hay cupon");
                return 0
            }


            var acumuladosTarifa = tarifas.obtenerAcumulados();
            // si no hay acumulados, devuelve 0
            if (!acumuladosTarifa) {
                console.error("no hay acumulados");
                return 0
            }

            // si no hay importe, devuelve 0
            var importeTarifa = acumuladosTarifa.metros;
            if (!importeTarifa) {
                console.error("no tiene importe tarifa");
                return 0
            }

            return importeTarifa
        }





        function esConImporteFijo(conImporteFijo) {
            return conImporteFijo == 1
        }





        //si viene un undefined lo pone en false
        function setearCompletarCupones(valor) {

            if (valor == null) {
                valor = false;
            }
            completarCupones = valor;
        }





        function enviarCupon(cupon) {

            var defer = $q.defer();

            var sesion = {
                "hash": localStorageService.get("hash"),
                "dni": localStorageService.get("username"),
                "empresa": localStorageService.get("empresa")
            };


            console.error("cupon para el server antes del asign" + JSON.stringify(cupon));
            //a los datos del cupon le agrega los datos del chofer
            cupon = Object.assign(sesion, cupon);

            $log.warn("cupon para el server:" + JSON.stringify(cupon));
            servidor.emitWhenConnected("enviar_cupon", cupon, bien, mal);





            function bien(msg) {
                defer.resolve(msg);
            }





            function mal(msg) {
                defer.reject(msg);
            }





            return defer.promise;

        }





        function enviarDestino(destino) {


            var defer = $q.defer();
            var hash = localStorageService.get("hash");
            var empresa = localStorageService.get("empresa");


            var destinoParaElServer = {
                empresa: empresa,
                hash: hash,
                id_cupon: destino.id_cupon,
                espera: destino.espera,
                num_destino: destino.num_destino,
                latitud: destino.lat_servicio,
                longitud: destino.lon_servicio,
                fecha_hora: moment(destino.fecha_hora).format("YYYY-MM-DD HH:mm:ss")
            };


            console.error("destino a enviar al server:" + JSON.stringify(destinoParaElServer));

            servidor.emitWhenConnected("enviar_destino", destinoParaElServer, enviado, noEnviado);





            function enviado() {
                console.log("enviado");
                defer.resolve();
            }





            function noEnviado() {
                defer.reject();
                console.log("no enviado");
            }





            return defer.promise;

        }





        function buscarUltimoNumeroDestino(cuponActual) {


            var query = "select num_destino" +
                " from destinos" +
                " where id_cupon = " + cuponActual +
                " ORDER BY num_destino DESC";

            console.error(query);
            return orm.select(query);
        }





        function isCompletarCupones() {
            return completarCupones

        }





        function obtenerDestino() {

            var defer = $q.defer();

            console.log("entra en armar Destino");

            var posicion = obtenerPosicionActual();
            var numeroDestino = null;
            var espera = null; //se deja fijo null hasta próximo aviso
            var idCupon = obtenerIdCuponActual();


            console.log('posicion: ' + posicion);
            console.log('idCupon: ' + idCupon);

            obtenerUltimoNumeroDestino().then(function (respuesta) {
                console.error("respuesta en ultimo numero destino es:" + JSON.stringify(respuesta));

                if (respuesta == null) {
                    numeroDestino = 1;
                } else if (validaciones.validar_vacio_null_y_undefined(respuesta[0].num_destino).Estado) {
                    numeroDestino = respuesta[0].num_destino + 1;
                }


                var destino = {
                    lat_servicio: posicion.latitud,
                    lon_servicio: posicion.longitud,
                    num_destino: numeroDestino,
                    id_cupon: idCupon,
                    espera: espera,
                    fecha_hora: moment().milliseconds(0).toISOString()
                };

                console.warn("ldestino:" + JSON.stringify(destino));
                defer.resolve(destino);


            }, function (error) {
                console.log("error en número destino es:" + JSON.stringify(error));
                defer.reject();

            });


            return defer.promise;


        }





        function guardarDestino(destino) {
            var defer = $q.defer();


            console.log("entra en guardar Destino con datos:" + JSON.stringify(destino));
            orm.insertarEnBD("destinos", destino).then(function (respuesta) {

                defer.resolve(respuesta);
            }, function (error) {

                defer.reject(error);
            });
            return defer.promise;
        }





        function enviarDestinoAlServer(destino) {
            console.log("entra en enviar al server Destino");
            return enviarDestino(destino);
        }





        function obtenerUltimoNumeroDestino() {
            console.log("entra en obtener ultimo numero Destino");

            var cuponActual = obtenerIdCuponActual();

            return buscarUltimoNumeroDestino(cuponActual)


        }





        function obtenerIdCuponActual() {
            console.log("entra en obteneridCuponActual");

            var servicio = localStorageService.get("servicio");
            return servicio.id_cupon;

        }





        function obtenerPosicionActual() {
            console.log("entra en obtenerPosicionActual");

            var posicion = {
                latitud: localStorageService.get("latitud"),
                longitud: localStorageService.get("longitud")
            };

            return posicion;
        }





        function setearConFirma(_conFirma) {
            conFirma = _conFirma
        }





        function isConFirma() {
            return conFirma;
        }


    }
})();