/**
 * Creado por ivan fecha 31/05/19.
 */

angular
    .module('archivosModule', [])
    //usar camelcase para el nombre y el mismo para la llamada a la funcion
    .factory('archivos', archivos);





function archivos($q,
                  localStorageService) {


    var factory = {
        borrarArchivo: borrarArchivo,
        buscarArchivo: buscarArchivo,
        listarArchivosDeDirectorio: listarArchivosDeDirectorio
    };

    return factory;
    //De esta forma se asocian los bindeos desde el objeto que lo mantiene,
    //los valores primitivos no se pueden modificar por si solos usando este patrón

    function borrarArchivo(ruta, nombreArchivo) {

        var defer = $q.defer();

        if (!ruta || !nombreArchivo){
            defer.reject();
            return defer.promise;
        }

        console.error("entra a borrar achivo");
        window.resolveLocalFileSystemURL(ruta, function (dir) {
            dir.getFile(nombreArchivo, {create: false}, function (fileEntry) {

                fileEntry.remove(function (lp) {
                    console.log("The file has been removed succesfully" + JSON.stringify(lp));
                    console.timeEnd("borrar");
                    defer.resolve();

                }, function (error) {
                    console.log("Error deleting the file:" + error);
                    defer.reject();
                });

            }, function (err) {
                console.log("get:" + JSON.stringify(err)); // Error while requesting File.
                defer.reject(err);
            })

        }, function (err) {
            console.log("fs error:" + err);  // Error while requesting FS
            defer.reject(err);
        });

        return defer.promise;

    }

    function listarArchivosDeDirectorio(ruta) {
        var defer = $q.defer();

        window.resolveLocalFileSystemURL(ruta, function (lectorDirectorio) {

                // Get a directory reader
                var directorio = lectorDirectorio.createReader();

                // obtiene todos los archivos que hay en el directorio
                directorio.readEntries(
                    function (entries) {
                        console.log("archivos que hay en el directorio"+entries);

                        defer.resolve(entries);

                        // for (var i = 0, largo = entries.length; i < largo; i++) {
                        //     console.log(entries[i].name);
                        // }

                    },
                    falla
                );
            }, falla
        );





        function falla() {
            defer.reject();
        }





        return defer.promise;

    }



    function buscarArchivo(ubicacion) {

        var defer = $q.defer();


        var ruta = ubicacion.ruta;
        if (!ruta) {
            defer.reject("No hay ruta");
            return defer.promise;
        }

        var nombreArchivo = ubicacion.nombre;
        if (!nombreArchivo) {
            defer.reject("No hay nombre de archivo");
            return defer.promise;
        }


        console.log("enviadno archivo");
        window.resolveLocalFileSystemURL("file:///storage/emulated/0/" + ubicacion.ruta + "/" + ubicacion.nombre, gotFile, fail);





        function fail(e) {

            // plan B, si no lo encuentra en la memoria internal lo busca en la tarjeta de memoria
            // a pesar de que se declara que es obligatorio la interna, hace mucho hubo casos de que no le hacia
            // caso y lo guardaba en la sdcard de todas maneras


            window.resolveLocalFileSystemURL("file:///storage/sdcard1/" + ubicacion.ruta + "/" + ubicacion.nombre, gotFile, function () {
                //     window.resolveLocalFileSystemURL(cordova.file.cacheDirectory + "ion2.amr", gotFile, function () {
                //         window.resolveLocalFileSystemURL(cordova.file.externalRootDirectory + "ion2.amr", gotFile, function () {
                //             window.plugins.toast.showShortBottom('No se pudo enviar su mensaje', function (a) {
            }, function (b) {
                //                 console.log("FileSystem Error" + JSON.stringify(e));
                //                 //clearInterval($scope.intervalo);
                defer.reject("No se pudo grabar su audio");

                //             });
                //          });
                //     });
            });
        }





        function gotFile(fileEntry) {
            console.log("bieeeen");

            fileEntry.file(function (file) {
                var reader = new FileReader();


                reader.onloadend = function () {

                    // si no lo pudo cargar
                    if (!this.result) {
                        defer.reject("no se pudo cargar el archivo");
                        return defer.promise;
                    }

                    // si se pudo cargar todo bien
                    defer.resolve(this.result);

                    console.log("se termino");
                };


                reader.readAsDataURL(file);
                // El readAsDataURL lee el contenido del Blob o File. 
                // Cuando la operación de lectura es terminada, el readyState se convierte en DONE, y el loadend es lanzado.
                // En ese momento, el atributo result contiene  la información como una URL representando la información del archivo como una cadena de caracteres codificados en BASE64.
            });

        }





        return defer.promise;

    }
}

