angular
    .module('baseDatos', [])

    // service de sqlite
    .service('baseDatos', function ($cordovaSQLite,
                                    $log,
                                    $rootScope,
                                    $timeout,
                                    $q,
                                    dispositivo) {



            var factory = {

                alterTable: alterTable,
                borrarRegistro: borrarRegistro,
                borrarTabla: borrarTabla,
                conectaBD: conectaBD,
                //guardarDato:guardarDato,
                ejecutarQueryCreacionTablas: ejecutarQueryCreacionTablas,
                ejecutarQuery: ejecutarQuery,
                insertarEnBD: insertarEnBD,
                select: select,
                selectNuevo: selectNuevo,
                truncate: truncate,
                update: update
            };

            return factory;


            //function guardarDato (llave, dato, formato = 'ls'){
            //    if (formato == 'ls'){
            //        localStorageService.set(llave,dato);
            //    }
            //}
            //
            //function obtenerDato (llave){
            //
            //}


            function alterTable(tabla, columna) {
                var defer = $q.defer();

                var query = "alter table " + tabla + " add " + columna;

                $cordovaSQLite.execute($rootScope.db, query).then(function (res) {
                    console.log("alter correcto" + JSON.stringify(res));
                    defer.resolve();
                }, function (err) {
                    console.error(err);
                    console.log("alter incorrecto " + tabla + JSON.stringify(err));
                    defer.reject();
                });


                return defer.promise;
            }





            function armarQuery(tabla, obj) {

                var sal = Object.entries(obj);
                var texto = "update " + tabla + " set ";


                if (sal.length == 0) {
                    return "vacio";
                }


                for (var i = 0, longitud = sal.length; i < longitud; i++) {
                    if (sal[i][1] == null) {
                        continue;
                    }

                    texto += sal[i][0] + "=" + "'" + sal[i][1] + "',";
                }

                texto = texto.slice(0, -1);


                return texto;

            }





            function conectaBD(empresa) {

                var nombreBaseDatos;
                switch (empresa) {
                    case 'ptt': {
                        nombreBaseDatos = 'PideTuTaxi.bd';
                        break;
                    }
                    case 'ptr': {
                        nombreBaseDatos = 'PideTuRemis.bd';
                        break;
                    }
                }

                /** @namespace window.SQLitePlugin */
                if (window.cordova && window.SQLitePlugin) {
                    $rootScope.db = window.sqlitePlugin.openDatabase({
                        name: nombreBaseDatos,
                        location: 'default'
                    });

                } else {
                    //var dbShell = window.openDatabase(database_name, database_version, database_displayname, database_size);
                    $rootScope.db = window.openDatabase(nombreBaseDatos, '1.0', nombreBaseDatos, 8 * 1024 * 1024);

                }
            }





            //ejecuta una query y loguea
            function ejecutarQueryCreacionTablas(query, tabla) {
                $cordovaSQLite.execute($rootScope.db, query).then(function (res) {
                    console.log("Tabla " + tabla + " creada o intentada crear. " + JSON.stringify(res));
                }, function (err) {
                    console.error(err);
                    console.log("Tabla error " + tabla + JSON.stringify(err));
                });
            }





            function ejecutarQuery(query) {
                var defer = $q.defer();

                $cordovaSQLite.execute($rootScope.db, query).then(function (res) {
                    defer.resolve(res);
                }, function (err) {
                    defer.reject(err);
                });

                return defer.promise;

            }





            //la tabla debe ser pasada como string, el objeto como objeto obvio
            //todo:devolver si no se pudo insertar correctamente
            function insertarEnBD(tabla, objeto) {


                console.log("entro en insertarenbd");
                var a = dispositivo.dividirObjeto(objeto);

                var defer = $q.defer();

                var query = "INSERT INTO " + tabla + "(" + a.llaves + ") VALUES (" + a.cantidadLlaves + ")";
                console.log(query);


                $cordovaSQLite.execute($rootScope.db, query, a.valores).then(function () {
                    console.log("insertado correcto");
                    defer.resolve();
                    //ejemplo bueno
                    //result.rows.item(0).firstname
                }, function (err) {
                    console.log("insertado incorrecto" + JSON.stringify(err));
                    defer.reject(err);
                });

                return defer.promise;
            }





            function update(tabla, dic) {

                var defer = $q.defer();


                var query = armarQuery(tabla, dic);
                $log.warn("query de update:" + query);


                $cordovaSQLite.execute($rootScope.db, query).then(function (res) {
                    console.log("update correcto" + res);
                    console.log("celdas afectadas" + res.rows.length);
                    defer.resolve(res);

                }, function (err) {
                    console.log("update incorrecto" + err);
                    defer.reject(err);

                });

                return defer.promise;
            }





            //campos son los atributos a recuperar, si no les paso nada devuelve todos los atributos
            function select(tabla, campos) {

                var query;
                var resultado = [];
                var rta = {};
                var defer = $q.defer();

                if (campos == undefined) {
                    query = "SELECT * FROM " + tabla;
                } else {
                    query = "SELECT " + campos + " FROM " + tabla;
                }

                //console.log(query);

                $cordovaSQLite.execute($rootScope.db, query).then(function (results) {

                    if (results.rows.length > 0) {
                        //alert("largo: "+results.rows.length);
                        //console.log("resultado en la funcion" + JSON.stringify(results.rows.item(0)));


                        for (var i = 0; i < results.rows.length; i++) {
                            resultado.push(results.rows.item(i));
                        }

                        rta = resultado;
                    }
                    else {
                        rta = null;
                    }

                    defer.resolve(rta);
                }, function (err) {
                    defer.reject(err);

                });

                return defer.promise;
            }





            //campos son los atributos a recuperar, si no les paso nada devuelve todos los atributos
            function selectNuevo(query, base) {

                // por defecto usa db
                if (base == null) {
                    base = $rootScope.db;
                }

                //console.error("select que llega a select nuevo es:"+query);
                var resultado = [];
                var rta = {};
                var defer = $q.defer();

                $cordovaSQLite.execute(base, query).then(function (results) {

                    if (results.rows.length > 0) {
                        //alert("largo: "+results.rows.length);
                        //console.log("resultado en la funcion" + JSON.stringify(results.rows.item(0)));


                        for (var i = 0; i < results.rows.length; i++) {
                            resultado.push(results.rows.item(i));
                        }

                        rta = resultado;
                    }
                    else {
                        rta = null;
                    }

                    defer.resolve(rta);
                }, function (err) {
                    defer.reject(err);

                });

                return defer.promise;
            }





            function borrarRegistro(tabla, nombre) {
                var defer = $q.defer();
                console.log("entro en funcion del service.borrarRegistro");
                var query = "DELETE FROM " + tabla + " where nombre=? AND id_usuario=? AND id_calle1=? AND altura=?";

                console.log("nombre: " + nombre);
                console.log('la query de borrado es : ' + query);

                $cordovaSQLite.execute($rootScope.db, query, nombre).then(function () {
                    defer.resolve();
                    console.log("borrado correcto");
                }, function (err) {
                    defer.reject();
                    console.log("borrado incorrecto" + JSON.stringify(err));
                });

                return defer.promise;
            }





            function borrarTabla(tabla) {
                var query = "DROP TABLE " + tabla;
                console.log('la query de borrado es : ' + query);
                $cordovaSQLite.execute($rootScope.db, query).then(function () {
                    console.log("borrado correcto");
                }, function (err) {
                    console.log("borrado incorrecto" + JSON.stringify(err));
                });
            }





            function truncate(tabla) {
                var query = "DELETE FROM " + tabla;
                console.log('la query de borrado es : ' + query);
                $cordovaSQLite.execute($rootScope.db, query).then(function () {
                    console.log("truncate correcto");
                }, function (err) {
                    console.log("truncate incorrecto" + JSON.stringify(err));
                });
            }


        }
    );
