angular
    .module('baseDatos')
    .service('orm', servicio);





function servicio($cordovaSQLite,
                  $log,
                  $rootScope,
                  $timeout,
                  $q,
                  $localForage,
                  localStorageService,
                  baseDatos,
                  localForage,
                  dispositivo) {

    var tipo;


    //lo de base de datos son los mismos métodos, pero este servicio es un intermediario
    var factory = {

        alterTable: alterTable,
        borrarRegistro: borrarRegistro,
        borrarTabla: borrarTabla,
        conectaBD: conectaBD,
        guardarElemento: guardarElemento,
        obtenerElemento: obtenerElemento,
        ejecutarQuery: ejecutarQuery,
        ejecutarQueryCreacionTablas: ejecutarQueryCreacionTablas,
        insertarEnBD: insertarEnBD,
        select: select,
        setearTipo: setearTipo,
        truncate: truncate,
        update: update
    };

    return factory;


    //function guardarDato (llave, dato, formato = 'ls'){
    //    if (formato == 'ls'){
    //        localStorageService.set(llave,dato);
    //    }
    //}
    //
    //function obtenerDato (llave){
    //
    //}

    function setearTipo(tipoBd) {

        // tendria que usar ya el service de localforage
        if (tipoBd == 'localForage') {
            tipo = $localForage;
        }
        if (tipoBd == 'localStorage' || !tipoBd) {
            tipo = localStorageService;
        }

    }



    function guardarElemento(llave, elemento) {
        return localForage.guardarElemento(llave, elemento)
    }





    function obtenerElemento(llave) {
        return localForage.obtenerElemento(llave)

    }


    function alterTable(tabla, columna) {
        return baseDatos.alterTable(tabla, columna)
    }





    // function armarQuery(tabla, obj) {
    //
    //     var sal = Object.entries(obj);
    //     var texto = "update " + tabla + " set ";
    //
    //
    //     if (sal.length == 0) {
    //         return "vacio";
    //     }
    //
    //
    //     for (var i = 0, longitud = sal.length; i < longitud; i++) {
    //         if (sal[i][1] == null) {
    //             continue;
    //         }
    //
    //         texto += sal[i][0] + "=" + "'" + sal[i][1] + "',";
    //     }
    //
    //     texto = texto.slice(0, -1);
    //
    //
    //     return texto;
    //
    // }


    function conectaBD(empresa) {

        var nombreBaseDatos;
        switch (empresa) {
            case 'ptt': {
                nombreBaseDatos = 'PideTuTaxi.bd';
                break;
            }
            case 'ptr': {
                nombreBaseDatos = 'PideTuRemis.bd';
                break;
            }
        }

        /** @namespace window.SQLitePlugin */
        if (window.cordova && window.SQLitePlugin) {
            $rootScope.db = window.sqlitePlugin.openDatabase({
                name: nombreBaseDatos,
                location: 'default'
            });

        } else {
            //var dbShell = window.openDatabase(database_name, database_version, database_displayname, database_size);
            $rootScope.db = window.openDatabase(nombreBaseDatos, '1.0', nombreBaseDatos, 8 * 1024 * 1024);

        }
    }





    function ejecutarQuery(query) {
        return baseDatos.ejecutarQuery(query);
    }





    //ejecuta una query y loguea
    function ejecutarQueryCreacionTablas(query, tabla) {
        $cordovaSQLite.execute($rootScope.db, query).then(function (res) {
            console.log("Tabla " + tabla + " creada o intentada crear. " + JSON.stringify(res));
        }, function (err) {
            console.error(err);
            console.log("Tabla error " + tabla + JSON.stringify(err));
        });
    }





    //la tabla debe ser pasada como string, el objeto como objeto obvio
    //todo:devolver si no se pudo insertar correctamente
    function insertarEnBD(tabla, objeto) {
        return baseDatos.insertarEnBD(tabla, objeto)
    }





    function update(tabla, dic) {
        return baseDatos.update(tabla, dic)
    }





    //campos son los atributos a recuperar, si no les paso nada devuelve todos los atributos
    function select(query, base) {

        //console.error("entra en la select del orm");
        //aca tendria que ver que base de datos usar, pero asi por el momento queda
        return baseDatos.selectNuevo(query, base);

    }





    function borrarRegistro(tabla, nombre) {
        var defer = $q.defer();
        console.log("entro en funcion del service.borrarRegistro");
        var query = "DELETE FROM " + tabla + " where nombre=? AND id_usuario=? AND id_calle1=? AND altura=?";

        console.log("nombre: " + nombre);
        console.log('la query de borrado es : ' + query);

        $cordovaSQLite.execute($rootScope.db, query, nombre).then(function () {
            defer.resolve();
            console.log("borrado correcto");
        }, function (err) {
            defer.reject();
            console.log("borrado incorrecto" + JSON.stringify(err));
        });

        return defer.promise;
    }





    function borrarTabla(tabla) {
        return baseDatos.borrarTabla(tabla);
    }





    function truncate(tabla) {
        var query = "DELETE FROM " + tabla;
        console.log('la query de borrado es : ' + query);
        $cordovaSQLite.execute($rootScope.db, query).then(function () {
            console.log("truncate correcto");
        }, function (err) {
            console.log("truncate incorrecto" + JSON.stringify(err));
        });
    }


}





