/**
 * Creado por ivan fecha 03/01/19.
 */

angular
    .module('despachoModule', ['angularMoment', 'LocalStorageModule'])
    .factory('despacho', servicio);






function servicio(localStorageService, moment) {


    var factory = {


        borrarHoraInicioViaje: borrarHoraInicioViaje,
        borrarHoraFinViaje: borrarHoraFinViaje,
        guardarCoordenadasServicio: guardarCoordenadasServicio,
        guardarHoraInicioViaje: guardarHoraInicioViaje,
        guardarHoraFinViaje: guardarHoraFinViaje,
        limpiarLocalStorage: limpiarLocalStorage,
        obtenerEstado: obtenerEstado,
        obtenerHoraInicioViaje: obtenerHoraInicioViaje,
        obtenerHoraFinViaje: obtenerHoraFinViaje,
        obtenerIdServicio: obtenerIdServicio,
        setearEstado: setearEstado,

    };

    return factory;
    //De esta fo rma se asocian los bindeos desde el objeto que lo mantiene,
    //los valores primitivos no se pueden modificar por si solos usando este patrón

    function obtenerEstado() {
        return localStorageService.get("estadoIcono")
    }






    function setearEstado(estado) {
        var valor;

        switch (estado) {
            case 'libre': {
                valor = 1;
                break;
            }

            case 'ocupado': {
                valor = 0;
                break;
            }

            case 'panico': {
                valor = 2;
                break;
            }
        }

        localStorageService.set('estadoIcono', valor);
    }






    function borrarHoraInicioViaje() {
        console.log("borra horaa inicio viaje");
        localStorageService.set("horaInicioViaje", null)
    }






    function limpiarLocalStorage() {
        localStorageService.set("servicio", null);
        guardarCoordenadasServicio(null, null);
        localStorageService.set("textoAleer", null);
    }






    function guardarCoordenadasServicio(lat, lon) {
        localStorageService.set("lat_servicio", lat);
        localStorageService.set("lon_servicio", lon);

    }






    function obtenerIdServicio() {
        var servicio = localStorageService.get("servicio");

        if (!servicio) {
            return 0;
        }

        if (!servicio.id_servicio) {
            return 0
        }

        return servicio.id_servicio
    }






    function borrarHoraFinViaje() {
        console.log("borra horaa fin viaje");
        localStorageService.set("horaFinViaje", null)
    }






    function obtenerHoraFinViaje() {
        return localStorageService.get("horaFinViaje")
    }






    function obtenerHoraInicioViaje() {
        return localStorageService.get("horaInicioViaje")
    }






    function guardarHoraInicioViaje() {
        var horaActual = moment().format("YYYY-MM-DD HH:mm:ss");
        localStorageService.set("horaInicioViaje", horaActual);
    }






    function guardarHoraFinViaje() {
        var horaActual = moment().format("YYYY-MM-DD HH:mm:ss");
        localStorageService.set("horaFinViaje", horaActual);
    }

}
