angular
    .module('starter')
    .factory('dispositivo', dispositivo);




function dispositivo($q,
                     $timeout,
                     $ionicPopup,
                     $document,
                     $rootScope) {


    var hayPopupEnPantalla;


    var factory = {


        hayScroll: hayScroll,
        ab2str: ab2str,
        esArray: esArray,
        ejecutarApp: ejecutarApp,
        existeLaApp: existeLaApp,
        string2Bytes: string2Bytes,
        mostrarToast: mostrarToast,
        mostrarMensaje: mostrarMensaje,
        renombrarClavesDeObjeto: renombrarClavesDeObjeto,
        leerConTTS: leerConTTS,
        obtenerVersionDeLaCamara: obtenerVersionDeLaCamara,
        popupLeerOescucharMensaje: popupLeerOescucharMensaje,
        respuesta: respuesta,

        removerElementosDuplicadosArray: function (array) {
            var arrayDevuelto = array.filter(function (elem, pos) {
                return array.indexOf(elem) == pos;
            });
            return arrayDevuelto;
        },


        //busca un elemento en un array y si esta lo retorna
        buscaObjetoEnarray: function (elemento, array, llave) {

            console.log("elementopasado" + elemento);
            console.log("arraypasado" + JSON.stringify(array));
            //obtengo un objeto defered
            var defered = $q.defer();


            var estaEnArray = false;

            if (array == undefined) {
                defered.reject();
                return defered.promise;
            }

            console.log('longitud array : ' + array.length);
            if (array.length != 0) {
                for (var j = 0; j < array.length; j++) {
                    if (elemento == array[j][llave]) {

                        estaEnArray = true;
                        var resultado = {
                            resultado: array[j],
                            indice: j
                        };

                        defered.resolve(resultado);

                    }
                }

                if (!estaEnArray) {
                    defered.resolve(false);
                }
            } else {
                defered.resolve(false);
            }

            return defered.promise;
        },


        //devuelve un hash aleatorio con un largo pasado como parametro
        generarHash: function (largo) {

            var text = "";
            var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

            for (var i = 0; i < largo; i++)
                text += possible.charAt(Math.floor(Math.random() * possible.length));

            return text;

        }
        ,

        //generarHashConTiempoActual: function () {
        //    //obtiene la hora actual
        //    var fechaYhoraActual = tiempo.getFechaActualReal();
        //
        //    //obtiene un aleatorio entre 1 y 1000
        //    var aleatorio = Math.floor((Math.random() * (999 - 100) + 100)) + "";
        //
        //    //concatena fecha y aleatorio
        //    //console.log('aleatorio: ' + aleatorio);
        //    var resultado = fechaYhoraActual + aleatorio;
        //
        //    //retorna el resultado
        //    return resultado;
        //}
        //,

        validarHash: function (estado) {
            console.log("estado:" + estado);
            if (estado == null) {
                ionic.Platform.exitApp();
            }

        }
        ,

        convertirLargoAsigno: function (cantidadLlaves) {
            var largo = "?";
            var i = 1;
            for (i; i < cantidadLlaves; i++)
                largo += ",?";

            return largo;
        }
        ,

        getCantidadLlaves: function (obj) {
            return Object.keys(obj).length;
        }
        ,

        //loguearObjeto:function(objeto){
        //    console.log("el objeto es:"+JSON.stringify(objeto);
        //    if (objeto==undefined)
        //
        //}

        getStringDeValoresDeObjeto: function (obj) {
            var valores = Object.keys(obj).map(function (k) {
                return obj[k]
            });

            return valores;
        }
        ,

        getStringDeLLavesDeObjeto: function (obj) {
            return Object.keys(obj) + "";
        },


        dividirObjeto: function (obj) {

            var valores = this.getStringDeValoresDeObjeto(obj);
            var llaves = this.getStringDeLLavesDeObjeto(obj);
            var cantidadLlaves = this.getCantidadLlaves(obj);
            var stringDeSignos = this.convertirLargoAsigno(cantidadLlaves);

            return {
                llaves: llaves,
                valores: valores,
                cantidadLlaves: stringDeSignos
            };

        }
        ,

        div: function (obj) {

            var valores = this.getStringDeValoresDeObjeto(obj);
            var llaves = this.getStringDeLLavesDeObjeto(obj);
            var cantidadLlaves = this.getCantidadLlaves(obj);
            var stringDeSignos = this.convertirLargoAsigno(cantidadLlaves);

            return resultado

        },


        reemplazarCaracter: function (string, caracter) {
            string = string + '';
            return string.replace(/-| |\.|_|\)|\*|\,|\+|#/g, caracter);
        },


        existeLlaveEnObjeto: function (llave, objeto) {
            if (!objeto) {
                return false;
            }
            return objeto.hasOwnProperty(llave)
        }


    };

    return factory;




    function popupLeerOescucharMensaje(scope, titulo, texto, mensaje) {

        var self = this;

        //si hay un popup en pantalla no muestra nada
        if (hayPopupEnPantalla) {
            return;
        }


        hayPopupEnPantalla = true;

        var myPopup = $ionicPopup.confirm({
                title: titulo,
                scope: scope,
                template: texto,
                okText: 'Escuchar',
                cancelText: 'Leer'
            }
        );

        myPopup.then(
            function (res) {

                // si quiere escuchar el mensaje
                if (res) {
                    self.leerConTTS(mensaje);
                }

                // si quiere leerlo en la pestaña de mensajes
                else {
                    try {
                        scope.onTabTabbed(true, 1);
                    } catch (e) {
                        console.error("agarro error");
                    }
                }

                hayPopupEnPantalla = false;

                //si no lo puede mostrar, de todas maneras pongo que no hay popup, porque sino no me llegarian mas mensajes
            }, function () {
                hayPopupEnPantalla = false;
            });
    }




    function leerConTTS(texto, localizacion, rate) {

        localizacion = 'es-AR';

        if (!rate) {
            rate = 1.0
        }

        var defer = $q.defer();

        console.log("texto a leer: " + texto);

        if ($rootScope.esUnAndroid) {
            //invoca a la aufncion setear volumen del plugin sistema. aumenta el volumen al maximo
            sistema.setearVolumen($rootScope.volumen);
        }
        TTS.speak({text: texto, locale: localizacion, rate: rate}, function () {
            console.log('success');
            defer.resolve();
        }, function (motivo) {
            console.log("no pudo leer tts",motivo);
            defer.reject();
        });

        return defer.promise;
    }




    function renombrarClavesDeObjeto(objeto, viejaClave, nuevaClave) {
        if (objeto.hasOwnProperty(viejaClave)) {
            objeto[nuevaClave] = objeto[viejaClave];
            delete objeto[viejaClave];
        }
        return objeto;
    }




    function string2Bytes(string) {

        //crea array de uint8 del largo del string
        var array = new Uint8Array(string.length);

        //recorre cada caracter y en el arreglo guarda su codigo
        for (var i = 0, l = string.length; i < l; i++) {
            array[i] = string.charCodeAt(i);
        }

        console.log("array: " + array);

        //retorna el array buffer
        return array.buffer;
    }




    function esArray(value) {
        return value && typeof value === 'object' && value.constructor === Array;
        //podria haber usado angular.isArray(value); probar
    }




    function ab2str(buf) {
        return String.fromCharCode.apply(null, new Uint8Array(buf));
    }




    function mostrarToast(mensaje, ubicacion, duracion) {
        var tiempo;
        var hayUnToastEnPantalla;

        if (ubicacion == undefined) {
            ubicacion = "abajo";
        }
        if (duracion == undefined) {
            duracion = "largo";
        }


        //si esta mostrando un toast sale
        if (hayUnToastEnPantalla) {
            console.log("ya hay toast mostrado: ");
            return
        }

        //si no hay toast mostrado
        hayUnToastEnPantalla = true;

        tiempo = (duracion = "largo") ? 4000 : 2000;

        $timeout(function () {
            hayUnToastEnPantalla = false;
        }, tiempo);


        switch (ubicacion) {
            case "arriba": {
                if (duracionlargo()) {
                    mostrarArribaLargo();
                    return;
                }

                mostrarArribaCorto();

                break;
            }
            case "medio": {
                if (duracionlargo()) {
                    mostrarMedioLargo();
                    return;
                }

                mostrarMedioCorto();

                break;
            }
            case "abajo": {
                if (duracionlargo()) {
                    mostrarAbajoLargo();
                    return
                }

                mostrarAbajoCorto();

                break;
            }
            default : {
                mostrarAbajoLargo()
            }
        }




        function duracionlargo() {
            return duracion == "largo";
        }




        function mostrarArribaLargo() {
            window.plugins.toast.showLongTop(mensaje, function (a) {
            }, function (b) {
            });
        }




        function mostrarArribaCorto() {
            window.plugins.toast.showShortTop(mensaje, function (a) {
            }, function (b) {
            });
        }




        function mostrarMedioLargo() {
            window.plugins.toast.showLongCenter(mensaje, function (a) {
            }, function (b) {
            });
        }




        function mostrarMedioCorto() {
            window.plugins.toast.showShortCenter(mensaje, function (a) {
            }, function (b) {
            });
        }




        function mostrarAbajoLargo() {
            window.plugins.toast.showLongBottom(mensaje, function (a) {
            }, function (b) {
            });
        }




        function mostrarAbajoCorto() {
            window.plugins.toast.showShortBottom(mensaje, function (a) {
            }, function (b) {
            });
        }

    }




    function hayScroll() {
        var myDiv = $document[0].getElementById("formul"); //obtiene el formulario mismo

        if (myDiv) {
            return myDiv.clientHeight < myDiv.scrollHeight - 1; // -1 porque lo retorna con el mismo numero y no funciona
        }

        return false;
    }




    function respuesta(estado, respuesta, dato) {
        return {Estado: estado, Respuesta: respuesta, Dato: dato}
    }




    function existeLaApp(app) {
        var defer = $q.defer();
        window.plugins.launcher.canLaunch({packageName: app}, function () {
            console.log("si existe la app");
            defer.resolve();
        }, function () {
            defer.reject();
        });
        return defer.promise;
    }




    function ejecutarApp(app) {
        var defer = $q.defer();
        window.plugins.launcher.launch({packageName: app}, function () {
            console.log("si existe la app");
            defer.resolve();
        }, function () {
            defer.reject();
        });
        return defer.promise;
    }




    function mostrarMensaje(mensaje, tipo, ubicacion, duracion) {
        if (tipo == 'alert' || !tipo) {
            alert(mensaje);
            return;
        }

        if (tipo == 'toast') {
            mostrarToast(mensaje, ubicacion, duracion);
        }
    }




    function obtenerVersionDeLaCamara() {
        var version = device.versionNameCamara;
        if (!version) {
            return respuesta(false, 'no hay version');
        }

        return respuesta(true, null, version);
    }


}









