
    angular
        .module('estado', [])
        .factory('estado', estado);





    function estado($state,
                    $rootScope,
                    notificaciones,
                    tarifas) {


        var factory = {
            determinarEstadoAir: determinarEstadoAir,
            estadoActual: estadoActual,
            irAlEstado: irAlEstado,
            volver: volver

        };

        return factory;
        //De esta fo rma se asocian los bindeos desde el objeto que lo mantiene,
        //los valores primitivos no se pueden modificar por si solos usando este patrón


        function irAlEstado(estado) {
            $state.go(estado)
        }





        function volver() {
            $ionicHistory.goBack();
        }





        function minimizarApp() {
            backAsHome.trigger(function () {
                console.log("apreto boton volver");
            }, function () {
                console.log("Error al apretar boton volver");
            });
        }





        function estadoActual(estado) {
            return $state.current.name == estado
        }





        // https://github.com/angular-ui/ui-router/wiki/quick-reference#stateisstateorname--params
        function determinarEstadoAir() {
            if (estadoActual("barra.general")) {
                if ($rootScope.estaTarifando && tarifas.obtenerUsaTarifador()) {
                    irAlEstado("barra.general.tarifador");
                } else {
                    minimizarApp();
                }
            }

            if (estadoActual("loginConfiguracion") ||
                estadoActual("formularioConfiguracion")) {
                irAlEstado("login")
            }

            if (estadoActual("barra.general.tarifador")) {
                if ($rootScope.estaTarifando && tarifas.obtenerUsaTarifador()) {
                    irAlEstado("barra.general");
                    return
                }

                notificaciones.anunciar("finalizarTarifador");
                irAlEstado("barra.general");
                return;
            }


            if (estadoActual("barra.general.importeServicio")) {
                alert("Debe enviar un importe válido");
                return;
            }

            if (estadoActual("barra.general.listadoCupones") ||
                estadoActual("barra.general.credito") ||
                estadoActual("barra.general.creditos") ||
                estadoActual("barra.general.servicios") ||
                estadoActual("barra.general.tarifador")) {
                $rootScope.vista_despacho = true;

                console.log("vistaDespachotrue");
                irAlEstado("^");
            }

            if (estadoActual("barra.general.verCupon")) {
                irAlEstado("^.listadoCupones");
            }

            if (estadoActual("barra.general.formularioCupon.dniYpin")) {
                notificaciones.anunciar("apretoVolver")
            }

            if (estadoActual("barra.general.formularioCupon.pass")) {
                irAlEstado("^.dniYpin");
            }

            if (estadoActual("barra.general.detalleServicio")) {
                irAlEstado("^.servicios");
            }

            if (estadoActual("barra.general.formularioCupon")) {
                irAlEstado("^.verCupon");
            }

            if (estadoActual('login')) {
                $rootScope.salir();
            }
        }

    }



// Envuelve los componentes Angular en una función que se invoca inmediatamente...Immediately Invoked Function Expression (IIFE).
// ¿Por qué?: Una IIFE elimina las variables del scope global. Esto ayuda a prevenir que las variables y las declaraciones
// de funciones vivan más de lo esperado en el scope global, evitando así colisión de variables.
// ¿Por qué?: Cuando tu código se minimiza y se empaqueta en un archivo único para desplegar a producción,
// podrías tener colisión de variables y muchas variables globales. Una IIFE te protege contra ambos, creando una scope por cada archivo.
// IIFE previene que el código de los tests llegue a sus variables privadas,
// como expresiones regulares o funciones de ayuda que normalmente vienen bien para hacer pruebas por sí solas.
// Sin embargo, puedes acceder a ellas creando accesorios o accediendo a través de sus componentes.
// Por ejemplo, poniendo las funciones de ayuda, expresiones regulares o constantes en su propia factoría.

// Separando los datos de servicios movemos la lógica de cómo conseguirlos al servicio de datos
// ¿Por qué?: el controlador presenta y recoge información para la vista.
// No debe importarle cómo se consiguen los datos, sólo saber de donde conseguirlos.
// Separando los datos de servicios movemos la lógica de cómo conseguirlos al servicio de datos

