/**
 * Created by ivan on 15/11/16.
 */

// that code executed in event-listeners
// does not delegate exceptions to the $exceptionHandler
// (unless executed during a digest).

var app = angular.module('starter');

app.factory('$exceptionHandler', function ($injector, $log) {


    // si desarrollo es true mostrara un alerta con el error
    var desarrollo = false;


    //catchear excepciones de javascript

    window.onerror = function (message, url, line, col, error) {

        var Database;   // Will initialize it later
        if (!Database) {
            Database = $injector.get('localStorageService');
        }

        var servidor;   // Will initialize it later
        if (!servidor) {
            servidor = $injector.get('servidor');
        }

        var mostrarErrores = servidor.obtenerMostrarErrores();

        var informacionDispositivo = JSON.stringify(Database.get("dispositivo"));

        var stopPropagation = !desarrollo;
        var data = {
            tipo: 'javascript',
            state: window.location.hash,
            hora: Date.now(),
            versionApk: Database.get("versionApk")

        };
        if (message) {
            data.mensaje = message;
        }
        if (url) {
            data.pagina = url;
        }
        if (line) {
            data.linea = line;
        }
        if (col) {
            data.columna = col;
        }
        if (error) {
            if (error.name) {
                data.nombreError = error.name;
            }
            if (error.stack) {
                data.descripcion = error.stack;
            }
        }

        if (desarrollo || mostrarErrores) {
            $log.warn('excepcion', data);
            window.alert('Error: ' + JSON.stringify(data));
        }

        var errorJava = JSON.stringify(data) + informacionDispositivo;
        var dic = {
            error: errorJava,
            hash: Database.get("hash")
        };

        if (servidor.getConexion()) {
            servidor.getConexion().emit("enviar_error", dic, function () {
                console.log('se pudo realizar el emit: ');
            });
        }
        console.log('excepcion para enviar al server: ' + JSON.stringify(data));


        return stopPropagation;
    };

    //catchear excepciones de angular
    return function (exception, cause) {

        var Database;   // Will initialize it later
        if (!Database) {
            Database = $injector.get('localStorageService');
        }

        var servidor;   // Will initialize it later
        if (!servidor) {
            servidor = $injector.get('servidor');
        }

        var mostrarErrores = servidor.obtenerMostrarErrores();


        var informacionDispositivo = JSON.stringify(Database.get("dispositivo"));

        var data = {
            tipo: 'angular',
            pagina: window.location.hash,
            hora: Date.now(),
            versionApk: Database.get("versionApk")
        };
        if (cause) {
            data.causa = cause;
        }
        if (exception) {
            if (exception.message) {
                data.mensaje = exception.message;
            }
            if (exception.name) {
                data.nombreError = exception.name;
            }
            if (exception.stack) {
                data.descripcion = exception.stack;
            }
        }

        if (desarrollo || mostrarErrores) {
            $log.warn('excepcion', data);
            window.alert('Error: ' + JSON.stringify(data));
        }

        var errorEnviar = JSON.stringify(data) + informacionDispositivo;
        var dic = {
            error: errorEnviar,
            hash: Database.get("hash")
        };

        if (servidor.getConexion())
        // los envia al server
        {
            servidor.getConexion().emit("enviar_error", dic, function () {
                console.log('se pudo realizar el emit: ');
            });
        }

        console.log('excepcion para enviar al server: ' + JSON.stringify(data));

    };
});

//para cachar un error y redivarlo al excepction handler
//try {
//    var x = r + 1
//} catch (e) {
//    console.log('error: ' + e);
//    $exceptionHandler(e);
//}

