/**
 * Creado por ivan fecha 14/06/19.
 */

angular
    .module('fotosModule', [
        'archivosModule',
        'baseDatos',
        'LocalStorageModule'
    ])
    //usar camelcase para el nombre y el mismo para la llamada a la funcion
    .factory('fotos', fotos);





function fotos($q,
               $rootScope,
               $timeout,
               localStorageService,
               archivos,
               bluetooth,
               dispositivo,
               despacho,
               orm,
               servidor) {


    var factory = {
        enviarFoto: enviarFoto,
        sacarFoto: sacarFoto
    };

    return factory;
    //De esta fo rma se asocian los bindeos desde el objeto que lo mantiene,
    //los valores primitivos no se pueden modificar por si solos usando este patrón


    function sacarFoto(tiempo) {

        // habilitar nuevamente en produccion!!!!!!
        // if (!bluetooth.obtenerQueUsaBluetooth()) {
        //     return;
        // }

        if (!tiempo) {
            tiempo = 3000;
        }


        console.log("llamando a ejecutar app");
        dispositivo.ejecutarApp('mobile.camara').then(function (respuesta) {
            console.info("pudo abrirl la app de sacar:" + JSON.stringify(respuesta));


            $timeout(function () {
                enviarFoto();


                $rootScope.cantidadFotosSacadas++;
                if ($rootScope.cantidadFotosSacadas === 1) {
                    $rootScope.cantidadFotosSacadas = 0;
                    $rootScope.estoySacandoFoto = false;
                    return;
                }

                sacarFoto(tiempo)

            }, tiempo);
        }, function (error) {
            console.error("error en  es:" + JSON.stringify(error));
        });
    }





    function enviarFoto() {

        // archivos.listarArchivosDeDirectorio(cordova.file.externalRootDirectory + "/camara/").then(function(respuesta){

        // archivos.listarArchivosDeDirectorio("file:///storage/emulated/0/camara/").then(function(respuesta){


        // declara un array vacio
        var datosDeFotosPorEnviar = [];

        // obtiene el array entero
        orm.obtenerElemento('datosDeFotosPorEnviar').then(function (respuesta) {

            console.info("respuesta en obtener datos de fotos por enviar es:" + JSON.stringify(respuesta));

            // si ya habia datos de fotos guardadas setea esa informacion en el arreglo, para poder adjuntar las nuevas fotos
            if (respuesta) {
                datosDeFotosPorEnviar = respuesta;
            }

        }, function (error) {
            console.error("error en  es:" + JSON.stringify(error));

        });


        archivos.listarArchivosDeDirectorio(cordova.file.externalRootDirectory + "/camara/").then(function (respuesta) {
            console.log("respuesta en listar archivos del directorio es:" + JSON.stringify(respuesta));

            for (var i = 0, longitud = respuesta.length; i < longitud; i++) {

                // para cada uno de los archivos
                respuesta[i].file(function (file) {
                    var reader = new FileReader();


                    // cuando termina de leer
                    reader.onloadend = function () {

                        // si no lo pudo cargar al archivo
                        if (!this.result) {
                            console.error("no pudo cargar el archivo");
                            return;
                        }

                        console.log("leido correctamente un archivo");

                        console.log("nombre archivo:" + file.name);

                        // archivos.buscarArchivo(ubicacion).then(function (archivo) {


                        var data = this.result.replace(/^data:image\/jpeg;base64,/, ''); //obligatorio si no no lo puede leer el server


                        var fotoYdatos = {

                            'dni': localStorageService.get('username'),
                            'foto': data,
                            'empresa': localStorageService.get("empresa"),
                            'nombre': file.name,
                            'hash': localStorageService.get('hash'),
                            'id_movil': localStorageService.get("id_movil"),
                            "id_servicio": despacho.obtenerIdServicio()
                        };


                        // por cada archivo leido lo busca si esta en la tablita temporal
                        dispositivo.buscaObjetoEnarray(file.name, datosDeFotosPorEnviar, "nombre").then(function (respuestao) {
                            console.info("respuesta en busca objeto array es:" + JSON.stringify(respuestao));

                            // si no está en el array
                            if (!respuestao) {

                                // si no esta en el array lo añade al array y lo guarda

                                var objeto = {
                                    nombre: fotoYdatos.nombre,
                                    id_servicio: fotoYdatos.id_servicio,
                                };

                                // al pedo esta este
                                fotoYdatos.id_servicio = objeto.id_servicio;

                                // agrega esta foto al arreglo (esté limpio el array o no)
                                datosDeFotosPorEnviar.push(objeto);
                                guardarElemento(datosDeFotosPorEnviar);

                            }

                            // si esta en el array no hace nada


                        }, function (error) {
                            console.error("error en busca objeto array  es:" + JSON.stringify(error));
                        });


                        enviarAlServer(fotoYdatos);

                    };


                    reader.readAsDataURL(file);
                    // El readAsDataURL lee el contenido del Blob o File.
                    // Cuando la operación de lectura es terminada, el readyState se convierte en DONE, y el loadend es lanzado.
                    // En ese momento, el atributo result contiene  la información como una URL representando la información del archivo como una cadena de caracteres codificados en BASE64.
                });
            }

        }, function (error) {
            console.error("error en  es:" + JSON.stringify(error));
        });
    }





    function enviarAlServer(fotoYdatos) {

        servidor.emitWhenConnected('guardar_foto', fotoYdatos, function () {
            console.log("enviada bien la foto");
        }, function () {
            console.log('No se pudo enviar la foto');
        });

    }





    function guardarElemento(datosDeFotosPorEnviar) {
        orm.guardarElemento('datosDeFotosPorEnviar', datosDeFotosPorEnviar).then(function (respuesta) {
            console.info("se guardo con local forage:" + JSON.stringify(respuesta));
        }, function (error) {
            console.error("error al querer guaradr en localforage:" + JSON.stringify(error));
        });
    }


}

