/**
 * Created by ivan on 17/03/17.
 */
var app = angular.module("ConversionesModule", ['moduloValidaciones']);

app.service("ConversionesService", function (validaciones) {

    return {

        dec2hex: function (valor) {
            return valor.toString(16);
        },

        dec2stringEnHexa: function (valor) {
            return this.dec2hex(valor);
        },

        dec2string: function (valor) {
            return valor.toString();
        },

        dec2a: function (valor) {
            return String.fromCharCode(valor);
        },

        dec2bin: function (valor) {
            return (valor >>> 0).toString(2);
        },

        hex2dec: function (valor) {
            return parseInt(valor, 16);
        },

        hex2bin: function (valor) {
            return this.a2bin(this.hex2string(valor));
        },

        //pasa de hexa a string directo, si pasa 5a, lo pasa a 5A en string
        hex2string: function (valor) {
            return valor.toString(16).toUpperCase();
        },

        hex2a: function (valor) {
            var hex = valor.toString();
            var str = '';
            for (var n = 0; n < hex.length; n += 2) {
                str += String.fromCharCode(parseInt(hex.substr(n, 2), 16));
            }
            return str;
        },

        a2bin: function (valor) {
            return valor.charCodeAt(0).toString(2);
        },

        a2dec: function (valor) {
            return valor.charCodeAt(0).toString(10);
        },

        //solo permite que le pase un solo valor
        a2hex: function (valor) {
            return (valor.charCodeAt(0).toString(16));
        },

        //permite una cadena ascii
        a2hex2: function (valor) {
            var arr = [];
            for (var i = 0, l = valor.length; i < l; i++) {
                var hex = Number(valor.charCodeAt(i)).toString(16);
                arr.push(hex);
            }
            return arr.join('');
        },














        reemplazarCaracter: function (string, caracter) {
            return string.replace(/-| |\.|_|\*|\,|\+|#/g, caracter);

        },






        separarString: function (a) {
            if (!a) {
                return ["-", "-"];
            }
            else {
                return a.split(",");
            }

        },



        dividirZonas: function (elementos) {

            // console.log("elementos son:" + elementos);
            if (elementos == null) {
                // console.log("ojo que dividir zonas es undefined: ");
                return;
            }

            if (!validaciones.validar_vacio_null_y_undefined(elementos).Estado) {
                // console.error("ojo que dividir zonas es undefined: ");
                return;
            }

            var a = elementos.split("-");

            //console.log(a);
            var j = [];
            for (var i = 0; i < a.length; i++) {
                j.push(a[i].split(","));

            }

            //console.log(j);

            return j;

        },

        existeLlaveEnObjeto: function(llave, objeto){
            if (!objeto) return false;
            return objeto.hasOwnProperty(llave)
        },





        leerZonas: function (elementos) {

            if (!validaciones.validar_vacio_null_y_undefined(elementos).Estado) {
                // console.warn("ojo que leer zonas es undefined: ");
                return;
            }

            //console.log("elementos: "+elementos);

            //console.log("elementos: " + elementos.length);
            var string = '';

            //console.log("elementos[i][0]: "+elementos[0][0]);
            //console.log("elementos[i][0]: "+elementos[1][0]);
            //console.log("elementos[i][0]: "+elementos[2][0]);

            for (var i = 0; i < elementos.length; i++) {
                string = string + '' + elementos[i][0] + ". ";

            }

            //console.log("string: "+string);
            return string;
        }

    }
});
