describe("ConversionesModule", function () {

  var conversionesService;

  beforeEach(module('ConversionesModule'));

  beforeEach(inject(function (ConversionesService) {
    conversionesService = ConversionesService;
  }));

  beforeEach(function () {
    expect(conversionesService).toBeDefined();
  });

  it('dec2hex', function () {
    expect(conversionesService.dec2hex).toBeDefined(); //verifica que este definida la funcion del servicio
    expect(conversionesService.dec2hex(10)).toBe('a');
  });

  it('dec2stringEnHexa', function () {
    expect(conversionesService.dec2stringEnHexa).toBeDefined(); //verifica que este definida la funcion del servicio
    expect(conversionesService.dec2stringEnHexa(10)).toBe('a');
  });

  it('dec2string', function () {
    expect(conversionesService.dec2string).toBeDefined(); //verifica que este definida la funcion del servicio
    expect(conversionesService.dec2string(10)).toBe('10');
  });

  it('dec2bin', function () {
    expect(conversionesService.dec2bin).toBeDefined(); //verifica que este definida la funcion del servicio
    expect(conversionesService.dec2bin(95)).toBe('1011111');
  });

  it('hex2dec', function () {
    expect(conversionesService.hex2dec).toBeDefined(); //verifica que este definida la funcion del servicio
    expect(conversionesService.hex2dec("a")).toBe(10);
    expect(conversionesService.hex2dec("a")).not.toBe("10");
  });

  xit('hex2bin', function () {
    expect(conversionesService.hex2bin).toBeDefined(); //verifica que este definida la funcion del servicio
    expect(conversionesService.hex2bin("a")).toBe(1010);
  });

  it('hex2string', function () {
    expect(conversionesService.hex2string).toBeDefined(); //verifica que este definida la funcion del servicio
    expect(conversionesService.hex2string("5a")).toBe("5A");
    expect(conversionesService.hex2string("5A")).toBe("5A");
  });

  it('hex2a', function () {
    expect(conversionesService.hex2a).toBeDefined(); //verifica que este definida la funcion del servicio
    expect(conversionesService.hex2a("5a")).toBe("Z");
    expect(conversionesService.hex2a("5A")).toBe("Z");
  });

  it('a2bin', function () {
    expect(conversionesService.a2bin).toBeDefined(); //verifica que este definida la funcion del servicio
    expect(conversionesService.a2bin("Y")).toBe("1011001");
  });

  it('a2dec', function () {
    expect(conversionesService.a2dec).toBeDefined(); //verifica que este definida la funcion del servicio
    expect(conversionesService.a2dec("Y")).toBe("89");
  });

  it('a2hex', function () {
    expect(conversionesService.a2hex).toBeDefined(); //verifica que este definida la funcion del servicio
    expect(conversionesService.a2hex("Y")).toBe("59");
  });

  it('a2hex2', function () {
    expect(conversionesService.a2hex2).toBeDefined(); //verifica que este definida la funcion del servicio
    expect(conversionesService.a2hex2("Y")).toBe("59");
    expect(conversionesService.a2hex2("YZ")).not.toBe("595A");
    expect(conversionesService.a2hex2("YZ")).toBe("595a");
  });

  it('dec2a', function () {
    expect(conversionesService.dec2a).toBeDefined(); //verifica que este definida la funcion del servicio
    expect(conversionesService.dec2a(50)).toBe('2');
    expect(conversionesService.dec2a(38)).toBe('&');
    expect(conversionesService.dec2a(93)).toBe(']');
  });

  it('reemplar caracter', function () {
    expect(conversionesService.reemplazarCaracter).toBeDefined(); //verifica que este definida la funcion del servicio
    expect(conversionesService.reemplazarCaracter('1',"_")).toBe('1');
    expect(conversionesService.reemplazarCaracter('1')).toBe('1');
    expect(conversionesService.reemplazarCaracter('1.66',"_")).toBe('1_66');
    expect(conversionesService.reemplazarCaracter('1 66',"_")).toBe('1_66');
    expect(conversionesService.reemplazarCaracter('1_66',"_")).toBe('1_66');
    expect(conversionesService.reemplazarCaracter('1-66',"_")).toBe('1_66');
    expect(conversionesService.reemplazarCaracter('1+66',"_")).toBe('1_66');
    expect(conversionesService.reemplazarCaracter('166 ',"_")).toBe('166_');


  });


});












describe("validaciones telefono", function () {

  var conversiones;

  beforeEach(module('ConversionesModule'));

  beforeEach(inject(function (ConversionesService) {
    conversiones = ConversionesService;
  }));



  it("dividirZonas", function () {
    var zonasPedidas = "2,5-4,3-22,2";

    expect(conversiones.dividirZonas(zonasPedidas)).toEqual([['2', '5'], ['4', '3'], ['22', '2']]);
    expect(conversiones.dividirZonas(undefined)).toEqual(undefined);
    expect(conversiones.dividirZonas('')).toEqual(undefined);
  });



  it("dividirZonas", function () {
    var zonasPedidas = "4 SUR,12-2,8-1 NORTE,1-22,1";

    expect(conversiones.dividirZonas(zonasPedidas)).toEqual([['4 SUR', '12'], ['2', '8'], ['1 NORTE', '1'], ['22', '1']]);
    expect(conversiones.dividirZonas(undefined)).toEqual(undefined);
    expect(conversiones.dividirZonas('')).toEqual(undefined);
  });



  it("separarString", function () {
    expect(conversiones.separarString("2,5")).toEqual(['2', '5']);
    expect(conversiones.separarString("")).toEqual(['-', '-']);
    expect(conversiones.separarString(undefined)).toEqual(['-', '-']);
  });




  it("separarString2", function () {
    expect(conversiones.separarString('4 SUR,12')).toEqual(['4 SUR', '12']);
    expect(conversiones.separarString("")).toEqual(['-', '-']);
    expect(conversiones.separarString(undefined)).toEqual(['-', '-']);
  });




  it("leerZonas", function () {
    expect(conversiones.leerZonas([['2', '5'], ['4', '3'], ['22', '2']])).toEqual("2. 4. 22. ");
    expect(conversiones.leerZonas([['2', '5'], ['22', '2']])).toEqual("2. 22. ");
    expect(conversiones.leerZonas([['2', '5']])).toEqual("2. ");
    expect(conversiones.leerZonas([['2', '']])).toEqual("2. ");
    expect(conversiones.leerZonas([['', '']])).toEqual('. ');
    expect(conversiones.leerZonas(undefined)).toEqual(undefined);
  });




  it("leerZonas2", function () {
    expect(conversiones.leerZonas([['4 SUR', '12'], ['2', '8'], ['1 NORTE', '1'], ['22', '1']])).toEqual("4 SUR. 2. 1 NORTE. 22. ");
  });

  it("llaveobjeto",function(){
    var objeto = {
      "perro":1
    };

    expect(conversiones.existeLlaveEnObjeto("perro", objeto)).toBeTruthy();
    expect(conversiones.existeLlaveEnObjeto("caballo", objeto)).toBeFalsy();
    expect(conversiones.existeLlaveEnObjeto("caballo", null)).toBeFalsy();
    expect(conversiones.existeLlaveEnObjeto(null, null)).toBeFalsy();
    expect(conversiones.existeLlaveEnObjeto(null, objeto)).toBeFalsy();
  });



});