//26/6/17 creado por ivan paredes

var app = angular.module('mobile', []);
//app es un objeto que devuelve la aplicación entera

app.service('mobile', function ($cordovaFile,
                                $ionicLoading,
                                $ionicPopup,
                                $interval,
                                $q,
                                $timeout,
                                $rootScope,
                                localStorageService) {


        var timeoutSpinner;
        var versionAndroid;
        var version;
        var imei;

        var estadoConexionViejo = '4g';
        try {
            estadoConexionViejo = navigator.connection.type;
        } catch (e) {
        }






        function obtenerImei() {
            return imei
        }






        function obtenerDatosDispositivo() {
            return localStorageService.get("dispositivo")
        }






        function vibrar(milisegundos) {
            console.log('segundos: ', milisegundos);
            if (this.obtenerVersionAndroid() < 5) {
                return
            }
            try {
                navigator.vibrate(milisegundos);
            } catch (e) {
            }
        }






        function detenerVibrar() {
            if (this.obtenerVersionAndroid() < 5) {
                return
            }
            try {
                navigator.vibrate(0);
            } catch (e) {
            }

        }






        return {


            obtenerDatosDispositivo: obtenerDatosDispositivo,
            abrirArchivo: abrirArchivo,
            activarModoBackground: activarModoBackground,
            desactivarModoBackground: desactivarModoBackground,
            esconderStatusBar: esconderStatusBar,
            esFalsaLaUbicacion: esFalsaLaUbicacion,
            mantenerPantallaEncendida: mantenerPantallaEncendida,
            modificarComportamientoTeclado: modificarComportamientoTeclado,
            mostrarStatusBarSiEstaElTecladoAbierto: mostrarStatusBarSiEstaElTecladoAbierto,
            setearVersionCelular: setearVersionCelular,
            obtenerImei: obtenerImei,
            vibrar: vibrar,
            detenerVibrar: detenerVibrar,
            mostrarSpinner: function (tiempoMaximo) {
                var yo = this;
                $ionicLoading.show({
                    animation: 'fade-in',
                    maxWidth: 300
                }).then(function () {
                    yo.iniciaTimeoutSpinner(tiempoMaximo);

                }, function (l) {

                });
            },

            cancelarYocultarSpinner: function () {

                $timeout.cancel(timeoutSpinner);

                this.ocultarSpinner();

                //$ionicLoading.hide().then(function () {});

            },

            errorSpinner: function () {
                $ionicLoading.hide().then(function () {
                    //todo aca se tendria que cancelar el emit
                    alert("no se pudo procesar su pedido")
                });
            },


            iniciaTimeoutSpinner: function (tiempo) {
                timeoutSpinner = $timeout(function () {
                    $ionicLoading.hide().then(function () {
                    });
                    alert("Intente nuevamente mas tarde")
                }, tiempo);
            },

            obtenerDatosTelefono: function () {
                var deferred = $q.defer();

                var datos = this.obtenerDatos();

                if (datos == undefined) {
                    deferred.reject();
                } else {
                    deferred.resolve(datos);
                }

                return deferred.promise;
            },

            //lo puse aparte para poder simular la respuesta con un mock
            obtenerDatos: function () {
                return ionic.Platform.device();
            },

            obtenerRedActual: function () {
                return navigator.connection.type;
            },

            ocultarSpinner: function () {
                $ionicLoading.hide().then(function () {
                    //console.log("Error al registrar. por vencimiento del timeout, por no poder obtener el gcmid o por error en la devolucion del server");
                });
                //servidor.getConexion().removeAllListeners();
                //alert("error al registrar");
            },

            //devuelve la ruta de la imagen acorde al dispositivo donde corre la aplicacion
            rutaImagen: function (ruta) {

                //pregunta si estoy usando un celular. esta en el futuro tiene qu ever que tipo de celu es
                if (window.cordova) {
                    return "/android_asset/www/" + ruta;
                }

                return ruta
            },

            spinner: function (bien, tiempoMuestraSpinner) {
                var self = this;
                $ionicLoading.show({
                    content: 'Loading',
                    animation: 'fade-in',
                    hideOnStateChange: true
                }).then(function () {
                    var timeSpinner = $timeout(function () {
                        self.errorSpinner();
                    }, tiempoMuestraSpinner * 1000);
                    bien(timeSpinner)
                });
            },

            validarStrSegunVersion: function (str) {
                if (localStorageService.get("dispositivo").version <= 4.3) {
                    return this.validarStr(str)
                }

                return str;

            },

            //devuelve el string sin caracteres raros
            validarStr: function (str) {

                var from = "ÃÀÁÄÂÈÉËÊÌÍÏÎÒÓÖÔÙÚÜÛãàáäâèéëêìíïîòóöôùúüûÑñÇç",
                    to = "AAAAAEEEEIIIIOOOOUUUUaaaaaeeeeiiiioooouuuunncc",
                    mapping = {};

                for (var i = 0, j = from.length; i < j; i++)
                    mapping[from.charAt(i)] = to.charAt(i);

                var ret = [];

                for (var i = 0, j = str.length; i < j; i++) {
                    var c = str.charAt(i);
                    if (mapping.hasOwnProperty(str.charAt(i))) {
                        ret.push(mapping[c]);
                    } else {
                        ret.push(c);
                    }
                }

                return ret.join('');

            },

            //se encarga de verificar si hay un cambio de red
            verificarCambioRed: function () {

                //console.log('Connection type: ' + navigator.connection.type);

                var retorno = {};
                var redActual = this.obtenerRedActual();

                if (redActual == estadoConexionViejo) {
                    retorno = {
                        Estado: false,
                        Respuesta: "no hubo cambios"
                    };
                } else {

                    retorno = {
                        Estado: true,
                        Respuesta: {"redAnterior": estadoConexionViejo, "redActual": redActual}
                    };

                    console.log("cambio de red: " + JSON.stringify(retorno.Respuesta));

                    //y ahora la actual es la anterior
                    estadoConexionViejo = redActual;


                }

                return retorno;

            },

            //controla si hubo un cambio de red que hace que se desconecte con el server)
            controlCambioRed: function () {
                var huboCambios = this.verificarCambioRed();
                var retorno = {};

                //si no hubo cambios sale
                if (!huboCambios.Estado) {
                    return retorno = {Estado: false, Respuesta: huboCambios.Respuesta};
                }


                //si hubo cambios de none a otra red, o de otra red a none
                //excepto que sea de wifi a 2g,3g,4g
                if ((huboCambios.Respuesta.redAnterior != "none") && !(huboCambios.Respuesta.redAnterior == "wifi" && huboCambios.Respuesta.redActual != "none")) {

                    console.log("entro: ");
                    //devuelve que hubo cambios
                    retorno = {Estado: true, Respuesta: huboCambios.Respuesta};

                    //si no hubo cambios
                } else {
                    retorno = {Estado: false, Respuesta: huboCambios.Respuesta}
                }

                return retorno;
            },


            verificarPosicionDisponible: function () {
                var deferred = $q.defer();

                cordova.plugins.diagnostic.isLocationAvailable(function (enabled) {

                    deferred.resolve(enabled)


                }, function () {
                    deferred.reject()

                });

                return deferred.promise;
            },

            //si esta activo por alta precision (gps+wifi), devuelve true
            //si solo esta activo el gps, devuelve true
            //si solo esta activa la posicion por wifi, devuelve false
            verificarGPSprendido: function () {
                var deferred = $q.defer();

                cordova.plugins.diagnostic.isGpsLocationEnabled(function (enabled) {

                    deferred.resolve(enabled)


                }, function () {
                    deferred.reject()

                });

                return deferred.promise;
            },


            setearVersionAndroid: function (version) {
                versionAndroid = parseFloat(version);

                console.log("version android seteada:" + versionAndroid);
            },


            obtenerVersionAndroid: function () {
                return versionAndroid
            }

        };






        function abrirArchivo(ubicacion, archivo, tipo) {
            return cordova.plugins.fileOpener2.showOpenWithDialog(
                ubicacion + archivo, // You can also use a Cordova-style file uri: cdvfile://localhost/persistent/Download/starwars.pdf
                tipo,
                {
                    error: function (e) {
                        console.log('Error status: ' + e.status + ' - Error message: ' + e.message);
                        alert("No se pudo instalar el archivo")
                    },
                    success: function () {
                        console.log('file opened successfully');
                    }
                }
            );
        }






        function mostrarStatusBarSiEstaElTecladoAbierto() {

            if (!StatusBar) {
                return;
            }

            $interval(function () {
                if (Keyboard.isVisible) {
                    StatusBar.hide();
                }
            }, 20);


        }






        function esconderStatusBar() {
            if (StatusBar) {
                StatusBar.hide();
            }
        }






        function modificarComportamientoTeclado() {
            if (window.cordova.plugins.Keyboard) {
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                cordova.plugins.Keyboard.disableScroll(false);
            }
        }






        function mantenerPantallaEncendida() {
            window.plugins.insomnia.keepAwake();
        }






        function setearConfiguracionModoBackground() {
            cordova.plugins.backgroundMode.setDefaults({
                text: 'En ejecución',
                title: $rootScope.tipo,
                icon: 'icon',
                ticker: 'En ejecución'
            });
        }






        function desactivarModoBackground() {
            cordova.plugins.backgroundMode.disable();

        }






        function activarModoBackground() {
            setearConfiguracionModoBackground();
            cordova.plugins.backgroundMode.enable();
        }






        function setearVersionCelular(_version) {
            version = _version
        }






        function esFalsaLaUbicacion() {

            var defer = $q.defer();

            console.log("esfalsa");

            console.log("version:" + version);
            if (version >= 6) {
                window.plugins.mocklocationchecker.check(successCallbac, errorCallbac); //6.0 en adelante
                function successCallbac(result) {
                    console.error("ACTIVADO O NO2:" + JSON.stringify(result)); // true - enabled, false - disabled

                    result = result.mock_false;
                    defer.resolve(result)

                }






                function errorCallbac() {
                    defer.reject(result);
                }
            } else {
                window.plugins.mocklocation.check(successCallback, errorCallback); //6.0 en adelante
                function successCallback(result) {
                    console.error("ACTIVADO O NO2:" + JSON.stringify(result)); // true - enabled, false - disabled

                    defer.resolve(result)
                }






                function errorCallback() {

                    defer.reject(result);
                }
            }


            return defer.promise;
        }
    }
);
