/**
 * Created by ivan on 18/05/17.
 */
describe("module.validaciones", function () {

  var Validaciones;

  beforeEach(module('moduloValidaciones'));

  beforeEach(inject(function (validaciones) {
    Validaciones = validaciones;

  }));

  it('validar_vacio_null_y_undefined', function () {

    expect(Validaciones).toBeDefined(); //verifica que este definido y exista el service

    expect(Validaciones.validar_vacio_null_y_undefined).toBeDefined(); //verifica que este definida o sea que exista la funcion del servicio
    expect(Validaciones.lista_no_vacio).toBeDefined(); //verifica que este definida o sea que exista la funcion del servicio
    expect(Validaciones.validar_objeto_vacio).toBeDefined(); //verifica que este definida o sea que exista la funcion del servicio
    expect(Validaciones.validar_email).toBeDefined(); //verifica que este definida o sea que exista la funcion del servicio
    expect(Validaciones.validar_nombres).toBeDefined(); //verifica que este definida o sea que exista la funcion del servicio

    expect(Validaciones.validar_vacio_null_y_undefined()).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'el mensaje es undefined'
    }));
    expect(Validaciones.validar_vacio_null_y_undefined(undefined)).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'el mensaje es undefined'
    }));
    expect(Validaciones.validar_vacio_null_y_undefined(null)).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'el mensaje es null'
    }));
    expect(Validaciones.validar_vacio_null_y_undefined('')).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'el mensaje esta vacio'
    }));
    expect(Validaciones.validar_vacio_null_y_undefined("hola")).toEqual(jasmine.objectContaining({
      Estado: true, Respuesta: 'el mensaje es correcto'
    }));

    var objetoVacio = {};
    var objetoNoVacio = {'hola': 1};
    var arregloVacio = [];
    var arregloNoVacio = ['2'];
    var arregloNoVacioParcial = ['2', ''];
    var arregloDeDic = [{"id": 1}, {"id": 2}];
    var arregloDeDicVacio = [{}, {}];

    expect(Validaciones.validar_vacio_null_y_undefined(objetoVacio)).toEqual(jasmine.objectContaining({
      Estado: true, Respuesta: 'el mensaje es correcto'
    }));
    expect(Validaciones.validar_vacio_null_y_undefined(objetoNoVacio)).toEqual(jasmine.objectContaining({
      Estado: true, Respuesta: 'el mensaje es correcto'
    }));
    expect(Validaciones.validar_vacio_null_y_undefined(12)).toEqual(jasmine.objectContaining({
      Estado: true, Respuesta: 'el mensaje es correcto'
    }));
    expect(Validaciones.validar_vacio_null_y_undefined("12")).toEqual(jasmine.objectContaining({
      Estado: true, Respuesta: 'el mensaje es correcto'
    }));
    expect(Validaciones.validar_vacio_null_y_undefined("")).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'el mensaje esta vacio'
    }));
    expect(Validaciones.validar_vacio_null_y_undefined(arregloNoVacio)).toEqual(jasmine.objectContaining({
      Estado: true, Respuesta: 'el mensaje es correcto'
    }));
    expect(Validaciones.validar_vacio_null_y_undefined(arregloNoVacioParcial)).toEqual(jasmine.objectContaining({
      Estado: true, Respuesta: 'el mensaje es correcto'
    }));
    expect(Validaciones.validar_vacio_null_y_undefined(null)).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'el mensaje es null'
    }));
    expect(Validaciones.validar_vacio_null_y_undefined(undefined)).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'el mensaje es undefined'
    }));
    expect(Validaciones.validar_vacio_null_y_undefined(arregloVacio)).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'el mensaje esta vacio'
    }));


    expect(Validaciones.lista_no_vacio(objetoVacio)).toEqual(jasmine.objectContaining({
      Estado: true, Respuesta: 'Todos los valores tienen información.'
    }));
    expect(Validaciones.lista_no_vacio(arregloDeDic)).toEqual(jasmine.objectContaining({
      Estado: true, Respuesta: 'Todos los valores tienen información.'
    }));
    expect(Validaciones.lista_no_vacio(objetoNoVacio)).toEqual(jasmine.objectContaining({
      Estado: true, Respuesta: 'Todos los valores tienen información.'
    }));
    expect(Validaciones.lista_no_vacio(arregloNoVacio)).toEqual(jasmine.objectContaining({
      Estado: true, Respuesta: 'Todos los valores tienen información.'
    }));
    expect(Validaciones.lista_no_vacio(arregloVacio)).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'el mensaje esta vacio'
    }));
    expect(Validaciones.lista_no_vacio(arregloNoVacioParcial)).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'Algunos valores son vacio o nulo'
    }));
    expect(Validaciones.lista_no_vacio(null)).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'el mensaje es null'
    }));
    expect(Validaciones.lista_no_vacio(undefined)).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'el mensaje es undefined'
    }));
    expect(Validaciones.lista_no_vacio([''])).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'el mensaje esta vacio'
    }));


    expect(Validaciones.validar_objeto_vacio(objetoVacio)).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'El objeto esta vacio'
    }));
    expect(Validaciones.validar_objeto_vacio(arregloVacio)).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'el mensaje esta vacio'
    }));
    expect(Validaciones.validar_objeto_vacio(null)).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'el mensaje es null'
    }));
    expect(Validaciones.validar_objeto_vacio(undefined)).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'el mensaje es undefined'
    }));
    expect(Validaciones.validar_objeto_vacio(objetoNoVacio)).toEqual(jasmine.objectContaining({
      Estado: true, Respuesta: 'El objeto no esta vacio'
    }));
    expect(Validaciones.validar_objeto_vacio(arregloNoVacio)).toEqual(jasmine.objectContaining({
      Estado: true, Respuesta: 'El objeto no esta vacio'
    }));
    expect(Validaciones.validar_objeto_vacio(arregloNoVacioParcial)).toEqual(jasmine.objectContaining({
      Estado: true, Respuesta: 'El objeto no esta vacio'
    }));
    expect(Validaciones.validar_objeto_vacio(5)).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'el parametro es un numero'
    }));
    expect(Validaciones.validar_objeto_vacio("5")).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'el parametro es un string'
    }));

    expect(Validaciones.es_cero(0)).toEqual(jasmine.objectContaining({
      Estado: true, Respuesta: 'El valor ingresado es cero'
    }));
    expect(Validaciones.es_cero("0")).toEqual(jasmine.objectContaining({
      Estado: true, Respuesta: 'El valor ingresado es cero'
    }));
    expect(Validaciones.es_cero(1)).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'El valor ingresado no es cero'
    }));
    expect(Validaciones.es_cero("1")).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'El valor ingresado no es cero'
    }));

    expect(Validaciones.validar_email()).toBe(false);
    expect(Validaciones.validar_email("2@hotmail.com")).toBe(true);
    expect(Validaciones.validar_email(".2@hotmail.com")).toBe(true); //si lleva punto delante no anda
    expect(Validaciones.validar_email("2@hotmailcom")).toBe(false); //si falta . no anda
    expect(Validaciones.validar_email("2@hotmailcom")).toBe(false);
    expect(Validaciones.validar_email("2@hotmail.ar")).toBe(true);
    expect(Validaciones.validar_email(" 2@hotmail.com")).toBe(true);
    expect(Validaciones.validar_email("!#$%&'*+/=?^_`{|}~.-@com.com")).toBe(true);
    expect(Validaciones.validar_email("	a@p.com	")).toBe(true);
    expect(Validaciones.validar_email("@p.com	")).toBe(false);
    expect(Validaciones.validar_email("@p")).toBe(false);
    expect(Validaciones.validar_email("ivancito@p")).toBe(false);
    expect(Validaciones.validar_email("ivancito@p.com")).toBe(true);
    expect(Validaciones.validar_email("ivancito@p.com.ar")).toBe(true);
    expect(Validaciones.validar_email("ivancito@com.ar")).toBe(true);

    expect(Validaciones.validar_nombres("hola")).toBe(true);
    expect(Validaciones.validar_nombres("hola   ")).toBe(true);
    expect(Validaciones.validar_nombres("HOLA")).toBe(true);
    expect(Validaciones.validar_nombres("HOLA COMO")).toBe(true);
    expect(Validaciones.validar_nombres("hola como")).toBe(true);
    expect(Validaciones.validar_nombres("ha")).toBe(true); //menos de 2 caracteres no anda
    expect(Validaciones.validar_nombres("hsssssssssssssssssssssss")).toBe(true);
    expect(Validaciones.validar_nombres("hola9")).toBe(false); //con numero no anda
    expect(Validaciones.validar_nombres("hola 9")).toBe(false);
    expect(Validaciones.validar_nombres("hOola 9")).toBe(false);
    expect(Validaciones.validar_nombres("h")).toBe(false); //menos de 2 caracteres no anda
    expect(Validaciones.validar_nombres("hsssssssssssssssssssssssssssssssssssssssssssssssssssssssssss")).toBe(false); //mas de 30 caracteres no anda
    expect(Validaciones.validar_nombres("h_")).toBe(false); //otro caracter que no sea letras no anda
    expect(Validaciones.validar_nombres("h-")).toBe(false);
    expect(Validaciones.validar_nombres("-")).toBe(false);
    expect(Validaciones.validar_nombres(" ")).toBe(false);
    expect(Validaciones.validar_nombres("$")).toBe(false);
    expect(Validaciones.validar_nombres("ñandu")).toBe(true);
    expect(Validaciones.validar_nombres("Ñandu")).toBe(true);
    expect(Validaciones.validar_nombres("Ñandú Ó")).toBe(true);
    expect(Validaciones.validar_nombres("áéíóúÁÉÍÓÚ Ó")).toBe(true);
  });

  it("lista_numero_entero_positivo", function () {
    expect(Validaciones.lista_numero_entero_positivo([])).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'No hay elementos en la lista'
    }));
    expect(Validaciones.lista_numero_entero_positivo()).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'No hay elementos en la lista'
    }));
    expect(Validaciones.lista_numero_entero_positivo(null)).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'No hay elementos en la lista'
    }));
    expect(Validaciones.lista_numero_entero_positivo(['', 2])).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'Algunos valores no son número enteros positivos'
    }));
    expect(Validaciones.lista_numero_entero_positivo(['', ''])).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'Algunos valores no son número enteros positivos'
    }));
    expect(Validaciones.lista_numero_entero_positivo([null, 2])).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'Algunos valores no son número enteros positivos'
    }));
    expect(Validaciones.lista_numero_entero_positivo([null, -2])).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'Algunos valores no son número enteros positivos'
    }));
    expect(Validaciones.lista_numero_entero_positivo([null, null])).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'Algunos valores no son número enteros positivos'
    }));
    expect(Validaciones.lista_numero_entero_positivo([-5, -2])).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'Algunos valores no son número enteros positivos'
    }));
    expect(Validaciones.lista_numero_entero_positivo([1, -2])).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'Algunos valores no son número enteros positivos'
    }));
    expect(Validaciones.lista_numero_entero_positivo([-1, 2])).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'Algunos valores no son número enteros positivos'
    }));
    expect(Validaciones.lista_numero_entero_positivo([1, 2])).toEqual(jasmine.objectContaining({
      Estado: true, Respuesta: 'Todos los valores son número enteros positivos.'
    }));
  });


  it("numero entero positivo",function(){
    expect(Validaciones.numero_entero_positivo([])).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'Este campo es obligatorio.'
    }));
    expect(Validaciones.numero_entero_positivo(null)).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'Este campo es obligatorio.'
    }));
    expect(Validaciones.numero_entero_positivo('')).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'Este campo es obligatorio.'
    }));
    expect(Validaciones.numero_entero_positivo(-1)).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'El valor ingresado no es un número entero positivo.'
    }));
    expect(Validaciones.numero_entero_positivo(0.5)).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'El valor ingresado no es un número entero.'
    }));
    expect(Validaciones.numero_entero_positivo(-0.5)).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'El valor ingresado no es un número entero.'
    }));
    expect(Validaciones.numero_entero_positivo(1)).toEqual(jasmine.objectContaining({
      Estado: true, Respuesta: 'El valor ingresado es un número entero positivo.'
    }));
  });

  it("numero positivo",function(){
    expect(Validaciones.numero_positivo(2)).toEqual(jasmine.objectContaining({
      Estado: true, Respuesta: 'El valor ingresado es un número entero positivo.'
    }));
    expect(Validaciones.numero_positivo(-2)).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'El valor ingresado no es un número entero positivo.'
    }));
    expect(Validaciones.numero_positivo()).toEqual(jasmine.objectContaining({
      Estado: false, Respuesta: 'Este campo es obligatorio.'
    }));
  });


});
