var app = angular.module('moduloValidaciones',[]);
//app es un objeto que devuelve la aplicacion entera

app.service('validaciones', function () {

  return {


    //////////// //  INICIO DE SERVICIO/////////////////

    no_vacio: function (valor) {
      var rta = {};
      if (valor == null || valor == '') {
        rta['Estado'] = false;
        rta['Respuesta'] = "Este campo es obligatorio.";
        return rta
      }
      rta['Estado'] = true;
      rta['Respuesta'] = "El valor ingresado no es vacio o nulo.";
      return rta
    },

    es_cero: function (valor) {
      var rta = {};
      if (valor == 0) {
        rta['Estado'] = true;
        rta['Respuesta'] = "El valor ingresado es cero";
        rta['Dato'] = 0;
        return rta
      }
      rta['Estado'] = false;
      rta['Respuesta'] = "El valor ingresado no es cero";
      return rta
    },

    validar_objeto_vacio: function (objeto) {

      var rta = {};

      if (typeof objeto == 'number') {
        rta['Estado'] = false;
        rta['Respuesta'] = "el parametro es un numero";
        return rta
      }

      if (typeof objeto == 'string') {
        rta['Estado'] = false;
        rta['Respuesta'] = "el parametro es un string";
        return rta
      }

      var respuestaValidar = this.validar_vacio_null_y_undefined(objeto);
      if (!respuestaValidar['Estado']) {
        return respuestaValidar
      }

      if (Object.keys(objeto).length == 0) {
        rta['Estado'] = false;
        rta['Respuesta'] = "El objeto esta vacio";
        return rta
      }
      rta['Estado'] = true;
      rta['Respuesta'] = "El objeto no esta vacio";
      return rta
    },

    validar_vacio_null_y_undefined: function (mensaje) {
      var respuesta = {};

      if (mensaje === undefined) {
        respuesta = {
          Estado: false,
          Respuesta: "el mensaje es undefined"
        };
        return respuesta;
      }

      if (mensaje === null) {
        respuesta = {
          Estado: false,
          Respuesta: "el mensaje es null"
        };
        return respuesta;
      }

      if (mensaje == '') {
        respuesta = {
          Estado: false,
          Respuesta: "el mensaje esta vacio"
        };
        return respuesta;
      }

      respuesta = {
        Estado: true,
        Respuesta: "el mensaje es correcto"
      };

      return respuesta;

    },

    lista_no_vacio: function (lista) {
      var rta = {};

      var respuestaValidar = this.validar_vacio_null_y_undefined(lista);
      if (!respuestaValidar['Estado']) {
        return respuestaValidar
      }

      if (lista.length < 1) {
        rta['Estado'] = false;
        rta['Respuesta'] = "No hay elementos en la lista";
        return rta
      }
      for (var i = 0; i < lista.length; i++) {
        var v = this.no_vacio(lista[i]);
        if (v['Estado'] != true) {
          rta['Estado'] = false;
          rta['Respuesta'] = "Algunos valores son vacio o nulo";
          return rta
        }
      }
      rta['Estado'] = true;
      rta['Respuesta'] = "Todos los valores tienen información.";
      return rta
    },

    numero: function (valor) {
      var rta = {};

      //Valido que no sea vacio.
      var v = this.no_vacio(valor);
      if (v['Estado'] != true) {
        return v
      }

      // Valido que sea un número.
      if (isNaN(valor)) {
        rta['Estado'] = false;
        rta['Respuesta'] = "El valor ingresado no es número.";
        return rta
      }

      rta['Estado'] = true;
      rta['Respuesta'] = "El valor ingresado es número.";
      rta['Dato'] = parseFloat(valor);
      return rta
    },

    numero_entero: function (valor) {
      var rta = {};
      //Valido que no sea numero.
      var v = this.numero(valor);
      if (v['Estado'] != true) {
        return v
      }
      //Verifico que sea entero
      if (valor % 1 != 0) {
        rta['Estado'] = false;
        rta['Respuesta'] = "El valor ingresado no es un número entero.";
        return rta
      }

      rta['Estado'] = true;
      rta['Respuesta'] = "El valor ingresado es un número entero.";
      rta['Dato'] = parseInt(valor);
      return rta
    },

    numero_positivo: function (valor) {
      var rta = {};
      //Valido que no sea numero.
      var v = this.numero(valor);
      if (v['Estado'] != true) {
        return v
      }
      //Verifico que sea positivo
      if (valor <= 0) {
        rta['Estado'] = false;
        rta['Respuesta'] = "El valor ingresado no es un número entero positivo.";
        return rta
      }

      rta['Estado'] = true;
      rta['Respuesta'] = "El valor ingresado es un número entero positivo.";
      rta['Dato'] = parseFloat(valor);
      return rta
    },

    numero_entero_positivo: function (valor) {
      var rta = {};
      //Valido que no sea numero.
      var v = this.numero_entero(valor);
      if (v['Estado'] != true) {
        return v
      }
      var v_e = this.numero_positivo(valor);
      if (v_e['Estado'] != true) {
        return v_e
      }

      rta['Estado'] = true;
      rta['Respuesta'] = "El valor ingresado es un número entero positivo.";
      rta['Dato'] = parseInt(valor);
      return rta
    },

    lista_numero_entero_positivo: function (lista) {
      var rta = {};

      if (lista == undefined) {
        rta['Estado'] = false;
        rta['Respuesta'] = "No hay elementos en la lista";
        return rta
      }
      if (lista.length < 1) {
        rta['Estado'] = false;
        rta['Respuesta'] = "No hay elementos en la lista";
        return rta
      }
      for (var i = 0; i < lista.length; i++) {
        var v = this.numero_entero_positivo(lista[i]);
        if (v['Estado'] != true) {
          rta['Estado'] = false;
          rta['Respuesta'] = "Algunos valores no son número enteros positivos";
          return rta
        }
      }
      rta['Estado'] = true;
      rta['Respuesta'] = "Todos los valores son número enteros positivos.";
      return rta
    },

    hora: function (timeStrtotal) {

      //Obtengo el string y lo separo por :
      var timePat = timeStrtotal.split(":");

      //Defino la respuesta por defecto en false.
      var rta = {
        'Estado': false,
        'Respuesta': 'No es un formato valido [HH:MM:SS]'
      };

      //Si obtengo menos de 3 elementos retorno false.
      if (timePat.length != 3) {
        return rta;
      }

      //Si es null retorjno false.
      if (timePat == null) {
        return rta;
      }

      // Si recibo vacio retorno false
      if (timeStrtotal == "") {
        return rta;
      }

      //Obtengo hora, munitos y segundos
      var hora = timePat[0];
      var minutos = timePat[1];
      var segundos = timePat[2];

      //Verifico que esos valores no sean vacio o null.
      if (hora == "" || hora == null) {
        return rta;
      }
      if (minutos == "" || minutos == null) {
        return rta;
      }
      if (segundos == "" || segundos == null) {
        return rta;
      }

      //Paso los valores a enteros para realizar compraciones.
      hora = parseInt(hora);
      minutos = parseInt(minutos);
      segundos = parseInt(segundos);

      //Verifo que el valor de la hora sea coherente.
      if (hora < 0 || hora > 23) {
        rta['Respuesta'] = "La hora debe estar entre 0 y 23";
        return rta;
      }

      //Verifo que el valor de los minutos sea coherente.
      if (minutos < 0 || minutos > 59) {
        rta['Respuesta'] = "los minutos deben estar entre 0 y 59.";
        return rta;
      }

      //Verifo que el valor de los segundos sea coherente.
      if (segundos != null && (segundos < 0 || segundos > 59)) {
        rta['Respuesta'] = "los segundos deben estar entre 0 y 59.";
        return rta;
      }

      //Retorno True.
      rta['Estado'] = true;
      rta['Respuesta'] = "Es un formato valido [HH:MM:SS]";
      rta['Dato'] = timeStrtotal;
      return rta;
    },

    fecha: function (valor) {
      var dic = {
        'Estado': false,
        'Respuesta': 'Formato invalido de fecha.'
      };

      var fechaf = valor.split("/");

      if (fechaf.length != 3) {
        return dic
      }
      var d = parseInt(fechaf[0]);
      var m = parseInt(fechaf[1]);
      var y = parseInt(fechaf[2]);
      if (d < 0 || d > 31) {
        return dic
      }

      if (m < 0 || m > 12) {
        return dic
      }

      if (y < 1900) {
        return dic
      }

      dic['Estado'] = true;
      dic['Respuesta'] = 'Formato valido de fecha.';
      dic['Dato'] = valor;
      return dic
    },

    ejecutar_validaciones_input: function (objeto_input) {
      var dic = {
        'Estado': true,
        'Respuesta': "El input es válido."
      };

      var valor = objeto_input.val();

      dic['Dato'] = valor;

      var no_obligatorio = objeto_input.attr("at_no_obligatorio");

      var rta_no_vacio = this.no_vacio(valor);

      if (no_obligatorio == 'true' && rta_no_vacio['Estado'] == false) {
        return dic;
      }

      var no_vacio = objeto_input.attr("at_no_vacio");
      var numero = objeto_input.attr("at_numero");
      var numero_entero = objeto_input.attr("at_numero_entero");
      var numero_positivo = objeto_input.attr("at_numero_positivo");
      var hora = objeto_input.attr("at_hora");
      var fecha = objeto_input.attr("at_fecha");


      if (no_vacio == "true") {

        if (rta_no_vacio['Estado'] != true) {
          return rta_no_vacio
        }
      }

      if (numero == "true") {
        var rta_numero = this.numero(valor);
        if (rta_numero['Estado'] != true) {
          return rta_numero
        }
        dic['Dato'] = rta_numero['Dato'];
      }

      if (numero_entero == "true") {
        var rta_numero_entero = this.numero_entero(valor);
        if (rta_numero_entero['Estado'] != true) {
          return rta_numero_entero
        }
        dic['Dato'] = rta_numero_entero['Dato'];
      }

      if (numero_positivo == "true") {
        var rta_numero_positivo = this.numero_positivo(valor);
        if (rta_numero_positivo['Estado'] != true) {
          return rta_numero_positivo
        }
        dic['Dato'] = rta_numero_positivo['Dato'];
      }

      if (hora == "true") {
        var rta_hora = this.hora(valor);
        if (rta_hora['Estado'] != true) {
          return rta_hora
        }
        dic['Dato'] = rta_hora['Dato'];

      }

      if (fecha == "true") {
        var rta_fecha = this.fecha(valor);
        if (rta_fecha['Estado'] != true) {
          return rta_fecha
        }
        dic['Dato'] = rta_fecha['Dato'];

      }

      return dic;
    },

    input: function (id_input, input_error, popover) {

      var objeto_input = $('#' + id_input);

      var v_input = this.ejecutar_validaciones_input(objeto_input);
      if (v_input['Estado'] == true) {
        objeto_input.removeClass('input_error');
        objeto_input.popover('destroy');
        return v_input
      }
      if (input_error == true) {
        objeto_input.addClass('input_error')
      }
      else {
        objeto_input.removeClass('input_error');
      }

      if (popover == true) {
        if (objeto_input.data("content") != v_input['Respuesta']) {
          objeto_input.popover('destroy');
        }
        setTimeout(function () {
          objeto_input
            .data("content", v_input['Respuesta'])
            .data("data-toggle", 'popover')
            //.data("placement", 'left')
            .popover('show');
        }, 150);
      }
      else {
        objeto_input.popover('destroy');
      }
      return v_input
    }
    ,

    formulario: function (id_formulario, input_error, popover, focus_input) {
      var formulario = $('#' + id_formulario + ' input, textarea, select');
      var dic = {
        'Estado': true,
        'Respuesta': []
      };

      var casos_correctos = {};

      var lista_input = [];
      formulario.each(function () {
        var id_input = $(this).attr("id");
        lista_input.push(id_input);
      });
      for (var i = 0; i < lista_input.length; i++) {
        var v_input = this.input(lista_input[i], input_error, popover);
        if (v_input['Estado'] != true) {
          var lista = [lista_input[i], v_input['Respuesta']];
          dic['Estado'] = false;
          dic['Respuesta'].push(lista);
        }
        else {

          var input_tmp = $('#' + lista_input[i]);

          var valor = v_input['Dato'];

          if (valor === '') {
            valor = null
          }

          if(valor === undefined){
            continue
          }

          var type = input_tmp.attr("type");
          if (type == 'checkbox') {
            if (input_tmp.is(':checked')) {
              valor = true
            }
            else {
              valor = false
            }
          }

          casos_correctos[lista_input[i]] = valor;
        }
      }
      if (dic['Estado'] != true && focus_input == true) {
        setTimeout(function () {
          $('#' + dic['Respuesta'][0][0]).focus();
        }, 200);
      }
      else {
        dic['Dato'] = casos_correctos
      }
      return dic
    },

    limpiar_formulario: function (id_formulario, datos) {
      var formulario = $('#' + id_formulario + ' input, textarea, select');
      formulario.each(function () {
        var input = $(this);
        input.removeClass('input_error');
        input.popover('destroy');
        if (datos == true) {
          input.val('');
        }
      });
      var dic = {
        'Estado': true,
        'Respuesta': ''
      };
      return dic
    },

    limpiar_input: function (id_input) {
      var input = $('#' + id_input);
      input.removeClass('input_error');
      input.popover('destroy');
      var dic = {
        'Estado': true,
        'Respuesta': ''
      };
      return dic
    },

    validar_email: function (email) {
      var expresionRegular = /[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?/;
      return expresionRegular.test(email);
    },

    validar_nombres: function (nombre) {
      var expresionRegular = /^[a-zA-ZñÑáéíóúÁÉÍÓÚ ]{2,30}$/;
      return expresionRegular.test(nombre);
    }

//////////// FIN DE SERVICIO  ///////////////////
  }

});

