/**
 * Creado por ivan fecha 15/01/18.
 */



//██████╗  █████╗ ███╗   ██╗██╗ ██████╗ ██████╗
//██╔══██╗██╔══██╗████╗  ██║██║██╔════╝██╔═══██╗
//██████╔╝███████║██╔██╗ ██║██║██║     ██║   ██║
//██╔═══╝ ██╔══██║██║╚██╗██║██║██║     ██║   ██║
//██║     ██║  ██║██║ ╚████║██║╚██████╗╚██████╔╝
//╚═╝     ╚═╝  ╚═╝╚═╝  ╚═══╝╚═╝ ╚═════╝ ╚═════╝



    angular
        .module('starter')
        .factory('panico', panico);





    /**
     * @ngInject
     */
    function panico($cordovaSQLite,
                    $interval,
                    $q,
                    $rootScope,
                    $timeout,
                    bluetooth,
                    localStorageService,
                    servidor) {



        //variables privadas
        var intervaloBusquedaPendientes = 6000, //intervalo con el que busca los pendientes, por si no se pudieron enviar
            timeoutPanico = 22000, //timeout que no le hace caso al panico
            estadoPrevioAlPanico,
            bluetoothActivo,
            variableTimeoutPanico;
        var permiteEnviarAlarma;
        var panicoActivo;

        //metodos públicos o sea accesibles desde cualquier lugar que inyecte el servicio
        var service = {


            inicializar: inicializar,
            buscarPanicosPendientes: buscarPanicos,
            desactivar_panico: desactivar_panico,
            enviarPanico: enviarPanico,
            obtenerBluetoothActivo: obtenerBluetoothActivo,
            setearBluetoothActivo: setearBluetoothActivo,
            obtenerPanicoActivo: obtenerPanicoActivo,
            obtenerPermiteEnviarAlarma: obtenerPermiteEnviarAlarma,
            setearPanicoActivo: setearPanicoActivo,
            setearPermiteEnviarAlarma: setearPermiteEnviarAlarma

        };

        return service;





        function setearPermiteEnviarAlarma(valor) {
            permiteEnviarAlarma = valor
        }





        function obtenerPermiteEnviarAlarma() {
            return permiteEnviarAlarma
        }





        function setearPanicoActivo(_panico) {
            panicoActivo = _panico
        }





        function obtenerPanicoActivo() {
            return panicoActivo
        }





        //implementacion de metodos tanto publicos como privados
        function inicializar() {

            resetearPanicos(); //limpia los pánicos pendientes

            //crea la tabla o la carga
            crearTablaPendientes().then(function () {
                iniciarIntervaloDePanicosPendientes();
            }, function () {

            });

            registrarListeners(); //monitoriza las respuestas del server ante cada envio de panico


        }





        function registrarListeners() {


            //cuando el servidor responde que se activo el panico
            $rootScope.$on('rta_activar_panico', function (a, msg) {
                rta_activar_panico(msg);
            });


            //cuando el server me dice que desactivó el panico
            $rootScope.$on('desactivar_panico', function (a, msg) {
                desactivar_panico(msg);
            });


        }





        function obtenerBluetoothActivo() {
            return bluetoothActivo;
        }





        function setearBluetoothActivo(bluetoothActivoP) {
            if (!bluetoothActivoP) {
                bluetoothActivoP = 'false'
            }
            bluetoothActivo = bluetoothActivoP;
        }





        function iniciarIntervaloBluetoothPrendido() {
            $interval(function () {
                bluetooth.estaPrendido().then(function () {
                    console.log("99esta bluetooth prendido: ");

                }, function () {
                    console.log("99esta bluetooth apagado: ");
                });
            }, 5000);
        }





        //metodos privados. algunos accesibles desde los metodos publicos
        function resetearPanicos() {
            $rootScope.panico = false; //visaulmente ya no esta mas en panico
            localStorageService.set("panicoActivado", false); //en localstorage no esto mas en panico
            var panicoActivado = false;
            console.log("reseteando pancio");
        }





        function iniciarIntervaloDePanicosPendientes() {
            //var query = "select * from pendientes where username=" + localStorageService.get("username");
            var query = "select * from pendientes";
            $interval(function () {
                if ($rootScope.internetPrendido) {
                    buscarPanicos(query);
                }
            }, intervaloBusquedaPendientes);
        }





        function buscarPanicos(query) {
            servidor.select(query).then(function (resultado) {

                if (resultado == null) {
                    // console.info("en select de panicos pendientes es null asi que no hay panicos: ");
                    return;
                }

                //si no es null quiere decir que hay alguno
                console.info("en select de panicos pendientes es" + JSON.stringify(resultado));

                var msg = {
                    "dni": resultado[0].username,
                    "hash": localStorageService.get("hash"),
                    "empresa": resultado[0].empresa
                };


                // estas dos se ponen porque una vez pasó que no habia nada cuando recuperó el registro
                if (msg.dni == null || msg.dni == '') {
                    msg.dni = localStorageService.get("username")
                }

                if (msg.empresa == null || msg.empresa == '') {
                    msg.empresa = localStorageService.get("empresa");
                }

                console.log("msg de select de panicos pendientes es: " + JSON.stringify(msg));

                //enviarPanico();
                servidor.getConexion().emit('activar_panico', msg);

                //pregunta si ya no esta iniciado asi no lo inicia de nuevo
                // inicia el timeout para que no mande de nuevo el panico hasta que se cumpla el tiempo
                if (!variableTimeoutPanico) {
                    iniciarTimeoutPanico();
                }

            }, function () {
                console.log("todo mal: ");
            });
        }





        //muestra que el panico fue activado
        function rta_activar_panico(msg) {

            console.log("llega en rta activar panico: " + msg);
            msg = angular.fromJson(msg);


            // if (msg['Estado'] == true) {
                $rootScope.panico = true;
                servidor.borrar("pendientes");
            // }
        }





        //vuelve a indicar que esta todo_ bien
        function desactivar_panico(msg) {

            msg = angular.fromJson(msg); //convierte el dato

            $rootScope.panico = false; //indica que el panico se desactivo visaulmente

            setearPanicoActivo(0);

            //vuelva a dejar el estado del icono como estaba para enviar en los ping

            //si no toco ocupado o libre recupera ese estado
            if (localStorageService.get('estadoIcono') == 2) {
                localStorageService.set('estadoIcono', estadoPrevioAlPanico);
            }

            //si toco libre u ocupado no hace nada

            servidor.confirmarComando(localStorageService.get('empresa'), msg['id_comando'], localStorageService.get('hash')); //confirma el comando

            // if (localStorageService.get("idComando") >= msg['id_comando']) {
            //     return;
            // } //si el id comando es mas nuevo sale, sino actualiza

            localStorageService.set("idComando", msg['id_comando']);


        }





        //inicia el timeout para no hacerle caso al panico. tanto sea por el modulo o por el boton
        function iniciarTimeoutPanico() {
            console.log("iniciando timeout: ");
            variableTimeoutPanico = $timeout(function () {
                localStorageService.set("panicoActivado", false);
                console.info("timeout panico vencido:.vuelvo a estar atento a los panicos que mande beto ");
                variableTimeoutPanico = null;
            }, timeoutPanico);
        }





        function crearTablaPendientes() {
            var defer = $q.defer();

            var query = "CREATE TABLE IF NOT EXISTS pendientes (idPendiente INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, username varchar, empresa varchar)";
            $cordovaSQLite.execute($rootScope.db, query).then(function (res) {
                console.log("se intento crear o se creo la tabla pendientes correctamente");
                defer.resolve();
            }, function (err) {
                console.error(err);
                defer.reject();
            });
            return defer.promise;

        }





        //_modificado
        function enviarPanico(estado, tipoPanico) {
            console.error("entra en enviar panico");

            //var respuesta = {Estado: 'false', Respuesta: 'no se activo'};


            //envio el panico al server
            servidor.enviarEstado(3, tipoPanico);

            //pregunta si ya no esta iniciado asi no lo inicia de nuevo
            // inicia el timeout para que no mande de nuevo el panico hasta que se cumpla el tiempo
            if (!variableTimeoutPanico) {
                iniciarTimeoutPanico();
            }

            var respuesta = {Estado: 'true', Respuesta: 'se activo'};

            //guarda el estado como que está en panico, asi en el ping se enviaría el estado con el que estaba
            estadoPrevioAlPanico = localStorageService.get('estadoIcono');

            localStorageService.set('estadoIcono', 2);
            console.warn("seteandado estadoIcono en 2: ");

            //}

            return respuesta;

        }


    }
