/**
 * Created by ivan on 21/03/17.
 */
angular
    .module('starter')
    .factory('respuestas', respuestas);




function respuestas($interval,
                    $ionicLoading,
                    $log,
                    $rootScope,
                    $state,
                    $timeout,
                    $cordovaFileTransfer,
                    $cordovaFile,
                    audio,
                    bluetooth,
                    catalogoCupones,
                    cupon,
                    dispositivo,
                    fotos,
                    estado,
                    localStorageService,
                    mobile,
                    notificaciones,
                    panico,
                    servicios,
                    sesion,
                    servidor,
                    tarea,
                    tarifas,
                    utiles) {


    const TIEMPO_ENVIO_DESTINOS_PENDIENTES = 300000;
    const TIEMPO_ENVIO_CUPONES_PENDIENTES = 1000 * 60 * 60; //1 HORA
    const TIEMPO_ENVIO_VALIDAR_SALDO = 1000 * 60 * 60; //1 HORA
    const TIEMPO_ENVIO_TICKETS_PENDIENTES = 420000; //7 minutos
    const TIEMPO_ENVIO_FOTOS_PENDIENTES = 180000; //3 minutos


    var factory = {

        rta_agregar_ticket: rta_agregar_ticket,
        rta_enviar_cupon: rta_enviar_cupon,
        rta_enviar_importe: rta_enviar_importe,
        rta_enviar_destino: rta_enviar_destino,
        rta_iniciar_sesion: rta_iniciar_sesion,
        rta_validar_pass_config: rta_validar_pass_config,
        rta_validar_saldo: rta_validar_saldo,
    };



    return factory;




    function rta_agregar_ticket(msg) {
        // console.log('llega rta_enviar_ticket: ');
    }




    function rta_validar_pass_config(msg) {

        console.error("entra en rta_validar_pass_config de repsuestas" + JSON.stringify(msg));
        console.log("removiendo listener");
        // conexion.removeListener('rta_validar_pass_config');
        //
        notificaciones.anunciar("rta_validar_pass_config", msg)
        // $rootScope.$emit("rta_validar_pass_config", msg);
    }




    function rta_enviar_cupon(msg) {
        msg = angular.fromJson(msg);
        console.log("rta de enviar cupon" + msg);
        catalogoCupones.rta_enviar_cupon(msg);
    }




    function rta_enviar_importe(msg) {
        msg = angular.fromJson(msg);
    }




    function rta_enviar_destino(msg) {
        msg = angular.fromJson(msg);
        console.log("rta_enviar_destino:" + JSON.stringify(msg));
        catalogoCupones.rta_enviar_destino(msg);

    }




    function rta_validar_saldo(msg) {

        msg = angular.fromJson(msg);

        mobile.ocultarSpinner();

        if (msg.Estado) {
            if (msg.Respuesta != '') {
                alert(msg.Respuesta);
            }
        } else {
            alert(msg.Respuesta);
        }

    }




    function debeAvisarPocoSaldo(aviso_saldo) {
        return aviso_saldo != '' && aviso_saldo != undefined;
    }




    function guardarHash(msg) {
        localStorageService.set('hash', msg.hash);
    }




    function setearSiDebeEnviarUbicacionFalsa(enviarUbicacionFalsa) {
        if (enviarUbicacionFalsa) {
            sesion.setearEnviarUbicacionFalsa(true);
        } else {
            sesion.setearEnviarUbicacionFalsa(false);
        }
    }




    function debeEnviarUbicacionFalsa(enviarUbicacionFalsa) {
        return enviarUbicacionFalsa;
    }




    function setearNuevaIp(nueva_ip) {

        return sesion.setearNuevaIp(nueva_ip);

    }




    function seteoParametros(msg) {
        cupon.setearCompletarCupones(msg.enviar_cupon);            // permite mostrar o no el menu de cupones

        servicios.setearImporteServicioObligatorio(msg.enviar_importe);            // si el importe sera obligatorio ingresarlo al finalizar un viaje
        servicios.setearImporteMinimo(msg.enviar_importe);            // modificar aca el importe mínimo

        panico.setearPermiteEnviarAlarma(msg.enviar_alarma);


        servidor.setearMostrarErrores(msg.mostrar_errores);


        // hardocdeado
        // msg.sugerir_importe = 1;

        sesion.setearSugerirImporte(msg.sugerir_importe);

        sesion.setearSucursal(msg.id_sucursal);

        audio.setearPermisoParaEnviarAudio(msg.habilitar_mensaje_de_voz); //hardcodeado

        sesion.setearIdMovil(msg.id_movil);


        if (msg.usa_tarifador == 1) {
            tarifas.setearUsaTarifador(true); //se setea y esta disponible para todo el servicio
        } else {
            tarifas.setearUsaTarifador(false);
        }


        tarifas.setearFechaHoraActual(msg.fecha_hora_actual);


        // si llegan nuevas tarifas
        if (msg.tarifas) {
            tarifas.setearTarifas(msg.tarifas);
            tarifas.guardarTarifas(msg.tarifas);
            tarifas.setearFechaModificacionTarifas(msg.fecha_modificacion_tarifas);

            if (msg.feriados) {
                tarifas.setearFeriados(msg.feriados);
            }
        }

        var retorno = setearNuevaIp(msg.nueva_ip);
        console.log("ip fija modificada:" + retorno);


        // si me dice que tiene bluetooth setea la variable
        if (msg.id_bluetooth == null || msg.id_bluetooth == '') {
            bluetooth.setearQueUsaBluetooth(false);
        } else {
            bluetooth.setearQueUsaBluetooth(true);

            sesion.setearMac(msg.id_bluetooth);
        }


        // bluetooth cercania
        // // si me dice que tiene bluetooth setea la variable
        // if (msg.id_bluetoothCercania == null) {
        //     bluetooth.setearUsaModuloCercania(false);
        // } else {koko
        //     bluetooth.setearUsaModuloCercania(true);
        // }


        // ubicacion falsa
        // msg.enviarUbicacionFalsa = true;
        // setearSiDebeEnviarUbicacionFalsa(msg.enviarUbicacionFalsa);

        $rootScope.mostrar_id_servicio = msg.mostrar_siempre_id_servicio;

    }




    function desconectarEirAlLogin() {
        // desconecta el servidor
        servidor.desconectar();

        // vuelve al login por las dudas, aunque es innecesario creo
        $state.go("login");
    }




    function iniciarControlDeRed() {
        var a = mobile.controlCambioRed();
        //lo puse aca y no en despacho porque sino va a estar "desconectado" hasta enviar el primer ping y estaria mal
        //si lo ponia en index nunca entraria en la aplicacion
        //cada 2 segundos verifica si hubo cambios en la conexion (que indiquen que no hay conexion) y si hubo cambios pone internetPrendido en false
        $interval(function () {
            if (cambioDeRed()) {
                $rootScope.internetPrendido = false;
                console.log("hubo cambio de red : ");
            }
        }, 2000);
    }




    function borrarDatosUsuario() {
        localStorageService.set('username', null);
        localStorageService.set('password', null);
    }




    function esValidaHoraTelefono(fecha_hora_actual) {
        //compara la hora actual, con la del server y verifica que no esté desfasada 5 minutos
        // si es valida devuelve true

        return tarifas.validarHoraTelefono(moment(), fecha_hora_actual, 5, "minutes");
    }




    function rta_iniciar_sesion(msg) {
        // convertir devolucion
        if (msg.con_json != null) {
            msg = angular.fromJson(msg.con_json);
        }

        // hardcodeado
        // msg.id_bluetooth = "42:24:0E:04:01:C4"; //vieja
        // msg.id_bluetooth = "00:0E:0E:13:B1:44"; //nueva

        servidor.guardarIpEnUso();

        console.log('rta_iniciar_sesion: ' + JSON.stringify(msg));
        //lo cancela al timeout del spinner pero no lo oculta porque sino cuando cambia de estado lo corta y
        // vuelve a iniciar el spinner
        mobile.cancelarYocultarSpinner();


        // si está todo_ bien
        if (msg['Estado'] == true) {


            //si no es valida no inicia sesion
            if (!esValidaHoraTelefono(msg.fecha_hora_actual)) {
                alert("Por favor configure correctamente su fecha y hora actual");
                return;
            }


            guardarHash(msg);


            validacionBluetooth();


            // si el servidor menciona algun inconveniente no se puede loguear
        } else {

            // si debe actualizar la app le pasa la ruta que envia el servidor
            if (msg['actualizar_app'] == true && msg['ruta_app'] != null && msg['ruta_app'] != '') {
                desconectarEirAlLogin();

                var url = msg['ruta_app'];

                $timeout(function () {
                    descargarNuevaVersion(url);
                }, 1000);

                return;
            }


            // borrarDatosUsuario();

            alert(msg.Respuesta);

        }




        function usaBluetooth() {
            // hardcodeado
            return msg.id_bluetooth != null && msg.id_bluetooth != '';
        }





        function validacionBluetooth() {


            if (!usaBluetooth()) {
                console.log("no usa camara ingresa normalmente");
                ingresarNormalSinDescargar();
                return
            }

            bluetooth.determinarBluetoothAusar().then(exito, null);


            function exito() {

                var versionCamaraRequerida = '1.0.3';

                var versionCamara = dispositivo.obtenerVersionDeLaCamara();
                
                console.log('versionCamara: ' + JSON.stringify(versionCamara));

                // si no esta instalada o no la puede recuperar
                if (!versionCamara.Estado) {
                    console.log("entra en descargarcamara");
                    descargarCamara(versionCamaraRequerida);
                    return;
                }

                // si esta instalada valida la version


                if (versionCamaraRequerida !== versionCamara.Dato){
                    console.log("entra en son distintas");
                    descargarCamara(versionCamaraRequerida);
                    return;
                }
                
                console.log("descargara normalmente");


                // si existe pero no puede obtener la version entra normalmente y no la descarga;
                ingresarNormalSinDescargar();

            }
        }



        function descargarCamara(version) {
            
            desconectarEirAlLogin();

            // aca tiene que guardar la url de la camara
            // var url = msg['usa_camara'];

            var url = "https://s3.amazonaws.com/public.airtrack/camara/camara-" + version + ".apk";
            //asi quedaria. https://s3.amazonaws.com/public.airtrack/camara/camara-1.0.3.apk


            // cuando se cumple el tiempo baja la app de la camara
            $timeout(function () {
                descargarNuevaVersion(url);
            }, 1000);
        }




        function determinarRutaAseguir() {
            //solo pasa a mapa si esta en login
            if ($state.current.name == 'login') {
                $timeout(function () {
                    $rootScope.vista_despacho = true;
                }, 0);

                $timeout(function () {
                    $state.go('barra.general');
                }, 20);
            }
        }




        function guardarNombreEmpresa() {
            //si no hay una empresa cargada, la inserta en la base de datos
            if ($rootScope.empresaVisible == false && localStorageService.get('nombreEmpresa') == undefined) {
                //if ($rootScope.empresaVisible == false) {

                localStorageService.set('nombreEmpresa', msg.nombre_empresa);

                //emite un mensaje entre rootscropes anunciando que sucedio una modificacion
                $rootScope.$emit("insertar");

            }
        }




        function guardarRecordarDatos() {
            localStorageService.set("recordar", $rootScope.recordar);
        }




        function ingresarNormalSinDescargar() {
            // guarda datos importantes para la sesion o permanentes


            seteoParametros(msg);


            if (debeAvisarPocoSaldo(msg.aviso_saldo)) {
                alert(msg.aviso_saldo);
            }

            //$rootScope.empresaVisible = true;


            $timeout(function () {
                iniciarTareas(msg);
            }, 1000);

            guardarNombreEmpresa();

            //si recordar esta activo o no lo guarda en el local storage
            guardarRecordarDatos();

            determinarRutaAseguir();

            iniciarControlDeRed();

        }

    }




    function descargarNuevaVersion(url) {

        // descargarNuevaVersion("http://192.168.0.111:3001/descargar_app"); funcionando

        $log.warn("entrando a descargar nueva version,", url);

        var archivo = utiles.obtenerNombreArchivo(url);
        if (!archivo) {
            alert("No se pudo instalar la actualizacion");
            return;
        }


        var ubicacion = cordova.file.externalDataDirectory;
        var targetPath = ubicacion + archivo;
        var tipo = "application/vnd.android.package-archive"; //es el tipo de archivo. en este caso paquete
        var trustHosts = true; //si se confía en el proveedor
        var options = {};


        $rootScope.ruta = null; //por las dudas, medio al cuete
        $rootScope.ruta = url;


        $ionicLoading.show({
            title: 'Descargando',
            template: 'Actualizando la aplicación <br>' +
            '<div style="font-size: 12px;max-width: 80%;margin: auto;">{{ruta}}</div> <br> <br> Descargado {{downloadProgress| number:0}} % <progress value="{{downloadProgress}}" max="100"></progress>',
            scope: $rootScope,
            noBackdrop: true,
            hideOnStateChange: true
        });

        $rootScope.downloadProgress = 0;
        console.error("url a descargar:" + url);
        descargar(url, targetPath, options, trustHosts).then(function (respuesta) {

            // si se pudo descargar bien
            console.log("resspuesta en descargar es:" + JSON.stringify(respuesta));


            try {
                $ionicLoading.hide();
            } catch (e) {

            }

            checkearSiExisteElArchivo(ubicacion, archivo).then(function (respuesta) {
                console.log("respuesta en checkear archivo es:" + JSON.stringify(respuesta));

                abrirArchivo(ubicacion, archivo, tipo)

            }, function (error) {
                console.error("error en checkear archivo es:" + JSON.stringify(error));

                alert("No se pudo instalar la actualizacion")

            });

            //sino se pudo descargar bien
        }, function (error) {
            console.error("error en descargar es:" + JSON.stringify(error));
            $ionicLoading.hide();
            alert("No se pudo descargar la actualizacion")

            //mientras descarga
        }, function (progress) {
            $rootScope.downloadProgress = ((progress.loaded / progress.total) * 100).toFixed(2);

        });
    }




    function checkearSiExisteElArchivo(ubicacion, archivo) {
        return $cordovaFile.checkFile(ubicacion, archivo)
    }




    function abrirArchivo(ubicacion, archivo, tipo) {
        return mobile.abrirArchivo(ubicacion, archivo, tipo)
    }




    function descargar(url, targetPath, options, trustHosts) {
        return $cordovaFileTransfer.download(url, targetPath, options, trustHosts)
    }




    function enviarFoto() {
        fotos.enviarFoto();
    }




    function enviarTicketAlServer() {

        var j = 0;
        var tickets = tarifas.obtenerTickets();

        if (!tickets) {
            return
        }

        console.log("cantidad tickets:" + tickets.length);

        var hashActual = sesion.obtenerHash();

        for (var i = 0, longitud = tickets.length; i < longitud; i++) {


            var ticket = tickets[i];
            ticket.hash = hashActual;
            console.log("ticket:" + JSON.stringify(ticket));


            servidor.emitWhenConnected('agregar_ticket', ticket, function () {
                console.log('emit enviar ticket: ' + JSON.stringify(ticket));

                j = j + 1;

                if (j == longitud) {

                    console.log('limpiando tickets: ');

                    // limpia tickets guardados
                    localStorageService.set("ticketsGuardados", null);
                }


            }, function () {
                console.log('hubo un error al realizar el emit común: posiblemente se perdio la conexion con el server ');
            })


        }

    }




    function iniciarTareas(msg) {


        // catalogoCupones.enviarCuponesPendientes(); //lo ejecuto asi no espero al fin del intervalo para la primer ejecucion
        tarea.ejecutarTarea(catalogoCupones.enviarCuponesPendientes, TIEMPO_ENVIO_CUPONES_PENDIENTES);


        // catalogoCupones.enviarDestinosPendientes(); //lo ejecuto asi no espero al fin del intervalo para la primer ejecucion
        tarea.ejecutarTarea(catalogoCupones.enviarDestinosPendientes, TIEMPO_ENVIO_DESTINOS_PENDIENTES);


        // enviarTicketAlServer(); //lo ejecuto asi no espero al fin del intervalo para la primer ejecucion
        tarea.ejecutarTarea(enviarTicketAlServer, TIEMPO_ENVIO_TICKETS_PENDIENTES);

        // por ahora solo envia fotos si tiene bluetooth, pero lo ideal es que sea otro el parametro
        if (msg.id_bluetooth != null && msg.id_bluetooth != '') {
            console.log("iniciando tarea de envio de fotos");
            // enviarTicketAlServer(); //lo ejecuto asi no espero al fin del intervalo para la primer ejecucion
            tarea.ejecutarTarea(enviarFoto, TIEMPO_ENVIO_FOTOS_PENDIENTES);
        }

        if ($rootScope.apk == 'trackphone') {
            tarea.ejecutarTarea(sesion.enviarValidarSaldo, TIEMPO_ENVIO_VALIDAR_SALDO);
        }

    }




    function cambioDeRed() {
        return mobile.controlCambioRed().Estado
    }


}
