angular.module('starter')
//app es un objeto que devuelve la aplicacion entera

    .factory('servidor', servidor);




function servidor($timeout,
                  $interval,
                  $q,
                  $state,
                  $rootScope,
                  $cordovaSQLite,
                  localStorageService,
                  mobile,
                  notificaciones,
                  URLSERVER,
                  validaciones,
                  websocket) {
    var conexion;
    var url;
    var transporte;
    var puerto;
    var numeroIpParaConectar = 0;


    var tipoConexion;

    var mostrarErrores = false;


    function desconectar() {
        if (tipoConexion == 'websocket') {
            websocket.desconectar();
            return
        }

        try {
            conexion.removeAllListeners();
            conexion.disconnect(true);
            conexion = null;

            console.error("si pudo desconectar");
        } catch (e) {
            console.error("entra en el catch de desconexion. quiere desconectar, pero no esta conectado");
        }
    }

    function setearMostrarErrores(valor) {
        mostrarErrores = valor;
    }




    function obtenerMostrarErrores() {
        return mostrarErrores;
    }


    function setearTipo(tipo) {
        tipoConexion = tipo
    }




    function obtenerTipo() {
        return tipoConexion
    }




    return {

        conectar: conectar,
        desconectar: desconectar,
        guardarPuerto: guardarPuerto,
        guardarIpEnUso: guardarIpEnUso,
        guardarUltimaIpProbada: guardarUltimaIpProbada,
        enviarAlServer: enviarAlServer,
        obtenerMostrarErrores: obtenerMostrarErrores,

        obtenerPuerto: obtenerPuerto,
        obtenerPuertoGuardado: obtenerPuertoGuardado,
        obtenerUrlServidor: obtenerUrlServidor,
        ping: ping,
        reconectar: reconectar,
        removerListener: removerListener,
        removerTodosLosListeners: removerTodosLosListeners,
        setearMostrarErrores: setearMostrarErrores,
        setearTransporte: setearTransporte,
        setearTipo: setearTipo,
        obtenerTipo: obtenerTipo,
        setearUrl: setearUrl,
        setearPuerto: setearPuerto,



        getConexion: function () {
            return conexion;
        },



        //msg es el nombre de l comando ejemlo "enviar_cupon"
        emitWhenConnected: function (msg, data, success, error) {

            if (tipoConexion == 'websocket') {
                websocket.enviar(msg, data);
                return
            }

            if (conexion.connected) {
                //console.log("esta conectada: ");
                return conexion.emit(msg, data, success);
            } else {
                error();
            }
        },


        isconnected: function () {
            //retorna true si hay conexion
            if (tipoConexion == 'websocket') {
                return websocket.estaConectado();
            }


            if (conexion) {
                return conexion.connected;
            }


            return false
        },


        iniciarSesion: function () {

            console.log("ya se conecto, ahora envia iniciar sesion. estado de conexion: " + this.isconnected());

            var dic = {
                dni: localStorageService.get('username'),
                empresa: localStorageService.get('empresa'),
                password: localStorageService.get('password')
            };

            //si no tiene los datos del dispositivo por algun motivo
            if (localStorageService.get("dispositivo") == null) {

                dic.version_android = '';
                dic.version_apk = '';
                dic.modelo = '';
                dic.marca = '';

                //si los tiene de todos modos tengo que enviar vacio en vez de null
            } else {

                //si es null, envia vacio en cada uno de ellos
                var temp = localStorageService.get("dispositivo").version;
                if (temp == null) {
                    dic.version_android = '';
                } else {
                    dic.version_android = temp;
                }

                temp = localStorageService.get("versionApk");
                if (temp == null) {
                    dic.version_apk = '';
                } else {
                    dic.version_apk = temp;
                }

                temp = localStorageService.get("dispositivo").modelo;
                if (temp == null) {
                    dic.modelo = '';
                } else {
                    dic.modelo = temp;
                }

                temp = localStorageService.get("dispositivo").marca;
                if (temp == null) {
                    dic.marca = '';
                } else {
                    dic.marca = temp;
                }

                temp = localStorageService.get("fechaModificacionTarifas");
                if (temp == null) {
                    dic.fecha_modificacion_tarifas = '';
                } else {
                    dic.fecha_modificacion_tarifas = temp;
                }


            }

            console.log("enviando en inicar sesion previo control a empresa: " + JSON.stringify(dic));


            if (!validaciones.validar_vacio_null_y_undefined(dic.dni).Estado) {
                return;
            }
            if (!validaciones.validar_vacio_null_y_undefined(dic.password).Estado) {
                return;
            }

            if ($rootScope.apk == 'trackphone') {
                if (!validaciones.validar_vacio_null_y_undefined(dic.empresa).Estado) {
                    return;
                }
            }


            //console.log("dni: "+dic.dni);
            //console.log("empresa: "+dic.empresa);
            //console.log("password: "+dic.password);
            ////conexion.emit('iniciar_sesion', dic);

            this.emitWhenConnected('iniciar_sesion', dic, function () {
                console.log('emit iniciar sesion realizado bien. hora:');
            }, function () {
                console.log('no se pudo realizar el emit realizar sesion, posiblemente porque no tenga conexion: ');
            });

            //conexion.emit('iniciar_sesion',dic,function(){console.log("realizada: ");})

        },


        confirmarComando: function (empresa, id_comando, hash) {
            var msg = {
                'empresa': empresa,
                'id_comando': id_comando,
                'hash': hash
            };
            conexion.emit('confirmar_comando', msg, function () {
                console.log('+enviado confirmar comando: ');
            });
        },

        registrarListenerPanico: function () {
            //var self = this;
            //conexion.on('rta_activar_panico', function (msg) {
            //    if (msg['Estado'] == true) {
            //        $rootScope.panico = true;
            //
            //    }
            //});
            //
            //conexion.on('desactivar_panico', function (msg) {
            //    $rootScope.panico = false;
            //    self.confirmarComando(localStorageService.get('empresa'), msg['id_comando'], localStorageService.get('hash'));
            //
            //});
        },

        enviarEstado: function (estado, tipoPanico) {

            console.error('entra en enviar estado');
            var msg = {
                'dni': localStorageService.get('username'),
                'empresa': localStorageService.get('empresa'),
                'hash': localStorageService.get('hash')
            };


            switch (estado) {
                case 0: //quiero ponerme libre
                {
                    msg.id_zona = 0;
                    conexion.emit('libre', msg);
                    console.log('LIBRE dni:' + msg['dni'] + ' empresa:' + msg['empresa'] + 'id zona' + msg['id_zona']);
                    break;
                }
                case 1: //quiero ponerme ocupado
                {
                    conexion.emit('ocupado', msg);
                    console.log('ocupado dni:' + msg['dni'] + ' empresa:' + msg['empresa']);
                    break;
                }
                case 2: //con pasajero
                {
                    msg.id_zona = 0;
                    msg.fecha_hora_servicio = localStorageService.get("servicio").fecha_hora_servicio;
                    msg.telefono = localStorageService.get("servicio").telefono;
                    msg.lat_servicio = localStorageService.get("servicio").lat_servicio;
                    msg.lon_servicio = localStorageService.get("servicio").lon_servicio;
                    msg.lat_movil = localStorageService.get("latitud");
                    msg.lon_movil = localStorageService.get("longitud");
                    conexion.emit('con_pasajero', msg);
                    break;
                }
                case 3: //panico
                {

                    //_agregado
                    msg.estado_panico = tipoPanico;

                    this.guardarPendientes(msg);

                    //indica que el panico esta activado
                    localStorageService.set("panicoActivado", true);

                    console.error("enviado panico:" + JSON.stringify(msg));
                    $timeout(function () {
                        conexion.emit('activar_panico', msg);
                    }, 1000);
                    console.log('activar panico tratado de enviar dni:' + msg['dni'] + ' empresa:' + msg['empresa']);


                    break;

                }

            }
        },


        guardarPendientes: function (msg) {

            var yo = this;

            //hace una busqueda si ya existe no la inserta
            var query = "select * from pendientes where username=" + localStorageService.get("username");

            yo.select(query).then(function (resultado) {
                console.log("resutlado: " + JSON.stringify(resultado));

                if (resultado == null) {
                    //si no hay registros todavia del usuario, inserta en la base de datos para enviar pendientes
                    query = "INSERT INTO pendientes (username, empresa) VALUES (?,?)";

                    //ejecuta la query
                    $cordovaSQLite.execute($rootScope.db, query, [msg.dni, msg.empresa]).then(function (result) {
                        console.log("pendiente insertado correctamente: " + JSON.stringify(result));
                        //yo.select("pendientes");
                    }, function (err) {
                        console.log(err);
                    });
                }
            });
        },


        //campos son los atributos a recuperar, si no les paso nada devuelve todos los atributos
        select: function (query) {

            var resultado = [];
            var rta = {};
            var defer = $q.defer();

            $cordovaSQLite.execute($rootScope.db, query).then(function (results) {

                if (results.rows.length > 0) {
                    //alert("largo: "+results.rows.length);
                    //console.log("resultado en la funcion" + JSON.stringify(results.rows.item(0)));


                    for (var i = 0; i < results.rows.length; i++) {
                        resultado.push(results.rows.item(i));
                    }

                    rta = resultado;
                }
                else {
                    rta = null;
                }

                defer.resolve(rta);
            }, function (err) {
                defer.reject(err);

            });

            return defer.promise;
        },


        borrar: function (tabla) {

            var usuario = localStorageService.get("username");

            if (!usuario) {
                return;
            }

            var query = "DELETE FROM " + tabla + " where username=?";
            console.log('la query de borrado es : ' + query);
            $cordovaSQLite.execute($rootScope.db, query, [usuario]).then(function () {
                console.log("limpieza correcta");
            }, function (err) {
                console.log("limpieza incorrecta" + JSON.stringify(err));
            });
        },
    };




    function obtenerUrlServidor() {
        if ($rootScope.desarrollo) {
            return URLSERVER.DESARROLLOPACO;
        }

        if ($rootScope.apk == 'trackphone') {
            return URLSERVER.PRODUCCION_TRACKPHONE;
        }

        if ($rootScope.apk == 'cpmobile') {
            console.log('entro en cpmobile: ');
            return obtenerUrlcpMobile();
        }
    }




    function enviarAlServer(datos) {
        console.log("enviadno datos al server:" + JSON.stringify(datos));
        var defer = $q.defer();


        this.emitWhenConnected("validar_pass_config", datos, bien, mal);




        // conexion.emit("validar_pass_config", datos, bien);


        function bien() {
            defer.resolve();
        }




        function mal() {
            defer.reject();
        }




        return defer.promise;


    }




    function ping() {

        var defer = $q.defer();
        var lista = [{query: 'www.google.com', timeout: 1, retry: 3, version: 'v4'}];
        var miping = new Ping();

        miping.ping(lista, function (results) {
            if (results[0].response.status == 'success') {
                defer.resolve(true);
            } else {
                defer.reject();
            }
        }, function (e) {
            defer.reject();
        });

        return defer.promise;

    }




    function obtenerUrlcpMobile() {
        // return obtenerUrlPorDefecto();
        //fix voy a usar siempre la primera ip
        return url = 'http://' + localStorageService.get('ip1') + ':' + localStorageService.get("puerto");
    }




    function conectar(url, reconexion, trackphone) {

        // si no es trackphone arma la url;
        if (!trackphone) {
            url = armarUrl(url);
        }
        // por si trabajo con websocket puro
        if (tipoConexion == 'websocket') {
            websocket.conectar(url);
            return
        }


        console.warn("entra conectar");

        // setearUrl(url);

        // console.log("version android" + versionAndroid);
        // if (versionAndroid <= "4.3") {
        //     setearTransporte('polling')
        // } else {
        setearTransporte('websocket');
        // }

        if (reconexion) {
            reconectar(url);
        } else {
            connect(url)
        }

    }




    function armarUrl(url) {
        try {
            url = url.toLowerCase();
        } catch (e) {
            return false
        }

        url = 'http://' + url + ':' + localStorageService.get("puerto");
        return url;
    }




    function connect(url) {

        desconectar();

        console.log("seteando conexion: " + url + "transporte:" + transporte);
        conexion = io.connect(url, {'transports': [transporte], 'query': {imei: 'asd'}});
    }




    // una vez que se desconecta necesita usarse esta porque sino no reconecta
    function reconectar(url) {

        desconectar(); //para que siempre haya una conexion por las dudas



        $timeout(function () {
            conexion = io.connect(url, {
                'transports': [transporte],
                rememberUpgrade: true,
                reconnectionDelay: 20000,
                reconnectionDelayMax: 20000,
                'forceNew': false, //asi no genera muchas conexiones al intentar reconectar
            });

            console.log("seteando reconexion: " + url + ".    transporte:" + transporte);

            // conexion.on('connect_error', function (error) {
            //     console.error("conecta: connect_error " + error);
            //     console.error("estoy en :" + $state.current.name);
            //
            //     if ($state.current.name == 'login'){
            //         console.error("estoy en login reconecta");
            //         reconectar(url) //para que intente de conectar nuevamente si esta en el login y tira error
            //     }
            // });

        }, 500); //para que le de tiempo a desconectar

    }




    function setearUrl(_url) {
        console.log("seteando url:" + _url);
        url = _url
    }




    function setearPuerto(_puerto) {
        console.log("seteando puerto:" + _puerto);
        puerto = _puerto
    }




    function obtenerPuerto() {
        return puerto;
    }




    function obtenerPuertoGuardado() {
        return localStorageService.get("puerto")
    }




    function setearTransporte(_trasporte) {
        transporte = _trasporte
    }




    function guardarPuerto(puerto) {
        localStorageService.set("puerto", puerto)
    }




    function guardarUltimaIpProbada(ip) {
        localStorageService.set("ultimaIpProbada", ip)
    }




    // recien cuando se loguea exitosamente guarda la ip como la ip1
    function guardarIpEnUso() {
        localStorageService.set("ip0", obtenerUltimaIpProbada())
    }




    function obtenerUltimaIpProbada() {
        return localStorageService.get("ultimaIpProbada")
    }




    function removerTodosLosListeners() {
        console.log("removiendo listeners");
        try {
            conexion.removeAllListeners();
        } catch (e) {
            console.error("trato de remover listener pero entro en el catch");
        }
    }




    function removerListener(listener) {
        conexion.removeListener(listener)
    }


}




//angular.module('starter.factories', [])
//    .factory('servicioCalculadora', function () {
//        return {
//            alcuadrado: function (n) {
//
//                if (typeof n === 'string') {
//                    throw new Error("Se esperaba un nro");
//                    return;
//                }
//
//                return n * n;
//            }
//        };
//    });
