/**
 * Creado por ivan fecha 14/05/18.
 */
/**
 * Created by ivan on 20/03/17.
 */
angular
    .module('socket', []) //app es un objeto que devuelve la aplicacion entera
    .service('socket', socket);





function socket($timeout,
                $interval,
                $state,
                $rootScope,
                $q,
                $ionicPopup,
                dispositivo,
                notificaciones,
                respuestas,
                servidor) {


    var factory = {

        ping: ping,
        registrarSocketon: registrarSocketon
    };

    return factory;





    function ping() {

        var defer = $q.defer();
        var lista = [{query: 'www.google.com', timeout: 1, retry: 3, version: 'v4'}];
        var miping = new Ping();

        miping.ping(lista, function (results) {
            if (results[0].response.status == 'success') {
                defer.resolve(true);
            } else {
                defer.reject();
            }
        }, function (e) {
            defer.reject();
        });

        return defer.promise;

    }





    //cada envento perteneciente a la conexion llegara por aqui
    function registrarSocketon() {


        var intervaloSocketon = $interval(function () {

            //pregunta si la conexion esta definida, si es asi cancela el intervalo y empieza a escuchar
            if (!servidor.getConexion()) {
                return;
            }

            $interval.cancel(intervaloSocketon);

            console.log('registrando socketones: ');

            servidor.getConexion().on('rta_iniciar_sesion', function (msg) {
                console.log("entrando a rta_iniciar_sesion: ");
                respuestas.rta_iniciar_sesion(msg);
            });


            servidor.getConexion().on('rta_validar_saldo', function (msg) {
                console.log("entrando a rta_validar saldo: ");
                respuestas.rta_validar_saldo(msg);
            });


            servidor.getConexion().on('rta_cancelar_servicio', function (msg) {
                console.log("entrando a rta_cancelar servioc: ");

                $rootScope.$emit("rta_cancelar_servicio", msg);
            });


            servidor.getConexion().on('rta_recuperar_posiciones', function (msg) {
                console.log("entrando a rta_recuperar posiciones: ");

                $rootScope.$emit("rta_recuperar_posiciones", msg);
            });

            servidor.getConexion().on('nuevo_servicio', function (msg) {
                console.log('entrando a nuevo servicio: ' + JSON.stringify(msg));

                $rootScope.$emit("nuevo_servicio", msg);
            });

            servidor.getConexion().on('servicio_cancelado', function (msg) {
                console.log("entrando a servicio cancelado: ");

                $rootScope.$emit("servicio_cancelado", msg);
            });

            servidor.getConexion().on('rta_confirmar_servicio', function (msg) {
                console.log("entrando a rta confirmar servicio: ");

                $rootScope.$emit("rta_confirmar_servicio", msg);
            });

            servidor.getConexion().on('rta_ocupado', function (msg) {

                console.log('entrando  un mensaje de rta_ocupado: ');
                $rootScope.$emit("rta_ocupado", msg);
            });

            servidor.getConexion().on('rta_libre', function (msg) {
                console.log("entrando a rta_libre: " + JSON.stringify(msg));

                $rootScope.$emit("rta_libre", msg);
            });

            servidor.getConexion().on('rta_con_pasajero', function (msg) {
                console.log("entrando a rta_con pasajero: ");

                $rootScope.$emit("rta_con_pasajero", msg);
            });

            /////nuevos

            servidor.getConexion().on('nuevo_mensaje_de_voz', function (msg) {
                console.log("llega nuevo mensaje de voz: ");

                $rootScope.$emit("nuevo_mensaje_de_voz", msg);
            });

            servidor.getConexion().on('rta_audio', function (msg) {
                console.log("entrando a rta_audio");

                $rootScope.$emit("rta_audio", msg);
            });

            servidor.getConexion().on('rta_ping', function (msg) {
                console.log("entrando a rta_ping");

                $rootScope.$emit("rta_ping", msg);
            });

            servidor.getConexion().on('rta_enviar_mensaje', function (msg) {
                console.log("entrando a rta_enviar_mensaje");

                $rootScope.$emit("rta_enviar_mensaje", msg);
            });

            servidor.getConexion().on('nuevo_mensaje', function (msg) {
                console.log("entrando a nuevo_mensaje");

                $rootScope.$emit("nuevo_mensaje", msg);
            });

            servidor.getConexion().on('rta_consultar_movimientos', function (msg) {
                console.log("entrando a rta_consultar_movimientos");

                $rootScope.$emit("rta_consultar_movimientos", msg); //emite hacia abajo
            });

            servidor.getConexion().on('rta_activar_panico', function (msg) {
                console.log("entrando a rta_activar_panico: ");
                $rootScope.$emit("rta_activar_panico", msg);

            });

            servidor.getConexion().on('desactivar_panico', function (msg) {
                console.log("entrando a desactivar_panico: ");
                $rootScope.$emit("desactivar_panico", msg);

            });

            servidor.getConexion().on('estado_zonas', function (msg) {
                console.log("entrando a zonas: ");
                $rootScope.$emit("zona", msg);
            });


            //agregadas con la funcionalidad de cuenta corriente
            servidor.getConexion().on('rta_enviar_cupon', function (msg) {
                console.log("entrando a rta_enviarcupon: ");

                respuestas.rta_enviar_cupon(msg);
            });


            servidor.getConexion().on('rta_enviar_importe', function (msg) {
                console.log("entrando a rta_enviar_importe: ");
                respuestas.rta_enviar_importe(msg);
            });


            servidor.getConexion().on('rta_enviar_destino', function (msg) {
                console.log("entrando a rta_enviar_destino: ");
                respuestas.rta_enviar_destino(msg);
            });


            servidor.getConexion().on('rta_validar_pass_config', function (msg) {
                console.error("entrando a rta_validar_pass_config: " + JSON.stringify(msg));
                respuestas.rta_validar_pass_config(msg)
            });


            servidor.getConexion().on('rta_agregar_ticket', function (msg) {
                msg = angular.fromJson(msg);
                console.error("entrando a rta_agregar_ticket: " + JSON.stringify(msg));

                $rootScope.$emit("rta_agregar_ticket", msg);
            });

            servidor.getConexion().on('cambiar_estado', function (msg) {
                msg = angular.fromJson(msg);
                console.error("cambiar_estado: " + JSON.stringify(msg));

                $rootScope.$emit("cambiar_estado", msg);
            });

            servidor.getConexion().on('pasar_a_ocupado', function (msg) {
                msg = angular.fromJson(msg);
                console.error("pasar a ocupado: " + JSON.stringify(msg));

                $rootScope.$emit("pasar_a_ocupado", msg);
            });

            servidor.getConexion().on('rta_guardar_foto', function (msg) {
                msg = angular.fromJson(msg);
                console.log("entrando a rta_guardar_foto: " + JSON.stringify(msg));

                $rootScope.$emit("rta_guardar_foto", msg);
            });

            servidor.getConexion().on('sacar_foto', function (msg) {
                msg = angular.fromJson(msg);
                console.log("entrando a rta_guardar_foto: " + JSON.stringify(msg));

                $rootScope.$emit("sacar_foto", msg);
            });

            servidor.getConexion().on('cerrar_sesion', function (msg) {
                msg = angular.fromJson(msg);
                console.log("entrando a cerrar_sesion: " + JSON.stringify(msg));

                $rootScope.$emit("cerrar_sesion", msg);
            });


            //reason (String) either 'io server disconnect' or 'io client disconnect'
            //Fired upon a disconnection.
            servidor.getConexion().on('disconnect', function (fn) {
                console.log('desconecta: ' + fn);
                $rootScope.internetPrendido = false;

            });

            //Fired upon a connection including a successful reconnection.
            servidor.getConexion().on('connect', function (fn) {
                console.log('conecta: ');
                $rootScope.internetPrendido = true;

            });

            // note: you should register event handlers outside of connect,
            // so they are not registered again on reconnection
            servidor.getConexion().on('myevent', function () {

            });

            //#Event: 'connect_error'
            //        error (Object) error object
            //        Fired upon a connection error.

            servidor.getConexion().on('connect_error', function (error) {
                console.error("conecta: connect_error " + error);

            });

            //#Event: 'connect_timeout'
            //        Fired upon a connection timeout.
            //
            servidor.getConexion().on('connect_timeout', function (timeout) {
                console.log("conecta: connect_timeout " + timeout);

            });
//#Event: 'error'
//        error (Object) error object
//        Fired when an error occurs.

            servidor.getConexion().on('error', function (error) {
                console.error("conecta: error " + error);

            });

//#Event: 'reconnect'
//        attempt (Number) reconnection attempt number
//        Fired upon a successful reconnection.

            servidor.getConexion().on('reconnect', function (atemp) {
                console.log("conecta: reconnect " + atemp);

            });
//#Event: 'reconnect_attempt'
//        attempt (Number) reconnection attempt number
//        Fired upon an attempt to reconnect.

            servidor.getConexion().on('reconnect_attempt', function (atemp) {
                console.log("conecta: reconnect atemp " + atemp);

            });
//#Event: 'reconnecting'
//        attempt (Number) reconnection attempt number
//        Fired upon an attempt to reconnect.

            servidor.getConexion().on('reconnecting', function (atemp) {
                console.log("conecta:reconnecting " + atemp);

            });
//#Event: 'reconnect_error'
//        error (Object) error object
//        Fired upon a reconnection attempt error.

            servidor.getConexion().on('reconnect_error', function (error) {
                console.error("conecta: reconnect_error " + error);

            });
//#Event: 'reconnect_failed'
//        Fired when couldn't reconnect within reconnectionAttempts.

            servidor.getConexion().on('reconnect_failed', function () {
                console.log("conecta: reconnect_failed");

            });
            //#Event: 'ping'
            //Fired when a ping packet is written out to the server.

            servidor.getConexion().on('ping', function () {
                // console.log("conecta: ping");

            });
            //#Event: 'pong'
            //ms (Number) number of ms elapsed since ping packet (i.e.: latency).
            //Fired when a pong is received from the server.

            servidor.getConexion().on('pong', function (latencia) {
                // console.log("conecta: pong'" + latencia);

                $rootScope.latencia = latencia;
            });

        }, 1);


    }
}