
    angular
        .module('websocket', [])
        .factory('websocket', servicio);


    var conexion;





    function servicio() {


        var factory = {

            conectar: conectar,
            desconectar: desconectar,
            enviar: enviar,
            estaConectado: estaConectado,
            recibir: recibir,
            obtenerEstado: obtenerEstado

        };





        function estaConectado() {
            var estado = obtenerEstado();
            return estado == 1
        }





        function obtenerEstado() {
            return conexion.readyState

            // 0 (CONNECTING)
            // The connection is not yet open.
            // 1 (OPEN)
            // The connection is open and ready to communicate.
            // 2 (CLOSING)
            // The connection is in the process of closing.
            // 3 (CLOSED)
            // The connection is closed or couldn't be opened.

        }





        function conectar(url) {
            console.log("conectando por websocket:" + url);

            conexion = new WebSocket('ws://192.168.0.111:3002/cpmobileweb');


            conexion.onopen = function () {
                console.log("abierto");
                recibir();
            };
            conexion.onclose = function () {
                console.log("close");
            };
            conexion.onerror = function () {
                console.log("error")
            }


        }





        function desconectar() {
            conexion.close()
        }





        // function enviar(funcion, datos) {
        //
        //     var datos = angular.toJson(datos);
        //     console.log('datos: ' + JSON.stringify(datos));
        //     conexion.send(datos)
        // }

        function enviar(funcion, _datos) {
            var datos = {
                funcion: funcion,
                data: _datos
            };

            datos = angular.toJson(datos);

            console.log('datos: ' + JSON.stringify(datos));
            conexion.send(datos)
        }





        function recibir() {
            conexion.onmessage = function (evt) {
                var received_msg = evt.data;
                console.log("Message is received...:" + received_msg);
            };
        }





        return factory;


    }
