/**
 * Creado por ivan fecha 06/04/18.
 */


(function (angular) {
    "use strict";
    angular
        .module('starter')
        .factory('sesion', sesion);






    /**
     * @ngInject
     */
    function sesion($interval,
                    localStorageService,
                    servidor) {

        var mac;
        var enviarUbicacionFalsa = false;
        var sugerirImporte;
        var sucursal;



        var service = {

            enviarValidarSaldo: enviarValidarSaldo,
            obtenerDNI: obtenerDNI,
            obtenerEmpresa: obtenerEmpresa,
            obtenerHash: obtenerHash,
            obtenerMac: obtenerMac,
            obtenerUsaMac: obtenerUsaMac,
            obtenerSesion: obtenerSesion,
            obtenerSucursal: obtenerSucursal,
            obtenerSugerirImporte: obtenerSugerirImporte,
            obtenerEnviarUbicacionFalsa: obtenerEnviarUbicacionFalsa,
            obtenerReproducirMensajeServicio: obtenerReproducirMensajeServicio,
            obtenerVersionApk: obtenerVersionApk,
            passwordCoinciden: passwordCoinciden,
            setearEnviarUbicacionFalsa: setearEnviarUbicacionFalsa,
            setearIdMovil: setearIdMovil,
            setearMac: setearMac,
            setearNuevaIp: setearNuevaIp,
            setearSugerirImporte: setearSugerirImporte,
            setearSucursal: setearSucursal,

        };






        function obtenerVersionApk() {
            return localStorageService.get("versionApk")
        }






        function setearSucursal(_sucursal) {
            sucursal = _sucursal;
        }






        function obtenerSucursal() {
            return sucursal
        }






        function setearSugerirImporte(valor) {
            // si es uno lo guarda como true, sino como false
            valor = valor == 1;
            sugerirImporte = valor
        }






        function obtenerSugerirImporte() {
            return sugerirImporte
        }






        function obtenerMac() {
            return mac
        }






        function obtenerUsaMac() {
            return localStorageService.get("mac");
        }






        function setearMac(_mac) {
            localStorageService.set("mac", _mac);
            mac = _mac
        }






        function setearIdMovil(id_movil) {

            if (id_movil) {
                localStorageService.set("id_movil", id_movil);
                return true;
            }
            return false;

        }






        function setearNuevaIp(ip) {
            if (ip) {
                localStorageService.set("ip3", ip);
                return true;
            }
            return false;
        }






        function obtenerEnviarUbicacionFalsa() {
            return enviarUbicacionFalsa
        }






        function setearEnviarUbicacionFalsa(booleano) {
            console.error("booleano es: " + booleano);
            enviarUbicacionFalsa = booleano
        }






        function enviarValidarSaldo() {

            var datos = obtenerSesion();

            servidor.getConexion().emit('validar_saldo', datos, function () {
                console.log('emit validar saldo: ');
            });

        }






        function obtenerReproducirMensajeServicio() {
            return localStorageService.get("reproducirMensajeServicio");
        }






        function obtenerDNI() {
            return localStorageService.get("username");
        }






        function obtenerEmpresa() {
            return localStorageService.get("empresa")
        }






        function obtenerHash() {
            return localStorageService.get("hash")

        }






        function passwordCoinciden(passIngresado) {

            var passGuardado = localStorageService.get('password');
            //si no hay pass
            if (!passGuardado) {
                alert("no hay pass");
                return false;
            }

            return passGuardado == passIngresado;
        }






        function obtenerSesion() {

            return {
                hash: obtenerHash(),
                empresa: obtenerEmpresa(),
                dni: obtenerDNI()
            }
        }






        return service;


    }

})(angular);