/**
 * Created by ivan on 17/10/16.
 */
//service dedicado a funciones de manejo de tiempo/fechas/horas

angular
    .module('tiempo', ['angularMoment', 'moduloValidaciones'])
    .service('tiempo', function (moment, validaciones) {


        return {
            esValidaLaDiferenciaHoraria: esValidaLaDiferenciaHoraria,
            str_to_datetime: str_to_datetime,
            diferenciaDeFechas: diferenciaDeFechas,
            obtenerFechaHoy: obtenerFechaHoy,
            obtenerHoraActual: obtenerHoraActual,

            obtenerCantidadDiasMes: function (mes) {
                var cantDias;

                switch (mes) {
                    case "Enero":
                    case "Marzo":
                    case "Mayo":
                    case "Julio":
                    case "Agosto":
                    case "Octubre":
                    case "Diciembre": {
                        cantDias = 31;
                        break;
                    }
                    case "Febrero": {
                        cantDias = 28;
                        break;
                    }
                    case "Abril":
                    case "Junio":
                    case "Septiembre":
                    case "Setiembre":
                    case "Noviembre":
                        cantDias = 30;
                }

                return cantDias;
            },

            //convierte la fecha pasada a real
            fechaAreal: function (dia, mes, anio) {
                if (!validaciones.validar_vacio_null_y_undefined(dia).Estado) {
                    console.log("error fechaareal undefined: ");
                    return;

                }
                if (!validaciones.validar_vacio_null_y_undefined(mes).Estado) {
                    console.log("error fechaareal undefined: ");
                    return;

                }
                if (!validaciones.validar_vacio_null_y_undefined(anio).Estado) {
                    console.log("error fechaareal undefined: ");
                    return;
                }

                if (validaciones.es_cero(dia).Estado) {
                    console.log("error fechaareal cero o undefined: ");
                    return;
                }

                if (validaciones.es_cero(mes).Estado) {
                    console.log("error fechaareal cero o undefined: ");
                    return;
                }

                if (validaciones.es_cero(anio).Estado) {
                    console.log("error fechaareal cero o undefined: ");
                    return;
                }

                return new Date(anio, mes - 1, dia).getTime();
            },

            //convierte un numero al mes que le corresponde. ejemplo: si le paso el mes numero 5, devuelve "Mayo"
            numToMes: function (numero) {

                if (!validaciones.validar_vacio_null_y_undefined(numero).Estado) {
                    console.log("error numtomes undefined: ");
                    return;
                }

                if (validaciones.es_cero(numero).Estado) {
                    console.log("error numtomes cero: ");
                    return;
                }

                numero = parseInt(numero);

                var meses = [
                    "Enero",
                    "Febrero",
                    "Marzo",
                    "Abril",
                    "Mayo",
                    "Junio",
                    "Julio",
                    "Agosto",
                    "Septiembre",
                    "Octubre",
                    "Noviembre",
                    "Diciembre"];

                return meses[numero - 1]
            },

            mesToNum: function (mes) {

                var meses = [
                    "Enero",
                    "Febrero",
                    "Marzo",
                    "Abril",
                    "Mayo",
                    "Junio",
                    "Julio",
                    "Agosto",
                    "Septiembre",
                    "Octubre",
                    "Noviembre",
                    "Diciembre"];

                var salida = meses.indexOf(mes) + 1;

                if (salida <= 0) {
                    return undefined;
                }

                return salida;
            },

            //retorna la fecha actual con el formato indicado como argumento
            getFechaActual: function (forma) {
                var timestamp = Number(new Date());

                var humanize = function (timestamp) {
                    return moment(timestamp).format(forma);
                };

                var fecha = humanize(timestamp);

                console.log(fecha);

                return fecha;

            },

            getFechaActualReal: function () {

                var fecha = new Date();
                return fecha.getTime();

            },

            convertirCurrentDateToFechaReal: function (fecha) {
                return fecha.getTime()
            },

            fechaRealaDia: function (fechaP) {

                return parseInt(moment(fechaP).format('DD'));

            },

            fechaRealaMes: function (fechaP) {

                return parseInt(moment(fechaP).format('MM'));

            },

            fechaRealaAnio: function (fechaP) {

                return parseInt(moment(fechaP).format('YYYY'));

            },

            fechaAformatoParaServer: function (dia, mes, anio) {
                return anio + "-" + mes + "-" + dia
            },

            fechaRealAFormatoParaServer: function (fechaP) {
                return moment(fechaP).format('YYYY-MM-DD');
            },

            fechaRealAFormatoParaHistorial: function (fechaP) {
                return moment(fechaP).format('DD/MM/YYYY');
            },

            realAhoraActual: function (fechaP) {
                return moment(fechaP).format('HH:mm:ss');

            },


        };





        function obtenerFechaHoy() {

            //var today = new Date();
            //var dd = today.getDate();
            //var mm = today.getMonth()+1; //January is 0!
            //var yyyy = today.getFullYear();
            //
            //if(dd<10) {
            //    dd = '0'+dd
            //}
            //
            //if(mm<10) {
            //    mm = '0'+mm
            //}
            //
            //return dd + '/' + mm + '/' + yyyy;

            return moment().format('YYYY-MM-DD');
        }





        function obtenerHoraActual() {
            return Date.now();
        }





        // unidad ejemplo 'hours' o 'days'
        function diferenciaDeFechas(fecha1, fecha2, unidad) {
            var a = moment(fecha1);
            var b = moment(fecha2);

            return a.diff(b, unidad)
        }





        function esValidaLaDiferenciaHoraria(fecha1, fecha2, diferencia) {
            var respuesta = diferenciaDeFechas(fecha1, fecha2, 'hours');
            console.log("respuesta");


            return respuesta >= diferencia * -1 && respuesta <= diferencia;

        }





        function str_to_datetime(fecha_hora_str) {
            // Declaro el diccionario a retornar
            var rta = {};

            // Separo la fecha de la hora
            var fecha_hora_separada = fecha_hora_str.split(' ');
            // Guardo la fecha sola
            var fecha = fecha_hora_separada[0];
            // Guardo la hora sola
            var hora = fecha_hora_separada[1];

            // Separo la fecha
            var fecha_separada = fecha.split('/');

            // Paso la fecha al formato yyyy-mm-dd
            fecha = fecha_separada[2] + '-' + fecha_separada[1] + '-' + fecha_separada[0];

            // Ahora si junto la fecha con la hora
            fecha_hora_str = fecha + ' ' + hora;

            // Valido la fecha
            var fecha_hora_date = new Date(fecha_hora_str);
            // Si la fecha no es válida
            if (fecha_hora_date == 'Invalid Date') {
                // Retorno false y un mensaje de error
                rta.Estado = false;
                rta.Respuesta = 'La fecha y hora no es válida';
                return rta;
            }

            // Si se pudo cambiar el formato retorno true y la fecha y hora en datetime
            rta.Estado = true;
            rta.Respuesta = fecha_hora_str;
            return rta;
        }





        //var a = 'Fri Feb 23 2018 16:10:00 GMT-0300 (ART)'; //asi me lo da el input date
        //console.log(moment(a).format('DD/MM/YYYY')); //con esto lo convierte a ese formato

    });










