/**
 * Creado por ivan fecha 28/02/18.
 */

angular
    .module('starter')
    .controller('ImporteController', importeServiciosController);





function importeServiciosController($rootScope,
                                    $scope,
                                    $state,
                                    $timeout,
                                    $cordovaSQLite,
                                    $ionicPopup,
                                    $ionicLoading,
                                    $interval,
                                    $ionicHistory,
                                    $q,
                                    $document,
                                    moment,
                                    $filter,
                                    baseDatos,
                                    cupon,
                                    despacho,
                                    estado,
                                    dispositivo,
                                    localStorageService,
                                    mobile,
                                    servidor,
                                    servicios,
                                    sesion,
                                    tarifas,
                                    tiempo) {


    $scope.myGoBack = volverAtras;
    $scope.enviarImporte = btnEnviarImporte;


    //esta puesto para ejecutarlo en el browser, ya que no tiene el deviceready obviamente
    //antes de consultar en base de datos me tengo que asegurar que el dispositivo este listo
    if (window.cordova) {
        document.addEventListener("deviceready", dispositivoListo, false);
    }
    else {
        dispositivoListo();
    }





    function dispositivoListo() {
        $rootScope.vista_despacho = false;

        inicializarVariables()

    }





    function inicializarVariables() {
        setearImportePorDefecto();
        $scope.importeMinimo = servicios.obtenerImporteMinimo();
    }





    function setearImportePorDefecto() {
        // ya setea el servicio en vacio
        $scope.servicio = {importeServicio: null};


        // si no debe sugerir el importe muestra vacio nomas
        if (!sesion.obtenerSugerirImporte()) {
            return
        }
        // si debe sugerir el importe, use o no el tarifador lo muestra


        var importeTarifa = 0; //la pongo en 0 por las dudas
        var acumulados = tarifas.obtenerAcumulados();

        // si hay acumulados
        if (acumulados) {
            importeTarifa = acumulados.monto;

            if (importeTarifa) {
                $scope.servicio = {importeServicio: importeTarifa}
            }
        }

        // si no hay acumulados muestra el importe en vacio
    }




    // esto tendria que ir en DIRECTIVAS
    $scope.foco = function (valor) {
        $scope.inputActivo = valor;
    };

    // esto tendria que ir en DIRECTIVAS
    $scope.vale = function () {
        if ($scope.servicio.importeServicio == 0.00) {
            return 'oculta'
        }
        return ''
    };
    // esto tendria que ir en DIRECTIVAS
    $scope.reve = function () {
        if ($scope.servicio.importeServicio == null || $scope.servicio.importeServicio == 0) {
            return 'sinMargen'
        }
        return ''
    };




    function obtenerIdServicio() {

        //obtiene el servicio
        var servicio = localStorageService.get("servicio");

        // lo devuelve
        if (servicio) {
            return servicio.id_servicio;
        }

        // o devuelve false
        return false
    }





    function btnEnviarImporte() {



        // si no es valido el importe ingresado
        if (!esValidoImporteIngresado()) {
            dispositivo.mostrarMensaje("Ingrese un importe válido");

            return;
        }



        //por las dudas se setea que si es null mande un vacio
        if ($scope.servicio.importeServicio == null) {
            $scope.servicio.importeServicio = " ";
        }

        //obtiene el id_servicio
        var id_servicio = obtenerIdServicio();
        if (id_servicio == '' || id_servicio == null || id_servicio == false) {
            dispositivo.mostrarMensaje("No se pudo enviar el importe");
            volverAtras();
            return;
        }


        var datosParaElServer = obtenerDatosParaEnviar(id_servicio);


        //trata de enviar el importe al server si hay conexion
        enviarImporteAlServer(datosParaElServer)
            .then(function () {

                dispositivo.mostrarMensaje('El importe se envió correctamente',"toast");


                volverAtras();
                despacho.limpiarLocalStorage();

            }, function () {

                dispositivo.mostrarMensaje('No se pudo enviar el importe',"toast");

                despacho.limpiarLocalStorage();

                volverAtras();

            })


    }







    function esValidoImporteIngresado() {
        return $scope.importeMinimo <= $scope.servicio.importeServicio;
    }






    function obtenerDatosParaEnviar(id_servicio) {
        return {
            "hash": localStorageService.get("hash"),
            "dni": localStorageService.get("username"),
            "empresa": localStorageService.get("empresa"),
            'id_servicio': id_servicio,
            'importe': $scope.servicio.importeServicio
        };

    }





    function enviarImporteAlServer(objeto) {
        return servicios.enviarImporteAlServer(objeto)
    }





    function volverAtras() {
        $rootScope.vista_despacho = true;
        estado.irAlEstado("barra.general");
    }
}

