/**
 * Creado por ivan fecha 16/02/18.
 */
angular
    .module('starter')
    .controller('ServiciosController', serviciosController);





function serviciosController($rootScope,
                             $scope,
                             $state,
                             moment,
                             catalogoServicios,
                             estado,
                             mobile,
                             notificaciones,
                             tiempo) {


    $scope.buscarServiciosPorFecha = buscarServiciosPorFecha;
    $scope.colorFondo = colorFondo;
    $scope.myGoBack = volverAtras;
    $scope.ordenarColumna = ordenarColumna;
    // $scope.seleccionarServicio = seleccionarServicio;

    notificaciones.escuchar('nuevoServicio', $scope, dispositivoListo);
    notificaciones.escuchar('servicioCancelado', $scope, dispositivoListo);


    //esta puesto para ejecutarlo en el browser, ya que no tiene el deviceready obviamente
    //antes de consultar en base de datos me tengo que asegurar que el dispositivo este listo
    if (window.cordova) {
        document.addEventListener("deviceready", dispositivoListo, false);
    }
    else {
        dispositivoListo();
    }





    function dispositivoListo() {

        const TIEMPO_MUESTRA_SPINNER = 5000;

        mobile.mostrarSpinner(TIEMPO_MUESTRA_SPINNER);
        $rootScope.vista_despacho = false;

        inicializar()

    }





    function inicializar() {

        console.log("carga controlelr");

        $scope.orden = "fecha_hora_servicio"; //el orden inicial que tendra la columna
        $scope.fechaElegida = {dato: new Date(Date.now())}; //inicializa con la fecha de hoy


        listarServicios(tiempo.obtenerFechaHoy());

    }





    // function seleccionarServicio(id_servicio) {
    //     console.log("id" + JSON.stringify(id_servicio));
    //     $state.go("barra.general.detalleServicio", {id_servicio_seleccionado: id_servicio});
    // }





    function ordenarColumna(columnaElegida) {
        $scope.reversa = !$scope.reversa;
        $scope.orden = columnaElegida;
    }





    function colorFondo(estado) {
        switch (estado) {

            case 'pendiente': {
                return 'rosa';
            }


            case 'despachado': {
                return 'blanco';
            }


            case 'cancelado': {
                return 'celeste';
            }
        }
    }





    function buscarServiciosPorFecha(fecha) {

        console.log("$scope." + $scope.fechaElegida.dato);


        var fechaConFormato = convertirFechaAformato(fecha, 'YYYY-MM-DD');

        listarServicios(fechaConFormato);

    }





    //busca los cuopnes en una fecha
    function convertirFechaAformato(fecha, formato) {

        return moment(fecha).format(formato);
    }



    $scope.abrirGrupo = function (group) {
        if ($scope.estaMostrandose(group)) {
            $scope.mostrado = null;
        } else {
            $scope.mostrado = group;
        }

    };

    $scope.estaMostrandose = function (group) {
        return $scope.mostrado === group;
    };

    //trae los cupones de una fecha en particular
    function listarServicios(fecha) {
        catalogoServicios.buscarServicios(fecha).then(function (respuesta) {
            console.log("respuesta en buscarServiocios es:" + JSON.stringify(respuesta));
            $scope.servicios = respuesta;
            mobile.cancelarYocultarSpinner();
        }, function (error) {
            console.error("error en buscar cupones es:" + JSON.stringify(error));
            mobile.cancelarYocultarSpinner();
        });
    }





    function volverAtras() {
        estado.determinarEstadoAir()
    }


}





