/**
 * Creado por ivan fecha 16/02/18.
 */

    angular
        .module('starter')
        .factory('catalogoServicios', factoryCupon);





    /* @ngInject */
    function factoryCupon($q,
                          localStorageService,
                          orm,
                          tiempo) {


        var factory = {
            actualizarServicio: actualizarServicio,
            buscarServicios: buscarServiciosPorFecha,
            buscarServicioPorId: buscarServicioPorId,
            cambiarEstado: cambiarEstado,
            insertarServicio: insertarServicio,
            obtenerEstadoServicio: obtenerEstadoServicio,
            obtenerServicios: obtenerServicios,
            selectServicios: selectServicios,


        };


        return factory;





        function obtenerUsuarioActual() {
            return localStorageService.get("username");
        }





        function cambiarEstado(id_servicio, estado) {
            var query = "update servicios set estado='" + estado + "' where id_servicio=" + id_servicio;
            return orm.ejecutarQuery(query);
        }





        //busca servicios de un rango de fechas
        //sino le pasa nada busca el de hoy
        function buscarServiciosPorFecha(inicio, fin) {

            var defer = $q.defer();
            var inicial;
            var final;


            //si no le pasa nada busca en el dia de hoy
            if (inicio == null) {
                var hoy = tiempo.obtenerFechaHoy('YYYY-MM-DD');
                inicial = hoy + ' 00:00:00';
                final = hoy + ' 23:59:59';

                //si le pasa solo el dia busca de ese dia
            } else if (fin == null) {
                inicial = inicio + ' 00:00:00';
                final = inicio + ' 23:59:59';

                //si le pasa ambos busca en un rango
            } else {
                inicial = inicio + ' 00:00:00';
                final = fin + ' 23:59:59';
            }

            var usuarioActual = obtenerUsuarioActual();
            var query = "SELECT * FROM servicios where fecha_hora_servicio >='" + inicial +"' AND fecha_hora_servicio <='" + final + "' and (estado='despachado' or estado='pendiente') and usuario='" + usuarioActual + "'";
            // var query = "SELECT * FROM servicios where fecha_hora_servicio between '" + inicial + "' AND '" + final + "' and estado='despachado' or estado='pendiente' and usuario='" + usuarioActual + "'";

            console.log("query de busqueda de servicios:" + query);

            orm.select(query).then(function (respuesta) {

                defer.resolve(respuesta);

            }, function (error) {

                defer.reject(error);
            });


            return defer.promise;
        }





        function obtenerEstadoServicio(id_servicio) {
            var defer = $q.defer();


            buscarServicioPorId(id_servicio).then(function (respuesta) {
                console.log("resspuesta en buscarservicio por id es:" + JSON.stringify(respuesta));

                if (respuesta == null) {
                    defer.reject("No hay servicio");
                    return;
                }

                var estado = respuesta[0].estado;

                if (estado == null) {
                    defer.reject("No hay estado del servicio");
                    return;
                }

                defer.resolve(estado);


            }, function (error) {
                console.log("error en  es:" + JSON.stringify(error));
                defer.reject('hubo un error al obtener el servicio');
            });

            return defer.promise;
        }





        function actualizarServicio(objeto) {
            var defer = $q.defer();
            orm.update("servicios", objeto).then(function (respuesta) {
                defer.resolve(respuesta);
            }, function (error) {
                defer.reject(error);
            });

            return defer.promise;
        }





        function insertarServicio(objeto) {
            var defer = $q.defer();
            orm.insertarEnBD("servicios", objeto).then(function (respuesta) {
                defer.resolve(respuesta);
            }, function (error) {
                defer.reject(error);
            });

            return defer.promise;
        }





        function obtenerServicios() {
            var defer = $q.defer();

            orm.select("servicios").then(
                function (msg) {
                    console.log("msg entero recuperado en la sesion: " + JSON.stringify(msg));

                    if (msg != null) {

                        defer.resolve(msg)

                    }
                    else {
                        defer.reject('vacio');
                    }

                },
                function (e) {
                    defer.reject(e);

                }
            );

            return defer.promise;
        }





        function selectServicios(query) {

            var defer = $q.defer();

            orm.select(query).then(
                function (msg) {
                    console.log("msg entero recuperado en la sesion: " + JSON.stringify(msg));

                    if (msg != null) {

                        defer.resolve(msg)

                    }
                    else {
                        defer.reject('vacio');
                    }

                },
                function (e) {
                    defer.reject(e);

                }
            );

            return defer.promise;

        }





        function buscarServicioPorId(id) {
            var query = "select * from servicios where id_servicio ='" + id + "'";
            console.log("query a realizar" + query);
            return orm.select(query)

        }


    }
