/**
 * Creado por ivan fecha 19/02/18.
 */

angular
    .module('servicios', [])
    .factory('servicios', servicios);





function servicios($q,
                   localStorageService,
                   servidor,
                   validaciones) {

    var importeServicio;
    var importeMinimo;
    var conCC;

    var factory = {

        enviarImporteAlServer: enviarImporteAlServer,
        esImporteServicioObligatorio: esImporteServicioObligatorio,
        esConCuentaCorriente: esConCuentaCorriente,

        obtenerImporteMinimo: obtenerImporteMinimo,
        setearImporteServicioObligatorio: setearImporteServicioObligatorio,
        setearImporteMinimo: setearImporteMinimo,
        setearConCC: setearConCC,
        verificarSiHayFirmantes: verificarSiHayFirmantes

    };

    return factory;





    function setearImporteMinimo(importe) {
        importeMinimo = importe;
    }





    function obtenerImporteMinimo() {
        return importeMinimo
    }





    function enviarImporteAlServer(objeto) {
        var defer = $q.defer();

        servidor.emitWhenConnected("enviar_importe", objeto, bien, mal);





        function bien(msg) {
            defer.resolve(msg);
        }





        function mal(msg) {
            defer.reject(msg);
        }





        return defer.promise;

    }





    function setearConCC(_conCc) {
        conCC = _conCc;
    }





    //busca si el dni y el pin que le pasa coincide con el hash de un firmante
    function verificarSiHayFirmantes(stringAbuscar) {

        //obtiene el servicio
        var servicio = obtenerServicio();
        console.log("servicio" + JSON.stringify(servicio));

        if (servicio == null) {
            return {
                Estado: false,
                Respuesta: 'no hay servicio'
            };
        }

        //verifica si hay firmantes.
        //si no existe la llave
        //si esta vacia
        //si es null
        //devuelve false
        if (validaciones.lista_no_vacio(servicio.firmantes).Estado == false) {
            console.log("no hay firmantes");

            //si no hay firmantes retorna false
            return {
                Estado: false,
                Respuesta: 'no hay firmantes'
            };
        }

        //si hay firmantes
        var hash = stringAhash(stringAbuscar);

        if (hash == null) {
            return {
                Estado: false,
                Respuesta: 'no se pudo obtener el hash'
            };
        }

        //si se pudo generar el hash y hay firmantes
        //se busca si esta en el arreglo
        var resultado = buscarCoincidentes(hash, servicio.firmantes);

        //si encuentra coincidentes
        console.log("resultado" + resultado);

        //retorna el resultado
        return resultado;

    }





    //busca si el hash esta en la lista de listas que manda el server
    function buscarCoincidentes(hash, firmantes) {

        var respuesta = {
            Estado: false,
            Respuesta: 'no hay coincidencias'
        };


        for (var i = 0, longitud = firmantes.length; i < longitud; i++) {

            for (var j = 0, longitud2 = firmantes[i].length; j < longitud2; j++) {

                if (firmantes[i][j] == hash) {

                    return respuesta = {
                        Estado: true,
                        Respuesta: firmantes[i]
                    };
                }
            }
        }


        return respuesta;

    }





    //esta puesto en una funcion porque puede que algún dia el servicio lo obtenga de otra manera
    function obtenerServicio() {
        return localStorageService.get("servicio");
    }





    function stringAhash(string) {

        return SHA256(string);
    }





    function esConCuentaCorriente() {
        //obtiene el id_servicio
        var servicio = localStorageService.get("servicio");
        console.log("servicio:" + JSON.stringify(servicio));

        var id_cupon;

        if (servicio) {
            id_cupon = servicio.id_cupon;
        }


        return id_cupon;


    }





    function setearImporteServicioObligatorio(valor) {

        if (!valor) {
            valor = 0;
        }

        importeServicio = valor;
    }











    function esImporteServicioObligatorio() {
        console.error("importeServicio:" + importeServicio);
        return importeServicio
    }


}

