/**
 * Creado por ivan fecha 21/05/18.
 */
angular.module('BluetoothModule', [])

    .service('BluetoothService', function ($q) {

        return {
            conectado: {data: ''},
            prendido: {data: ''},
            salida: {data: ''},


            conectar: function (mac) {

                var defer = $q.defer();

                //lista los dispositivos vinculados
                bluetoothSerial.connect(mac, function () {

                    defer.resolve();

                }, function () {

                    defer.reject("no se pudo conectar al dispositivo con mac: " + mac);

                });

                return defer.promise;

            },


            desconectar: function () {

                var defer = $q.defer();

                //lista los dispositivos vinculados
                bluetoothSerial.disconnect(function () {

                    defer.resolve();

                }, function () {

                    defer.reject("no se pudo desconectar al dispositivo con mac: " + mac);

                });

                return defer.promise;

            },


            encender: function () {

                var defer = $q.defer();

                bluetoothSerial.enable(function () {

                    defer.resolve("se prendio el bluetooth");

                }, function () {

                    defer.reject("no se pudo prender el bluetooth")

                });

                return defer.promise;

            },

            escribir: function (datos) {

                var defer = $q.defer();

                bluetoothSerial.write(datos, function () {

                    defer.resolve();

                }, function () {

                    defer.reject("no se pudo enviar el mensaje:" + datos);

                });

                return defer.promise;


            },

            limpiarBuffer: function () {
                var defer = $q.defer();

                bluetoothSerial.clear(function () {

                    defer.resolve();

                }, function () {

                    defer.reject("no se pudo limpiar");
                });

                return defer.promise;
            },




            leer: function () {

                var defer = $q.defer();

                bluetoothSerial.read(function (data) {

                    defer.resolve(data);

                }, function () {

                    defer.reject("no se pudo leer");
                });

                return defer.promise;

            },


            obtenerEmparejados: function () {

                var defer = $q.defer();

                //lista los dispositivos vinculados
                bluetoothSerial.list(function (devices) {

                    defer.resolve(devices);

                }, function () {

                    defer.reject("no se pudieron obtener los dispositivos vinculados")

                });

                return defer.promise;
            },


            obtenerNoEmparejados: function () {

                var defer = $q.defer();

                //lista los dispositivos vinculados
                bluetoothSerial.discoverUnpaired(function (devices) {

                    defer.resolve(devices);

                }, function () {

                    defer.reject("no se pudieron obtener los dispositivos no emparejados")

                });

                return defer.promise;
            },

            obtenerBytesDisponibles: function () {

                var defer = $q.defer();

                //lista los dispositivos vinculados
                bluetoothSerial.available(function (bytes) {

                    defer.resolve(bytes);

                }, function () {

                    defer.reject("no se pudieron obtener los bytes disponibles")

                });

                return defer.promise;
            },


            suscribirse: function (delimitador) {

                var defer = $q.defer();

                bluetoothSerial.subscribe(delimitador, function (data) {

                    defer.resolve(data);

                }, function () {

                    defer.reject("no se pudo suscribir");
                });

                return defer.promise;

            },

            desuscribirse: function (delimitador) {

                var defer = $q.defer();

                bluetoothSerial.unsubscribe(function () {

                    defer.resolve();

                }, function () {

                    defer.reject("no se pudo desuscribir");
                });

                return defer.promise;

            },
            vincular: function (mac, pin) {

                var defer = $q.defer();

                bluetoothSerial.pair(mac, pin, function (data) {

                    defer.resolve(data);

                }, function () {

                    defer.reject("no se pudo vincular");

                });

                return defer.promise;

            }

        }

    });
