angular
    .module('tarifas', ['despachoModule', 'moduloValidaciones', 'LocalForageModule', 'angularMoment', 'mapa', 'tiempo', 'LocalStorageModule'])
    .factory('tarifas', service);




function service($localForage,
                 $q,
                 $rootScope,
                 despacho,
                 localStorageService,
                 mapa,
                 moment,
                 tiempo,
                 validaciones) {


    var usaTarifador;
    var tarifa;
    const METROS_SEGUNDOS_A_KMH = 0.277778; // 1 kilometro por hora = 0.277778 metros por segundo
    // const aceleracionNormalEnMs = 3; //aceleracion basada en corsa de 0 a 100km/h en 10.42segundos
    var maximaVelocidadEnKmH; //usada para determinar si va mas rapido que ello, me lo tendria que pasar paco!!!!!!!!!!!!!!!!!!!!!!
    var maximaVelocidadEnMs;
    var velocidadLimite;

    var acumulados = 0;
    // var acumulados = tarifas.obtenerAcumulados(); //por si se apagó la app
    var metrosParciales = 0;
    var tiempoParciales = 0;
    var banderaMetrosParciales = true;
    var banderaTiempoParciales = true;
    var metrosAcumulados = 0;
    var tiempoAcumulado = 0;
    var velocidadPrevia = 0;
    var fechaHoraActual;
    var tarifas;
    var posicionesCorrectas;

    var factory = {
        actualizarAnio: actualizarAnio,
        cortarAnio: cortarAnio,
        armarTicket: armarTicket,
        buscarTarifaActual: buscarTarifaActual,
        buscarTarifaPredeterminada: buscarTarifaPredeterminada,
        buscarTarifaFeriado: buscarTarifaFeriado,
        borrarTickets: borrarTickets,
        calcularAceleracion: calcularAceleracion,
        calcularTarifa: calcularTarifa,
        calcularVelocidad: calcularVelocidad,
        debeSumar: debeSumarMetrosOsegundos,
        esHoyFeriado: esHoyFeriado,
        esLaFechaIgual: esLaFechaIgual,
        esLaFechaIgualOmayor: esLaFechaIgualOmayor,
        esLaFechaIgualOmenor: esLaFechaIgualOmenor,
        estaLaHoraEnElRango: estaLaHoraEnElRango,
        estaTarifando: estaTarifando,
        esLaFechaDelAnio: esLaFechaDelAnio,
        guardarAcumulados: guardarAcumulados,
        obtenerHoraYminutosDeFecha: obtenerHoraYminutosDeFecha,
        guardarPosicionesCorrectas: guardarPosicionesCorrectas,
        guardarTarifas: guardarTarifas,
        guardarTiempoViaje: guardarTiempoViaje,
        guardarTicket: guardarTicket,
        inicializar: inicializar,
        limpiarAcumulados: limpiarAcumulados,
        limpiarPosicionesCorrectas: limpiarPosicionesCorrectas,
        // limpiarUltimaTarifaUsada:limpiarUltimaTarifaUsada,
        obtenerAcumulados: obtenerAcumulados,
        obtenerAnio: obtenerAnio,
        obtenerDia: obtenerDia,
        obtenerFichasMetros: obtenerFichasMetros,
        obtenerFeriados: obtenerFeriados,
        obtenerFichasSegundos: obtenerFichasSegundos,
        obtenerPosicionesCorrectas: obtenerPosicionesCorrectas,
        obtenerTarifasPorHora: obtenerTarifasPorHora,
        obtenerTarifaPorTipo: obtenerTarifasPorTipo,
        obtenerTarifasDelDia: obtenerTarifasDelDia,
        obtenerTarifaVigente: obtenerTarifaVigente,
        obtenerUsaTarifador: obtenerUsaTarifador,
        obtenerFechaModificacionTarifas: obtenerFechaModificacionTarifas,
        obtenerTarifaAusar: obtenerTarifaAusar,
        obtenerTarifas: obtenerTarifas,
        obtenerTickets: obtenerTickets,
        obtenerTiempoViaje: obtenerTiempoViaje,
        setearFechaHoraActual: setearFechaHoraActual,
        setearFeriados: setearFeriados,
        setearMetrosAcumulados: setearMetrosAcumulados,
        setearTiempoAcumulado: setearTiempoAcumulado,
        setearFechaModificacionTarifas: setearFechaModificacionTarifas,
        setearPosicionesCorrectasMemoria: setearPosicionesCorrectasMemoria,
        setearUsaTarifador: setearUsaTarifador,
        setearTarifaAusar: setearTarifaAusar,
        setearTarifando: setearTarifando,
        setearTarifas: setearTarifas,
        tarifar: tarifar,
        validarHora: validarHora,
        validarHoraTelefono: validarHoraTelefono,

    };


    return factory;




    function obtenerPosicionesCorrectas() {
        // return localStorageService.get("posicionesCorrectas")


        return $localForage.getItem('posicionesCorrectas')
    }




    function setearPosicionesCorrectasMemoria(posiciones) {
        posicionesCorrectas = posiciones;
    }




    function guardarPosicionesCorrectas(longitud, latitud, velocidad, hora) {
        // orm.guardar("posicionesCorrectas", posicionesCorrectas)
        // localStorageService.set("posicionesCorrectas", posicionesCorrectas)

        // si no hay posiciones correctas
        if (!posicionesCorrectas) {
            posicionesCorrectas = [];
        }

        var posicion = [longitud, latitud, velocidad, hora];


        posicionesCorrectas.push(posicion);

        return $localForage.setItem('posicionesCorrectas', posicionesCorrectas);

    }




    function limpiarPosicionesCorrectas() {
        // localStorageService.set("posicionesCorrectas", null);
        posicionesCorrectas = [];
        return $localForage.removeItem("posicionesCorrectas");

    }




    function obtenerTiempoViaje() {
        console.warn("obteneritmepoViaje:" + localStorageService.get("tiempoViaje"));
        return localStorageService.get("tiempoViaje");
    }




    function guardarTiempoViaje(tiempo) {
        console.warn("guarad tiempo viaje:" + tiempo);
        localStorageService.set("tiempoViaje", tiempo)
    }




    function obtenerTickets() {
        return localStorageService.get("ticketsGuardados");
    }




    function guardarTicket(ticket) {
        var tickets = localStorageService.get("ticketsGuardados");

        if (tickets) {
            tickets.push(ticket);
        } else {
            tickets = [ticket];
        }

        localStorageService.set("ticketsGuardados", tickets);
    }




    function borrarTickets() {
        console.log('entro a borrar tickets: ');
        localStorageService.set("ticketsGuardados", null)
    }




    function estaTarifando() {
        return localStorageService.get("estaTarifando")
    }




    function setearTarifando(valor) {
        localStorageService.set("estaTarifando", valor)
    }




    function redondearTiempo(tiempo) {
        return Math.round((tiempo / 60000) * 100) / 100;
    }




    function armarTicket() {

        var defer = $q.defer();

        var acumulados = localStorageService.get("acumulados");
        if (!acumulados) {
            console.error("no hay acumulados ");
            defer.reject();
            return defer.promise;

        }

        var espera = acumulados.tiempo;


        if (espera == null || espera == '') {
            espera = 0;
        } else {
            espera = redondearTiempo(acumulados.tiempo)
        }


        var km = acumulados.metros / 1000;
        if (km == null || km == '') {
            km = 0;
        } else {
            // km=Number((km).toFixed(2));
            km = Math.round(km * 10) / 10
        }


        var importe = acumulados.monto;
        if (importe == null || importe == '') {
            importe = 0;
        }


        var hash = localStorageService.get('hash');
        if (!hash) {
            console.error("no hay hash ");
            defer.reject();
            return defer.promise;
        }


        if (!tarifa) {
            console.error("no hay tarifa");
            defer.reject();
            return defer.promise;
        }


        var id_tarifa = tarifa.id_tarifa;
        if (!id_tarifa) {
            console.log("no hay id_tarifa");
            defer.reject();
            return defer.promise;
        }


        var id_chofer = localStorageService.get('username');
        if (!id_chofer) {
            console.error("no hay usuario");
            defer.reject();
            return defer.promise;
        }


        var id_movil = localStorageService.get("id_movil");
        if (!id_movil) {
            console.error("no hay id_movil");
            defer.reject();
            return defer.promise;
        }
        id_movil = parseInt(id_movil);


        var horaInicioViaje = despacho.obtenerHoraInicioViaje();
        if (!horaInicioViaje) {
            console.error("no hay hora inicio viaje");
            defer.reject();
            return defer.promise;
        }


        var horaFinViaje = despacho.obtenerHoraFinViaje();
        if (!horaFinViaje) {
            console.error("no hay hora fin viaje");
            defer.reject();
            return defer.promise;
        }


        var id_servicio = null;
        var servicio = localStorageService.get("servicio");
        if (servicio) {
            id_servicio = servicio.id_servicio;
            if (!id_servicio) {
                console.error("no hay id_servicio, algo fallo");
            }
        } else {
            console.error("no hay servicio: o falla o es un servicio de la calle");
        }


        var empresa = localStorageService.get("empresa");

        var recorridoRealizado = null;

        obtenerRecorrido().then(exitoObtenerRecorrido, fallaObtenerRecorrido);




        function fallaObtenerRecorrido() {
            defer.reject();
            return defer.promise;
        }




        function exitoObtenerRecorrido(recorrido) {

            if (recorrido.posiciones) {
                if (recorrido.posiciones.length < 2) {
                    recorridoRealizado = null;
                } else {
                    recorridoRealizado = recorrido.posiciones
                }
            } else {
                recorridoRealizado = null
            }

            var velocidad_promedio = recorrido.velocidad_promedio;
            console.log('velocidad_promedio: ' + velocidad_promedio);

            if (velocidad_promedio) {
                // velocidad_promedio = Number((velocidad_promedio).toFixed(2));
                velocidad_promedio = Math.round(velocidad_promedio * 10) / 10
            } else {
                velocidad_promedio = 0
            }

            var velocidad_final = recorrido.velocidad_final;
            console.log('velocidad_final: ' + velocidad_final);
            if (velocidad_final) {
                // velocidad_final = Number((velocidad_final).toFixed(2));
                velocidad_final = Math.round(velocidad_final * 10) / 10
            } else {
                velocidad_final = 0
            }

            // retorna el ticket
            return defer.resolve({
                empresa: empresa,
                espera: espera,
                fecha_hora_inicio: horaInicioViaje,
                fecha_hora_fin: horaFinViaje,
                hash: hash,
                id_servicio: id_servicio,
                id_tarifa: id_tarifa,
                id_movil: id_movil,
                id_chofer: id_chofer,
                importe: importe,
                km: km,
                recorrido: recorridoRealizado,
                velocidad_promedio: velocidad_promedio,
                velocidad_final: velocidad_final
            });

        }




        return defer.promise;

    }




    function obtenerRecorrido() {
        var defer = $q.defer();


        obtenerPosicionesCorrectas().then(function (posiciones) {
            console.log("respuesta en  es:" + JSON.stringify(posiciones));


            if (!posiciones) {
                return defer.reject();
            }

            var velocidadTotal = 0;

            var pos = [];
            var longitud = posiciones.length;
            for (var i = 0; i < longitud; i++) {
                pos.push([posiciones[i][1], posiciones[i][0]]);
                velocidadTotal += posiciones[i][2];
            }

            //obtiene la ultima velocidad,
            //para ver si deja de tarifar mientras andaba el auto
            var velocidad_final = posiciones.reverse()[0][2];

            var velocidad_promedio = velocidadTotal / longitud;

            console.log('velocidad_final: ' + velocidad_final);
            console.log('velocidad_promedio: ' + velocidad_promedio);

            return defer.resolve({
                posiciones: pos,
                velocidad_promedio: velocidad_promedio,
                velocidad_final: velocidad_final
            });


        }, function (error) {
            console.error("error en  es:" + JSON.stringify(error));
            return defer.reject();
        });

        return defer.promise;
    }




    function setearTarifaAusar(_tarifa) {
        localStorageService.set("tarifaAusar", _tarifa);
        tarifa = _tarifa;
    }




    function obtenerTarifaAusar() {
        return localStorageService.get("tarifaAusar");
    }




    function setearTarifas(_tarifas) {
        tarifas = _tarifas;
    }




    function obtenerTarifas() {
        return localStorageService.get("tarifas")
    }




    function cortarAnio(fecha) {
        // entra:2019-12-25
        // sale:12-25

        return fecha.slice(5, 10);
    }




    function esLaFechaDelAnio(anio, fecha) {

        if (!fecha) {
            return false
        }
        var a = moment(fecha).format('YYYY-MM-DD');

        var anioObtenido = a.slice(0, 4);
        return anioObtenido == anio

    }




    function obtenerAnio(fecha) {
        if (!fecha) {
            return false
        }
        return '' + moment(fecha).year();
    }




    function actualizarAnio(anio, fecha) {
        // entrada:anio:'1900'
        //         fecha = '1900-01-19';
        // salida: 2019-01-19


        if (!anio) {
            return false;
        }


        if (!fecha) {
            return false
        }


        // console.log("anio:"+anio);
        // console.log("fecha:"+fecha);


        // no es del anio ingresado sale
        if (!esLaFechaDelAnio(anio, fecha)) {
            // console.log("no es del anio");
            return false;
        }


        var anioActual = obtenerAnio(Date.now());
        var fechaSinAnio = cortarAnio(fecha);

        //concatena y devuelve
        return anioActual + '-' + fechaSinAnio


    }




    function esHoyFeriado(fecha, feriados) {

        //valida nulls
        if (!validaciones.validar_vacio_null_y_undefined(fecha).Estado) {
            return false
        }

        //valida nulls y vacios
        if (!validaciones.lista_no_vacio(feriados).Estado) {
            return false
        }


        for (var i = 0, longitud = feriados.length; i < longitud; i++) {

            var fechaConAnioActualizado = actualizarAnio('1900', feriados[i]);

            // si es una fecha de 1900 con anio actualizado
            if (fechaConAnioActualizado) {
                // console.log("entra");
                // si es un dia y mes igual, pero de 1900, lo actualiza al anio de hoy
                if (esLaFechaIgual(fechaConAnioActualizado, fecha)) {
                    // console.log("es igual");
                    return true;
                }
            }


            if (esLaFechaIgual(fecha, feriados[i])) {
                return true;
            }

        }

        return false;
    }




    function obtenerFeriados() {

        var feriados = localStorageService.get("feriados");

        // si encuentra feriados lo devuelve
        if (feriados) {
            return {
                Estado: true,
                Respuesta: feriados
            };
        }

        // si no hay feriados
        return {
            Estado: false,
            Respuesta: 'no hay feriados'
        }
    }




    function setearFeriados(feriados) {
        localStorageService.set("feriados", feriados)
    }




    function setearFechaModificacionTarifas(fechaModificacionTarifas) {
        localStorageService.set("fechaModificacionTarifas", fechaModificacionTarifas)
    }




    function obtenerFechaModificacionTarifas() {
        return localStorageService.get("fechaModificacionTarifas")
    }




    function obtenerDia(_fecha) {

        // entrada: 2018-12-24
        // salida: 2

        var fecha = new Date(_fecha);

        if (fecha == 'Invalid Date' || !fecha || _fecha == null || _fecha == '' || _fecha == ' ') {
            return false
        }

        var week = [1, 2, 3, 4, 5, 6, 7];
        var day = week[fecha.getDay()];

        return day
    }




    function obtenerTarifasDelDia(fecha, tarifas, diaFijo) {

        // entrada: 2018-12-25
        // salida: arreglo de tarifas que tengan el dia de la semana (en este caso 3)
        // domingo 1, lunes 2, martes 3...etc

        var respuesta = [];

        if (fecha === 0 || fecha === '0') {
            return {Estado: false, Respuesta: 'la fecha ingresada es 0'}
        }

        if (!validaciones.validar_vacio_null_y_undefined(fecha).Estado) {
            return {Estado: false, Respuesta: 'null vacio o undefined'}
        }

        if (fecha == "" || fecha == " ") {
            return {Estado: false, Respuesta: 'null vacio o undefined'}
        }

        var dia;

        // si pasa el dia fijo usa ese, sino lo busca
        if (diaFijo) {
            dia = diaFijo
        } else {
            dia = obtenerDia(fecha);
        }


        // console.log("dia:" + dia);

        for (var i = 0, largo = tarifas.length; i < largo; i++) {
            for (var j = 0, longitud = tarifas[i].tarifa_dias.length; j < longitud; j++) {

                if (tarifas[i].tarifa_dias[j].dia == dia) {
                    respuesta.push(tarifas[i]);
                }
            }
        }

        if (respuesta.length === 0) {
            return {Estado: false, Respuesta: 'no hay tarifa que coincidan con el dia'}
        }

        return {Estado: true, Respuesta: respuesta}
    }




    function obtenerTarifasPorTipo(tipo, tarifas) {
        var respuesta = [];

        if (tipo === 0 || tipo === '0') {
            return {Estado: false, Respuesta: 'tipo ingresado 0'}
        }

        if (tipo == null || tipo == "" || tipo == " ") {
            return {Estado: false, Respuesta: 'null vacio o undefined'}
        }

        if (!validaciones.validar_vacio_null_y_undefined(tarifas).Estado || tarifas == " ") {
            return {Estado: false, Respuesta: 'tarifas null vacio o undefined'}
        }

        for (var i = 0, largo = tarifas.length; i < largo; i++) {
            for (var j = 0, longitud = tarifas[i].tarifa_tipos.length; j < longitud; j++) {
                if (tarifas[i].tarifa_tipos[j] == tipo) {
                    respuesta.push(tarifas[i]);
                }
            }
        }

        if (respuesta.length === 0) {
            return {Estado: false, Respuesta: 'no hay tarifa que coincidan con el tipo'}
        }

        return {Estado: true, Respuesta: respuesta}
    }




    function obtenerTarifasPorHora(fecha, tarifas, diaFijo) {

        var dia;
        var respuesta = [];
        if (fecha === 0 || fecha === '0') {
            return {Estado: false, Respuesta: 'la fecha ingresada es 0'}
        }

        if (fecha == undefined || fecha == null || fecha == "" || fecha == " ") {
            return {Estado: false, Respuesta: 'null vacio o undefined'}
        }


        if (diaFijo) {
            dia = diaFijo;
        } else {
            dia = obtenerDia(fecha);
        }


        for (var i = 0, largo = tarifas.length; i < largo; i++) {

            for (var j = 0, longitud = tarifas[i].tarifa_dias.length; j < longitud; j++) {
                if (tarifas[i].tarifa_dias[j].dia == dia) {
                    var hora_desde = tarifas[i].tarifa_dias[j].hora_desde;
                    var hora_hasta = tarifas[i].tarifa_dias[j].hora_hasta;
                    var coincide = validarHora(fecha, hora_desde, hora_hasta);
                    if (coincide.Estado) {
                        // console.log("tarifa:" + JSON.stringify(tarifas[i]));
                        respuesta.push(tarifas[i])
                    }
                }
            }

        }

        if (respuesta.length === 0) {
            return {Estado: false, Respuesta: 'no hay tarifa que coincidan con el dia y horario'}
        }

        return {Estado: true, Respuesta: respuesta}


    }




    function obtenerHoraYminutosDeFecha(fecha) {
        return moment(fecha).format('HH:mm');
    }




    function estaLaHoraEnElRango(fecha, hora_desde, hora_hasta) {
        // entrada :10:00, 08:00, 12:00
        // salida true
        return moment(fecha, 'HH:mm').isBetween(moment(hora_desde, 'HH:mm'), moment(hora_hasta, 'HH:mm'), 'minute', '[]');
    }




    function validarHoraTelefono(horaActual, horaAcomparar, rango, tiempo) {
        // salida true
        var adelante = moment(horaAcomparar).add(rango, tiempo);
        // console.log("adelant:" + adelante);
        var atras = moment(horaAcomparar).subtract(rango, tiempo);
        // console.log("atras:" + atras);

        return moment(horaActual).isBetween(moment(atras), moment(adelante), 'minute', '[]');
    }




    function validarHora(fecha, hora_desde, hora_hasta) {
        var horaYminutosActual = obtenerHoraYminutosDeFecha(fecha);

        var horaDesdeMayor = esLaFechaIgualOmayor(moment(hora_desde, 'HH:mm'), moment(hora_hasta, 'HH:mm'));
        if (!horaDesdeMayor) {
            if (estaLaHoraEnElRango(horaYminutosActual, hora_desde, hora_hasta)) {
                return {Estado: true, Respuesta: 'dentro del rango'}
            } else {
                return {Estado: false, Respuesta: 'no esta dentro del rango'}
            }
        }

        if (estaLaHoraEnElRango(horaYminutosActual, "00:00", hora_hasta) || estaLaHoraEnElRango(horaYminutosActual, hora_desde, "23:59")) {
            return {Estado: true, Respuesta: 'dentro del rango'}
        }

        return {Estado: false, Respuesta: 'no esta dentro del rango'}
    }




    function obtenerTarifaVigente(fecha, tarifas) {

        var respuesta = [];


        if (fecha === 0 || fecha === '0') {
            return {Estado: false, Respuesta: 'la fecha ingresada es 0'}
        }

        if (fecha == undefined || fecha == null || fecha == "" || fecha == " ") {
            return {Estado: false, Respuesta: 'null vacio o undefined'}
        }


        for (var i = 0, longitud = tarifas.length; i < longitud; i++) {

            for (var j = 0, longitud2 = tarifas[i].tarifa_importes.length; j < longitud2; j++) {
                var mayor = esLaFechaIgualOmayor(fecha, tarifas[i].tarifa_importes[j].fecha_hora_vigencia);


                if (mayor) {
                    respuesta.push({
                        nombre: tarifas[i].nombre,
                        id_tarifa: tarifas[i].id_tarifa,
                        tarifa_importes: tarifas[i].tarifa_importes[j]
                    })
                }
            }

        }


        if (respuesta.length == 0) {
            return {Estado: false, Respuesta: 'no hay tarifa para ese dia'}
        }

        if (respuesta.length == 1) {
            return {Estado: true, Respuesta: respuesta[0]}
        }


        // console.error("respuesta0:"+JSON.stringify(respuesta[0]));
        // console.error("respuesta1:"+JSON.stringify(respuesta[1]));
        if (respuesta.length > 1) {
            var inicial = respuesta[0];

            for (var i = 1, largo = respuesta.length; i < largo; i++) {

                var devolucion = esLaFechaIgualOmayor(inicial.tarifa_importes.fecha_hora_vigencia, respuesta[i].tarifa_importes.fecha_hora_vigencia);
                if (!devolucion) {
                    inicial = respuesta[i]
                }
            }

            return {Estado: true, Respuesta: inicial}

        }


    }




    function esLaFechaIgualOmayor(horaActual, horaAcomparar) {
        return moment(horaActual).isSameOrAfter(horaAcomparar); // true
    }




    function esLaFechaIgual(horaActual, horaAcomparar) {
        // solo le presta atencion si es el mismo dia del mismo año, no la hora
        return moment(horaActual).isSame(horaAcomparar, 'day'); // true
    }




    function esLaFechaIgualOmenor(horaActual, horaAcomparar) {
        return moment(horaActual).isSameOrBefore(horaAcomparar); // true
    }




    function buscarTarifaActual(tipo, fecha, tarifas, diaFijo) {

        // var tarifas = obtenerTarifas();

        console.log('todas las tarifas: ',JSON.stringify(tarifas));
        var tarifasFiltradas = obtenerTarifasPorTipo(tipo, tarifas);

        if (!tarifasFiltradas.Estado) {
            return tarifasFiltradas;
        }


        tarifasFiltradas = obtenerTarifasDelDia(fecha, tarifasFiltradas.Respuesta, diaFijo);

        if (!tarifasFiltradas.Estado) {
            return tarifasFiltradas;
        }


        tarifasFiltradas = obtenerTarifasPorHora(fecha, tarifasFiltradas.Respuesta, diaFijo);

        if (!tarifasFiltradas.Estado) {
            return tarifasFiltradas;
        }


        tarifasFiltradas = obtenerTarifaVigente(fecha, tarifasFiltradas.Respuesta);

        if (!tarifasFiltradas.Estado) {
            return tarifasFiltradas;
        }


        return {Estado: true, Respuesta: tarifasFiltradas.Respuesta}


    }




    function buscarTarifaPredeterminada(fecha, tarifas) {


        var tarifasFiltradas = obtenerTarifasPorTipo(1, tarifas);

        if (!tarifasFiltradas.Estado) {
            return tarifasFiltradas;
        }


        tarifasFiltradas = obtenerTarifaVigente(fecha, tarifasFiltradas.Respuesta);

        if (!tarifasFiltradas.Estado) {
            return tarifasFiltradas;
        }


        return {Estado: true, Respuesta: tarifasFiltradas.Respuesta}


    }




    function buscarTarifaFeriado(tipo, fecha, tarifas) {

        // var tarifas = obtenerTarifas();

        var tarifasFiltradas = obtenerTarifasPorTipo(tipo, tarifas);

        if (!tarifasFiltradas.Estado) {
            return tarifasFiltradas;
        }


        //busco directamente la tarifa del dia 8
        tarifasFiltradas = obtenerTarifasDelDia(fecha, tarifasFiltradas.Respuesta, 8);

        if (!tarifasFiltradas.Estado) {
            return tarifasFiltradas;
        }


        tarifasFiltradas = obtenerTarifasPorHora(fecha, tarifasFiltradas.Respuesta);

        if (!tarifasFiltradas.Estado) {
            return tarifasFiltradas;
        }


        tarifasFiltradas = obtenerTarifaVigente(fecha, tarifasFiltradas.Respuesta);

        if (!tarifasFiltradas.Estado) {
            return tarifasFiltradas;
        }


        return {Estado: true, Respuesta: tarifasFiltradas.Respuesta}


    }




    function guardarTarifas(tarifas) {
        localStorageService.set("tarifas", tarifas)
    }




    function setearFechaHoraActual(_fechaHora) {
        fechaHoraActual = _fechaHora
    }




    function aceleracionValida(velocidadActual, velocidadPrevia, miliSegundosDiferencia, maxima) {

        //     vf - vi
        // a = -------
        //        t

        var aceleracion = (velocidadActual - velocidadPrevia) / (miliSegundosDiferencia / 1000);

        // console.log("^aceleracion:" + aceleracion);

        return aceleracion <= maxima;

    }




    function esValidaVelocidad(velocidadActual) {
        return (velocidadActual != null && !isNaN(velocidadActual));
    }




    function setearTiempoAcumulado(tiempo) {
        tiempoAcumulado = tiempo;
        console.error("seteando tiempo acumulado:" + tiempoAcumulado);
    }




    function setearMetrosAcumulados(metros) {
        metrosAcumulados = metros;
        console.error("seteando metros acumulado:" + metrosAcumulados);

    }




    function debeSumarMetrosOsegundos(metrosAcumulados, tiempoAcumulado) {

        if (metrosAcumulados >= tarifa.tarifa_importes.dist_primera_ficha) {
            if (metrosAcumulados / tarifa.tarifa_importes.dist_cada_ficha >= 1) {
                return true;
            }
        }

        if (tiempoAcumulado >= tarifa.tarifa_importes.espera_primera_ficha) {
            if (tiempoAcumulado / (tarifa.tarifa_importes.tiempo_espera) >= 1) {
                return true;
            }
        }

        return false;


    }




    function esValidaMetrosFicha() {
        return tarifa.tarifa_importes.dist_cada_ficha != null && tarifa.tarifa_importes.dist_cada_ficha != 0;
    }




    function esValidaSegundosFicha() {
        return tarifa.tarifa_importes.tiempo_espera != null && tarifa.tarifa_importes.tiempo_espera != 0;
    }




    function obtenerFichasMetros(metrosAcumulados) {

        var diferenciaMetros = metrosAcumulados - tarifa.tarifa_importes.dist_primera_ficha;

        if (diferenciaMetros < tarifa.tarifa_importes.dist_cada_ficha) {
            return 0
        }

        return Math.floor(diferenciaMetros / tarifa.tarifa_importes.dist_cada_ficha); //math floor redondea para abajo

    }




    function obtenerFichasSegundos(segundosAcumulados) {
        // realiza un calculo de diferencia entre los segundos acumulados y la tarifa minima, luego realiza el resto de la division
        // entre el calculado y el tiempo de espera

        // no es necesario pero lo pongo igual
        if (segundosAcumulados == false || segundosAcumulados == null || segundosAcumulados == 0) {
            return 0
        }

        var direfenciaSegundos = segundosAcumulados - tarifa.tarifa_importes.espera_primera_ficha;

        if (!tarifa.tarifa_importes.tiempo_espera) {
            return 0
        }

        if (direfenciaSegundos < tarifa.tarifa_importes.tiempo_espera) {
            return 0
        }

        // funcionamiento MOD %: 180 % 80 arroja 20 que es el resto de dividir 180/80. obvio sin decimales
        return Math.floor(direfenciaSegundos / tarifa.tarifa_importes.tiempo_espera);

    }




    function debeSumarTiempo(velocidad, velocidadLimite) {
        return (velocidad < velocidadLimite) || velocidad == null
    }




    function tarifar(posicionAnterior, posicionActual) {


        var miliSegundosDiferencia = tiempo.diferenciaDeFechas(posicionActual.hora, posicionAnterior.hora, "milliseconds"); // determina diferencia en milisegundos entre possiciones


        var metrosDiferencia = mapa.distanciaEntre2PuntosEnMetros(
            posicionAnterior.latitud,
            posicionAnterior.longitud,
            posicionActual.latitud,
            posicionActual.longitud
        ); //determina diferencia metros entre posiciones


        if (miliSegundosDiferencia <= 0) {
            console.error("miliSegundosDiferencia menor o igual a 0");
            return {Estado: false, Respuesta: 'miliSegundosDiferencia menor o igual a 0'};
        }


        if (metrosDiferencia < 0 || metrosDiferencia == null) {
            console.error("metros negativo o null");
            return {Estado: false, Respuesta: 'metros negativos o null'};
        }


        //primero hay que llevar a km/h para comparar si la velocidad actual es mas alta que la velocidad maxima
        if ((posicionActual.velocidad / METROS_SEGUNDOS_A_KMH) > maximaVelocidadEnKmH) {
            console.error("la velocidad del plugin se fue de mambo" + posicionActual.velocidad);
            return {Estado: false, Respuesta: 'la velocidad se fue de mambo'};
        }

        //este control lo que hace es evitar metros recorridos en poco tiempo, a pesar de que el plugin
        //me arroja una velocidad similar a esta,
        //pero ante un error del plugin me arroja una distancia recorrida excesiva en la cantidad de segundos calculada.
        //de esta manera se evita ese problema
        var velocidadCalculadaPorMi = determinarVelocidad(metrosDiferencia, miliSegundosDiferencia);
        // console.log('velocidadCalculadaPorMi: ' + velocidadCalculadaPorMi / METROS_SEGUNDOS_A_KMH);


        // la setea igual en pantalla por mas que muestre cualquier cosa
        $rootScope.velocidad = velocidadCalculadaPorMi / METROS_SEGUNDOS_A_KMH;

        if (velocidadCalculadaPorMi > maximaVelocidadEnMs) {
            console.error("la velocidad mia se fue de mambo");
            return {Estado: false, Respuesta: 'se bandeo la velocidad'};
        }


        //8 ms² es la aceleracion maxima
        if (!aceleracionValida(posicionActual.velocidad, velocidadPrevia, miliSegundosDiferencia, 8)) {
            console.error("la aceleracion se bandeo. mayor a 8m/s²");
            return {Estado: false, Respuesta: 'la aceleracion se bandeo. mayor a 8m/s²'};

        }


        velocidadPrevia = posicionActual.velocidad; //dejar despues de la validacion anterior sino pisaria la vieja con una velocidad mala.


        // determina que suma: entre tiempo y metros
        if (debeSumarTiempo(posicionActual.velocidad, velocidadLimite)) {
            // si no supera el limite se suma segundos
            tiempoAcumulado += miliSegundosDiferencia;

            // si supera el limite suma metros
        } else {
            metrosAcumulados += metrosDiferencia; //va realizando la suma parcial previa a realizar el tarifamiento por distancia
        }


        // si cumple la condición de ser mayor a la distancia de cada ficha o el tiempo de espera
        //y si es mayor que la distancia y metros minimos
        if (debeSumarMetrosOsegundos(metrosAcumulados, tiempoAcumulado / 1000)) {

            // validaciones comunes

            if (esValidaMetrosFicha()) {
                var fichasMetros = obtenerFichasMetros(metrosAcumulados);
            }

            if (esValidaSegundosFicha()) {
                var fichasSegundos = obtenerFichasSegundos(tiempoAcumulado / 1000);
            }

            if (tarifa.tarifa_importes.precio_espera == null) {
                tarifa.tarifa_importes.precio_espera = 0;
            }
            if (tarifa.tarifa_importes.precio_ficha == null) {
                tarifa.tarifa_importes.precio_ficha = 0;
            }
            if (tarifa.tarifa_importes.precio_bajada_bandera == null) {
                tarifa.tarifa_importes.precio_bajada_bandera = 0;
            }


            // z = ax + by + c
            var monto = (tarifa.tarifa_importes.precio_ficha * fichasMetros) + (tarifa.tarifa_importes.precio_espera * fichasSegundos) + tarifa.tarifa_importes.precio_bajada_bandera;

            // console.log("tarifa.:" + JSON.stringify(tarifa));
            // console.log("monto:" + monto);
            // console.log(tarifa.tarifa_importes.precio_ficha); //15
            // console.log(fichasMetros);//17
            // console.log(tarifa.tarifa_importes.precio_espera);//0
            // console.log(tarifa.tarifa_importes.precio_bajada_bandera);//45
            // console.log(fichasSegundos); //undefined. tendria que ser 0
            // si hay tarifas suma lo calculado
            acumulados = {
                metros: metrosAcumulados,
                tiempo: tiempoAcumulado,
                monto: monto,
                fichasMetros: fichasMetros,
                fichasSegundos: fichasSegundos
            };


            guardarAcumulados(acumulados);

            console.error("acumulados:" + JSON.stringify(acumulados));

            return {Estado: true, Respuesta: acumulados}

        } else {

            acumulados = {
                metros: metrosAcumulados,
                tiempo: tiempoAcumulado,
            };

            if (tarifa.tarifa_importes.precio_bajada_bandera == null) {
                acumulados.monto = 0;
            } else {
                acumulados.monto = tarifa.tarifa_importes.precio_bajada_bandera
            }
            guardarAcumulados(acumulados);


            // console.error("entro en el else de que no hay fichas calculadas todavia");
            return {Estado: true, Respuesta: acumulados}
        }
    }




    function determinarVelocidad(metrosDiferencia, miliSegundosDiferencia) {
        return metrosDiferencia / (miliSegundosDiferencia / 1000);
    }




    function inicializar(velocidad) {

        // setea variables

        tiempoAcumulado = 0;
        metrosAcumulados = 0;
        maximaVelocidadEnKmH = velocidad;
        maximaVelocidadEnMs = maximaVelocidadEnKmH * METROS_SEGUNDOS_A_KMH;

        if (tarifa) {
            if (tarifa.tarifa_importes) {
                velocidadLimite = METROS_SEGUNDOS_A_KMH * tarifa.tarifa_importes.velocidad_max_espera;
                console.error('sasa:' + tarifa.tarifa_importes.velocidad_max_espera);
                console.error('tarifa a usar:' + tarifa);
                console.error('tarifa a usar:' + JSON.stringify(tarifa));
            }
        }


    }




    function limpiarAcumulados() {
        console.log("limpiando acumulados");
        localStorageService.set("acumulados", null);
    }




    function obtenerUsaTarifador() {
        return usaTarifador
    }




    function setearUsaTarifador(valor) {
        usaTarifador = valor
    }




    function guardarAcumulados(acumulados) {

        //para poder recuperarlos despues. si no se quiere recuperar, evitar la llamada a esta funcion
        localStorageService.set("acumulados", acumulados)
    }




    function obtenerAcumulados() {
        return localStorageService.get("acumulados")
    }




    // devuelve fichas y monto
    function calcularTarifa(cantidadFichasMetros, cantidadFichasSegundos) {
        // segun una tarifa y los metros o segundos contabilizados se realiza el calculo del importe


        if (!tarifa) {
            return false;
        }

        console.warn("tarifa:" + JSON.stringify(tarifa));


        // z = ax + by + c

    }




    // vf = vi + a * t   =>   a = (vf - vi) / t
    function calcularAceleracion(velocidadActual, velocidadPrevia, segundosDiferencia) {
        if (!velocidadActual || !velocidadPrevia || !segundosDiferencia || segundosDiferencia == 0) {
            return 0;
        }
        return (velocidadActual - velocidadPrevia) / (segundosDiferencia)
    }




    function calcularVelocidad(metros, segundos) {
        // la devuelve en m/s

        if (!metros || !segundos || segundos == 0) {
            return false
        }
        return metros / segundos
    }

}
